SystemOrganization addCategory: #'XPath-Core'!
SystemOrganization addCategory: 'XPath-Core-Compilation'!
SystemOrganization addCategory: 'XPath-Core-Compilation-AST'!
SystemOrganization addCategory: 'XPath-Core-DOM'!
SystemOrganization addCategory: 'XPath-Core-Exceptions'!
SystemOrganization addCategory: 'XPath-Core-Functions'!
SystemOrganization addCategory: 'XPath-Core-Parsers'!
SystemOrganization addCategory: 'XPath-Core-Streams'!
SystemOrganization addCategory: 'XPath-Core-Types'!

!Collection methodsFor: '*XPath-Core-converting' stamp: 'monty 3/14/2018 04:00'!
asXPathFunctionSet
	^ XPathFunctionSet newFrom: self! !

Collection subclass: #XPathFunctionSet
	instanceVariableNames: 'functionsByName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFunctionSet commentStamp: 'monty 2/10/2015 03:01' prior: 0!
A set for XPath functions. Supports set composition with + and - and lookup of functions by name.
!

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 1/13/2017 13:12'!
default
	^ XPathBooleanFunction +
		XPathCeilingFunction +
		XPathConcatFunction +
		XPathContainsFunction +
		XPathCountFunction +
		XPathEndsWithFunction +
		XPathFloorFunction +
		XPathIDFunction +
		XPathLangFunction +
		XPathLocalNameFunction +
		XPathNameFunction +
		XPathNamespaceURIFunction +
		XPathNormalizeSpaceFunction +
		XPathNotFunction +
		XPathNumberFunction +
		XPathRoundFunction +
		XPathStartsWithFunction +
		XPathStringFunction +
		XPathStringLengthFunction +
		XPathSubstringAfterFunction +
		XPathSubstringBeforeFunction +
		XPathSubstringFunction +
		XPathSumFunction +
		XPathTranslateFunction! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 1/18/2015 15:23'!
new
	^ self new: 15! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 12/27/2014 17:02'!
new: aCapacity
	^ self basicNew initialize: aCapacity! !

!XPathFunctionSet class methodsFor: 'instance creation' stamp: 'monty 3/6/2016 14:41'!
newFrom: aCollection
	"for GS portability"
	^ self withAll: aCollection! !

!XPathFunctionSet methodsFor: 'composition' stamp: 'monty 3/6/2016 14:40'!
+ aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asXPathFunctionSetWithFunctions: self! !

!XPathFunctionSet methodsFor: 'copying' stamp: 'monty 9/28/2016 22:39'!
, aCollection
	"GS doesn't define #, for non-Sequenceable collections"
	^ self copy
		addAll: aCollection;
		yourself! !

!XPathFunctionSet methodsFor: 'composition' stamp: 'monty 3/6/2016 14:39'!
- aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asXPathFunctionSetSubtractedFromFunctions: self! !

!XPathFunctionSet methodsFor: 'comparing' stamp: 'monty 10/25/2017 07:36'!
= anObject
	self == anObject
		ifTrue: [^ true].

	(self species == anObject species
		and: [self size = anObject size])
		ifFalse: [^ false].

	^ self allSatisfy: [:each | anObject includes: each].! !

!XPathFunctionSet methodsFor: 'adding' stamp: 'monty 1/9/2017 09:47'!
add: aFunction
	^ functionsByName
		at: aFunction prototypeName
		put: aFunction! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSet
	^ self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetSubtractedFromFunction: aFunction
	^ aFunction asXPathFunctionSet copyWithoutAll: self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetSubtractedFromFunctions: aFunctionSet
	^ aFunctionSet copyWithoutAll: self! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetWithFunction: aFunction
	^ self copyWith: aFunction! !

!XPathFunctionSet methodsFor: 'converting' stamp: 'monty 3/6/2016 14:40'!
asXPathFunctionSetWithFunctions: aFunctionSet
	^ self, aFunctionSet! !

!XPathFunctionSet methodsFor: 'enumerating' stamp: 'monty 12/27/2014 16:59'!
do: aBlock
	functionsByName valuesDo: aBlock! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 11/18/2015 05:25'!
functionNamed: aFunctionName
	^ self
		functionNamed: aFunctionName
		ifAbsent: [nil]! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 11/18/2015 05:18'!
functionNamed: aFunctionName ifAbsent: aBlock
	^ functionsByName
		at: aFunctionName
		ifAbsent: aBlock! !

!XPathFunctionSet methodsFor: 'private' stamp: 'monty 1/19/2015 17:08'!
functionsByName
	^ functionsByName! !

!XPathFunctionSet methodsFor: 'comparing' stamp: 'monty 2/12/2017 21:05'!
hash
	^ self species hash bitXor: functionsByName hash! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 1/9/2017 09:48'!
includes: aFunction
	^ (functionsByName
		at: aFunction prototypeName
		ifAbsent: [^ false]) == aFunction! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 4/21/2017 15:12'!
includesFunctionNamed: aFunctionName
	^ functionsByName includesKey: aFunctionName! !

!XPathFunctionSet methodsFor: 'initialization' stamp: 'monty 12/27/2014 17:01'!
initialize: aCapacity
	functionsByName := Dictionary new: aCapacity! !

!XPathFunctionSet methodsFor: 'testing' stamp: 'monty 2/14/2017 01:14'!
isEmpty
	"Squeak's Collection>>#isEmpty is inefficient"
	^ self size = 0! !

!XPathFunctionSet methodsFor: 'copying' stamp: 'monty 12/27/2014 03:55'!
postCopy
	functionsByName := functionsByName copy! !

!XPathFunctionSet methodsFor: 'removing' stamp: 'monty 4/21/2017 15:47'!
remove: aFunction ifAbsent: aBlock
	^ (self includes: aFunction)
		ifTrue: [
			functionsByName
				removeKey: aFunction prototypeName
				ifAbsent: aBlock]
		ifFalse: [aBlock value]! !

!XPathFunctionSet methodsFor: 'removing' stamp: 'monty 2/26/2017 09:31'!
removeAll
	"Redefined because Collection>>#removeAll assumes the collection can
	be safely modified while iterating it with #do:"

	functionsByName removeAll! !

!XPathFunctionSet methodsFor: 'removing' stamp: 'monty 4/21/2017 15:13'!
removeFunctionNamed: aFunctionName
	^ functionsByName removeKey: aFunctionName! !

!XPathFunctionSet methodsFor: 'removing' stamp: 'monty 4/21/2017 15:12'!
removeFunctionNamed: aFunctionName ifAbsent: aBlock
	^ functionsByName
		removeKey: aFunctionName
		ifAbsent: aBlock! !

!XPathFunctionSet methodsFor: 'accessing' stamp: 'monty 12/27/2014 03:59'!
size
	^ functionsByName size! !

!XMLAttributeList methodsFor: '*XPath-Core-private' stamp: 'monty 2/20/2018 17:36'!
attributeAxisSelectName: anAttributeName into: aNodeSet
	| i |

	"Must match anAttributeName exactly.
	We avoid #attributeNodeAt: because it matches names and local
	names, not names exactly, and #attributeValueAt: returns the
	value, not the node"
	(i := self indexOfAttributeValueAt: anAttributeName) > 0
		ifTrue: [
			aNodeSet addLast:
				(self at: i)].
	^ aNodeSet.! !

!BlockClosure methodsFor: '*XPath-Core-converting' stamp: 'monty 2/11/2017 18:28'!
?? aPredicateOrPredicateCollection
	^ XPathNodeTestWithPredicates
		nodeTest: self
		predicates: aPredicateOrPredicateCollection! !

!BlockClosure methodsFor: '*XPath-Core-converting' stamp: 'monty 2/5/2017 16:46'!
asXPathAttributeAxisNodeTest
	^ self! !

!BlockClosure methodsFor: '*XPath-Core-converting' stamp: 'monty 2/5/2017 16:46'!
asXPathNamespaceAxisNodeTest
	^ self! !

!BlockClosure methodsFor: '*XPath-Core-converting' stamp: 'monty 2/4/2017 19:10'!
asXPathNodeTest
	^ XPathBlockNodeTest block: self! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/11/2017 18:29'!
?? aPredicateOrPredicateCollection
	^ XPathNodeTestWithPredicates
		nodeTest: self
		predicates: aPredicateOrPredicateCollection! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/17/2014 14:19'!
asXPath
	^ XPath for: self! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/9/2017 23:19'!
asXPathAttributeAxisNodeTest
	"parse the receiver as a node test where attributes are the principal node type"
	^ (XPathNodeTestParser
		on: self
		for: XPathStringNodeTestParserHandler withAttributePrincipalNodeType) parse! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 14:36'!
asXPathBoolean
	^ self notEmpty! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:47'!
asXPathComparable
	^ XPathStringComparable value: self! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 1/25/2017 11:01'!
asXPathFilterExpressionLocationPathRoot
	XPathTypeException signal: 'Cannot use strings as location path roots'! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/18/2017 02:54'!
asXPathFilterExpressionPredicateRoot
	XPathTypeException signal: 'Cannot filter strings'! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/9/2017 23:20'!
asXPathNamespaceAxisNodeTest
	"parse the receiver as a node test where namespaces are the principal node type"
	^ (XPathNodeTestParser
		on: self
		for: XPathStringNodeTestParserHandler withNamespacePrincipalNodeType) parse! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:46'!
asXPathNodeSet
	XPathTypeException signal: 'Cannot convert strings to node sets'! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/9/2017 23:19'!
asXPathNodeTest
	"parse the receiver as a node test where elements are the principal node type"
	^ (XPathNodeTestParser
		on: self
		for: XPathStringNodeTestParserHandler withElementPrincipalNodeType) parse! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 1/18/2017 09:35'!
asXPathNumber
	^ [(XPathNumberParser
			on: self
			for: XPathFloatNumberParserHandler new) parse]
		on: XPathSyntaxException
		do: [:error | Float nan]! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 15:06'!
asXPathString
	^ self! !

!String methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:19'!
asXPathUnionable
	XPathTypeException signal: 'Cannot union strings'! !

!XMLComment methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self string! !

!XMLCachingAttributeList methodsFor: '*XPath-Core-private' stamp: 'monty 2/20/2018 17:37'!
attributeAxisSelectName: anAttributeName into: aNodeSet
	self attributeNodesByName
		at: anAttributeName
		ifPresent: [:attribute |
			aNodeSet addLast: attribute].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-enumerating' stamp: 'monty 1/16/2015 14:20'!
allNodesReverseDo: aBlock
	self hasChildren
		ifTrue: [self nodes reverseDo: [:each | each allNodesReverseDo: aBlock]].
	aBlock value: self.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:16'!
childAxisAnySatisfy: aNodeTest
	^ self hasChildren
		and: [self nodes anySatisfy: aNodeTest]! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/10/2017 21:51'!
childAxisSelect: aNodeTest at: aPosition into: aNodeSet
	(aPosition > 0
		and: [self hasChildren
			and: [self nodes size >= aPosition]])
		ifFalse: [^ aNodeSet].

	aNodeTest isAnyNodeTest
		ifTrue: [
			aNodeSet addLast:
				(self nodes at: aPosition)]
		ifFalse: [| totalMatched nodeList |
			totalMatched := 0.
			"use to:do: with direct access for speed"
			nodeList := self nodes.
			1 to: nodeList size do: [:i | | node |
				node := nodeList at: i.
				((aNodeTest value: node)
					and: [(totalMatched := totalMatched + 1) = aPosition])
					ifTrue: [
						aNodeSet addLast: node.
						^ aNodeSet]]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:14'!
childAxisSelect: aNodeTest into: aNodeSet
	self hasChildren
		ifTrue: [| nodeList |
			"use to:do: with direct access for speed"
			nodeList := self nodes.
			1 to: nodeList size do: [:i | | node |
				node := nodeList at: i.
				(aNodeTest value: node)
					ifTrue: [aNodeSet addLast: node]]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:16'!
descendantAxisAnySatisfy: aNodeTest
	self descendantNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [^ true]].
	^ false.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 16:51'!
descendantAxisSelect: aNodeTest at: aPosition into: aNodeSet
	| totalMatched |

	aPosition > 0
		ifFalse: [^ aNodeSet].
	totalMatched := 0.
	self descendantNodesDo: [:each |
		((aNodeTest value: each)
			and: [(totalMatched := totalMatched + 1) = aPosition])
			ifTrue: [
				aNodeSet addLast: each.
				^ aNodeSet]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:14'!
descendantAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	self descendantNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTest value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:14'!
descendantAxisSelect: aNodeTest into: aNodeSet
	self descendantNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:17'!
descendantOrSelfAxisAnySatisfy: aNodeTest
	self allNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [^ true]].
	^ false.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 16:51'!
descendantOrSelfAxisSelect: aNodeTest at: aPosition into: aNodeSet
	| totalMatched |

	aPosition > 0
		ifFalse: [^ aNodeSet].
	totalMatched := 0.
	self allNodesDo: [:each |
		((aNodeTest value: each)
			and: [(totalMatched := totalMatched + 1) = aPosition])
			ifTrue: [
				aNodeSet addLast: each.
				^ aNodeSet]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:14'!
descendantOrSelfAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	self allNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTest value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNodeWithChildren methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:14'!
descendantOrSelfAxisSelect: aNodeTest into: aNodeSet
	self allNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 12/20/2014 14:36'!
asXPathBoolean
	^ self! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:47'!
asXPathComparable
	^ XPathBooleanComparable value: self! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 1/25/2017 11:01'!
asXPathFilterExpressionLocationPathRoot
	XPathTypeException signal: 'Cannot use booleans as location path roots'! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 2/18/2017 02:54'!
asXPathFilterExpressionPredicateRoot
	XPathTypeException signal: 'Cannot filter booleans'! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:45'!
asXPathNodeSet
	XPathTypeException signal: 'Cannot convert booleans to node sets'! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 3/3/2015 17:29'!
asXPathNumber
	"Gemstone has TrueClass/FalseClass instead of True/False subclasses,
	so this is implemented in the superclass for portability"
	^ self
		ifTrue: [1.0]
		ifFalse: [0.0]! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 3/3/2015 17:28'!
asXPathString
	"Gemstone has TrueClass/FalseClass instead of True/False subclasses,
	so this is implemented in the superclass for portability"
	^ self
		ifTrue: ['true']
		ifFalse: ['false']! !

!Boolean methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:18'!
asXPathUnionable
	XPathTypeException signal: 'Cannot union booleans'! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:29'!
% aStringOrBlockOrNodeTestWithPredicates
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				parentAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self parentAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:33'!
%% aStringOrBlockOrNodeTestWithPredicates
	"reverse axis, requires sorting"
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				ancestorAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self ancestorAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:33'!
%%~ aStringOrBlockOrNodeTestWithPredicates
	"reverse axis, requires sorting"
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:29'!
/ aStringOrBlockOrNodeTestWithPredicates
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				childAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self childAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/11/2017 18:21'!
// aStringOrBlockOrNodeTestWithPredicates
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				descendantAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self descendantAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 2/11/2017 18:21'!
//~ aStringOrBlockOrNodeTestWithPredicates
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				descendantOrSelfAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self descendantOrSelfAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:33'!
<< aStringOrBlockOrNodeTestWithPredicates
	"reverse axis, requires sorting"
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				precedingAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self precedingAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:33'!
<<< aStringOrBlockOrNodeTestWithPredicates
	"reverse axis, requires sorting"
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				precedingSiblingAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self precedingSiblingAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:29'!
>> aStringOrBlockOrNodeTestWithPredicates
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				followingAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self followingAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:30'!
>>> aStringOrBlockOrNodeTestWithPredicates
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				followingSiblingAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self followingSiblingAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:30'!
@ aStringOrBlockOrNodeTestWithPredicates
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				attributeAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self attributeAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/16/2017 17:53'!
@@ aStringOrBlockOrNodeTestWithPredicates
	"Returns the attribute value string of the first matching attribute of the
	receiver or an empty string if there isn't one."

	^ (self @ aStringOrBlockOrNodeTestWithPredicates) stringValue! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 1/16/2015 14:18'!
allNodesReverseDo: aBlock
	aBlock value: self! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 19:08'!
ancestorAxis: aNodeTestStringOrBlock
	^ (self
		ancestorAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathReverseDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/10/2017 23:10'!
ancestorAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				ancestorAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathReverseDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self ancestorAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 19:24'!
ancestorAxisAnySatisfy: aNodeTest
	self ancestorNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [^ true]].
	^ false.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 14:10'!
ancestorAxisSelect: aNodeTest at: aPosition into: aNodeSet
	| totalMatched |

	aPosition > 0
		ifFalse: [^ aNodeSet].
	totalMatched := 0.
	self ancestorNodesDo: [:each |
		((aNodeTest value: each)
			and: [(totalMatched := totalMatched + 1) = aPosition])
			ifTrue: [
				aNodeSet addLast: each.
				^ aNodeSet]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
ancestorAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	self ancestorNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTest value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
ancestorAxisSelect: aNodeTest into: aNodeSet
	self ancestorNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 19:08'!
ancestorOrSelfAxis: aNodeTestStringOrBlock
	^ (self
		ancestorOrSelfAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathReverseDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/10/2017 23:10'!
ancestorOrSelfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				ancestorOrSelfAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathReverseDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self ancestorOrSelfAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 19:24'!
ancestorOrSelfAxisAnySatisfy: aNodeTest
	self withAncestorNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [^ true]].
	^ false.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 14:10'!
ancestorOrSelfAxisSelect: aNodeTest at: aPosition into: aNodeSet
	| totalMatched |

	aPosition > 0
		ifFalse: [^ aNodeSet].
	totalMatched := 0.
	self withAncestorNodesDo: [:each |
		((aNodeTest value: each)
			and: [(totalMatched := totalMatched + 1) = aPosition])
			ifTrue: [
				aNodeSet addLast: each.
				^ aNodeSet]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 04:42'!
ancestorOrSelfAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	self withAncestorNodesDo: [:each|
		((aNodeSet includes: each) not
			and: [aNodeTest value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 04:42'!
ancestorOrSelfAxisSelect: aNodeTest into: aNodeSet
	self withAncestorNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:40'!
asXPathBoolean
	XPathTypeException signal: 'Cannot convert nodes to booleans'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:52'!
asXPathComparable
	XPathTypeException signal: 'Cannot compare nodes'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 1/25/2017 11:01'!
asXPathFilterExpressionLocationPathRoot
	^ self! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/18/2017 02:54'!
asXPathFilterExpressionPredicateRoot
	XPathTypeException signal: 'Cannot filter nodes'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:45'!
asXPathNodeSet
	XPathTypeException signal: 'Cannot convert nodes to node sets'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:41'!
asXPathNumber
	XPathTypeException signal: 'Cannot convert nodes to numbers'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:44'!
asXPathString
	XPathTypeException signal: 'Cannot convert nodes to strings'! !

!XMLNode methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:20'!
asXPathUnionable
	XPathTypeException signal: 'Cannot union nodes'! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:30'!
attributeAxis: aNodeTestStringOrBlock
	^ (self
		attributeAxisSelect: aNodeTestStringOrBlock asXPathAttributeAxisNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathLevelDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:40'!
attributeAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				attributeAxisSelect:
					aNodeTestStringOrBlock asXPathAttributeAxisNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathLevelDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self attributeAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:24'!
attributeAxisAnySatisfy: anAttributeNodeTest
	^ false! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 14:11'!
attributeAxisSelect: anAttributeNodeTest at: aPosition into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
attributeAxisSelect: anAttributeNodeTest into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:31'!
childAxis: aNodeTestStringOrBlock
	^ (self
		childAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathLevelDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:40'!
childAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				childAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathLevelDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self childAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:21'!
childAxisAnySatisfy: aNodeTest
	^ false! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 14:19'!
childAxisSelect: aNodeTest at: aPosition into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
childAxisSelect: aNodeTest into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 19:08'!
descendantAxis: aNodeTestStringOrBlock
	^ (self
		descendantAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/10/2017 23:10'!
descendantAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				descendantAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self descendantAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:21'!
descendantAxisAnySatisfy: aNodeTest
	^ false! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 16:52'!
descendantAxisSelect: aNodeTest at: aPosition into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
descendantAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
descendantAxisSelect: aNodeTest into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 19:08'!
descendantOrSelfAxis: aNodeTestStringOrBlock
	^ (self
		descendantOrSelfAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/10/2017 23:10'!
descendantOrSelfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				descendantOrSelfAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self descendantOrSelfAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:21'!
descendantOrSelfAxisAnySatisfy: aNodeTest
	^ aNodeTest value: self! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 16:53'!
descendantOrSelfAxisSelect: aNodeTest at: aPosition into: aNodeSet
	(aPosition = 1
		and: [aNodeTest value: self])
		ifTrue: [aNodeSet addLast: self].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
descendantOrSelfAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	((aNodeSet includes: self) not
		and: [aNodeTest value: self])
		ifTrue: [aNodeSet addLast: self].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
descendantOrSelfAxisSelect: aNodeTest into: aNodeSet
	(aNodeTest value: self)
		ifTrue: [aNodeSet addLast: self].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 19:08'!
followingAxis: aNodeTestStringOrBlock
	^ (self
		followingAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/10/2017 23:10'!
followingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				followingAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self followingAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:23'!
followingAxisAnySatisfy: aNodeTest
	self followingNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [^ true]].
	^ false.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 18:22'!
followingAxisSelect: aNodeTest at: aPosition into: aNodeSet
	| totalMatched |

	aPosition > 0
		ifFalse: [^ aNodeSet].
	totalMatched := 0.
	self followingNodesDo: [:each |
		((aNodeTest value: each)
			and: [(totalMatched := totalMatched + 1) = aPosition])
			ifTrue: [
				aNodeSet addLast: each.
				^ aNodeSet]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
followingAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	self followingNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTest value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
followingAxisSelect: aNodeTest into: aNodeSet
	self followingNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 2/19/2017 23:19'!
followingNodes
	"returns a node list with all following sibling or descendant nodes
	of the receiver"
	| following |

	following := self newListForSelect.
	self followingNodesDo: [:each |
		following addLast: each].
	^ following.! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:42'!
followingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodesDo: [:each |
				visitedSelf
					ifTrue: [each allNodesDo: aBlock]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:31'!
followingSiblingAxis: aNodeTestStringOrBlock
	^ (self
		followingSiblingAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathLevelDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:40'!
followingSiblingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				followingSiblingAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathLevelDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self followingSiblingAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:22'!
followingSiblingAxisAnySatisfy: aNodeTest
	self followingSiblingNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [^ true]].
	^ false.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 18:22'!
followingSiblingAxisSelect: aNodeTest at: aPosition into: aNodeSet
	| totalMatched |

	aPosition > 0
		ifFalse: [^ aNodeSet].
	totalMatched := 0.
	self followingSiblingNodesDo: [:each |
		((aNodeTest value: each)
			and: [(totalMatched := totalMatched + 1) = aPosition])
			ifTrue: [
				aNodeSet addLast: each.
				^ aNodeSet]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
followingSiblingAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	self followingSiblingNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTest value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:16'!
followingSiblingAxisSelect: aNodeTest into: aNodeSet
	self followingSiblingNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 2/19/2017 23:19'!
followingSiblingNodes
	"returns a node list with all following sibling nodes of the receiver"
	| followingSiblings |

	followingSiblings := self newListForSelect.
	self followingSiblingNodesDo: [:each |
		followingSiblings addLast: each].
	^ followingSiblings.! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:42'!
followingSiblingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodesDo: [:each |
				visitedSelf
					ifTrue: [aBlock value: each]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:38'!
hasExpandedName
	^ false! !

!XMLNode methodsFor: '*XPath-Core-testing' stamp: 'monty 1/29/2015 00:39'!
isNamespace
	^ false! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:31'!
namespaceAxis: aNodeTestStringOrBlock
	^ (self
		namespaceAxisSelect: aNodeTestStringOrBlock asXPathNamespaceAxisNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathLevelDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:39'!
namespaceAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				namespaceAxisSelect:
					aNodeTestStringOrBlock asXPathNamespaceAxisNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathLevelDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self namespaceAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 23:50'!
namespaceAxisAnySatisfy: aNamespaceNodeTest
	^ false! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 23:50'!
namespaceAxisSelect: aNamespaceNodeTest at: aPosition into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:15'!
namespaceAxisSelect: aNamespaceNodeTest into: aNodeSet
	^ aNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 6/30/2015 05:10'!
nodeSetClass
	^ XPathNodeSet! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:31'!
parentAxis: aNodeTestStringOrBlock
	^ (self
		parentAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			"the spec says this is a forawrd axis"
			sortOrder: XPathLevelDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:39'!
parentAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				parentAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					"the spec says this is a forawrd axis"
					sortOrder: XPathLevelDocumentSortOrder new;
					filterEachInSeparateContextWithAll: aPredicateCollection
						startingAt: 2]
		ifFalse: [
			^ (self parentAxis: aNodeTestStringOrBlock)
				filterEachInSeparateContextWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:23'!
parentAxisAnySatisfy: aNodeTest
	^ self hasParent
		and: [aNodeTest value: self parent]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 16:55'!
parentAxisSelect: aNodeTest at: aPosition into: aNodeSet
	(aPosition = 1
		and: [self hasParent
			and: [aNodeTest value: self parent]])
		ifTrue: [aNodeSet addLast: self parent].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:16'!
parentAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	(self hasParent
		and: [(aNodeSet includes: self parent) not
			and: [aNodeTest value: self parent]])
		ifTrue: [aNodeSet addLast: self parent].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:16'!
parentAxisSelect: aNodeTest into: aNodeSet
	(self hasParent
		and: [aNodeTest value: self parent])
		ifTrue: [aNodeSet addLast: self parent].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 19:08'!
precedingAxis: aNodeTestStringOrBlock
	^ (self
		precedingAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathReverseDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/10/2017 23:10'!
precedingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				precedingAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathReverseDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self precedingAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:22'!
precedingAxisAnySatisfy: aNodeTest
	self precedingNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [^ true]].
	^ false.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 18:23'!
precedingAxisSelect: aNodeTest at: aPosition into: aNodeSet
	| totalMatched |

	aPosition > 0
		ifFalse: [^ aNodeSet].
	totalMatched := 0.
	self precedingNodesDo: [:each |
		((aNodeTest value: each)
			and: [(totalMatched := totalMatched + 1) = aPosition])
			ifTrue: [
				aNodeSet addLast: each.
				^ aNodeSet]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:16'!
precedingAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	self precedingNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTest value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:16'!
precedingAxisSelect: aNodeTest into: aNodeSet
	self precedingNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 2/19/2017 07:02'!
precedingNodes
	"returns a node list with all preceding sibling or descendant nodes
	of the receiver"
	| preceding |

	preceding := self newListForSelect.
	self precedingNodesDo: [:each |
		preceding addLast: each].
	^ preceding.! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:43'!
precedingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodes reverseDo: [:each |
				visitedSelf
					ifTrue: [each allNodesReverseDo: aBlock]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:32'!
precedingSiblingAxis: aNodeTestStringOrBlock
	^ (self
		precedingSiblingAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathLevelReverseDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:39'!
precedingSiblingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				precedingSiblingAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathLevelReverseDocumentSortOrder new;
					filterWithAll: aPredicateCollection startingAt: 2]
		ifFalse: [
			^ (self precedingSiblingAxis: aNodeTestStringOrBlock)
				filterWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:22'!
precedingSiblingAxisAnySatisfy: aNodeTest
	self precedingSiblingNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [^ true]].
	^ false.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 18:23'!
precedingSiblingAxisSelect: aNodeTest at: aPosition into: aNodeSet
	| totalMatched |

	aPosition > 0
		ifFalse: [^ aNodeSet].
	totalMatched := 0.
	self precedingSiblingNodesDo: [:each |
		((aNodeTest value: each)
			and: [(totalMatched := totalMatched + 1) = aPosition])
			ifTrue: [
				aNodeSet addLast: each.
				^ aNodeSet]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:16'!
precedingSiblingAxisSelect: aNodeTest ifNotPresentInto: aNodeSet
	self precedingSiblingNodesDo: [:each |
		((aNodeSet includes: each) not
			and: [aNodeTest value: each])
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:16'!
precedingSiblingAxisSelect: aNodeTest into: aNodeSet
	self precedingSiblingNodesDo: [:each |
		(aNodeTest value: each)
			ifTrue: [aNodeSet addLast: each]].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 2/19/2017 07:02'!
precedingSiblingNodes
	"returns a node list with all preceding sibling nodes of the receiver"
	| precedingSiblings |

	precedingSiblings := self newListForSelect.
	self precedingSiblingNodesDo: [:each |
		precedingSiblings addLast: each].
	^ precedingSiblings.! !

!XMLNode methodsFor: '*XPath-Core-enumerating' stamp: 'monty 2/4/2015 06:43'!
precedingSiblingNodesDo: aBlock
	self hasParent
		ifTrue: [| visitedSelf |
			visitedSelf := false.
			self parent nodes reverseDo: [:each |
				visitedSelf
					ifTrue: [aBlock value: each]
					ifFalse: [
						each = self
							ifTrue: [visitedSelf := true]]]]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:31'!
selfAxis: aNodeTestStringOrBlock
	^ (self
		selfAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
		into: self nodeSetClass new)
			sortOrder: XPathLevelDocumentSortOrder new! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 3/15/2017 17:39'!
selfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	(aPredicateCollection notEmpty
		and: [aPredicateCollection first isNumber])
		ifTrue: [
			^ (self
				selfAxisSelect: aNodeTestStringOrBlock asXPathNodeTest
				at: aPredicateCollection first asXPathNodeSetPosition
				into: self nodeSetClass new)
					sortOrder: XPathLevelDocumentSortOrder new;
					filterEachInSeparateContextWithAll: aPredicateCollection
						startingAt: 2]
		ifFalse: [
			^ (self selfAxis: aNodeTestStringOrBlock)
				filterEachInSeparateContextWithAll: aPredicateCollection]! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 20:22'!
selfAxisAnySatisfy: aNodeTest
	^ aNodeTest value: self! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 16:55'!
selfAxisSelect: aNodeTest at: aPosition into: aNodeSet
	(aPosition = 1
		and: [aNodeTest value: self])
		ifTrue: [aNodeSet addLast: self].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:16'!
selfAxisSelect: aNodeTest into: aNodeSet
	(aNodeTest value: self)
		ifTrue: [aNodeSet addLast: self].
	^ aNodeSet.! !

!XMLNode methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	"returns XPath node string-value"
	 ^ ''! !

!XMLNode methodsFor: '*XPath-Core-private' stamp: 'monty 2/6/2017 04:42'!
withAncestorNodesDo: aBlock
	aBlock value: self.
	self ancestorNodesDo: aBlock.! !

!XMLNode methodsFor: '*XPath-Core-deprecated' stamp: 'monty 3/20/2017 15:45'!
xPath: anXPathOrXPathExpressionSourceString
	"deprecated alternate spelling;
	will be supported indefinitely for backwards compatibility"

	^ self xpath: anXPathOrXPathExpressionSourceString! !

!XMLNode methodsFor: '*XPath-Core-deprecated' stamp: 'monty 3/20/2017 15:45'!
xPath: anXPathOrXPathExpressionSourceString context: aContext
	"deprecated alternate spelling;
	will be supported indefinitely for backwards compatibility"

	^ self
		xpath: anXPathOrXPathExpressionSourceString
		context: aContext! !

!XMLNode methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/14/2017 22:25'!
xpath: anXPathOrXPathExpressionSourceString
	^ anXPathOrXPathExpressionSourceString asXPath in: self! !

!XMLNode methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/14/2017 22:25'!
xpath: anXPathOrXPathExpressionSourceString context: aContext
	^ anXPathOrXPathExpressionSourceString asXPath
		in: self
		context: aContext! !

!XMLNode methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:30'!
~ aStringOrBlockOrNodeTestWithPredicates
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				selfAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self selfAxis: aStringOrBlockOrNodeTestWithPredicates]! !

XMLNode subclass: #XPathNamespaceNode
	instanceVariableNames: 'name uri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNamespaceNode commentStamp: 'monty 2/12/2017 21:09' prior: 0!
This class models an element namespace prefix and URI mapping as a DOM node for compatibility with the XPath standard. Namespace nodes are equal only if they have the same name, namespace URI, and belong to the same element.!

!XPathNamespaceNode class methodsFor: 'instance creation' stamp: 'monty 3/22/2015 02:55'!
element: anElement name: aPrefix uri: aURI
	^ self new
		setElement: anElement
		name: aPrefix
		uri: aURI! !

!XPathNamespaceNode class methodsFor: 'instance creation' stamp: 'monty 3/10/2015 13:50'!
withXMLNamespaceOnElement: anElement
	^ self
		element: anElement
		name: 'xml'
		uri: XMLNamespaceScope xmlNamespaceURI! !

!XPathNamespaceNode methodsFor: 'comparing' stamp: 'monty 4/9/2015 02:08'!
= anObject
	"This is needed because namespace nodes aren't part of DOM trees
	and are created dynamically by XPath, so unless = is defined the union
	of two node sets could contain duplicate nodes for the same element
	namespace"

	self == anObject
		ifTrue: [^ true].

	self class == anObject class
		ifFalse: [^ false].

	"different elements don't share namespace nodes with the same name/uri
	according to the spec"
	^ self element = anObject element
		and: [self name = anObject name
			and: [self uri = anObject uri]].! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 12/23/2014 15:22'!
element
	^ parent! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:56'!
expandedName
	^ self localName expandWithXMLNamespaceURI: self namespaceURI! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 4/1/2016 17:44'!
hasNamespaceURI
	"spec says namespace nodes cannot be namespaced
	(the namespace part of the expanded name is null)"
	^ false! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 4/1/2016 17:47'!
hasPrefix
	"namespace names cannot be prefixed"
	^ false! !

!XPathNamespaceNode methodsFor: 'comparing' stamp: 'monty 1/25/2018 23:49'!
hash
	^ (self species hash bitXor:
		self name hash) bitXor:
			self uri hash! !

!XPathNamespaceNode methodsFor: 'testing' stamp: 'monty 1/29/2015 00:39'!
isNamespace
	^ true! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/10/2015 13:52'!
localName
	^ self name! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/10/2015 13:52'!
name
	^ name ifNil: [name := '']! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/10/2015 14:14'!
namespaceURI
	"spec says namespace nodes cannot be namespaced
	(the namespace part of the expanded name is null)"
	^ ''! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 4/2/2016 02:40'!
prefix
	"namespace names cannot be prefixed"
	^ ''! !

!XPathNamespaceNode methodsFor: 'initialization' stamp: 'monty 3/22/2015 02:55'!
setElement: anElement name: aPrefix uri: aURI
	"reuse parent inst var, like in XMLAttribute"
	parent := anElement.
	name := aPrefix.
	uri := aURI.! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self uri! !

!XPathNamespaceNode methodsFor: 'accessing' stamp: 'monty 1/26/2015 20:32'!
uri
	^ uri ifNil: [uri := '']! !

!XPathNamespaceNode methodsFor: 'printing' stamp: 'monty 4/12/2017 23:16'!
writeXMLOn: aWriter
	aWriter
		writeXMLNS: self name;
		nextPut: $=;
		writeEscapedContentString: self uri! !

!XMLElement methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 19:57'!
attributeAxisAnySatisfy: anAttributeNodeTest
	self hasAttributes
		ifTrue: [
			^ anAttributeNodeTest isAttributeNodeTestForName
				ifTrue: [self includesAttribute: anAttributeNodeTest name]
				ifFalse: [self attributeNodes anySatisfy: anAttributeNodeTest]]
		ifFalse: [^ false]! !

!XMLElement methodsFor: '*XPath-Core-private' stamp: 'monty 2/20/2018 17:38'!
attributeAxisSelect: anAttributeNodeTest at: aPosition into: aNodeSet
	(aPosition > 0
		and: [self hasAttributes
			and: [self attributeNodes size >= aPosition]])
		ifFalse: [^ aNodeSet].

	anAttributeNodeTest isAnyNodeTest
		ifTrue: [
			aNodeSet addLast:
				(self attributeNodes at: aPosition)]
		ifFalse: [
			anAttributeNodeTest isAttributeNodeTestForName
				ifTrue: [
					"since it's a test for a name, if the position
					is anything other than 1, it can't match"
					aPosition = 1
						ifTrue: [
							self attributeNodes
								attributeAxisSelectName: anAttributeNodeTest name
								into: aNodeSet]]
				ifFalse: [| totalMatched |
					totalMatched := 0.
					self attributeNodesDo: [:each |
						((anAttributeNodeTest value: each)
							and: [(totalMatched := totalMatched + 1) = aPosition])
							ifTrue: [
								aNodeSet addLast: each.
								^ aNodeSet]]]].
	^ aNodeSet.! !

!XMLElement methodsFor: '*XPath-Core-private' stamp: 'monty 2/20/2018 17:34'!
attributeAxisSelect: anAttributeNodeTest into: aNodeSet
	self hasAttributes
		ifTrue: [
			anAttributeNodeTest isAttributeNodeTestForName
				ifTrue: [
					self attributeNodes
						attributeAxisSelectName: anAttributeNodeTest name
						into: aNodeSet]
				ifFalse: [
					self attributeNodesDo: [:each |
						(anAttributeNodeTest value: each)
							ifTrue: [aNodeSet addLast: each]]]].
	^ aNodeSet.! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLElement methodsFor: '*XPath-Core-testing' stamp: 'monty 2/9/2015 22:23'!
hasNamespaceNodes
	"elements have at least one node for the default xml namespace"
	^ self usesNamespaces! !

!XMLElement methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 19:58'!
namespaceAxisAnySatisfy: aNamespaceNodeTest
	^ self hasNamespaces
		and: [self namespaceNodes anySatisfy: aNamespaceNodeTest]! !

!XMLElement methodsFor: '*XPath-Core-private' stamp: 'monty 2/18/2017 23:51'!
namespaceAxisSelect: aNamespaceNodeTest at: aPosition into: aNodeSet
	| totalMatched |

	(self hasNamespaces
		and: [aPosition > 0])
		ifFalse: [^ aNodeSet].
	totalMatched := 0.
	self namespaceNodesDo: [:each |
		((aNamespaceNodeTest value: each)
			and: [(totalMatched := totalMatched + 1) = aPosition])
			ifTrue: [
				aNodeSet addLast: each.
				^ aNodeSet]].
	^ aNodeSet.! !

!XMLElement methodsFor: '*XPath-Core-private' stamp: 'monty 2/4/2017 22:14'!
namespaceAxisSelect: aNamespaceNodeTest into: aNodeSet
	self hasNamespaceNodes
		ifTrue: [
			self namespaceNodesDo: [:each |
				(aNamespaceNodeTest value: each)
					ifTrue: [aNodeSet addLast: each]]].
	^ aNodeSet.! !

!XMLElement methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/26/2015 22:07'!
namespaceNodes
	| namespaceNodes |

	namespaceNodes := self newListForSelect.
	self namespaceNodesDo: [:each | namespaceNodes addLast: each].
	^ namespaceNodes.! !

!XMLElement methodsFor: '*XPath-Core-enumerating' stamp: 'monty 3/26/2015 23:29'!
namespaceNodesDo: aBlock
	"every element has a node for the default xml namespace.
	if it isn't explicitly defined, then it's first in order"
	self usesNamespaces
		ifFalse: [^ self].

	(self hasNamespaces
		and: [self namespaceScope includesPrefix: 'xml'])
		ifFalse: [aBlock value: (XPathNamespaceNode withXMLNamespaceOnElement: self)].

	self hasNamespaces
		ifTrue: [
			self namespaceScope prefixesAndURIsDo: [:prefix :uri |
				aBlock value:
					(XPathNamespaceNode
						element: self
						name: prefix
						uri: uri)]].! !

XMLException subclass: #XPathException
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathException commentStamp: 'monty 12/20/2014 19:26' prior: 0!
A base class for XPath exceptions.!

XPathException subclass: #XPathArgumentNumberException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathArgumentNumberException commentStamp: 'monty 1/18/2015 13:59' prior: 0!
Invoked for function calls with the wrong number of arguments.!

XPathException subclass: #XPathDOMException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathDOMException commentStamp: 'monty 6/11/2015 00:17' prior: 0!
Invoked when node sets are manipulated incorrectly.!

!XPathException methodsFor: 'testing' stamp: 'monty 4/12/2015 07:26'!
hasPosition
	^ position notNil! !

!XPathException methodsFor: 'accessing' stamp: 'monty 9/4/2017 02:52'!
messageText
	^ self hasPosition
		ifTrue: [super messageText, ' (near pos. ', self position asString, ')']
		ifFalse: [super messageText]! !

!XPathException methodsFor: 'accessing' stamp: 'monty 4/11/2015 05:37'!
position
	^ position! !

!XPathException methodsFor: 'accessing' stamp: 'monty 9/29/2017 21:19'!
position: anInteger
	position := anInteger! !

XPathException subclass: #XPathSyntaxException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathSyntaxException commentStamp: 'monty 1/18/2015 13:59' prior: 0!
Invoked for syntax errors in XPath expressions.!

XPathException subclass: #XPathTypeException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathTypeException commentStamp: 'monty 1/18/2015 13:55' prior: 0!
Invoked for type conversion errors.!

XPathException subclass: #XPathUndeclaredFunctionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredFunctionException commentStamp: 'monty 1/18/2015 14:01' prior: 0!
Invoked for undeclared functions.!

XPathException subclass: #XPathUndeclaredPrefixException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredPrefixException commentStamp: 'monty 6/15/2015 00:34' prior: 0!
Invoked for undeclared namespace prefixes used in name tests (only when one or more namespaces are set in the context).!

XPathException subclass: #XPathUndeclaredVariableException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Exceptions'!

!XPathUndeclaredVariableException commentStamp: 'monty 1/18/2015 14:01' prior: 0!
Invoked for undeclared variables.!

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 4/1/2016 00:56'!
expandedName
	^ self localName expandWithXMLNamespaceURI: self namespaceURI! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 2/28/2015 14:13'!
hasNamespaceURI
	^ false! !

!XMLPI methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:58'!
hasPrefix
	^ false! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 14:13'!
localName
	^ self name! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 13:21'!
name
	^ self target! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 13:21'!
namespaceURI
	"The spec says the namespace URI part of a PI expanded name is null"
	^ ''! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/10/2015 14:05'!
prefix
	^ ''! !

!XMLPI methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self data! !

!XMLAttribute methodsFor: '*XPath-Core-testing' stamp: 'monty 12/30/2014 16:39'!
hasExpandedName
	^ true! !

!XMLAttribute methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self value! !

!XMLNodeWithElements methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:30'!
/ aStringOrBlockOrNodeTestWithPredicates
	"redefined here to prevent a conflicting method from the Pastell project
	from shadowing the inherited implementation if Pastell was installed"
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				childAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self childAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XMLNodeWithElements methodsFor: '*XPath-Core-enumerating - axis' stamp: 'monty 3/23/2017 23:31'!
// aStringOrBlockOrNodeTestWithPredicates
	"redefined here to prevent a conflicting method from the Pastell project
	from shadowing the inherited implementation if Pastell was installed"
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				descendantAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self descendantAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XMLNodeWithElements methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	"spec says the string-value of documents and elements is all text
	descendants concatenated, so contentString can't be used because it
	inserts spaces"
	^ self rawContentString! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 1/23/2017 10:48'!
asXPathBoolean
	^ (self isNaN
		or: [self isZero]) not! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:47'!
asXPathComparable
	^ XPathNumberComparable value: self! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 1/25/2017 11:01'!
asXPathFilterExpressionLocationPathRoot
	XPathTypeException signal: 'Cannot use numbers as location path roots'! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/18/2017 02:54'!
asXPathFilterExpressionPredicateRoot
	XPathTypeException signal: 'Cannot filter numbers'! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/23/2016 11:42'!
asXPathNodeSet
	XPathTypeException signal: 'Cannot convert numbers to node sets'! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/26/2017 10:30'!
asXPathNodeSetPosition
	"this catches literal integer predicates used with #??"
	self isInteger
		ifTrue: [^ self].

	"Pharo/Squeak (but not GS) OrderedCollections, which XPathNodeSets
	use internally, round float indexes down to the nearest integer, which is
	not OK because the spec doesn't require it (and LibXML2 doesn't do it), so
	fractional, NaN, and infinite positions all have to be converted to an
	always out-of-bounds index"
	(self isNaN
		or: [self isInfinite])
		ifFalse: [| truncated |
			(truncated := self truncated) = self
				ifTrue: [^ truncated]].

	"always out-of-bounds"
	^ 0.! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 12/23/2014 14:40'!
asXPathNumber
	^ self asFloat! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/2/2017 18:37'!
asXPathString
	"NaN is converted to the string NaN
	positive zero is converted to the string 0
	negative zero is converted to the string 0
	positive infinity is converted to the string Infinity
	negative infinity is converted to the string -Infinity"
	self isNaN
		ifTrue: [^ 'NaN'].
	self isZero
		ifTrue: [^ '0'].
	self isInfinite
		ifTrue: [
			self negative
				ifTrue: [^ '-Infinity']
				ifFalse: [^ 'Infinity']].

	"integers and floats with no fractional part must be printed as integers,
	so 1 and 1.0 are both output as '1' and -1 and -1.0 are output as '-1'"
	self fractionPart isZero
		ifTrue: [
			"#integerPart returns a float, so it can't be used"
			^ self asInteger asString]
		ifFalse: [| printedWithFixedDecimalPlaces end |
			"this portably gives a decimal, not scientific, representation
			of the number (unlike #asString or #printString:base:, which use
			scientific for some floats), but it may have redundant trailing
			zeros that the spec forbids that need to be removed"
			printedWithFixedDecimalPlaces := self printShowingDecimalPlaces: 16.
			end := printedWithFixedDecimalPlaces size.
			[end > 3
				and: [(printedWithFixedDecimalPlaces at: end) == $0
					and: [(printedWithFixedDecimalPlaces at: end - 1) ~~ $.]]]
				whileTrue: [end := end - 1].
			end < printedWithFixedDecimalPlaces size
				ifTrue: [
					"avoid #first: for portability"
					^ printedWithFixedDecimalPlaces
						copyFrom: 1
						to: end]
				ifFalse: [^ printedWithFixedDecimalPlaces]].! !

!Number methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 10:19'!
asXPathUnionable
	XPathTypeException signal: 'Cannot union numbers'! !

!Number methodsFor: '*XPath-Core-testing' stamp: 'monty 1/27/2017 12:01'!
hasSameXPathSignAs: aNumber
	"#sign/#sign: do not behave consistently across Pharo/Squeak/GS"
	^ (self negative
		or: [self isXPathNegativeZero]) =
			(aNumber negative
				or: [aNumber isXPathNegativeZero])! !

!Number methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/14/2017 22:29'!
xpathCeiling
	"'The ceiling function returns the smallest (closest to negative infinity)
	number that is not less than the argument and that is an integer.'
	(The spec doesn't say how to handle NaN and infinity; LibXML2 returns NaN.)"
	(self isNaN
		or: [self isInfinite])
		ifTrue: [^ Float nan]
		ifFalse: [^ self ceiling]! !

!Number methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/14/2017 22:29'!
xpathDivision: aDivisor
	self isNaN
		ifTrue: [^ self].

	aDivisor isZero
		ifTrue: [
			self isZero
				ifTrue: [^ Float nan].
			"if the signs are different, the result should be negative infinity"
			(self hasSameXPathSignAs: aDivisor)
				ifTrue: [^ Float infinity]
				ifFalse: [^ Float xpathNegativeInfinity]].

	^ self / aDivisor.! !

!Number methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/14/2017 22:29'!
xpathFloor
	"'The floor function returns the largest (closest to positive infinity)
	number that is not greater than the argument and that is an integer.'
	(The spec doesn't say how to handle NaN and infinity; LibXML2 returns NaN.)"
	(self isNaN
		or: [self isInfinite])
		ifTrue: [^ Float nan]
		ifFalse: [^ self floor]! !

!Number methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/14/2017 22:29'!
xpathModulus: aDivisor
	| modulus |

	"XPath modulus must take the sign of the receiver unlike #// which
	takes the sign of the argument"
	modulus := self - ((self xpathDivision: aDivisor) xpathFloor * aDivisor).
	(modulus hasSameXPathSignAs: self)
		ifTrue: [^ modulus]
		ifFalse: [^ modulus negated].! !

!Number methodsFor: '*XPath-Core-evaluating' stamp: 'monty 3/14/2017 22:29'!
xpathRounded
	| rounded |

	(self isNaN
		or: [self isZero
			or: [self isInfinite]])
		ifTrue: [^ self].

	((rounded := (self + 0.5) xpathFloor) isZero
		and: [self negative])
		ifTrue: [^ Float xpathNegativeZero]
		ifFalse: [^ rounded].! !

!Float class methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/14/2017 22:29'!
xpathNegativeInfinity
	"older Pharo/Squeak images don't have #negativeInfinity, so this is used instead"
	^ self infinity negated! !

!Float class methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/14/2017 22:29'!
xpathNegativeZero
	"Pharo3's OpalCompiler doesn't correctly compile some methods
	with -0.0 literals"
	^ 0.0 negated! !

!Object methodsFor: '*XPath-Core-testing' stamp: 'monty 3/20/2017 22:56'!
isXPathNodeSet
	^ false! !

!Object methodsFor: '*XPath-Core-testing' stamp: 'monty 2/11/2017 18:09'!
isXPathNodeTestWithPredicates
	^ false! !

Object subclass: #XPath
	instanceVariableNames: 'compiledExpression expressionSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

XPath class
	instanceVariableNames: 'compiledExpressionCacheEnabled compiledExpressionCache'!

!XPath commentStamp: 'monty 3/20/2017 17:14' prior: 0!
This class evaluates XPath expressions in the context of XMLNodes with optional custom context objects to control evaluation. It supports complete XPath 1.0 syntax with extensions.

Basic usage:
	| doc path result context |
	doc := XMLDOMParser parse: '<test>test</test>'.
	path := XPath for: '/test'.
	result := path in: doc.

	"with a custom context"
	path := XPath for: '/*[name() = $name]'.
	context :=  XPathContext new.
	context
		variableAt: 'name'
		put: 'test'.
	result :=
		path
			in: doc
			context: context.

The syntax extensions are:
- Prefix wildcards in name tests like "*:name"
- Expanded name tests like "Q{namespaceURI}localName" that allow easier namespace testing 
- The element(), attribute(), and namespace() type tests that can also have embedded name tests like "element(name)"

Unlike standard XPath, by default prefixes in node tests are matched against literal prefixes of nodes, so you don't need to declare prefixes in the context before using them in node tests. Declaring at least one prefix triggers standard behavior. See XPathContext for more.

XPath expressions can be encoded directly in Smalltalk using special binary selectors on XMLNodes and  XMLNodeSets:
	xmlNode // 'entry' / '*' / 'link' @ 'href'.

Block or position predicates can be applied with ?? to axis node test arguments or to result node sets. This returns the first element of each 'entry' descendant:
	xmlNode // 'entry' / ('*' ?? 1).

These return the first (document order) element of the first (document order) 'entry' descendant:
	(xmlNode // 'entry' / '*') ?? 1.
	xmlNode // 'entry' / '*' ?? 1. "same"

Block predicates take upto three arguments, the context node, context position, and context size. This returns the 2nd-5th 'link' elements of all descendant 'entry' elements with no more than 5 'link' elements:
	xmlNode // 'entry' //
		('link' ?? [:node :position :size |
				position >= 2
					and: [size <= 5]]).

Multiple predicates are supported by chaining ?? or using collection arguments. These return the first 'content' element with children of each 'entry' descendant:
	xmlNode // 'entry' //
		('content'
			?? [:node | node hasChildren]
			?? 1).
	xmlNode // 'entry' //
		('content' ?? {[:node | node hasChildren]. 1})!

XPath class
	instanceVariableNames: 'compiledExpressionCacheEnabled compiledExpressionCache'!

!XPath class methodsFor: 'clearing' stamp: 'monty 2/10/2017 20:02'!
clearCompiledExpressionCache
	"self clearCompiledExpressionCache"
	compiledExpressionCache
		ifNotNil: [compiledExpressionCache clear]! !

!XPath class methodsFor: 'private' stamp: 'monty 2/10/2017 20:00'!
compiledExpressionCache
	^ compiledExpressionCache
		ifNil: [compiledExpressionCache := XMLKeyValueCache maxSize: 512]! !

!XPath class methodsFor: 'accessing' stamp: 'monty 2/10/2017 20:01'!
compiledExpressionCacheAt: anExpressionSourceString
	^ self compiledExpressionCache
		at: anExpressionSourceString
		ifAbsent: [nil]! !

!XPath class methodsFor: 'accessing' stamp: 'monty 2/10/2017 20:01'!
compiledExpressionCacheAt: anExpressionSourceString ifAbsent: aBlock
	^ self compiledExpressionCache
		at: anExpressionSourceString
		ifAbsent: aBlock! !

!XPath class methodsFor: 'accessing' stamp: 'monty 2/10/2017 20:01'!
compiledExpressionCacheAt: anExpressionSourceString ifAbsentPut: aBlock
	^ self compiledExpressionCache
		at: anExpressionSourceString
		ifAbsentPut: aBlock! !

!XPath class methodsFor: 'accessing' stamp: 'monty 2/10/2017 20:01'!
compiledExpressionCacheAt: anExpressionSourceString put: aCompiledXPath
	^ self compiledExpressionCache
		at: anExpressionSourceString
		put: aCompiledXPath! !

!XPath class methodsFor: 'testing' stamp: 'monty 2/10/2017 20:00'!
compiledExpressionCacheEnabled
	^ compiledExpressionCacheEnabled
		ifNil: [compiledExpressionCacheEnabled := true]! !

!XPath class methodsFor: 'accessing' stamp: 'monty 10/25/2017 11:25'!
compiledExpressionCacheEnabled: aBoolean
	"This can be used to disable the XPath compiled expression cache"

	(compiledExpressionCacheEnabled := aBoolean)
		ifFalse: [self clearCompiledExpressionCache]! !

!XPath class methodsFor: 'instance creation' stamp: 'monty 2/10/2017 20:05'!
for: anExpressionSourceString
	^ self new expressionSource: anExpressionSourceString
! !

!XPath class methodsFor: 'evaluating' stamp: 'monty 10/25/2017 07:26'!
for: anExpressionSourceString in: aNode
	"Evaluates the XPath expression anExpressionSourceString with aNode
	as the initial context node"

	^ (self for: anExpressionSourceString)
		in: aNode
! !

!XPath class methodsFor: 'evaluating' stamp: 'monty 10/25/2017 07:26'!
for: anExpressionSourceString in: aNode context: aContext
	"Evaluates the XPath expression anExpressionSourceString with aNode
	as the initial context node and aContext as the controlling
	XPathContext object"

	^ (self for: anExpressionSourceString)
		in: aNode
		context: aContext! !

!XPath class methodsFor: 'class initialization' stamp: 'monty 5/15/2017 21:08'!
initialize
	"self initialize"

	"reset to nil instead of just clearing to get full reinitialization"
	compiledExpressionCache := nil! !

XPath initialize!

!XPath class methodsFor: 'accessing' stamp: 'monty 2/10/2017 20:00'!
maxCachedCompiledExpressions
	^ self compiledExpressionCache maxSize! !

!XPath class methodsFor: 'accessing' stamp: 'monty 2/10/2017 20:01'!
maxCachedCompiledExpressions: anInteger
	self compiledExpressionCache maxSize: anInteger! !

!XPath methodsFor: 'converting' stamp: 'monty 1/17/2015 04:38'!
asXPath
	^ self! !

!XPath methodsFor: 'compiling' stamp: 'monty 2/10/2017 20:18'!
compileExpression
	self compileExpressionWith: self compilerClass new! !

!XPath methodsFor: 'compiling' stamp: 'monty 3/2/2017 20:42'!
compileExpressionWith: anExpressionCompiler
	compiledExpression :=
		anExpressionCompiler compileExpression: self expressionSource.
	self class compiledExpressionCacheEnabled
		ifTrue: [
			self class
				compiledExpressionCacheAt: self expressionSource
				put: compiledExpression].! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/10/2017 20:17'!
compiledExpression
	^ compiledExpression
		ifNil: [| cachedCompiledXPath |
			(self class compiledExpressionCacheEnabled
				and: [
					"avoid #compiledXPathCacheAt:ifAbsent: and
					#compiledXPathCacheAt:ifAbsentPut: here so the cache isn't
					locked during compilation, which could stall other processes"
					(cachedCompiledXPath :=
						self class compiledExpressionCacheAt:
							self expressionSource) notNil])
				ifTrue: [compiledExpression := cachedCompiledXPath]
				ifFalse: [self compileExpression].
			compiledExpression]! !

!XPath methodsFor: 'defaults' stamp: 'monty 2/10/2017 19:57'!
compilerClass
	^ XPathExpressionCompiler! !

!XPath methodsFor: 'defaults' stamp: 'monty 1/19/2015 08:26'!
contextClass
	^ XPathContext! !

!XPath methodsFor: 'evaluating' stamp: 'monty 10/25/2017 07:27'!
evaluate
	"Used to evaluate expressions that don't need a context node
	(Mostly for testing)"

	^ self in: nil! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/10/2017 19:54'!
expressionSource
	^ expressionSource! !

!XPath methodsFor: 'accessing' stamp: 'monty 2/10/2017 20:05'!
expressionSource: anExpressionSourceString
	expressionSource := anExpressionSourceString.
	compiledExpression := nil.! !

!XPath methodsFor: 'evaluating' stamp: 'monty 10/25/2017 07:23'!
in: aNode
	"Evaluates the XPath expression with aNode as the initial context node"

	^ self
		in: aNode
		context: self contextClass new! !

!XPath methodsFor: 'evaluating' stamp: 'monty 10/25/2017 07:27'!
in: aNode context: aContext
	"Evaluates the XPath expression with aNode as the initial context node
	and aContext as the controlling XPathContext object"

	^ self compiledExpression
		evaluateInNode: aNode
		withContext: aContext! !

!XPath methodsFor: 'printing' stamp: 'monty 3/10/2018 22:57'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		print: self expressionSource;
		nextPut: $).! !

Object subclass: #XPathASTNode
	instanceVariableNames: 'parent type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNode commentStamp: 'monty 2/2/2017 20:06' prior: 0!
This is a base class for XPath AST nodes. It has testing messages, messages to access the parent, and a stub node visitor accepting method.

XPath ASTs can be printed as XPath source using #printOn: or #asString.!

XPathASTNode subclass: #XPathASTFunctionCallNode
	instanceVariableNames: 'name arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTFunctionCallNode commentStamp: 'monty 1/25/2017 12:02' prior: 0!
This is an AST node class for function calls. Instances have a function name and zero or more argument AST nodes.!

!XPathASTFunctionCallNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 18:58'!
name: aName
	^ self new name: aName! !

!XPathASTFunctionCallNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitFunctionCall: self! !

!XPathASTFunctionCallNode methodsFor: 'adding' stamp: 'monty 1/2/2017 20:40'!
addArgument: aNode
	^ self arguments addLast: aNode! !

!XPathASTFunctionCallNode methodsFor: 'accessing' stamp: 'monty 1/1/2017 05:44'!
arguments
	^ arguments ifNil: [arguments := OrderedCollection new]! !

!XPathASTFunctionCallNode methodsFor: 'accessing' stamp: 'monty 1/2/2017 20:39'!
arguments: aCollection
	arguments := aCollection asOrderedCollection! !

!XPathASTFunctionCallNode methodsFor: 'enumerating' stamp: 'monty 1/11/2017 13:31'!
argumentsDo: aBlock
	self arguments do: aBlock! !

!XPathASTFunctionCallNode methodsFor: 'testing' stamp: 'monty 1/11/2017 03:12'!
hasArguments
	^ arguments notNil
		and: [arguments notEmpty]! !

!XPathASTFunctionCallNode methodsFor: 'testing' stamp: 'monty 1/20/2017 09:39'!
isFalseFunctionCall
	^ self name = 'false'! !

!XPathASTFunctionCallNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isFunctionCall
	^ true! !

!XPathASTFunctionCallNode methodsFor: 'testing' stamp: 'monty 1/20/2017 09:36'!
isLastFunctionCall
	^ self name = 'last'! !

!XPathASTFunctionCallNode methodsFor: 'testing' stamp: 'monty 1/20/2017 09:36'!
isPositionFunctionCall
	^ self name = 'position'! !

!XPathASTFunctionCallNode methodsFor: 'testing' stamp: 'monty 1/20/2017 09:39'!
isTrueFunctionCall
	^ self name = 'true'! !

!XPathASTFunctionCallNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:52'!
name
	^ name ifNil: [name := '']! !

!XPathASTFunctionCallNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:51'!
name: aFunctionName
	name := aFunctionName! !

!XPathASTFunctionCallNode methodsFor: 'removing' stamp: 'monty 1/3/2017 05:33'!
removeArgument: aNode
	^ self arguments remove: aNode! !

!XPathASTFunctionCallNode methodsFor: 'accessing' stamp: 'monty 1/18/2017 15:02'!
totalArguments
	^ arguments
		ifNil: [0]
		ifNotNil: [arguments size]! !

XPathASTNode subclass: #XPathASTLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTLiteralNode commentStamp: 'monty 1/19/2017 11:07' prior: 0!
This is a base class for literal AST nodes, nodes that represent XPath constructs like strings or numbers that are self-evaluating.!

!XPathASTLiteralNode methodsFor: 'converting' stamp: 'monty 3/8/2017 17:06'!
asXPathBoolean
	self subclassResponsibility! !

!XPathASTLiteralNode methodsFor: 'converting' stamp: 'monty 1/18/2017 08:08'!
asXPathNumber
	self subclassResponsibility! !

!XPathASTLiteralNode methodsFor: 'converting' stamp: 'monty 1/18/2017 08:08'!
asXPathString
	self subclassResponsibility! !

!XPathASTLiteralNode methodsFor: 'testing' stamp: 'monty 1/11/2017 15:15'!
isLiteral
	^ true! !

XPathASTLiteralNode subclass: #XPathASTNumberLiteralNode
	instanceVariableNames: 'number xpathString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNumberLiteralNode commentStamp: 'monty 1/20/2017 07:54' prior: 0!
This is an AST node class for number literals.!

!XPathASTNumberLiteralNode class methodsFor: 'instance creation' stamp: 'monty 1/18/2017 06:59'!
number: aNumber
	^ self new number: aNumber! !

!XPathASTNumberLiteralNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNumberLiteral: self! !

!XPathASTNumberLiteralNode methodsFor: 'converting' stamp: 'monty 3/8/2017 17:07'!
asXPathBoolean
	^ self number asXPathBoolean! !

!XPathASTNumberLiteralNode methodsFor: 'converting' stamp: 'monty 1/18/2017 08:15'!
asXPathNumber
	^ self number! !

!XPathASTNumberLiteralNode methodsFor: 'converting' stamp: 'monty 3/14/2017 22:40'!
asXPathString
	^ xpathString ifNil: [xpathString := self number asXPathString]! !

!XPathASTNumberLiteralNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathNumberValueType! !

!XPathASTNumberLiteralNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isNumberLiteral
	^ true! !

!XPathASTNumberLiteralNode methodsFor: 'accessing' stamp: 'monty 1/24/2017 20:27'!
number
	^ number ifNil: [number := 0.0]! !

!XPathASTNumberLiteralNode methodsFor: 'accessing' stamp: 'monty 3/14/2017 22:40'!
number: aNumber
	number := aNumber.
	xpathString := nil.! !

XPathASTLiteralNode subclass: #XPathASTStringLiteralNode
	instanceVariableNames: 'string xpathNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTStringLiteralNode commentStamp: 'monty 1/20/2017 07:57' prior: 0!
This is an AST node class for string literals. The string is stored without quotes.!

!XPathASTStringLiteralNode class methodsFor: 'instance creation' stamp: 'monty 1/18/2017 07:00'!
string: aString
	^ self new string: aString! !

!XPathASTStringLiteralNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitStringLiteral: self! !

!XPathASTStringLiteralNode methodsFor: 'converting' stamp: 'monty 3/8/2017 17:07'!
asXPathBoolean
	^ self string asXPathBoolean! !

!XPathASTStringLiteralNode methodsFor: 'converting' stamp: 'monty 3/14/2017 22:40'!
asXPathNumber
	^ xpathNumber ifNil: [xpathNumber := self string asXPathNumber]! !

!XPathASTStringLiteralNode methodsFor: 'converting' stamp: 'monty 1/18/2017 08:18'!
asXPathString
	^ self string! !

!XPathASTStringLiteralNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:55'!
defaultTypeClass
	^ XPathStringValueType! !

!XPathASTStringLiteralNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isStringLiteral
	^ true! !

!XPathASTStringLiteralNode methodsFor: 'accessing' stamp: 'monty 1/18/2017 06:59'!
string
	^ string ifNil: [string := '']! !

!XPathASTStringLiteralNode methodsFor: 'accessing' stamp: 'monty 3/14/2017 22:40'!
string: aString
	string := aString.
	xpathNumber := nil.! !

XPathASTNode subclass: #XPathASTLocationPathNode
	instanceVariableNames: 'steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTLocationPathNode commentStamp: 'monty 1/20/2017 10:15' prior: 0!
This is a base class for absolute or relative location path AST nodes. Each path can have any number of step nodes.!

XPathASTLocationPathNode subclass: #XPathASTAbsoluteLocationPathNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAbsoluteLocationPathNode commentStamp: 'monty 1/21/2017 07:42' prior: 0!
This is an AST node class for absolute location paths whose root node is the root of the tree the context node is part of.!

!XPathASTAbsoluteLocationPathNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAbsoluteLocationPath: self! !

!XPathASTAbsoluteLocationPathNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAbsoluteLocationPath
	^ true! !

!XPathASTLocationPathNode class methodsFor: 'instance creation' stamp: 'monty 1/22/2017 18:48'!
steps: aStepCollection
	^ self new steps: aStepCollection! !

!XPathASTLocationPathNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitLocationPath: self! !

!XPathASTLocationPathNode methodsFor: 'adding' stamp: 'monty 1/19/2017 11:21'!
addStep: aStep
	^ self steps addLast: (self beParentOf: aStep)! !

!XPathASTLocationPathNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathNodeSetValueType! !

!XPathASTLocationPathNode methodsFor: 'testing' stamp: 'monty 1/11/2017 10:57'!
hasSteps
	^ steps notNil
		and: [steps notEmpty]! !

!XPathASTLocationPathNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isLocationPath
	^ true! !

!XPathASTLocationPathNode methodsFor: 'testing' stamp: 'monty 3/18/2017 06:12'!
isPredicateLocationPath
	^ self hasParent
		and: [self parent isPredicate]! !

!XPathASTLocationPathNode methodsFor: 'removing' stamp: 'monty 1/11/2017 03:51'!
removeStep: aStep
	^ self steps remove: aStep! !

!XPathASTLocationPathNode methodsFor: 'removing' stamp: 'monty 1/23/2017 11:02'!
removeSteps
	^ self steps removeAll! !

!XPathASTLocationPathNode methodsFor: 'accessing' stamp: 'monty 1/11/2017 03:52'!
steps
	^ steps ifNil: [steps := OrderedCollection new]! !

!XPathASTLocationPathNode methodsFor: 'accessing' stamp: 'monty 1/22/2017 18:51'!
steps: aStepCollection
	steps := self beParentOfAll: aStepCollection asOrderedCollection! !

!XPathASTLocationPathNode methodsFor: 'enumerating' stamp: 'monty 1/19/2017 11:10'!
stepsDo: aBlock
	steps
		ifNotNil: [steps do: aBlock]! !

!XPathASTLocationPathNode methodsFor: 'accessing' stamp: 'monty 1/17/2017 10:08'!
totalSteps
	^ steps
		ifNil: [0]
		ifNotNil: [steps size]! !

XPathASTLocationPathNode subclass: #XPathASTRelativeLocationPathNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTRelativeLocationPathNode commentStamp: 'monty 1/25/2017 11:59' prior: 0!
This is an AST node class for relative location paths whose root node is the context node.!

!XPathASTRelativeLocationPathNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitRelativeLocationPath: self! !

!XPathASTRelativeLocationPathNode methodsFor: 'testing' stamp: 'monty 1/4/2017 04:25'!
isRelativeLocationPath
	^ true! !

!XPathASTNode class methodsFor: 'private' stamp: 'monty 1/3/2017 09:42'!
generateTestingMethods
	"self generateTestingMethods"

	self allSubclassesDo: [:each | | selectorString |
		selectorString := 'is', each nameWithoutPrefixAndSuffix.
		each
			compile: selectorString, '
	^ true'
			classified: #testing.
		self
			compile: selectorString, '
	^ false'
			classified: #testing]! !

!XPathASTNode class methodsFor: 'private' stamp: 'monty 1/4/2017 04:05'!
generateVisitingMethods
	"self generateVisitingMethods"

	self allSubclassesDo: [:each | | nameWithoutPrefixAndSuffix |
		nameWithoutPrefixAndSuffix := each nameWithoutPrefixAndSuffix.
		each
			compile: 'acceptNodeVisitor: aNodeVisitor
	aNodeVisitor visit', nameWithoutPrefixAndSuffix, ': self'
			classified: #visiting.
		XPathASTNodeVisitor
			compile:
				'visit', nameWithoutPrefixAndSuffix, ': ',
					((nameWithoutPrefixAndSuffix first isVowel
						and: [(nameWithoutPrefixAndSuffix beginsWith: 'Un') not])
						ifTrue: ['an']
						ifFalse: ['a']), nameWithoutPrefixAndSuffix
			classified: #visiting]! !

!XPathASTNode class methodsFor: 'private' stamp: 'monty 1/4/2017 02:32'!
nameWithoutPrefixAndSuffix
	^ (self name asString allButFirst: 'XPathAST' size)
		allButLast: 'Node' size! !

!XPathASTNode methodsFor: 'visiting' stamp: 'monty 1/21/2017 14:04'!
acceptNodeVisitor: aNodeVisitor
	^ self! !

!XPathASTNode methodsFor: 'converting' stamp: 'monty 3/9/2017 21:24'!
asString
	"returns an XPath source code string for the AST capable of being
	parsed by an XPathExpressionParser, but without potentially truncating
	it like #printString can"

	^ XPathASTSourceWritingNodeVisitor new
		visitNode: self;
		contents! !

!XPathASTNode methodsFor: 'private' stamp: 'monty 1/19/2017 11:21'!
beParentOf: aNode
	aNode parent: self.
	^ aNode.! !

!XPathASTNode methodsFor: 'private' stamp: 'monty 1/19/2017 11:20'!
beParentOfAll: aNodeCollection
	aNodeCollection do: [:each | self beParentOf: each].
	^ aNodeCollection.! !

!XPathASTNode methodsFor: 'defaults' stamp: 'monty 5/15/2017 21:06'!
defaultTypeClass
	^ XPathValueType! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/24/2017 21:44'!
hasParent
	^ parent notNil
		and: [parent isNull not]! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAbsoluteLocationPath
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAdditionExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAdditiveExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAncestorOrSelfStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAncestorStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAndExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/9/2017 06:10'!
isAnyNodeTest
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/17/2017 14:45'!
isArgument
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTest
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForLocalName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForNamespaceURI
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isAttributeNodeTestForNamespaceURIAndLocalName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isAttributeNodeTestForPrefix
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isAttributeNodeTestForPrefixAndLocalName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAttributeStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/12/2017 19:00'!
isBinaryOperatorExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isChildStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isCommentNodeTest
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isDescendantOrSelfStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isDescendantStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isDivisionExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isElementNodeTest
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForLocalName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForNamespaceURI
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForNamespaceURIAndLocalName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForPrefix
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForPrefixAndLocalName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isEqualityExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isEqualsExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/11/2017 11:14'!
isExpressionRoot
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isFilterExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/11/2017 07:18'!
isFilterExpressionLocationPath
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isFilterable
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isFollowingSiblingStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isFollowingStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isFunctionCall
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isGreaterThanExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isGreaterThanOrEqualToExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isLessThanExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isLessThanOrEqualToExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/11/2017 15:15'!
isLiteral
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isLocationPath
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isModulusExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isMultiplicationExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isMultiplicativeExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTest
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForLocalName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isNamespaceNodeTestForNamespaceURI
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForNamespaceURIAndLocalName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isNamespaceNodeTestForPrefix
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isNamespaceNodeTestForPrefixAndLocalName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isNamespaceStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isNegationExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/9/2017 06:11'!
isNodeTest
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/20/2017 07:50'!
isNodeWithExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/20/2017 07:50'!
isNodeWithOtherExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isNotEqualsExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/22/2017 18:40'!
isNull
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isNumberLiteral
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/14/2017 12:26'!
isOperatorExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isOrExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isPINodeTest
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isPINodeTestForName
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isParentStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isPrecedingSiblingStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isPrecedingStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/17/2017 12:48'!
isPredicate
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isRelationalExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/4/2017 04:25'!
isRelativeLocationPath
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isSelfStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isStep
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isStringLiteral
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isSubtractionExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isTextNodeTest
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/12/2017 19:00'!
isUnaryOperatorExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isUnionExpression
	^ false! !

!XPathASTNode methodsFor: 'testing' stamp: 'monty 1/4/2017 09:26'!
isVariableReference
	^ false! !

!XPathASTNode methodsFor: 'accessing' stamp: 'monty 1/24/2017 21:40'!
parent
	^ parent ifNil: [parent := XPathASTNullNode new]! !

!XPathASTNode methodsFor: 'accessing' stamp: 'monty 1/19/2017 11:20'!
parent: aParent
	parent := aParent! !

!XPathASTNode methodsFor: 'printing' stamp: 'monty 3/9/2017 21:34'!
printOn: aStream
	"Prints the full AST on aStream as unabbreviated XPath source code that can
	be parsed by an XPathExpressionParser.

	To get the source code as a string without possible truncation of the
	output, use #asString instead of #printString."

	(XPathASTSourceWritingNodeVisitor on: aStream)
		visitNode: self! !

!XPathASTNode methodsFor: 'accessing' stamp: 'monty 1/30/2017 14:04'!
type
	^ type ifNil: [type := self defaultTypeClass new]! !

!XPathASTNode methodsFor: 'accessing' stamp: 'monty 1/30/2017 14:04'!
type: aType
	type := aType! !

XPathASTNode subclass: #XPathASTNodeTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNodeTestNode commentStamp: 'monty 1/21/2017 07:43' prior: 0!
This is a base class for location path step node test AST node classes.!

XPathASTNodeTestNode subclass: #XPathASTAnyNodeTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAnyNodeTestNode commentStamp: 'monty 1/20/2017 07:58' prior: 0!
This is an AST node class for the 'node()' type test for any node.!

!XPathASTAnyNodeTestNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAnyNodeTest: self! !

!XPathASTAnyNodeTestNode methodsFor: 'testing' stamp: 'monty 1/9/2017 06:09'!
isAnyNodeTest
	^ true! !

!XPathASTAnyNodeTestNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:36'!
nodeType
	^ XPathNodeType new! !

XPathASTNodeTestNode subclass: #XPathASTAttributeNodeTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAttributeNodeTestNode commentStamp: 'monty 1/22/2017 14:55' prior: 0!
This is an AST node class for the 'attribute()' type test or for the '*' type test when the principal node type of the axis is 'attribute'.!

XPathASTAttributeNodeTestNode subclass: #XPathASTAttributeNodeTestForLocalNameNode
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAttributeNodeTestForLocalNameNode commentStamp: 'monty 1/22/2017 14:55' prior: 0!
This is an AST node class for the 'attribute(*:localName)' type test or for the '*:localName' type test when the principal node type of the axis is 'attribute'.!

!XPathASTAttributeNodeTestForLocalNameNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 18:55'!
localName: aLocalName
	^ self new localName: aLocalName! !

!XPathASTAttributeNodeTestForLocalNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:28'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAttributeNodeTestForLocalName: self! !

!XPathASTAttributeNodeTestForLocalNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForLocalName
	^ true! !

!XPathASTAttributeNodeTestForLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:26'!
localName
	^ localName ifNil: [localName := '']! !

!XPathASTAttributeNodeTestForLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:26'!
localName: aLocalName
	localName := aLocalName! !

XPathASTAttributeNodeTestNode subclass: #XPathASTAttributeNodeTestForNameNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAttributeNodeTestForNameNode commentStamp: 'monty 1/22/2017 14:56' prior: 0!
This is an AST node class for the 'attribute(name)' type test or for the 'name' type test when the principal node type of the axis is 'attribute'.!

!XPathASTAttributeNodeTestForNameNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 18:58'!
name: aName
	^ self new name: aName! !

!XPathASTAttributeNodeTestForNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:28'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAttributeNodeTestForName: self! !

!XPathASTAttributeNodeTestForNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForName
	^ true! !

!XPathASTAttributeNodeTestForNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:24'!
name
	^ name ifNil: [name := '']! !

!XPathASTAttributeNodeTestForNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:24'!
name: aName
	name := aName! !

XPathASTAttributeNodeTestNode subclass: #XPathASTAttributeNodeTestForNamespaceURINode
	instanceVariableNames: 'namespaceURI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAttributeNodeTestForNamespaceURINode commentStamp: 'monty 1/22/2017 14:59' prior: 0!
This is an AST node class for the 'attribute(Q{namespaceURI}*)' type test or for the 'Q{namespaceURI}*' type test when the principal node type of the axis is 'attribute'.!

XPathASTAttributeNodeTestForNamespaceURINode subclass: #XPathASTAttributeNodeTestForNamespaceURIAndLocalNameNode
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAttributeNodeTestForNamespaceURIAndLocalNameNode commentStamp: 'monty 1/22/2017 15:00' prior: 0!
This is an AST node class for the 'attribute(Q{namespaceURI}localName)' type test or for the 'Q{namespaceURI}localName' type test when the principal node type of the axis is 'attribute'.!

!XPathASTAttributeNodeTestForNamespaceURIAndLocalNameNode class methodsFor: 'instance creation' stamp: 'monty 2/10/2017 21:56'!
namespaceURI: aURI localName: aLocalName
	^ (self namespaceURI: aURI)
		localName: aLocalName! !

!XPathASTAttributeNodeTestForNamespaceURIAndLocalNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:28'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAttributeNodeTestForNamespaceURIAndLocalName: self! !

!XPathASTAttributeNodeTestForNamespaceURIAndLocalNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isAttributeNodeTestForNamespaceURIAndLocalName
	^ true! !

!XPathASTAttributeNodeTestForNamespaceURIAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:28'!
localName
	^ localName ifNil: [localName := '']! !

!XPathASTAttributeNodeTestForNamespaceURIAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:28'!
localName: aLocalName
	localName := aLocalName! !

!XPathASTAttributeNodeTestForNamespaceURINode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:33'!
namespaceURI: aURI
	^ self new namespaceURI: aURI! !

!XPathASTAttributeNodeTestForNamespaceURINode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:28'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAttributeNodeTestForNamespaceURI: self! !

!XPathASTAttributeNodeTestForNamespaceURINode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForNamespaceURI
	^ true! !

!XPathASTAttributeNodeTestForNamespaceURINode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:27'!
namespaceURI
	^ namespaceURI ifNil: [namespaceURI := '']! !

!XPathASTAttributeNodeTestForNamespaceURINode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:27'!
namespaceURI: aURI
	namespaceURI := aURI! !

XPathASTAttributeNodeTestNode subclass: #XPathASTAttributeNodeTestForPrefixNode
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAttributeNodeTestForPrefixNode commentStamp: 'monty 1/22/2017 15:00' prior: 0!
This is an AST node class for the 'attribute(prefix:*)' type test or for the 'prefix:*' type test when the principal node type of the axis is 'attribute'.!

XPathASTAttributeNodeTestForPrefixNode subclass: #XPathASTAttributeNodeTestForPrefixAndLocalNameNode
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAttributeNodeTestForPrefixAndLocalNameNode commentStamp: 'monty 1/22/2017 15:01' prior: 0!
This is an AST node class for the 'attribute(prefix:localName)' type test or for the 'prefix:localName' type test when the principal node type of the axis is 'attribute'.!

!XPathASTAttributeNodeTestForPrefixAndLocalNameNode class methodsFor: 'instance creation' stamp: 'monty 2/10/2017 21:57'!
prefix: aPrefix localName: aLocalName
	^ (self prefix: aPrefix)
		localName: aLocalName! !

!XPathASTAttributeNodeTestForPrefixAndLocalNameNode methodsFor: 'visiting' stamp: 'monty 1/25/2018 23:23'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAttributeNodeTestForPrefixAndLocalName: self! !

!XPathASTAttributeNodeTestForPrefixAndLocalNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isAttributeNodeTestForPrefixAndLocalName
	^ true! !

!XPathASTAttributeNodeTestForPrefixAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:25'!
localName
	^ localName ifNil: [localName := '']! !

!XPathASTAttributeNodeTestForPrefixAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:25'!
localName: aLocalName
	localName := aLocalName! !

!XPathASTAttributeNodeTestForPrefixNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:35'!
prefix: aPrefix
	^ self new prefix: aPrefix! !

!XPathASTAttributeNodeTestForPrefixNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:29'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAttributeNodeTestForPrefix: self! !

!XPathASTAttributeNodeTestForPrefixNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isAttributeNodeTestForPrefix
	^ true! !

!XPathASTAttributeNodeTestForPrefixNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:24'!
prefix
	^ prefix ifNil: [prefix := '']! !

!XPathASTAttributeNodeTestForPrefixNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:25'!
prefix: aPrefix
	prefix := aPrefix! !

!XPathASTAttributeNodeTestNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:28'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAttributeNodeTest: self! !

!XPathASTAttributeNodeTestNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTest
	^ true! !

!XPathASTAttributeNodeTestNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:34'!
nodeType
	^ XPathAttributeNodeType new! !

XPathASTNodeTestNode subclass: #XPathASTCommentNodeTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTCommentNodeTestNode commentStamp: 'monty 1/20/2017 07:59' prior: 0!
This is an AST node class for the 'comment()' type test.!

!XPathASTCommentNodeTestNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:29'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitCommentNodeTest: self! !

!XPathASTCommentNodeTestNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isCommentNodeTest
	^ true! !

!XPathASTCommentNodeTestNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:35'!
nodeType
	^ XPathCommentNodeType new! !

XPathASTNodeTestNode subclass: #XPathASTElementNodeTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTElementNodeTestNode commentStamp: 'monty 1/20/2017 08:00' prior: 0!
This is an AST node class for the 'element()' type test or for '*' type tests when the principal node type of the axis is an element.!

XPathASTElementNodeTestNode subclass: #XPathASTElementNodeTestForLocalNameNode
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTElementNodeTestForLocalNameNode commentStamp: 'monty 1/22/2017 15:28' prior: 0!
This is an AST node class for the 'element(*:localName)' type test or for the '*:localName' type test when the principal node type of the axis is 'element'.!

!XPathASTElementNodeTestForLocalNameNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:33'!
localName: aLocalName
	^ self new localName: aLocalName! !

!XPathASTElementNodeTestForLocalNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:29'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitElementNodeTestForLocalName: self! !

!XPathASTElementNodeTestForLocalNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForLocalName
	^ true! !

!XPathASTElementNodeTestForLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:36'!
localName
	^ localName ifNil: [localName := '']! !

!XPathASTElementNodeTestForLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:36'!
localName: aLocalName
	localName := aLocalName! !

XPathASTElementNodeTestNode subclass: #XPathASTElementNodeTestForNameNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTElementNodeTestForNameNode commentStamp: 'monty 1/22/2017 15:29' prior: 0!
This is an AST node class for the 'element(name)' type test or for the 'name' type test when the principal node type of the axis is 'element'.!

!XPathASTElementNodeTestForNameNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:34'!
name: aName
	^ self new name: aName! !

!XPathASTElementNodeTestForNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:29'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitElementNodeTestForName: self! !

!XPathASTElementNodeTestForNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForName
	^ true! !

!XPathASTElementNodeTestForNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:33'!
name
	^ name ifNil: [name := '']! !

!XPathASTElementNodeTestForNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:33'!
name: aName
	name := aName! !

XPathASTElementNodeTestNode subclass: #XPathASTElementNodeTestForNamespaceURINode
	instanceVariableNames: 'namespaceURI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTElementNodeTestForNamespaceURINode commentStamp: 'monty 1/22/2017 15:29' prior: 0!
This is an AST node class for the 'element(Q{namespaceURI}*)' type test or for the 'Q{namespaceURI}*' type test when the principal node type of the axis is 'element'.!

XPathASTElementNodeTestForNamespaceURINode subclass: #XPathASTElementNodeTestForNamespaceURIAndLocalNameNode
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTElementNodeTestForNamespaceURIAndLocalNameNode commentStamp: 'monty 1/22/2017 15:29' prior: 0!
This is an AST node class for the 'element(Q{namespaceURI}localName)' type test or for the 'Q{namespaceURI}localName' type test when the principal node type of the axis is 'element'.!

!XPathASTElementNodeTestForNamespaceURIAndLocalNameNode class methodsFor: 'instance creation' stamp: 'monty 2/10/2017 21:56'!
namespaceURI: aURI localName: aLocalName
	^ (self namespaceURI: aURI)
		localName: aLocalName! !

!XPathASTElementNodeTestForNamespaceURIAndLocalNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:30'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitElementNodeTestForNamespaceURIAndLocalName: self! !

!XPathASTElementNodeTestForNamespaceURIAndLocalNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForNamespaceURIAndLocalName
	^ true! !

!XPathASTElementNodeTestForNamespaceURIAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:35'!
localName
	^ localName ifNil: [localName := '']! !

!XPathASTElementNodeTestForNamespaceURIAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:35'!
localName: aLocalName
	localName := aLocalName! !

!XPathASTElementNodeTestForNamespaceURINode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:33'!
namespaceURI: aURI
	^ self new namespaceURI: aURI! !

!XPathASTElementNodeTestForNamespaceURINode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:29'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitElementNodeTestForNamespaceURI: self! !

!XPathASTElementNodeTestForNamespaceURINode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForNamespaceURI
	^ true! !

!XPathASTElementNodeTestForNamespaceURINode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:35'!
namespaceURI
	^ namespaceURI ifNil: [namespaceURI := '']! !

!XPathASTElementNodeTestForNamespaceURINode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:34'!
namespaceURI: aURI
	namespaceURI := aURI! !

XPathASTElementNodeTestNode subclass: #XPathASTElementNodeTestForPrefixNode
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTElementNodeTestForPrefixNode commentStamp: 'monty 1/22/2017 15:29' prior: 0!
This is an AST node class for the 'element(prefix:*)' type test or for the 'prefix:*' type test when the principal node type of the axis is 'element'.!

XPathASTElementNodeTestForPrefixNode subclass: #XPathASTElementNodeTestForPrefixAndLocalNameNode
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTElementNodeTestForPrefixAndLocalNameNode commentStamp: 'monty 1/22/2017 15:30' prior: 0!
This is an AST node class for the 'element(prefix:localName)' type test or for the 'prefix:localName' type test when the principal node type of the axis is 'element'.!

!XPathASTElementNodeTestForPrefixAndLocalNameNode class methodsFor: 'instance creation' stamp: 'monty 2/10/2017 21:57'!
prefix: aPrefix localName: aLocalName
	^ (self prefix: aPrefix)
		localName: aLocalName! !

!XPathASTElementNodeTestForPrefixAndLocalNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:30'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitElementNodeTestForPrefixAndLocalName: self! !

!XPathASTElementNodeTestForPrefixAndLocalNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForPrefixAndLocalName
	^ true! !

!XPathASTElementNodeTestForPrefixAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:32'!
localName
	^ localName ifNil: [localName := '']! !

!XPathASTElementNodeTestForPrefixAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:32'!
localName: aLocalName
	localName := aLocalName! !

!XPathASTElementNodeTestForPrefixNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:35'!
prefix: aPrefix
	^ self new prefix: aPrefix! !

!XPathASTElementNodeTestForPrefixNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:30'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitElementNodeTestForPrefix: self! !

!XPathASTElementNodeTestForPrefixNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForPrefix
	^ true! !

!XPathASTElementNodeTestForPrefixNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:31'!
prefix
	^ prefix ifNil: [prefix := '']! !

!XPathASTElementNodeTestForPrefixNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 06:33'!
prefix: aPrefix
	prefix := aPrefix! !

!XPathASTElementNodeTestNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:29'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitElementNodeTest: self! !

!XPathASTElementNodeTestNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isElementNodeTest
	^ true! !

!XPathASTElementNodeTestNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:35'!
nodeType
	^ XPathElementNodeType new! !

XPathASTNodeTestNode subclass: #XPathASTNamespaceTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNamespaceTestNode commentStamp: 'monty 1/22/2017 15:30' prior: 0!
This is an AST node class for the 'namespace()' type test or for '*' type tests when the principal node type of the axis is an namespace.!

XPathASTNamespaceTestNode subclass: #XPathASTNamespaceTestForLocalNameNode
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNamespaceTestForLocalNameNode commentStamp: 'monty 1/22/2017 15:41' prior: 0!
This is an AST node class for the 'namespace(*:localName)' type test or for the '*:localName' type test when the principal node type of the axis is 'namespace'.!

!XPathASTNamespaceTestForLocalNameNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:34'!
localName: aLocalName
	^ self new localName: aLocalName! !

!XPathASTNamespaceTestForLocalNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:27'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNamespaceNodeTestForLocalName: self! !

!XPathASTNamespaceTestForLocalNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForLocalName
	^ true! !

!XPathASTNamespaceTestForLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:31'!
localName
	^ localName ifNil: [localName := '']! !

!XPathASTNamespaceTestForLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:30'!
localName: aLocalName
	localName := aLocalName! !

XPathASTNamespaceTestNode subclass: #XPathASTNamespaceTestForNameNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNamespaceTestForNameNode commentStamp: 'monty 1/22/2017 15:41' prior: 0!
This is an AST node class for the 'namespace(name)' type test or for the 'name' type test when the principal node type of the axis is 'namespace'.!

!XPathASTNamespaceTestForNameNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:34'!
name: aName
	^ self new name: aName! !

!XPathASTNamespaceTestForNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:27'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNamespaceNodeTestForName: self! !

!XPathASTNamespaceTestForNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForName
	^ true! !

!XPathASTNamespaceTestForNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:29'!
name
	^ name ifNil: [name := '']! !

!XPathASTNamespaceTestForNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:29'!
name: aName
	name := aName! !

XPathASTNamespaceTestNode subclass: #XPathASTNamespaceTestForNamespaceURINode
	instanceVariableNames: 'namespaceURI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNamespaceTestForNamespaceURINode commentStamp: 'monty 1/22/2017 15:41' prior: 0!
This is an AST node class for the 'namespace(Q{namespaceURI}*)' type test or for the 'Q{namespaceURI}*' type test when the principal node type of the axis is 'namespace'.!

XPathASTNamespaceTestForNamespaceURINode subclass: #XPathASTNamespaceTestForNamespaceURIAndLocalNameNode
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNamespaceTestForNamespaceURIAndLocalNameNode commentStamp: 'monty 1/22/2017 15:42' prior: 0!
This is an AST node class for the 'namespace(Q{namespaceURI}localName)' type test or for the 'Q{namespaceURI}localName' type test when the principal node type of the axis is 'namespace'.!

!XPathASTNamespaceTestForNamespaceURIAndLocalNameNode class methodsFor: 'instance creation' stamp: 'monty 2/10/2017 21:56'!
namespaceURI: aURI localName: aLocalName
	^ (self namespaceURI: aURI)
		localName: aLocalName! !

!XPathASTNamespaceTestForNamespaceURIAndLocalNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:27'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNamespaceNodeTestForNamespaceURIAndLocalName: self! !

!XPathASTNamespaceTestForNamespaceURIAndLocalNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForNamespaceURIAndLocalName
	^ true! !

!XPathASTNamespaceTestForNamespaceURIAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:35'!
localName
	^ localName ifNil: [localName := '']! !

!XPathASTNamespaceTestForNamespaceURIAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:35'!
localName: aLocalName
	localName := aLocalName! !

!XPathASTNamespaceTestForNamespaceURINode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:33'!
namespaceURI: aURI
	^ self new namespaceURI: aURI! !

!XPathASTNamespaceTestForNamespaceURINode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:28'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNamespaceNodeTestForNamespaceURI: self! !

!XPathASTNamespaceTestForNamespaceURINode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isNamespaceNodeTestForNamespaceURI
	^ true! !

!XPathASTNamespaceTestForNamespaceURINode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:34'!
namespaceURI
	^ namespaceURI ifNil: [namespaceURI := '']! !

!XPathASTNamespaceTestForNamespaceURINode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:34'!
namespaceURI: aURI
	namespaceURI := aURI! !

XPathASTNamespaceTestNode subclass: #XPathASTNamespaceTestForPrefixNode
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNamespaceTestForPrefixNode commentStamp: 'monty 1/22/2017 15:42' prior: 0!
This is an AST node class for the 'namespace(prefix:*)' type test or for the 'prefix:*' type test when the principal node type of the axis is 'namespace'.!

XPathASTNamespaceTestForPrefixNode subclass: #XPathASTNamespaceTestForPrefixAndLocalNameNode
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNamespaceTestForPrefixAndLocalNameNode commentStamp: 'monty 1/22/2017 15:42' prior: 0!
This is an AST node class for the 'namespace(prefix:localName)' type test or for the 'prefix:localName' type test when the principal node type of the axis is 'namespace'.!

!XPathASTNamespaceTestForPrefixAndLocalNameNode class methodsFor: 'instance creation' stamp: 'monty 2/10/2017 21:57'!
prefix: aPrefix localName: aLocalName
	^ (self prefix: aPrefix)
		localName: aLocalName! !

!XPathASTNamespaceTestForPrefixAndLocalNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:25'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNamespaceNodeTestForPrefixAndLocalName: self! !

!XPathASTNamespaceTestForPrefixAndLocalNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isNamespaceNodeTestForPrefixAndLocalName
	^ true! !

!XPathASTNamespaceTestForPrefixAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:31'!
localName
	^ localName ifNil: [localName := '']! !

!XPathASTNamespaceTestForPrefixAndLocalNameNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:30'!
localName: aLocalName
	localName := aLocalName! !

!XPathASTNamespaceTestForPrefixNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:35'!
prefix: aPrefix
	^ self new prefix: aPrefix! !

!XPathASTNamespaceTestForPrefixNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:26'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNamespaceNodeTestForPrefix: self! !

!XPathASTNamespaceTestForPrefixNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isNamespaceNodeTestForPrefix
	^ true! !

!XPathASTNamespaceTestForPrefixNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:31'!
prefix
	^ prefix ifNil: [prefix := '']! !

!XPathASTNamespaceTestForPrefixNode methodsFor: 'accessing' stamp: 'monty 1/9/2017 08:32'!
prefix: aPrefix
	prefix := aPrefix! !

!XPathASTNamespaceTestNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:27'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNamespaceNodeTest: self! !

!XPathASTNamespaceTestNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTest
	^ true! !

!XPathASTNamespaceTestNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:35'!
nodeType
	^ XPathNamespaceNodeType new! !

!XPathASTNodeTestNode class methodsFor: 'private ' stamp: 'monty 2/9/2017 20:07'!
generateNodeTestClasses
	"
	self generateNodeTestClasses
	"

	self allSubclasses
		sort: [:a :b |
			(b inheritsFrom: a)
				ifTrue: [true]
				ifFalse: [a name <= b name]];
		do: [:astNodeClass |
			| astNodeClassName astNodeSuperClassName astNodeSuperClass nodeTestClass |

			astNodeClassName := 'XPath', astNodeClass nameWithoutPrefixAndSuffix.
			astNodeSuperClassName := 'XPath', astNodeClass superclass nameWithoutPrefixAndSuffix.
			astNodeSuperClass := XMLClassFinder classNamed: astNodeSuperClassName.
			nodeTestClass :=
				astNodeSuperClass
					subclass: astNodeClassName asSymbol
					instanceVariableNames:
						(' ' join:
							(astNodeClass instanceVariables collect: #asString))
					classVariableNames: ''
					package: #'XPath-Core-Compilation'.
			astNodeClass methodsDo: [:method | | protocol |
				protocol := method protocol.
				((#('printing' 'visiting') anySatisfy: [:each |
					protocol asString beginsWith: each]))
					ifFalse: [
						nodeTestClass
							compile: method sourceCode
							classified: protocol]].
			astNodeClass class methodsDo: [:method |
				method selector = #generateNodeTestClasses
					ifFalse: [
						nodeTestClass class
							compile: method sourceCode
							classified: method protocol]]].! !

!XPathASTNodeTestNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNodeTest: self! !

!XPathASTNodeTestNode methodsFor: 'testing' stamp: 'monty 1/18/2017 12:47'!
isNodeTest
	^ true! !

!XPathASTNodeTestNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:36'!
nodeType
	self subclassResponsibility! !

XPathASTNodeTestNode subclass: #XPathASTPINodeTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTPINodeTestNode commentStamp: 'monty 1/21/2017 07:47' prior: 0!
This is an AST node class for the 'processing-instruction()' type test.!

XPathASTPINodeTestNode subclass: #XPathASTPINodeTestForNameNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTPINodeTestForNameNode commentStamp: 'monty 1/21/2017 07:47' prior: 0!
This is an AST node class for the 'processing-instruction(name)' type test.!

!XPathASTPINodeTestForNameNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 19:56'!
name: aName
	^ self new name: aName! !

!XPathASTPINodeTestForNameNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:24'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitPINodeTestForName: self! !

!XPathASTPINodeTestForNameNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isPINodeTestForName
	^ true! !

!XPathASTPINodeTestForNameNode methodsFor: 'accessing' stamp: 'monty 1/11/2017 11:42'!
name
	^ name ifNil: [name := '']! !

!XPathASTPINodeTestForNameNode methodsFor: 'accessing' stamp: 'monty 1/11/2017 11:42'!
name: aName
	name := aName! !

!XPathASTPINodeTestNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:27'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitPINodeTest: self! !

!XPathASTPINodeTestNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isPINodeTest
	^ true! !

!XPathASTPINodeTestNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:35'!
nodeType
	^ XPathPINodeType new! !

XPathASTNodeTestNode subclass: #XPathASTTextNodeTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTTextNodeTestNode commentStamp: 'monty 1/21/2017 07:47' prior: 0!
This is an AST node class for the 'text()' type test.!

!XPathASTTextNodeTestNode methodsFor: 'visiting' stamp: 'monty 2/6/2017 23:27'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitTextNodeTest: self! !

!XPathASTTextNodeTestNode methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isTextNodeTest
	^ true! !

!XPathASTTextNodeTestNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:35'!
nodeType
	^ XPathTextNodeType new! !

XPathASTNode subclass: #XPathASTNodeWithExpression
	instanceVariableNames: 'expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNodeWithExpression commentStamp: 'monty 1/22/2017 15:40' prior: 0!
This is a base class for AST nodes that have subexpressions.!

XPathASTNodeWithExpression subclass: #XPathASTArgumentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTArgumentNode commentStamp: 'monty 1/25/2017 12:01' prior: 0!
This is an AST node class to wrap argument expressions.!

!XPathASTArgumentNode methodsFor: 'visiting' stamp: 'monty 1/17/2017 14:46'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitArgument: self! !

!XPathASTArgumentNode methodsFor: 'testing' stamp: 'monty 1/17/2017 14:45'!
isArgument
	^ true! !

!XPathASTArgumentNode methodsFor: 'accessing' stamp: 'monty 1/30/2017 15:43'!
type
	^ self expression type! !

!XPathASTArgumentNode methodsFor: 'accessing' stamp: 'monty 1/30/2017 15:43'!
type: aType
	self expression type: aType! !

XPathASTNodeWithExpression subclass: #XPathASTExpressionRootNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTExpressionRootNode commentStamp: 'monty 1/19/2017 11:17' prior: 0!
This is an AST node class to wrap the root node of a parsed XPath expression.!

!XPathASTExpressionRootNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitExpressionRoot: self! !

!XPathASTExpressionRootNode methodsFor: 'testing' stamp: 'monty 1/11/2017 11:14'!
isExpressionRoot
	^ true! !

!XPathASTExpressionRootNode methodsFor: 'accessing' stamp: 'monty 1/30/2017 15:43'!
type
	^ self expression type! !

!XPathASTExpressionRootNode methodsFor: 'accessing' stamp: 'monty 1/30/2017 15:43'!
type: aType
	self expression type: aType! !

XPathASTNodeWithExpression subclass: #XPathASTFilterExpressionLocationPathNode
	instanceVariableNames: 'steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTFilterExpressionLocationPathNode commentStamp: 'monty 1/21/2017 08:03' prior: 0!
This is an AST node class for filter expression location paths, where the root of the location path is some type of expression that evaluates to a node (if it's a varaible bound to one) or a node set.!

!XPathASTFilterExpressionLocationPathNode class methodsFor: 'instance creation' stamp: 'monty 1/22/2017 18:49'!
expression: anExpression steps: aStepCollection
	^ (self expression: anExpression)
		steps: aStepCollection! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitFilterExpressionLocationPath: self! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'adding' stamp: 'monty 1/19/2017 11:22'!
addStep: aStep
	^ self steps addLast: (self beParentOf: aStep)! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathNodeSetValueType! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'testing' stamp: 'monty 1/19/2017 11:11'!
hasSteps
	^ steps notNil
		and: [steps notEmpty]! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'testing' stamp: 'monty 1/11/2017 07:18'!
isFilterExpressionLocationPath
	^ true! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'testing' stamp: 'monty 1/19/2017 11:00'!
isLocationPath
	^ true! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'testing' stamp: 'monty 3/18/2017 06:13'!
isPredicateLocationPath
	^ self hasParent
		and: [self parent isPredicate]! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'removing' stamp: 'monty 1/19/2017 11:09'!
removeStep: aStep
	^ self steps remove: aStep! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'removing' stamp: 'monty 1/23/2017 11:02'!
removeSteps
	^ self steps removeAll! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'accessing' stamp: 'monty 1/19/2017 11:12'!
steps
	^ steps ifNil: [steps := OrderedCollection new]! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'accessing' stamp: 'monty 1/22/2017 18:51'!
steps: aStepCollection
	steps := self beParentOfAll: aStepCollection asOrderedCollection! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'enumerating' stamp: 'monty 1/19/2017 11:10'!
stepsDo: aBlock
	steps
		ifNotNil: [steps do: aBlock]! !

!XPathASTFilterExpressionLocationPathNode methodsFor: 'accessing' stamp: 'monty 1/19/2017 11:08'!
totalSteps
	^ steps
		ifNil: [0]
		ifNotNil: [steps size]! !

XPathASTNodeWithExpression subclass: #XPathASTFilterExpressionNode
	instanceVariableNames: 'predicates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTFilterExpressionNode commentStamp: 'monty 1/20/2017 08:03' prior: 0!
This is an AST node class for filter expressions with a subexpression and zero or more predicates to filter the expression with.!

!XPathASTFilterExpressionNode class methodsFor: 'instance creation' stamp: 'monty 1/22/2017 18:51'!
expression: anExpression predicates: aPredicateCollection
	^ (self expression: anExpression)
		predicates: aPredicateCollection! !

!XPathASTFilterExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitFilterExpression: self! !

!XPathASTFilterExpressionNode methodsFor: 'adding' stamp: 'monty 1/19/2017 11:23'!
addPredicate: aPredicate
	^ self predicates addLast: (self beParentOf: aPredicate)! !

!XPathASTFilterExpressionNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathNodeSetValueType! !

!XPathASTFilterExpressionNode methodsFor: 'testing' stamp: 'monty 1/19/2017 10:55'!
hasPredicates
	^ predicates notNil
		and: [predicates notEmpty]! !

!XPathASTFilterExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isFilterExpression
	^ true! !

!XPathASTFilterExpressionNode methodsFor: 'testing' stamp: 'monty 1/19/2017 10:55'!
isFilterable
	^ true! !

!XPathASTFilterExpressionNode methodsFor: 'accessing' stamp: 'monty 1/19/2017 10:56'!
predicates
	^ predicates ifNil: [predicates := OrderedCollection new]! !

!XPathASTFilterExpressionNode methodsFor: 'accessing' stamp: 'monty 1/22/2017 18:50'!
predicates: aPredicateCollection
	predicates := self beParentOfAll: aPredicateCollection asOrderedCollection! !

!XPathASTFilterExpressionNode methodsFor: 'enumerating' stamp: 'monty 1/19/2017 10:56'!
predicatesDo: aBlock
	predicates
		ifNotNil: [predicates do: aBlock]! !

!XPathASTFilterExpressionNode methodsFor: 'removing' stamp: 'monty 1/19/2017 10:56'!
removePredicate: aPredicate
	^ self predicates remove: aPredicate! !

!XPathASTFilterExpressionNode methodsFor: 'removing' stamp: 'monty 1/23/2017 11:04'!
removePredicates
	^ self predicates removeAll! !

!XPathASTFilterExpressionNode methodsFor: 'accessing' stamp: 'monty 1/19/2017 11:01'!
totalPredicates
	^ predicates
		ifNil: [0]
		ifNotNil: [predicates size]! !

!XPathASTNodeWithExpression class methodsFor: 'instance creation' stamp: 'monty 1/19/2017 10:45'!
expression: anExpression
	^ self new expression: anExpression! !

!XPathASTNodeWithExpression methodsFor: 'visiting' stamp: 'monty 1/20/2017 07:51'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNodeWithExpression: self! !

!XPathASTNodeWithExpression methodsFor: 'accessing' stamp: 'monty 1/22/2017 18:41'!
expression
	^ expression ifNil: [expression := XPathASTNullNode new]! !

!XPathASTNodeWithExpression methodsFor: 'accessing' stamp: 'monty 1/19/2017 11:21'!
expression: anExpression
	expression := self beParentOf: anExpression! !

!XPathASTNodeWithExpression methodsFor: 'testing' stamp: 'monty 1/24/2017 20:22'!
hasLiteralExpression
	^ self expression isLiteral! !

!XPathASTNodeWithExpression methodsFor: 'testing' stamp: 'monty 1/24/2017 20:23'!
hasNonLiteralExpression
	^ self expression isLiteral not! !

!XPathASTNodeWithExpression methodsFor: 'testing' stamp: 'monty 1/24/2017 20:23'!
hasNumberLiteralExpression
	^ self expression isNumberLiteral! !

!XPathASTNodeWithExpression methodsFor: 'testing' stamp: 'monty 1/20/2017 07:49'!
isNodeWithExpression
	^ true! !

XPathASTNodeWithExpression subclass: #XPathASTNodeWithOtherExpression
	instanceVariableNames: 'otherExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNodeWithOtherExpression commentStamp: 'monty 1/24/2017 21:50' prior: 0!
This is a base class for AST node classes that have another subexpression in addition to the first.!

XPathASTNodeWithOtherExpression subclass: #XPathASTBinaryOperatorExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTBinaryOperatorExpressionNode commentStamp: 'monty 1/20/2017 08:04' prior: 0!
This is a base class for binary operator expression AST nodes.!

XPathASTBinaryOperatorExpressionNode subclass: #XPathASTAdditiveExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAdditiveExpressionNode commentStamp: 'monty 1/22/2017 20:55' prior: 0!
This is a base class for additive binary operator expression AST nodes of the same precedence.!

XPathASTAdditiveExpressionNode subclass: #XPathASTAdditionExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAdditionExpressionNode commentStamp: 'monty 1/22/2017 15:43' prior: 0!
This is an AST node class for addition '+' expressions.!

!XPathASTAdditionExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAdditionExpression: self! !

!XPathASTAdditionExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAdditionExpression
	^ true! !

!XPathASTAdditionExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:36'!
operatorName
	^ '+'! !

!XPathASTAdditiveExpressionNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathNumberValueType! !

!XPathASTAdditiveExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAdditiveExpression
	^ true! !

XPathASTAdditiveExpressionNode subclass: #XPathASTSubtractionExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTSubtractionExpressionNode commentStamp: 'monty 1/22/2017 15:45' prior: 0!
This is an AST node class for subtraction '-' expressions. Negation expressions have a separate AST node class.!

!XPathASTSubtractionExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitSubtractionExpression: self! !

!XPathASTSubtractionExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isSubtractionExpression
	^ true! !

!XPathASTSubtractionExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:37'!
operatorName
	^ '-'! !

XPathASTBinaryOperatorExpressionNode subclass: #XPathASTAndExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAndExpressionNode commentStamp: 'monty 1/22/2017 15:42' prior: 0!
This is an AST node class for 'and' expressions. The evaluation should short-curcuit so that the other expression is only evaluated if the first evaluates as true.!

!XPathASTAndExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAndExpression: self! !

!XPathASTAndExpressionNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathBooleanValueType! !

!XPathASTAndExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAndExpression
	^ true! !

!XPathASTAndExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:37'!
operatorName
	^ 'and'! !

!XPathASTBinaryOperatorExpressionNode methodsFor: 'visiting' stamp: 'monty 1/12/2017 19:04'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitBinaryOperatorExpression: self! !

!XPathASTBinaryOperatorExpressionNode methodsFor: 'testing' stamp: 'monty 1/12/2017 19:00'!
isBinaryOperatorExpression
	^ true! !

!XPathASTBinaryOperatorExpressionNode methodsFor: 'testing' stamp: 'monty 1/14/2017 12:26'!
isOperatorExpression
	^ true! !

!XPathASTBinaryOperatorExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:36'!
operatorName
	self subclassResponsibility! !

XPathASTBinaryOperatorExpressionNode subclass: #XPathASTEqualityExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTEqualityExpressionNode commentStamp: 'monty 1/22/2017 20:55' prior: 0!
This is a base class for AST equality expression nodes of the same precedence.!

!XPathASTEqualityExpressionNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathBooleanValueType! !

!XPathASTEqualityExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isEqualityExpression
	^ true! !

XPathASTEqualityExpressionNode subclass: #XPathASTEqualsExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTEqualsExpressionNode commentStamp: 'monty 1/22/2017 15:44' prior: 0!
This is an AST node class for '=' equals expressions.!

!XPathASTEqualsExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitEqualsExpression: self! !

!XPathASTEqualsExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isEqualsExpression
	^ true! !

!XPathASTEqualsExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:37'!
operatorName
	^ '='! !

XPathASTEqualityExpressionNode subclass: #XPathASTNotEqualsExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNotEqualsExpressionNode commentStamp: 'monty 1/22/2017 15:44' prior: 0!
This is an AST node class for '!!=' not equals expressions.!

!XPathASTNotEqualsExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNotEqualsExpression: self! !

!XPathASTNotEqualsExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isNotEqualsExpression
	^ true! !

!XPathASTNotEqualsExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:37'!
operatorName
	^ '!!='! !

XPathASTBinaryOperatorExpressionNode subclass: #XPathASTMultiplicativeExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTMultiplicativeExpressionNode commentStamp: 'monty 1/22/2017 20:54' prior: 0!
This is a base class for AST multiplicative expression nodes of the same precedence.!

XPathASTMultiplicativeExpressionNode subclass: #XPathASTDivisionExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTDivisionExpressionNode commentStamp: 'monty 1/22/2017 20:56' prior: 0!
This is an AST node class for 'div' division expressions.!

!XPathASTDivisionExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitDivisionExpression: self! !

!XPathASTDivisionExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isDivisionExpression
	^ true! !

!XPathASTDivisionExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:38'!
operatorName
	^ 'div'! !

XPathASTMultiplicativeExpressionNode subclass: #XPathASTModulusExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTModulusExpressionNode commentStamp: 'monty 1/22/2017 21:25' prior: 0!
This is an AST node class for 'mod' modulus expressions that return the remainder after truncating division. Unlike \\, the result takes the sign of the receiver, so '5 mod 2' and '5 mod -2'  are both '1'.!

!XPathASTModulusExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitModulusExpression: self! !

!XPathASTModulusExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isModulusExpression
	^ true! !

!XPathASTModulusExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:38'!
operatorName
	^ 'mod'! !

XPathASTMultiplicativeExpressionNode subclass: #XPathASTMultiplicationExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTMultiplicationExpressionNode commentStamp: 'monty 1/22/2017 21:28' prior: 0!
This is an AST node class for '*' multiplication expressions.!

!XPathASTMultiplicationExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitMultiplicationExpression: self! !

!XPathASTMultiplicationExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isMultiplicationExpression
	^ true! !

!XPathASTMultiplicationExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:38'!
operatorName
	^ '*'! !

!XPathASTMultiplicativeExpressionNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathNumberValueType! !

!XPathASTMultiplicativeExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isMultiplicativeExpression
	^ true! !

XPathASTBinaryOperatorExpressionNode subclass: #XPathASTOrExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTOrExpressionNode commentStamp: 'monty 1/22/2017 15:45' prior: 0!
This is an AST node class for 'or' expressions. The evaluation should short-curcuit so that the other expression is only evaluated if the first evaluates as false.!

!XPathASTOrExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitOrExpression: self! !

!XPathASTOrExpressionNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathBooleanValueType! !

!XPathASTOrExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isOrExpression
	^ true! !

!XPathASTOrExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:38'!
operatorName
	^ 'or'! !

XPathASTBinaryOperatorExpressionNode subclass: #XPathASTRelationalExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTRelationalExpressionNode commentStamp: 'monty 1/22/2017 15:48' prior: 0!
This is a base class for relational expression AST nodes.!

XPathASTRelationalExpressionNode subclass: #XPathASTGreaterThanExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTGreaterThanExpressionNode commentStamp: 'monty 1/22/2017 21:34' prior: 0!
This is an AST node class for '>' greater than expressions.!

!XPathASTGreaterThanExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitGreaterThanExpression: self! !

!XPathASTGreaterThanExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isGreaterThanExpression
	^ true! !

!XPathASTGreaterThanExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:39'!
operatorName
	^ '>'! !

XPathASTRelationalExpressionNode subclass: #XPathASTGreaterThanOrEqualToExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTGreaterThanOrEqualToExpressionNode commentStamp: 'monty 1/22/2017 21:34' prior: 0!
This is an AST node class for '>=' greater than or equal to expressions.!

!XPathASTGreaterThanOrEqualToExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitGreaterThanOrEqualToExpression: self! !

!XPathASTGreaterThanOrEqualToExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isGreaterThanOrEqualToExpression
	^ true! !

!XPathASTGreaterThanOrEqualToExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:39'!
operatorName
	^ '>='! !

XPathASTRelationalExpressionNode subclass: #XPathASTLessThanExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTLessThanExpressionNode commentStamp: 'monty 1/22/2017 21:35' prior: 0!
This is an AST node class for '<' less than expressions.!

!XPathASTLessThanExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitLessThanExpression: self! !

!XPathASTLessThanExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isLessThanExpression
	^ true! !

!XPathASTLessThanExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:39'!
operatorName
	^ '<'! !

XPathASTRelationalExpressionNode subclass: #XPathASTLessThanOrEqualToExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTLessThanOrEqualToExpressionNode commentStamp: 'monty 1/22/2017 21:35' prior: 0!
This is an AST node class for '<=' less than or equal to expressions.!

!XPathASTLessThanOrEqualToExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitLessThanOrEqualToExpression: self! !

!XPathASTLessThanOrEqualToExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isLessThanOrEqualToExpression
	^ true! !

!XPathASTLessThanOrEqualToExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:39'!
operatorName
	^ '<='! !

!XPathASTRelationalExpressionNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathBooleanValueType! !

!XPathASTRelationalExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isRelationalExpression
	^ true! !

XPathASTBinaryOperatorExpressionNode subclass: #XPathASTUnionExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTUnionExpressionNode commentStamp: 'monty 1/24/2017 21:51' prior: 0!
This is an AST node class for union expressions. Both subexpressions must evaluate to node sets.!

!XPathASTUnionExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitUnionExpression: self! !

!XPathASTUnionExpressionNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathNodeSetValueType! !

!XPathASTUnionExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isUnionExpression
	^ true! !

!XPathASTUnionExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:39'!
operatorName
	^ '|'! !

!XPathASTNodeWithOtherExpression class methodsFor: 'instance creation' stamp: 'monty 1/19/2017 19:52'!
expression: aFirstExpression otherExpression: aSecondExpression
	^ self new
		expression: aFirstExpression;
		otherExpression: aSecondExpression! !

!XPathASTNodeWithOtherExpression methodsFor: 'visiting' stamp: 'monty 1/20/2017 07:51'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNodeWithOtherExpression: self! !

!XPathASTNodeWithOtherExpression methodsFor: 'testing' stamp: 'monty 1/24/2017 20:22'!
hasLiteralExpression
	^ self expression isLiteral
		or: [self otherExpression isLiteral]! !

!XPathASTNodeWithOtherExpression methodsFor: 'testing' stamp: 'monty 1/24/2017 20:24'!
hasNonLiteralExpression
	^ self expression isLiteral not
		or: [self otherExpression isLiteral not]! !

!XPathASTNodeWithOtherExpression methodsFor: 'testing' stamp: 'monty 1/24/2017 20:23'!
hasNumberLiteralExpression
	^ self expression isNumberLiteral
		or: [self otherExpression isNumberLiteral]! !

!XPathASTNodeWithOtherExpression methodsFor: 'testing' stamp: 'monty 1/20/2017 07:50'!
isNodeWithOtherExpression
	^ true! !

!XPathASTNodeWithOtherExpression methodsFor: 'accessing' stamp: 'monty 1/22/2017 18:41'!
otherExpression
	^ otherExpression ifNil: [XPathASTNullNode new]! !

!XPathASTNodeWithOtherExpression methodsFor: 'accessing' stamp: 'monty 1/19/2017 19:52'!
otherExpression: anExpression
	otherExpression := self beParentOf: anExpression! !

XPathASTNodeWithExpression subclass: #XPathASTPredicateNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTPredicateNode commentStamp: 'monty 1/19/2017 10:42' prior: 0!
This is an AST node class for wrapping step and filter expression predicates.!

!XPathASTPredicateNode methodsFor: 'visiting' stamp: 'monty 1/17/2017 12:48'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitPredicate: self! !

!XPathASTPredicateNode methodsFor: 'testing' stamp: 'monty 1/17/2017 12:48'!
isPredicate
	^ true! !

!XPathASTPredicateNode methodsFor: 'accessing' stamp: 'monty 1/30/2017 15:44'!
type
	^ self expression type! !

!XPathASTPredicateNode methodsFor: 'accessing' stamp: 'monty 1/30/2017 15:43'!
type: aType
	self expression type: aType! !

XPathASTNodeWithExpression subclass: #XPathASTUnaryOperatorExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTUnaryOperatorExpressionNode commentStamp: 'monty 1/20/2017 08:04' prior: 0!
This is a base class for unary operator expression AST node classes.!

XPathASTUnaryOperatorExpressionNode subclass: #XPathASTNegationExpressionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNegationExpressionNode commentStamp: 'monty 1/19/2017 10:42' prior: 0!
This is an AST node class for the negation operator, which should return its operand converted to a number and negated.!

!XPathASTNegationExpressionNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNegationExpression: self! !

!XPathASTNegationExpressionNode methodsFor: 'defaults' stamp: 'monty 2/9/2017 19:54'!
defaultTypeClass
	^ XPathNumberValueType! !

!XPathASTNegationExpressionNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isNegationExpression
	^ true! !

!XPathASTNegationExpressionNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:40'!
operatorName
	^ '-'! !

!XPathASTUnaryOperatorExpressionNode methodsFor: 'visiting' stamp: 'monty 1/12/2017 19:01'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitUnaryOperatorExpression: self! !

!XPathASTUnaryOperatorExpressionNode methodsFor: 'testing' stamp: 'monty 1/14/2017 12:26'!
isOperatorExpression
	^ true! !

!XPathASTUnaryOperatorExpressionNode methodsFor: 'testing' stamp: 'monty 1/12/2017 19:00'!
isUnaryOperatorExpression
	^ true! !

!XPathASTUnaryOperatorExpressionNode methodsFor: 'accessing' stamp: 'monty 2/2/2017 03:10'!
operatorName
	self subclassResponsibility! !

XPathASTNode subclass: #XPathASTNullNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

XPathASTNullNode class
	instanceVariableNames: 'instance'!

!XPathASTNullNode commentStamp: 'monty 10/26/2017 05:27' prior: 0!
This class is used during parsing to separate the nested operator nodes belonging to one "or" expression from those belonging to another, and to function as a "null" object to simplify AST visiting and iteration.!

XPathASTNullNode class
	instanceVariableNames: 'instance'!

!XPathASTNullNode class methodsFor: 'accessing' stamp: 'monty 1/24/2017 21:56'!
instance
	^ instance
		ifNil: [instance := self basicNew initialize]! !

!XPathASTNullNode class methodsFor: 'instance creation' stamp: 'monty 1/24/2017 21:56'!
new
	^ self instance! !

!XPathASTNullNode methodsFor: 'testing' stamp: 'monty 1/22/2017 18:40'!
isNull
	^ true! !

!XPathASTNullNode methodsFor: 'accessing' stamp: 'monty 1/30/2017 14:08'!
parent
	^ parent ifNil: [parent := self]! !

!XPathASTNullNode methodsFor: 'accessing' stamp: 'monty 1/24/2017 21:52'!
parent: aNode! !

!XPathASTNullNode methodsFor: 'accessing' stamp: 'monty 1/30/2017 14:06'!
type: aType! !

XPathASTNode subclass: #XPathASTStepNode
	instanceVariableNames: 'nodeTest predicates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTStepNode commentStamp: 'monty 1/19/2017 19:14' prior: 0!
This is a base class for AST location path step nodes.!

XPathASTStepNode subclass: #XPathASTAncestorOrSelfStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAncestorOrSelfStepNode commentStamp: 'monty 1/24/2017 21:54' prior: 0!
This is an AST node class for 'ancestor-or-self::' steps.!

!XPathASTAncestorOrSelfStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAncestorOrSelfStep: self! !

!XPathASTAncestorOrSelfStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:42'!
axisName
	^ 'ancestor-or-self'! !

!XPathASTAncestorOrSelfStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAncestorOrSelfStep
	^ true! !

!XPathASTAncestorOrSelfStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:55'!
isReverseAxisStep
	^ true! !

XPathASTStepNode subclass: #XPathASTAncestorStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAncestorStepNode commentStamp: 'monty 1/24/2017 21:54' prior: 0!
This is an AST node class for 'ancestor::' steps.!

!XPathASTAncestorStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAncestorStep: self! !

!XPathASTAncestorStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:42'!
axisName
	^ 'ancestor'! !

!XPathASTAncestorStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAncestorStep
	^ true! !

!XPathASTAncestorStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:55'!
isReverseAxisStep
	^ true! !

XPathASTStepNode subclass: #XPathASTAttributeStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTAttributeStepNode commentStamp: 'monty 1/24/2017 21:54' prior: 0!
This is an AST node class for 'attribute::' (or '@') steps.!

!XPathASTAttributeStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitAttributeStep: self! !

!XPathASTAttributeStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:43'!
axisName
	^ 'attribute'! !

!XPathASTAttributeStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isAttributeStep
	^ true! !

!XPathASTAttributeStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:54'!
isForwardAxisStep
	^ true! !

!XPathASTAttributeStepNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:33'!
principalNodeType
	^ XPathAttributeNodeType new! !

XPathASTStepNode subclass: #XPathASTChildStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTChildStepNode commentStamp: 'monty 1/24/2017 21:54' prior: 0!
This is an AST node class for 'child::' steps.!

!XPathASTChildStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitChildStep: self! !

!XPathASTChildStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:44'!
axisName
	^ 'child'! !

!XPathASTChildStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isChildStep
	^ true! !

!XPathASTChildStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:53'!
isForwardAxisStep
	^ true! !

XPathASTStepNode subclass: #XPathASTDescendantOrSelfStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTDescendantOrSelfStepNode commentStamp: 'monty 1/24/2017 21:55' prior: 0!
This is an AST node class for 'descendant-or-self::' steps.!

!XPathASTDescendantOrSelfStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitDescendantOrSelfStep: self! !

!XPathASTDescendantOrSelfStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:44'!
axisName
	^ 'descendant-or-self'! !

!XPathASTDescendantOrSelfStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isDescendantOrSelfStep
	^ true! !

!XPathASTDescendantOrSelfStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:53'!
isForwardAxisStep
	^ true! !

XPathASTStepNode subclass: #XPathASTDescendantStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTDescendantStepNode commentStamp: 'monty 1/24/2017 21:55' prior: 0!
This is an AST node class for 'descendant::' steps.!

!XPathASTDescendantStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitDescendantStep: self! !

!XPathASTDescendantStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:44'!
axisName
	^ 'descendant'! !

!XPathASTDescendantStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isDescendantStep
	^ true! !

!XPathASTDescendantStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:54'!
isForwardAxisStep
	^ true! !

XPathASTStepNode subclass: #XPathASTFollowingSiblingStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTFollowingSiblingStepNode commentStamp: 'monty 1/24/2017 21:55' prior: 0!
This is an AST node class for 'following-sibling::' steps.!

!XPathASTFollowingSiblingStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitFollowingSiblingStep: self! !

!XPathASTFollowingSiblingStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:44'!
axisName
	^ 'following-sibling'! !

!XPathASTFollowingSiblingStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isFollowingSiblingStep
	^ true! !

!XPathASTFollowingSiblingStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:54'!
isForwardAxisStep
	^ true! !

XPathASTStepNode subclass: #XPathASTFollowingStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTFollowingStepNode commentStamp: 'monty 1/24/2017 21:55' prior: 0!
This is an AST node class for 'following::' steps.!

!XPathASTFollowingStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitFollowingStep: self! !

!XPathASTFollowingStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:44'!
axisName
	^ 'following'! !

!XPathASTFollowingStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isFollowingStep
	^ true! !

!XPathASTFollowingStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:54'!
isForwardAxisStep
	^ true! !

XPathASTStepNode subclass: #XPathASTNamespaceStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNamespaceStepNode commentStamp: 'monty 1/24/2017 21:55' prior: 0!
This is an AST node class for 'namespace::' steps.!

!XPathASTNamespaceStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitNamespaceStep: self! !

!XPathASTNamespaceStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:44'!
axisName
	^ 'namespace'! !

!XPathASTNamespaceStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:54'!
isForwardAxisStep
	^ true! !

!XPathASTNamespaceStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isNamespaceStep
	^ true! !

!XPathASTNamespaceStepNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:33'!
principalNodeType
	^ XPathNamespaceNodeType new! !

XPathASTStepNode subclass: #XPathASTParentStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTParentStepNode commentStamp: 'monty 1/24/2017 21:55' prior: 0!
This is an AST node class for 'parent::' steps.!

!XPathASTParentStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitParentStep: self! !

!XPathASTParentStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:44'!
axisName
	^ 'parent'! !

!XPathASTParentStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:54'!
isForwardAxisStep
	"according to the spec, this is a forward axis"
	^ true! !

!XPathASTParentStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isParentStep
	^ true! !

XPathASTStepNode subclass: #XPathASTPrecedingSiblingStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTPrecedingSiblingStepNode commentStamp: 'monty 1/24/2017 21:55' prior: 0!
This is an AST node class for 'preceding-sibling::' steps.!

!XPathASTPrecedingSiblingStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitPrecedingSiblingStep: self! !

!XPathASTPrecedingSiblingStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:45'!
axisName
	^ 'preceding-sibling'! !

!XPathASTPrecedingSiblingStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isPrecedingSiblingStep
	^ true! !

!XPathASTPrecedingSiblingStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:55'!
isReverseAxisStep
	^ true! !

XPathASTStepNode subclass: #XPathASTPrecedingStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTPrecedingStepNode commentStamp: 'monty 1/24/2017 21:55' prior: 0!
This is an AST node class for 'preceding::' steps.!

!XPathASTPrecedingStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitPrecedingStep: self! !

!XPathASTPrecedingStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:45'!
axisName
	^ 'preceding'! !

!XPathASTPrecedingStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isPrecedingStep
	^ true! !

!XPathASTPrecedingStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:55'!
isReverseAxisStep
	^ true! !

XPathASTStepNode subclass: #XPathASTSelfStepNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTSelfStepNode commentStamp: 'monty 1/24/2017 21:56' prior: 0!
This is an AST node class for 'self::' steps.!

!XPathASTSelfStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitSelfStep: self! !

!XPathASTSelfStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:45'!
axisName
	^ 'self'! !

!XPathASTSelfStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:54'!
isForwardAxisStep
	^ true! !

!XPathASTSelfStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isSelfStep
	^ true! !

!XPathASTStepNode class methodsFor: 'instance creation' stamp: 'monty 1/22/2017 18:48'!
nodeTest: aNodeTest
	^ self new nodeTest: aNodeTest! !

!XPathASTStepNode class methodsFor: 'instance creation' stamp: 'monty 1/22/2017 18:48'!
nodeTest: aNodeTest predicates: aPredicateCollection
	^ (self nodeTest: aNodeTest)
		predicates: aPredicateCollection! !

!XPathASTStepNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitStep: self! !

!XPathASTStepNode methodsFor: 'adding' stamp: 'monty 1/19/2017 11:24'!
addPredicate: aPredicate
	^ self predicates addLast: (self beParentOf: aPredicate)! !

!XPathASTStepNode methodsFor: 'accessing' stamp: 'monty 2/1/2017 23:42'!
axisName
	self subclassResponsibility! !

!XPathASTStepNode methodsFor: 'testing' stamp: 'monty 1/19/2017 10:53'!
hasPredicates
	^ predicates notNil
		and: [predicates notEmpty]! !

!XPathASTStepNode methodsFor: 'testing' stamp: 'monty 1/19/2017 10:53'!
isFilterable
	^ true! !

!XPathASTStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:53'!
isForwardAxisStep
	^ false! !

!XPathASTStepNode methodsFor: 'testing' stamp: 'monty 3/18/2017 06:12'!
isPredicateLocationPathStep
	"returns true if the step is part of a location path that is the
	expression of a predicate node"
	^ self hasParent
		and: [self parent isPredicateLocationPath]! !

!XPathASTStepNode methodsFor: 'testing' stamp: 'monty 1/23/2017 15:53'!
isReverseAxisStep
	^ false! !

!XPathASTStepNode methodsFor: 'testing' stamp: 'monty 1/3/2017 09:42'!
isStep
	^ true! !

!XPathASTStepNode methodsFor: 'accessing' stamp: 'monty 1/22/2017 18:41'!
nodeTest
	^ nodeTest ifNil: [nodeTest := XPathASTNullNode new]! !

!XPathASTStepNode methodsFor: 'accessing' stamp: 'monty 2/7/2017 00:28'!
nodeTest: aNode
	nodeTest := self beParentOf: aNode! !

!XPathASTStepNode methodsFor: 'accessing' stamp: 'monty 1/19/2017 10:54'!
predicates
	^ predicates ifNil: [predicates := OrderedCollection new]! !

!XPathASTStepNode methodsFor: 'accessing' stamp: 'monty 1/22/2017 18:50'!
predicates: aPredicateCollection
	predicates := self beParentOfAll: aPredicateCollection asOrderedCollection! !

!XPathASTStepNode methodsFor: 'enumerating' stamp: 'monty 1/19/2017 10:53'!
predicatesDo: aBlock
	predicates
		ifNotNil: [predicates do: aBlock]! !

!XPathASTStepNode methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:33'!
principalNodeType
	^ XPathElementNodeType new! !

!XPathASTStepNode methodsFor: 'removing' stamp: 'monty 1/19/2017 10:53'!
removePredicate: aPredicate
	^ self predicates remove: aPredicate! !

!XPathASTStepNode methodsFor: 'removing' stamp: 'monty 1/23/2017 11:04'!
removePredicates
	^ self predicates removeAll! !

!XPathASTStepNode methodsFor: 'accessing' stamp: 'monty 1/19/2017 11:01'!
totalPredicates
	^ predicates
		ifNil: [0]
		ifNotNil: [predicates size]! !

XPathASTNode subclass: #XPathASTVariableReferenceNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTVariableReferenceNode commentStamp: 'monty 1/19/2017 10:38' prior: 0!
This is an AST node class for variable references. Variables are bound to values at runtime using XPathContext objects.!

!XPathASTVariableReferenceNode class methodsFor: 'instance creation' stamp: 'monty 1/10/2017 18:58'!
name: aName
	^ self new name: aName! !

!XPathASTVariableReferenceNode methodsFor: 'visiting' stamp: 'monty 1/11/2017 12:50'!
acceptNodeVisitor: aNodeVisitor
	^ aNodeVisitor visitVariableReference: self! !

!XPathASTVariableReferenceNode methodsFor: 'testing' stamp: 'monty 1/4/2017 09:26'!
isVariableReference
	^ true! !

!XPathASTVariableReferenceNode methodsFor: 'accessing' stamp: 'monty 1/11/2017 03:14'!
name
	^ name ifNil: [name := '']! !

!XPathASTVariableReferenceNode methodsFor: 'accessing' stamp: 'monty 1/11/2017 03:14'!
name: aVariableName
	name := aVariableName! !

Object subclass: #XPathASTNodeVisitor
	instanceVariableNames: 'argumentIterator predicateIterator stepIterator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNodeVisitor commentStamp: 'monty 1/11/2017 11:21' prior: 0!
This is a base class for AST visitors.!

XPathASTNodeVisitor subclass: #XPathASTMutatingNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTMutatingNodeVisitor commentStamp: 'monty 1/11/2017 18:24' prior: 0!
This class is a rewriting node visitor that can replace any node in the tree with the result of its #visit*: message.!

!XPathASTMutatingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 10/26/2017 00:00'!
visitFilterable: aFilterable
	aFilterable hasPredicates
		ifTrue: [| oldPredicateIterator  predicates |
			oldPredicateIterator := predicateIterator.
			predicateIterator :=
				XPathASTNodeVisitorIterator on: aFilterable predicates.
			predicates := OrderedCollection new: aFilterable totalPredicates.
			[predicateIterator atEnd]
				whileFalse: [| predicate |
					(predicate := predicateIterator visitNextWith: self) isNull
						ifFalse: [predicates addLast: predicate]].
			aFilterable predicates: predicates.
			predicateIterator := oldPredicateIterator].
	^ aFilterable.! !

!XPathASTMutatingNodeVisitor methodsFor: 'visiting - functions' stamp: 'monty 1/27/2017 21:27'!
visitFunctionCall: aFunctionCall
	aFunctionCall hasArguments
		ifTrue: [| oldArgumentIterator arguments |
			oldArgumentIterator := argumentIterator.
			argumentIterator :=
				XPathASTNodeVisitorIterator on: aFunctionCall arguments.
			arguments := OrderedCollection new: aFunctionCall totalArguments.
			[argumentIterator atEnd]
				whileFalse: [| argument |
					(argument := argumentIterator visitNextWith: self) isNull
						ifFalse: [arguments addLast: argument]].
			aFunctionCall arguments: arguments.
			argumentIterator := oldArgumentIterator].
	^ aFunctionCall.! !

!XPathASTMutatingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 1/27/2017 21:30'!
visitLocationPath: aLocationPath
	aLocationPath hasSteps
		ifTrue: [| oldStepIterator steps |
			oldStepIterator := stepIterator.
			stepIterator := XPathASTNodeVisitorIterator on: aLocationPath steps.
			steps := OrderedCollection new: aLocationPath totalSteps.
			[stepIterator atEnd]
				whileFalse: [| step |
					(step := stepIterator visitNextWith: self) isNull
						ifFalse: [steps addLast: step]].
			aLocationPath steps: steps.
			stepIterator := oldStepIterator].
	^ aLocationPath.! !

!XPathASTMutatingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/20/2017 09:57'!
visitNodeWithExpression: aNodeWithExpression
	aNodeWithExpression expression:
		(aNodeWithExpression expression acceptNodeVisitor: self).
	^ aNodeWithExpression.! !

!XPathASTMutatingNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/20/2017 09:57'!
visitNodeWithOtherExpression: aNodeWithOtherExpression
	self visitNodeWithExpression: aNodeWithOtherExpression.
	aNodeWithOtherExpression otherExpression:
		(aNodeWithOtherExpression otherExpression acceptNodeVisitor: self).
	^ aNodeWithOtherExpression.! !

!XPathASTMutatingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2017 09:58'!
visitStep: aStep
	aStep nodeTest: (aStep nodeTest acceptNodeVisitor: self).
	^ self visitFilterable: aStep.! !

XPathASTMutatingNodeVisitor subclass: #XPathASTOptimizingMutatingNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTOptimizingMutatingNodeVisitor commentStamp: 'monty 1/25/2018 23:55' prior: 0!
This class is an optimizing mutating node visitor that does constant folding by eliminating operator expressions that can be evaluated at compile time, including arithmetic and boolean operator expressions with literal string or number operands, and optimizes location path steps, and eliminates redundant predicates.!

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'instance creation' stamp: 'monty 3/9/2017 19:05'!
newFunctionCallForBoolean: aBoolean
	"the XPath string value of a boolean is 'true' or 'false', the names of
	the true() and false() functions, and since these are inlined by the
	translator, we can safely infer their type"
	^ (XPathASTFunctionCallNode name: aBoolean asXPathString)
		type: XPathBooleanValueType new! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/5/2017 20:06'!
visitAdditionExpression: anAdditionExpression
	"traverse in post-order"
	super visitAdditionExpression: anAdditionExpression.

	"addition of literals can be evaluated at compile time"
	anAdditionExpression hasNonLiteralExpression
		ifTrue: [^ anAdditionExpression]
		ifFalse: [
			^ XPathASTNumberLiteralNode number:
				anAdditionExpression expression asXPathNumber +
					anAdditionExpression otherExpression asXPathNumber].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 10/25/2017 23:58'!
visitAndExpression: anAndExpression
	"traverse in post-order"
	super visitAndExpression: anAndExpression.

	"the 'and' of literals can be evaluated at compile time"
	anAndExpression hasNonLiteralExpression
		ifTrue: [^ anAndExpression]
		ifFalse: [
			^ self newFunctionCallForBoolean:
				(anAndExpression expression asXPathBoolean
					and: [anAndExpression otherExpression asXPathBoolean])]! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 10/26/2017 06:26'!
visitDescendantOrSelfStep: aDescendantOrSelfStep
	"traverse in post-order"
	super visitDescendantOrSelfStep: aDescendantOrSelfStep.

	"only optimize 'descendant-or-self::node()' steps"
	(aDescendantOrSelfStep nodeTest isAnyNodeTest
		and: [aDescendantOrSelfStep hasPredicates not])
		ifTrue: [
			"if the next step after this 'descendant-or-self::node()' step is
			'self::node()' or an identical 'descendant-or-self::node()' step,
			the next step is redundant"
			[(self peekStep isDescendantOrSelfStep
				or: [self peekStep isSelfStep])
				and: [self peekStep nodeTest isAnyNodeTest
					and: [self peekStep hasPredicates not]]]
				whileTrue: [self nextStep].

			"'descendant-or-self::node()/self::...' and
			'descendant-or-self::node()/descendant-or-self::...'
			are equivalent to 'descendant-or-self::...', regardless of the
			node test, as long as the second step also has no predicates"
			((self peekStep isDescendantOrSelfStep
				or: [self peekStep isSelfStep])
				and: [self peekStep hasPredicates not])
				ifTrue: [
					^ XPathASTDescendantOrSelfStepNode nodeTest:
						self nextStep nodeTest].

			"'descendant-or-self::node()/child::...' and
			'descendant-or-self::node()/descendant::...' are
			equivalent to 'descendant::...', regardless of the node test,
			as long as the second step also has no predicates"
			((self peekStep isChildStep
				or: [self peekStep isDescendantStep])
				and: [self peekStep hasPredicates not])
				ifTrue: [
					^ XPathASTDescendantStepNode nodeTest:
						self nextStep nodeTest]].

	^ aDescendantOrSelfStep.! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 3/14/2017 22:29'!
visitDivisionExpression: aDivisionExpression
	"traverse in post-order"
	super visitDivisionExpression: aDivisionExpression.

	"division of literals can be evaluated at compile time"
	aDivisionExpression hasNonLiteralExpression
		ifTrue: [^ aDivisionExpression]
		ifFalse: [
			^ XPathASTNumberLiteralNode number:
				(aDivisionExpression expression asXPathNumber xpathDivision:
					aDivisionExpression otherExpression asXPathNumber)].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/5/2017 20:20'!
visitEqualsExpression: anEqualsExpression
	"traverse in post-order"
	super visitEqualsExpression: anEqualsExpression.

	"equality comparisons of literals can be evaluated at compile time"
	anEqualsExpression hasNonLiteralExpression
		ifTrue: [
			"predicate expressions like 'position()=10' and '10=position()'
			can be replaced with number literals like '10' which are easier
			to optimize"
			(anEqualsExpression hasParent
				and: [anEqualsExpression parent isPredicate])
				ifTrue: [
					anEqualsExpression expression isNumberLiteral
						ifTrue: [
							(anEqualsExpression otherExpression isFunctionCall
								and: [
									anEqualsExpression otherExpression
										isPositionFunctionCall])
								ifTrue: [^ anEqualsExpression expression]]
						ifFalse: [
							anEqualsExpression otherExpression isNumberLiteral
								ifTrue: [
									(anEqualsExpression expression isFunctionCall
										and: [
											anEqualsExpression expression
												isPositionFunctionCall])
										ifTrue: [^ anEqualsExpression otherExpression]]]].
			^ anEqualsExpression]
		ifFalse: [
			"When neither object ... is a node-set and the operator is = or !!= ...
			if at least one object ... is a number, then each ... is converted to
			a number ... Otherwise, both ... are converted to strings"
			(anEqualsExpression hasNumberLiteralExpression
				ifTrue: [
					^ self newFunctionCallForBoolean:
						anEqualsExpression expression asXPathNumber =
							anEqualsExpression otherExpression asXPathNumber]
				ifFalse: [
					^ self newFunctionCallForBoolean:
						anEqualsExpression expression asXPathString =
							anEqualsExpression otherExpression asXPathString])].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 2/5/2017 20:19'!
visitFilterExpression: aFilterExpression
	"traverse in post-order"
	super visitFilterExpression: aFilterExpression.

	aFilterExpression hasPredicates
		ifFalse: [
			aFilterExpression type:
				aFilterExpression expression type].
	^ aFilterExpression.! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 2/26/2018 23:48'!
visitFilterExpressionLocationPath: aFilterExpressionLocationPath
	"traverse in post-order"
	super visitFilterExpressionLocationPath: aFilterExpressionLocationPath.

	"if it has no steps, its type is the type of the expression being filtered"
	aFilterExpressionLocationPath hasSteps
		ifFalse: [
			aFilterExpressionLocationPath type:
				aFilterExpressionLocationPath expression type].
	^ aFilterExpressionLocationPath.! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - functions' stamp: 'monty 2/9/2017 19:54'!
visitFunctionCall: aFunctionCall
	"traverse in post-order"
	super visitFunctionCall: aFunctionCall.

	"these function calls are inlined by the translator, so we can infer their
	types during compilation, but all other functions can be dynamically
	rebound at runtime with XPathContext objects, so we don't infer them"
	(aFunctionCall isTrueFunctionCall
		or: [aFunctionCall isFalseFunctionCall])
		ifTrue: [aFunctionCall type: XPathBooleanValueType new]
		ifFalse: [
			(aFunctionCall isPositionFunctionCall
				or: [aFunctionCall isLastFunctionCall])
				ifTrue: [aFunctionCall type: XPathNumberValueType new]].
	^ aFunctionCall.! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/5/2017 20:14'!
visitGreaterThanExpression: aGreaterThanExpression
	"traverse in post-order"
	super visitGreaterThanExpression: aGreaterThanExpression.

	"greater than comparisons of literals can be evaluated at compile time"
	aGreaterThanExpression hasNonLiteralExpression
		ifTrue: [^ aGreaterThanExpression]
		ifFalse: [
			^ self newFunctionCallForBoolean:
				aGreaterThanExpression expression asXPathNumber >
					aGreaterThanExpression otherExpression asXPathNumber].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/5/2017 20:15'!
visitGreaterThanOrEqualToExpression: aGreaterThanOrEqualToExpression
	"traverse in post-order"
	super visitGreaterThanOrEqualToExpression: aGreaterThanOrEqualToExpression.

	"greater than or equal to comparisons of literals can be evaluated at
	compile time"
	aGreaterThanOrEqualToExpression hasNonLiteralExpression
		ifTrue: [^ aGreaterThanOrEqualToExpression]
		ifFalse: [
			^ self newFunctionCallForBoolean:
				aGreaterThanOrEqualToExpression expression asXPathNumber >=
					aGreaterThanOrEqualToExpression otherExpression asXPathNumber].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/5/2017 20:15'!
visitLessThanExpression: aLessThanExpression
	"traverse in post-order"
	super visitLessThanExpression: aLessThanExpression.

	"less than comparisons of literals can be evaluated at compile time"
	aLessThanExpression hasNonLiteralExpression
		ifTrue: [^ aLessThanExpression]
		ifFalse: [
			^ self newFunctionCallForBoolean:
				aLessThanExpression expression asXPathNumber <
					aLessThanExpression otherExpression asXPathNumber].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/5/2017 20:15'!
visitLessThanOrEqualToExpression: aLessThanOrEqualToExpression
	"traverse in post-order"
	super visitLessThanOrEqualToExpression: aLessThanOrEqualToExpression.

	"less than or equal to comparisons of literals can be evaluated at
	compile time"
	aLessThanOrEqualToExpression hasNonLiteralExpression
		ifTrue: [^ aLessThanOrEqualToExpression]
		ifFalse: [
			^ self newFunctionCallForBoolean:
				aLessThanOrEqualToExpression expression asXPathNumber <=
					aLessThanOrEqualToExpression otherExpression asXPathNumber].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 3/14/2017 22:29'!
visitModulusExpression: aModulusExpression
	"traverse in post-order"
	super visitModulusExpression: aModulusExpression.

	"the modulus of literals can be evaluated at compile time"
	aModulusExpression hasNonLiteralExpression
		ifTrue: [^ aModulusExpression]
		ifFalse: [
			^ XPathASTNumberLiteralNode number:
				(aModulusExpression expression asXPathNumber xpathModulus:
					aModulusExpression otherExpression asXPathNumber)]! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/5/2017 20:16'!
visitMultiplicationExpression: aMultiplicationExpression
	"traverse in post-order"
	super visitMultiplicationExpression: aMultiplicationExpression.

	"multiplication of literals can be evaluated at compile time"
	aMultiplicationExpression hasNonLiteralExpression
		ifTrue: [^ aMultiplicationExpression]
		ifFalse: [
			^ XPathASTNumberLiteralNode number:
				aMultiplicationExpression expression asXPathNumber *
					aMultiplicationExpression otherExpression asXPathNumber]! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/5/2017 20:17'!
visitNegationExpression: aNegationExpression
	"traverse in post-order"
	super visitNegationExpression: aNegationExpression.

	"the negation of a literal can be evaluated at compile time"
	aNegationExpression hasNonLiteralExpression
		ifTrue: [^ aNegationExpression]
		ifFalse: [
			^ XPathASTNumberLiteralNode number:
				aNegationExpression expression asXPathNumber negated].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/5/2017 20:18'!
visitNotEqualsExpression: anNotEqualsExpression
	"traverse in post-order"
	super visitNotEqualsExpression: anNotEqualsExpression.

	"inequality comparisons of literals can be evaluated at compile time"
	anNotEqualsExpression hasNonLiteralExpression
		ifTrue: [^ anNotEqualsExpression]
		ifFalse: [
			"When neither object ... is a node-set and the operator is = or !!= ...
			if at least one object ... is a number, then each ... is converted to
			a number ... Otherwise, both ... are converted to strings"
			anNotEqualsExpression hasNumberLiteralExpression
				ifTrue: [
					^ self newFunctionCallForBoolean:
						anNotEqualsExpression expression asXPathNumber ~=
							anNotEqualsExpression otherExpression asXPathNumber]
				ifFalse: [
					^ self newFunctionCallForBoolean:
						anNotEqualsExpression expression asXPathString ~=
							anNotEqualsExpression otherExpression asXPathString]].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 10/25/2017 23:58'!
visitOrExpression: anOrExpression
	"traverse in post-order"
	super visitOrExpression: anOrExpression.

	"the 'or' of literals can be evaluated at compile time"
	anOrExpression hasNonLiteralExpression
		ifTrue: [^ anOrExpression]
		ifFalse: [
			^ self newFunctionCallForBoolean:
				(anOrExpression expression asXPathBoolean
					or: [anOrExpression otherExpression asXPathBoolean])]! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - predicates' stamp: 'monty 10/25/2017 07:16'!
visitPredicate: aPredicate
	"traverse in post-order"
	super visitPredicate: aPredicate.

	"a predicate that is just [true()] can be ignored if it's not first"
	(self previousPredicate isNull not
		and: [aPredicate expression isFunctionCall
			and: [aPredicate expression isTrueFunctionCall]])
		ifTrue: [^ XPathASTNullNode new]
		ifFalse: [^ aPredicate].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 10/26/2017 06:24'!
visitSelfStep: aSelfStep
	"traverse in post-order"
	super visitSelfStep: aSelfStep.

	"steps like 'self::node()' or '.' can be eliminated if they're not
	the first step and the previous step is a forward axis step"
	(aSelfStep nodeTest isAnyNodeTest
		and: [aSelfStep hasPredicates not
			and: [self previousStep isNull not
				and: [self previousStep isForwardAxisStep]]])
		ifTrue: [^ XPathASTNullNode new]
		ifFalse: [^ aSelfStep].! !

!XPathASTOptimizingMutatingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/5/2017 20:18'!
visitSubtractionExpression: aSubtractionExpression
	"traverse in post-order"
	super visitSubtractionExpression: aSubtractionExpression.

	"subtraction of literals can be evaluated at compile time"
	aSubtractionExpression hasNonLiteralExpression
		ifTrue: [^ aSubtractionExpression]
		ifFalse: [
			^ XPathASTNumberLiteralNode number:
				aSubtractionExpression expression asXPathNumber -
					aSubtractionExpression otherExpression asXPathNumber].! !

!XPathASTNodeVisitor methodsFor: 'private' stamp: 'monty 1/27/2017 22:29'!
argumentIterator
	^ argumentIterator
		ifNil: [argumentIterator := XPathASTNodeVisitorIterator null]! !

!XPathASTNodeVisitor methodsFor: 'iterating' stamp: 'monty 1/27/2017 21:01'!
nextArgument
	^ self argumentIterator next! !

!XPathASTNodeVisitor methodsFor: 'iterating' stamp: 'monty 1/27/2017 21:01'!
nextPredicate
	^ self predicateIterator next! !

!XPathASTNodeVisitor methodsFor: 'iterating' stamp: 'monty 1/27/2017 21:01'!
nextStep
	^ self stepIterator next! !

!XPathASTNodeVisitor methodsFor: 'iterating' stamp: 'monty 1/27/2017 21:01'!
peekArgument
	^ self argumentIterator peek! !

!XPathASTNodeVisitor methodsFor: 'iterating' stamp: 'monty 1/27/2017 21:02'!
peekPredicate
	^ self predicateIterator peek! !

!XPathASTNodeVisitor methodsFor: 'iterating' stamp: 'monty 1/27/2017 21:02'!
peekStep
	^ self stepIterator peek! !

!XPathASTNodeVisitor methodsFor: 'private' stamp: 'monty 1/27/2017 22:29'!
predicateIterator
	^ predicateIterator
		ifNil: [predicateIterator := XPathASTNodeVisitorIterator null]! !

!XPathASTNodeVisitor methodsFor: 'iterating' stamp: 'monty 1/27/2017 21:02'!
previousArgument
	^ self argumentIterator previousVisited! !

!XPathASTNodeVisitor methodsFor: 'iterating' stamp: 'monty 1/27/2017 21:03'!
previousPredicate
	^ self predicateIterator previousVisited! !

!XPathASTNodeVisitor methodsFor: 'iterating' stamp: 'monty 1/27/2017 21:03'!
previousStep
	^ self stepIterator previousVisited! !

!XPathASTNodeVisitor methodsFor: 'private' stamp: 'monty 1/27/2017 22:29'!
stepIterator
	^ stepIterator
		ifNil: [stepIterator := XPathASTNodeVisitorIterator null]! !

!XPathASTNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 1/11/2017 13:02'!
visitAbsoluteLocationPath: anAbsoluteLocationPath
	^ self visitLocationPath: anAbsoluteLocationPath! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitAdditionExpression: anAdditionExpression
	^ self visitBinaryOperatorExpression: anAdditionExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:09'!
visitAncestorOrSelfStep: anAncestorOrSelfStep
	^ self visitStep: anAncestorOrSelfStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:09'!
visitAncestorStep: anAncestorStep
	^ self visitStep: anAncestorStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitAndExpression: anAndExpression
	^ self visitBinaryOperatorExpression: anAndExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 1/11/2017 13:04'!
visitAnyNodeTest: anAnyNodeTest
	^ self visitNodeTest: anAnyNodeTest! !

!XPathASTNodeVisitor methodsFor: 'visiting - functions' stamp: 'monty 1/19/2017 19:24'!
visitArgument: aNode
	^ self visitNodeWithExpression: aNode! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:35'!
visitAttributeNodeTest: anAttributeNodeTest
	^ self visitNodeTest: anAttributeNodeTest! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:36'!
visitAttributeNodeTestForLocalName: anAttributeNodeTestForLocalName
	^ self visitNodeTest: anAttributeNodeTestForLocalName! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:28'!
visitAttributeNodeTestForName: anAttributeTestForName
	^ self visitNodeTest: anAttributeTestForName! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:37'!
visitAttributeNodeTestForNamespaceURI: anAttributeNodeTestForNamespaceURI
	^ self visitNodeTest: anAttributeNodeTestForNamespaceURI! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:37'!
visitAttributeNodeTestForNamespaceURIAndLocalName: anAttributeNodeTestForNamespaceURIAndLocalName
	^ self visitNodeTest: anAttributeNodeTestForNamespaceURIAndLocalName! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:38'!
visitAttributeNodeTestForPrefix: anAttributeNodeTestForPrefix
	^ self visitNodeTest: anAttributeNodeTestForPrefix! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 1/25/2018 23:23'!
visitAttributeNodeTestForPrefixAndLocalName: anAttributeNodeTestForPrefixAndLocalName
	^ self visitNodeTest: anAttributeNodeTestForPrefixAndLocalName! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:09'!
visitAttributeStep: anAttributeStep
	^ self visitStep: anAttributeStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/20/2017 07:49'!
visitBinaryOperatorExpression: aBinaryOperatorExpression
	^ self visitNodeWithOtherExpression: aBinaryOperatorExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2017 09:44'!
visitChildStep: aChildStep
	^ self visitStep: aChildStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:35'!
visitCommentNodeTest: aCommentNodeTest
	^ self visitNodeTest: aCommentNodeTest! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:09'!
visitDescendantOrSelfStep: aDescendantOrSelfStep
	^ self visitStep: aDescendantOrSelfStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:09'!
visitDescendantStep: aDescendantStep
	^ self visitStep: aDescendantStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitDivisionExpression: aDivisionExpression
	^ self visitBinaryOperatorExpression: aDivisionExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:40'!
visitElementNodeTest: anElementNodeTest
	^ self visitNodeTest: anElementNodeTest! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:40'!
visitElementNodeTestForLocalName: anElementNodeTestForLocalName
	^ self visitNodeTest: anElementNodeTestForLocalName! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:40'!
visitElementNodeTestForName: anElementNodeTestForName
	^ self visitNodeTest: anElementNodeTestForName! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:40'!
visitElementNodeTestForNamespaceURI: anElementNodeTestForNamespaceURI
	^ self visitNodeTest: anElementNodeTestForNamespaceURI! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:41'!
visitElementNodeTestForNamespaceURIAndLocalName: anElementNodeTestForNamespaceURIAndLocalName
	^ self visitNodeTest: anElementNodeTestForNamespaceURIAndLocalName! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:41'!
visitElementNodeTestForPrefix: anElementNodeTestForPrefix
	^ self visitNodeTest: anElementNodeTestForPrefix! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:41'!
visitElementNodeTestForPrefixAndLocalName: anElementNodeTestForPrefixAndLocalName
	^ self visitNodeTest: anElementNodeTestForPrefixAndLocalName! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitEqualsExpression: anEqualsExpression
	^ self visitBinaryOperatorExpression: anEqualsExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/19/2017 19:24'!
visitExpressionRoot: anExpressionRoot
	^ self visitNodeWithExpression: anExpressionRoot! !

!XPathASTNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 1/19/2017 19:24'!
visitFilterExpression: aFilterExpression
	^ self
		visitNodeWithExpression: aFilterExpression;
		visitFilterable: aFilterExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 1/19/2017 19:25'!
visitFilterExpressionLocationPath: aFilterExpressionLocationPath
	^ self
		visitNodeWithExpression: aFilterExpressionLocationPath;
		visitLocationPath: aFilterExpressionLocationPath! !

!XPathASTNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 1/27/2017 21:24'!
visitFilterable: aFilterable
	aFilterable hasPredicates
		ifTrue: [| oldPredicateIterator |
			oldPredicateIterator := predicateIterator.
			predicateIterator :=
				XPathASTNodeVisitorIterator on: aFilterable predicates.
			[predicateIterator atEnd]
				whileFalse: [predicateIterator visitNextWith: self].
			predicateIterator := oldPredicateIterator].
	^ aFilterable.! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:09'!
visitFollowingSiblingStep: aFollowingSiblingStep
	^ self visitStep: aFollowingSiblingStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:09'!
visitFollowingStep: aFollowingStep
	^ self visitStep: aFollowingStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - functions' stamp: 'monty 1/27/2017 21:27'!
visitFunctionCall: aFunctionCall
	aFunctionCall hasArguments
		ifTrue: [| oldArgumentIterator |
			oldArgumentIterator := argumentIterator.
			argumentIterator :=
				XPathASTNodeVisitorIterator on: aFunctionCall arguments.
			[argumentIterator atEnd]
				whileFalse: [argumentIterator visitNextWith: self].
			argumentIterator := oldArgumentIterator].
	^ aFunctionCall.! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:04'!
visitGreaterThanExpression: aGreaterThanExpression
	^ self visitBinaryOperatorExpression: aGreaterThanExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitGreaterThanOrEqualToExpression: aGreaterThanOrEqualToExpression
	^ self visitBinaryOperatorExpression: aGreaterThanOrEqualToExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitLessThanExpression: aLessThanExpression
	^ self visitBinaryOperatorExpression: aLessThanExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitLessThanOrEqualToExpression: aLessThanOrEqualToExpression
	^ self visitBinaryOperatorExpression: aLessThanOrEqualToExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 1/27/2017 21:24'!
visitLocationPath: aLocationPath
	aLocationPath hasSteps
		ifTrue: [| oldStepIterator |
			oldStepIterator := stepIterator.
			stepIterator := XPathASTNodeVisitorIterator on: aLocationPath steps.
			[stepIterator atEnd]
				whileFalse: [stepIterator visitNextWith: self].
			stepIterator := oldStepIterator].
	^ aLocationPath.! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitModulusExpression: aModulusExpression
	^ self visitBinaryOperatorExpression: aModulusExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitMultiplicationExpression: aMultiplicationExpression
	^ self visitBinaryOperatorExpression: aMultiplicationExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:34'!
visitNamespaceNodeTest: aNamespaceNodeTest
	^ self visitNodeTest: aNamespaceNodeTest! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:34'!
visitNamespaceNodeTestForLocalName: aNamespaceNodeTestForLocalName
	^ self visitNodeTest: aNamespaceNodeTestForLocalName! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:34'!
visitNamespaceNodeTestForName: aNamespaceNodeTestForName
	^ self visitNodeTest: aNamespaceNodeTestForName! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:33'!
visitNamespaceNodeTestForNamespaceURI: aNamespaceNodeTestForNamespaceURI
	^ self visitNodeTest: aNamespaceNodeTestForNamespaceURI! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:33'!
visitNamespaceNodeTestForNamespaceURIAndLocalName: aNamespaceNodeTestForNamespaceURIAndLocalName
	^ self visitNodeTest: aNamespaceNodeTestForNamespaceURIAndLocalName! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:32'!
visitNamespaceNodeTestForPrefix: aNamespaceNodeTestForPrefix
	^ self visitNodeTest: aNamespaceNodeTestForPrefix! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:25'!
visitNamespaceNodeTestForPrefixAndLocalName: aNamespaceTestForPrefixAndLocalName
	^ self visitNodeTest: aNamespaceTestForPrefixAndLocalName! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:09'!
visitNamespaceStep: aNamespaceStep
	^ self visitStep: aNamespaceStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:01'!
visitNegationExpression: aNegationExpression
	^ self visitUnaryOperatorExpression: aNegationExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/11/2017 13:13'!
visitNode: aNode
	^ aNode acceptNodeVisitor: self! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 1/11/2017 13:04'!
visitNodeTest: aNodeTest
	^ aNodeTest! !

!XPathASTNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/19/2017 19:23'!
visitNodeWithExpression: aNodeWithExpression
	aNodeWithExpression expression acceptNodeVisitor: self.
	^ aNodeWithExpression.! !

!XPathASTNodeVisitor methodsFor: 'visiting' stamp: 'monty 1/20/2017 07:49'!
visitNodeWithOtherExpression: aNodeWithOtherExpression
	self visitNodeWithExpression: aNodeWithOtherExpression.
	aNodeWithOtherExpression otherExpression acceptNodeVisitor: self.
	^ aNodeWithOtherExpression.! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitNotEqualsExpression: aNotEqualsExpression
	^ self visitBinaryOperatorExpression: aNotEqualsExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - literals' stamp: 'monty 1/11/2017 13:02'!
visitNumberLiteral: aNumberLiteral
	^ aNumberLiteral! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitOrExpression: anOrExpression
	^ self visitBinaryOperatorExpression: anOrExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:32'!
visitPINodeTest: aPINodeTest
	^ self visitNodeTest: aPINodeTest! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:24'!
visitPINodeTestForName: aPINodeTestForName
	^ self visitNodeTest: aPINodeTestForName! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:10'!
visitParentStep: aParentStep
	^ self visitStep: aParentStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:10'!
visitPrecedingSiblingStep: aPrecedingSiblingStep
	^ self visitStep: aPrecedingSiblingStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:10'!
visitPrecedingStep: aPrecedingStep
	^ self visitStep: aPrecedingStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - predicates' stamp: 'monty 1/19/2017 19:26'!
visitPredicate: aPredicate
	^ self visitNodeWithExpression: aPredicate! !

!XPathASTNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 1/11/2017 13:03'!
visitRelativeLocationPath: aRelativeLocationPath
	^ self visitLocationPath: aRelativeLocationPath! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/11/2017 13:10'!
visitSelfStep: aSelfStep
	^ self visitStep: aSelfStep! !

!XPathASTNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/19/2017 11:28'!
visitStep: aStep
	aStep nodeTest acceptNodeVisitor: self.
	^ self visitFilterable: aStep.! !

!XPathASTNodeVisitor methodsFor: 'visiting - literals' stamp: 'monty 1/11/2017 13:02'!
visitStringLiteral: aStringLiteral
	^ aStringLiteral! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitSubtractionExpression: aSubtractionExpression
	^ self visitBinaryOperatorExpression: aSubtractionExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:31'!
visitTextNodeTest: aTextNodeTest
	^ self visitNodeTest: aTextNodeTest! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/19/2017 19:25'!
visitUnaryOperatorExpression: aUnaryOperatorExpression
	^ self visitNodeWithExpression: aUnaryOperatorExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 19:03'!
visitUnionExpression: aUnionExpression
	^ self visitBinaryOperatorExpression: aUnionExpression! !

!XPathASTNodeVisitor methodsFor: 'visiting - variables' stamp: 'monty 1/11/2017 13:02'!
visitVariableReference: aVariableReference
	^ aVariableReference! !

XPathASTNodeVisitor subclass: #XPathASTWritingNodeVisitor
	instanceVariableNames: 'stream'
	classVariableNames: 'SpaceCharacter'
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTWritingNodeVisitor commentStamp: 'monty 3/9/2017 20:52' prior: 0!
This is a base class for AST node visitors that output the AST using a write stream. Instances can be created with #on: to supply a write stream or #new, which will create one, and the result of writing can be obtained with #asString or #contents. (#printString and #printOn: will truncate the output.)!

XPathASTWritingNodeVisitor subclass: #XPathASTSourceWritingNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTSourceWritingNodeVisitor commentStamp: 'monty 2/14/2017 00:40' prior: 0!
This class is a writing AST visitor that writes the AST as XPath source code that can be parsed by an XPathExpressionParser.!

!XPathASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 4/1/2017 23:20'!
emitArgumentSeparator
	self previousArgument isNull
		ifFalse: [self emitAll: ', ']! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 3/31/2017 07:26'!
emitAxisName: anAxisNameStringOrCharacter
	self
		emitAll: anAxisNameStringOrCharacter asString;
		emitAll: '::'! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 4/4/2017 17:57'!
emitNodeTest: aNodeTest withNameTest: aNameTestString
	(aNodeTest hasParent
		and: [aNodeTest nodeType = aNodeTest parent principalNodeType])
		ifTrue: [
			"if the node type of the node test is the principal node
			type of the axis, then it's redundant and can be omitted"
			self emitAll: aNameTestString]
		ifFalse: [
			self
				emitTypeTest: aNodeTest
				withNameTest: aNameTestString].
	^ aNodeTest! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 3/31/2017 07:26'!
emitOperatorName: anOperatorNameStringOrCharacter
	self emitAll: anOperatorNameStringOrCharacter asString! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 4/3/2017 17:05'!
emitTypeTest: aNodeTest withNameTest: aNameTestString
	self
		emitAll: aNodeTest nodeType name;
		emit: $(;
		emitAll: aNameTestString;
		emit: $).
	^ aNodeTest! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - functions' stamp: 'monty 4/1/2017 23:19'!
visitArgument: anArgument
	self emitArgumentSeparator.
	^ super visitArgument: anArgument.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitAttributeNodeTest: anAttributeNodeTest
	^ self
		emitNodeTest: anAttributeNodeTest
		withNameTest: '*'! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitAttributeNodeTestForLocalName: anAttributeNodeTestForLocalName
	^ self
		emitNodeTest: anAttributeNodeTestForLocalName
		withNameTest: anAttributeNodeTestForLocalName localName! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitAttributeNodeTestForName: anAttributeNodeTestForName
	^ self
		emitNodeTest: anAttributeNodeTestForName
		withNameTest: anAttributeNodeTestForName name! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitAttributeNodeTestForNamespaceURI: anAttributeNodeTestForNamespaceURI
	^ self
		emitNodeTest: anAttributeNodeTestForNamespaceURI
		withNameTest:
			('*' expandWithXMLNamespaceURI:
				anAttributeNodeTestForNamespaceURI namespaceURI)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitAttributeNodeTestForNamespaceURIAndLocalName: anAttributeNodeTestForNamespaceURIAndLocalName
	^ self
		emitNodeTest: anAttributeNodeTestForNamespaceURIAndLocalName
		withNameTest:
			(anAttributeNodeTestForNamespaceURIAndLocalName localName 
				expandWithXMLNamespaceURI:
					anAttributeNodeTestForNamespaceURIAndLocalName namespaceURI)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitAttributeNodeTestForPrefix: anAttributeNodeTestForPrefix
	^ self
		emitNodeTest: anAttributeNodeTestForPrefix
		withNameTest: ('*' qualifyWithXMLPrefix: anAttributeNodeTestForPrefix prefix)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitAttributeNodeTestForPrefixAndLocalName: anAttributeNodeTestForPrefixAndLocalName
	^ self
		emitNodeTest: anAttributeNodeTestForPrefixAndLocalName
		withNameTest:
			(anAttributeNodeTestForPrefixAndLocalName localName
				qualifyWithXMLPrefix:
					anAttributeNodeTestForPrefixAndLocalName prefix)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 3/31/2017 04:46'!
visitBinaryOperatorExpression: aBinaryOperatorExpression
	self emit: $(.
	aBinaryOperatorExpression expression acceptNodeVisitor: self.
	self
		emitSpace;
		emitOperatorName: aBinaryOperatorExpression operatorName;
		emitSpace.
	aBinaryOperatorExpression otherExpression acceptNodeVisitor: self.
	self emit: $).
	^ aBinaryOperatorExpression.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitElementNodeTest: anElementNodeTest
	^ self
		emitNodeTest: anElementNodeTest
		withNameTest: '*'! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitElementNodeTestForLocalName: anElementNodeTestForLocalName
	^ self
		emitNodeTest: anElementNodeTestForLocalName
		withNameTest: anElementNodeTestForLocalName localName! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitElementNodeTestForName: anElementNodeTestForName
	^ self
		emitNodeTest: anElementNodeTestForName
		withNameTest: anElementNodeTestForName name! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitElementNodeTestForNamespaceURI: anElementNodeTestForNamespaceURI
	^ self
		emitNodeTest: anElementNodeTestForNamespaceURI
		withNameTest:
			('*' expandWithXMLNamespaceURI:
				anElementNodeTestForNamespaceURI namespaceURI)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitElementNodeTestForNamespaceURIAndLocalName: anElementNodeTestForNamespaceURIAndLocalName
	^ self
		emitNodeTest: anElementNodeTestForNamespaceURIAndLocalName
		withNameTest:
			(anElementNodeTestForNamespaceURIAndLocalName localName 
				expandWithXMLNamespaceURI:
					anElementNodeTestForNamespaceURIAndLocalName namespaceURI)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitElementNodeTestForPrefix: anElementNodeTestForPrefix
	^ self
		emitNodeTest: anElementNodeTestForPrefix
		withNameTest: ('*' qualifyWithXMLPrefix: anElementNodeTestForPrefix prefix)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitElementNodeTestForPrefixAndLocalName: anElementNodeTestForPrefixAndLocalName
	^ self
		emitNodeTest: anElementNodeTestForPrefixAndLocalName
		withNameTest:
			(anElementNodeTestForPrefixAndLocalName localName
				qualifyWithXMLPrefix:
					anElementNodeTestForPrefixAndLocalName prefix)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 2/6/2017 21:50'!
visitFilterExpression: aFilterExpression
	self emit: $(.
	aFilterExpression expression acceptNodeVisitor: self.
	^ self
		emit: $);
		visitFilterable: aFilterExpression.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 2/6/2017 21:46'!
visitFilterExpressionLocationPath: aFilterExpressionLocationPath
	self emit: $(.
	aFilterExpressionLocationPath expression acceptNodeVisitor: self.
	^ self
		emit: $);
		visitLocationPath: aFilterExpressionLocationPath.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - functions' stamp: 'monty 2/6/2017 21:37'!
visitFunctionCall: aFunctionCall
	self
		emitAll: aFunctionCall name;
		emit: $(.
	super visitFunctionCall: aFunctionCall.
	self emit: $).
	^ aFunctionCall.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitNamespaceNodeTest: aNamespaceNodeTest
	^ self
		emitNodeTest: aNamespaceNodeTest
		withNameTest: '*'! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitNamespaceNodeTestForLocalName: aNamespaceNodeTestForLocalName
	^ self
		emitNodeTest: aNamespaceNodeTestForLocalName
		withNameTest: aNamespaceNodeTestForLocalName localName! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitNamespaceNodeTestForName: aNamespaceNodeTestForName
	^ self
		emitNodeTest: aNamespaceNodeTestForName
		withNameTest: aNamespaceNodeTestForName name! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitNamespaceNodeTestForNamespaceURI: aNamespaceNodeTestForNamespaceURI
	^ self
		emitNodeTest: aNamespaceNodeTestForNamespaceURI
		withNameTest:
			('*' expandWithXMLNamespaceURI:
				aNamespaceNodeTestForNamespaceURI namespaceURI)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitNamespaceNodeTestForNamespaceURIAndLocalName: aNamespaceNodeTestForNamespaceURIAndLocalName
	^ self
		emitNodeTest: aNamespaceNodeTestForNamespaceURIAndLocalName
		withNameTest:
			(aNamespaceNodeTestForNamespaceURIAndLocalName localName 
				expandWithXMLNamespaceURI:
					aNamespaceNodeTestForNamespaceURIAndLocalName namespaceURI)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitNamespaceNodeTestForPrefix: aNamespaceNodeTestForPrefix
	^ self
		emitNodeTest: aNamespaceNodeTestForPrefix
		withNameTest: ('*' qualifyWithXMLPrefix: aNamespaceNodeTestForPrefix prefix)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitNamespaceNodeTestForPrefixAndLocalName: aNamespaceNodeTestForPrefixAndLocalName
	^ self
		emitNodeTest: aNamespaceNodeTestForPrefixAndLocalName
		withNameTest:
			(aNamespaceNodeTestForPrefixAndLocalName localName
				qualifyWithXMLPrefix:
					aNamespaceNodeTestForPrefixAndLocalName prefix)! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitNodeTest: aNodeTest
	self
		emitNodeTest: aNodeTest
		withNameTest: ''.
	^ super visitNodeTest: aNodeTest.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - literals' stamp: 'monty 2/6/2017 22:06'!
visitNumberLiteral: aNumberLiteral
	| number |

	(number := aNumberLiteral number) isNaN
		ifTrue: [self emitAll: '(0 div 0)']
		ifFalse: [
			number isInfinite
				ifTrue: [
					number negative
						ifTrue: [self emitAll: '(-1 div 0)']
						ifFalse: [self emitAll: '(1 div 0)']]
				ifFalse: [
					number isZero
						ifTrue: [
							number isXPathNegativeZero
								ifTrue: [self emitAll: '-0.0']
								ifFalse: [self emitAll: '0.0']]
						ifFalse: [
							"otherwise, this is enough to get an acceptable
							integer or limited decimal (if the #fractionPart is
							non-zero) representation that an XPathExpressionParser
							or XPathNumberParser will understand"
							self emitAll: number asXPathString]]].

	^ aNumberLiteral.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 4/3/2017 17:03'!
visitPINodeTestForName: aPINodeTestForName
	^ self
		emitNodeTest: aPINodeTestForName
		withNameTest: aPINodeTestForName name! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - predicates' stamp: 'monty 2/6/2017 21:52'!
visitPredicate: aPredicate
	self emit: $[.
	super visitPredicate: aPredicate.
	self emit: $].
	^ aPredicate.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 3/31/2017 04:53'!
visitStep: aStep
	(self previousStep isNull
		and: [aStep parent isRelativeLocationPath])
		ifFalse: [self emit: $/].
	self emitAxisName: aStep axisName.
	super visitStep: aStep.
	^ aStep.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - literals' stamp: 'monty 2/21/2017 08:41'!
visitStringLiteral: aStringLiteral
	| quote |

	"use whichever quote char the string doesn't contain, but
	default to the double quote"
	quote :=
		(aStringLiteral string includes: $")
			ifTrue: [$']
			ifFalse: [$"].
	self
		emit: quote;
		emitAll: aStringLiteral string;
		emit: quote.
	^ aStringLiteral.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 3/31/2017 04:47'!
visitUnaryOperatorExpression: aUnaryOperatorExpression
	self
		emitOperatorName: aUnaryOperatorExpression operatorName;
		emit: $(.
	super visitUnaryOperatorExpression: aUnaryOperatorExpression.
	self emit: $).
	^ aUnaryOperatorExpression.! !

!XPathASTSourceWritingNodeVisitor methodsFor: 'visiting - variables' stamp: 'monty 2/6/2017 22:00'!
visitVariableReference: aVariableReference
	self
		emit: $$;
		emitAll: aVariableReference name! !

XPathASTWritingNodeVisitor subclass: #XPathASTTranslatingWritingNodeVisitor
	instanceVariableNames: 'contextBlockVariables contextBlockIndex nodeTests'
	classVariableNames: 'InlinedFunctionNamesAndSelectors'
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTTranslatingWritingNodeVisitor commentStamp: 'monty 2/21/2017 08:38' prior: 0!
This class is a writing AST visitor that translates the AST to Smalltalk source code and an array of node test objects that can be compiled. The resulting XPathTranslatedExpression object can be accessed with #translatedExpression after sending #visitNode: to the AST root.!

!XPathASTTranslatingWritingNodeVisitor class methodsFor: 'class initialization' stamp: 'monty 2/1/2017 03:19'!
initialize
	"self initialize"

	InlinedFunctionNamesAndSelectors :=
		Dictionary new
			at: 'true' put: #emitInlinedTrueFunctionCall:;
			at: 'false' put: #emitInlinedFalseFunctionCall:;
			at: 'position' put: #emitInlinedPositionFunctionCall:;
			at: 'last' put: #emitInlinedLastFunctionCall:;
			yourself! !

XPathASTTranslatingWritingNodeVisitor initialize!

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'testing' stamp: 'monty 1/20/2018 20:16'!
canEmitAsPredicateStep: aStep
	^ (self peekStep isNull
		and: [aStep hasPredicates not
			and: [aStep isPredicateLocationPathStep]])! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/29/2017 21:31'!
contextBlockVariableAt: anIndex
	^ (contextBlockVariables
		ifNil: [self generateNewContextBlockVariables])
			at: anIndex! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/29/2017 21:31'!
contextNodeVariable
	^ self contextBlockVariableAt: 1! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/29/2017 21:31'!
contextPositionVariable
	^ self contextBlockVariableAt: 2! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/29/2017 21:31'!
contextSizeVariable
	^ self contextBlockVariableAt: 3! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/29/2017 21:07'!
contextVariable
	"the XPathContext variable doesn't change during evaluation"
	^ 'c'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/29/2017 21:08'!
documentRootVariable
	"the document root variable doesn't change during evaluation"
	^ 'r'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/20/2018 20:30'!
emitBinaryArithmeticExpression: aBinaryExpression withOperator: aSelectorString
	self emit: $(.
	(aBinaryExpression expression
		acceptNodeVisitor: self;
		type) isNumberValueType
		ifFalse: [self emitNumberConversion].

	self
		emitSpace;
		emitAll: aSelectorString.

	(aBinaryExpression otherExpression
		acceptNodeVisitor: self;
		type) isNumberValueType
		ifFalse: [self emitNumberConversion].
	self emit: $).

	^ aBinaryExpression.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/20/2018 20:31'!
emitBinaryEqualityExpression: aBinaryExpression withOperator: aSelectorString
	| omitComparableConversions |

	"Smalltalk strings, numbers, and booleans have = and ~= selectors that behave
	like the XPath spec requires when the argument is the same type, so no
	comparable converion is needed, but cross-type comparisons and comparisons
	between node sets need to be handled with comparables"
	omitComparableConversions :=
		(aBinaryExpression expression type isNumberValueType
			or: [aBinaryExpression expression type isStringValueType
				or: [aBinaryExpression expression type isBooleanValueType]])
			and: [
				aBinaryExpression expression type =
					aBinaryExpression otherExpression type].

	self emit: $(.
	aBinaryExpression expression acceptNodeVisitor: self.
	omitComparableConversions
		ifFalse: [self emitComparableConversion].

	self
		emitSpace;
		emitAll: aSelectorString.

	aBinaryExpression otherExpression acceptNodeVisitor: self.
	omitComparableConversions
		ifFalse: [self emitComparableConversion].
	self emit: $).

	^ aBinaryExpression.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/20/2018 20:31'!
emitBinaryRelationalExpression: aBinaryExpression withOperator: aSelectorString
	| omitComparableConversions |

	"if neither subexpression is of node set type, then comparable
	conversions aren't needed, and converting non-numbers to numbers
	is enough."
	omitComparableConversions :=
		aBinaryExpression expression type isNodeSetValueType not
			and: [aBinaryExpression otherExpression type isNodeSetValueType not].

	self emit: $(.
	aBinaryExpression expression acceptNodeVisitor: self.
	omitComparableConversions
		ifTrue: [
			aBinaryExpression expression type isNumberValueType
				ifFalse: [self emitNumberConversion]]
		ifFalse: [self emitComparableConversion].

	self
		emitSpace;
		emitAll: aSelectorString.

	aBinaryExpression otherExpression acceptNodeVisitor: self.
	omitComparableConversions
		ifTrue: [
			aBinaryExpression otherExpression type isNumberValueType
				ifFalse: [self emitNumberConversion]]
		ifFalse: [self emitComparableConversion].
	self emit: $).

	^ aBinaryExpression.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/20/2018 20:31'!
emitBinaryShortCircuitExpression: aBinaryExpression withOperator: aSelectorString
	self emit: $(.
	(aBinaryExpression expression
		acceptNodeVisitor: self;
		type) isBooleanValueType
		ifFalse: [self emitBooleanConversion].

	self
		emitSpace;
		emitAll: aSelectorString;
		emit: $[.

	(aBinaryExpression otherExpression
		acceptNodeVisitor: self;
		type) isBooleanValueType
		ifFalse: [self emitBooleanConversion].
	self emitAll: '])'.

	^ aBinaryExpression.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/4/2017 08:36'!
emitBooleanConversion
	self emitAll: ' asXPathBoolean'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/4/2017 08:36'!
emitComparableConversion
	self emitAll: ' asXPathComparable'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/29/2017 21:01'!
emitEndBlock
	self emit: $]! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/30/2017 00:00'!
emitInitializingDocumentRootVariableReference
	self
		emit: $(;
		emitAll: self documentRootVariable;
		emitAll: ' ifNil:[';
		emitAll: self documentRootVariable;
		emitAll: ':=';
		emitAll: self contextNodeVariable;
		emitAll: ' documentRoot])'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/13/2017 04:46'!
emitInlinedFalseFunctionCall: aFunctionCall
	aFunctionCall hasArguments
		ifTrue: [self errorFalseFunctionTakesNoArguments].
	self emitAll: '(false)'.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/18/2017 14:57'!
emitInlinedLastFunctionCall: aFunctionCall
	aFunctionCall hasArguments
		ifTrue: [self errorLastFunctionTakesNoArguments].
	self
		emit: $(;
		emitAll: self contextSizeVariable;
		emitAll: ' ifNil:[1])'.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/18/2017 14:57'!
emitInlinedPositionFunctionCall: aFunctionCall
	aFunctionCall hasArguments
		ifTrue: [self errorPositionFunctionTakesNoArguments].
	self
		emit: $(;
		emitAll: self contextPositionVariable;
		emitAll: ' ifNil:[1])'.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/13/2017 04:46'!
emitInlinedTrueFunctionCall: aFunctionCall
	aFunctionCall hasArguments
		ifTrue: [self errorTrueFunctionTakesNoArguments].
	self emitAll: '(true)'.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 4/21/2017 13:11'!
emitNodeSetSortForLocationPath: aLocationPath
	(aLocationPath hasSteps
		and: [aLocationPath isPredicateLocationPath not])
		ifTrue: [self emitAll: ' sort']! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/4/2017 08:36'!
emitNumberConversion
	self emitAll: ' asXPathNumber'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/4/2017 08:36'!
emitNumberLiteral: anIntegerOrFloatString
	self
		emit: $(;
		emitAll: anIntegerOrFloatString;
		emit: $)! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/4/2017 08:36'!
emitPredicateSeparator
	self emit: $.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 2/21/2017 08:42'!
emitQuotedString: aString
	self emit: $'.
	"use #to:do: for speed"
	1 to: aString size do: [:i | | nextChar |
		"escape $' by outputting another $' before it"
		(nextChar := aString at: i) == $'
			ifTrue: [self emit: $'].
		self emit: nextChar].
	self emit: $'.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 2/4/2017 21:44'!
emitStartContextBlock
	self
		emitAll: '[:';
		emitAll: self contextNodeVariable;
		emitAll: ' :';
		emitAll: self contextVariable;
		emitAll: ' :';
		emitAll: self nodeTestsVariable;
		emitAll: '| |';
		emitAll: self contextPositionVariable;
		emitSpace;
		emitAll: self contextSizeVariable;
		emitSpace;
		emitAll: self documentRootVariable;
		emit: $|! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/11/2017 10:44'!
emitStartGroupingsForLocationPath: aLocationPath
	aLocationPath hasSteps
		ifTrue: [
			1 to: aLocationPath steps size do: [:i |
				self emit: $(]]! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 2/2/2017 13:32'!
emitStartPredicateBlock
	self
		emitAll: '[:';
		emitAll: self contextNodeVariable;
		emitAll: ' :';
		emitAll: self contextPositionVariable;
		emitAll: ' :';
		emitAll: self contextSizeVariable;
		emit: $|! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/4/2017 08:36'!
emitUnionableConversion
	self emitAll: ' asXPathUnionable'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/13/2017 04:47'!
errorFalseFunctionTakesNoArguments
	self errorFunctionTakesNoArguments: 'false'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/14/2017 08:51'!
errorFunctionTakesNoArguments: aFunctionName
	XPathArgumentNumberException
		formatSignal: 'The {1}() function takes no arguments'
		with: aFunctionName! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/13/2017 04:44'!
errorLastFunctionTakesNoArguments
	self errorFunctionTakesNoArguments: 'last'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/13/2017 04:44'!
errorPositionFunctionTakesNoArguments
	self errorFunctionTakesNoArguments: 'position'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/13/2017 04:47'!
errorTrueFunctionTakesNoArguments
	self errorFunctionTakesNoArguments: 'true'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/29/2017 21:26'!
generateNewContextBlockIndex
	^ contextBlockIndex := contextBlockIndex + 1! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 1/29/2017 21:27'!
generateNewContextBlockVariables
	| indexString |

	indexString := self generateNewContextBlockIndex asString.
	^ contextBlockVariables :=
		Array
			with: (indexString copyWithFirst: $n) "node variable"
			with: (indexString copyWithFirst: $p) "position variable"
			with: (indexString copyWithFirst: $s). "size variable"! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'initialization' stamp: 'monty 2/6/2017 21:27'!
initialize
	super initialize.

	contextBlockIndex := 0.
	nodeTests := OrderedCollection new.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'private' stamp: 'monty 2/4/2017 21:43'!
nodeTestsVariable
	^ 't'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'accessing' stamp: 'monty 2/6/2017 21:31'!
translatedExpression
	^ XPathTranslatedExpression
		sourceCode: self contents
		nodeTests: nodeTests! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 4/21/2017 13:12'!
visitAbsoluteLocationPath: anAbsoluteLocationPath
	self
		emit: $(;
		emitStartGroupingsForLocationPath: anAbsoluteLocationPath;
		emitInitializingDocumentRootVariableReference.
	super visitAbsoluteLocationPath: anAbsoluteLocationPath.
	self
		emit: $);
		emitNodeSetSortForLocationPath: anAbsoluteLocationPath.
	^ anAbsoluteLocationPath.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/11/2017 13:16'!
visitAdditionExpression: anAdditionExpression
	^ self
		emitBinaryArithmeticExpression: anAdditionExpression
		withOperator: '+'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:17'!
visitAncestorOrSelfStep: anAncestorOrSelfStep
	(self canEmitAsPredicateStep: anAncestorOrSelfStep)
		ifTrue: [self emitAll: ' ancestorOrSelfAxisAnySatisfy:']
		ifFalse: [self emitAll: ' ancestorOrSelfAxis:'].
	^ super visitAncestorOrSelfStep: anAncestorOrSelfStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:17'!
visitAncestorStep: anAncestorStep
	(self canEmitAsPredicateStep: anAncestorStep)
		ifTrue: [self emitAll: ' ancestorAxisAnySatisfy:']
		ifFalse: [self emitAll: ' ancestorAxis:'].
	^ super visitAncestorStep: anAncestorStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/11/2017 13:20'!
visitAndExpression: anAndExpression
	^ self
		emitBinaryShortCircuitExpression: anAndExpression
		withOperator: 'and:'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/4/2017 21:29'!
visitAnyNodeTest: anAnyNodeTest
	nodeTests addLast: XPathAnyNodeTest new.
	^ super visitAnyNodeTest: anAnyNodeTest.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - functions' stamp: 'monty 1/19/2017 11:34'!
visitArgument: anArgument
	super visitArgument: anArgument.
	self emit: $..
	^ anArgument.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:36'!
visitAttributeNodeTest: anAttributeNodeTest
	nodeTests addLast: XPathAttributeNodeTest new.
	^ super visitAttributeNodeTest: anAttributeNodeTest.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:36'!
visitAttributeNodeTestForLocalName: anAttributeNodeTestForLocalName
	nodeTests addLast:
		(XPathAttributeNodeTestForLocalName localName:
			anAttributeNodeTestForLocalName localName).
	^ super visitAttributeNodeTestForLocalName: anAttributeNodeTestForLocalName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:28'!
visitAttributeNodeTestForName: anAttributeTestForName
	nodeTests addLast:
		(XPathAttributeNodeTestForName name:
			anAttributeTestForName name).
	^ super visitAttributeNodeTestForName: anAttributeTestForName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:37'!
visitAttributeNodeTestForNamespaceURI: anAttributeNodeTestForNamespaceURI
	nodeTests addLast:
		(XPathAttributeNodeTestForNamespaceURI namespaceURI:
			anAttributeNodeTestForNamespaceURI namespaceURI).
	^ super visitAttributeNodeTestForNamespaceURI:
		anAttributeNodeTestForNamespaceURI.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:37'!
visitAttributeNodeTestForNamespaceURIAndLocalName: anAttributeNodeTestForNamespaceURIAndLocalName
	nodeTests addLast:
		(XPathAttributeNodeTestForNamespaceURIAndLocalName
			namespaceURI: anAttributeNodeTestForNamespaceURIAndLocalName namespaceURI
			localName: anAttributeNodeTestForNamespaceURIAndLocalName localName).
	^ super visitAttributeNodeTestForNamespaceURIAndLocalName:
		anAttributeNodeTestForNamespaceURIAndLocalName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:38'!
visitAttributeNodeTestForPrefix: anAttributeNodeTestForPrefix
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' attributeTestForPrefix:''';
		emitAll: anAttributeNodeTestForPrefix prefix;
		emitAll: ''')'.
	^ super visitAttributeNodeTestForPrefix: anAttributeNodeTestForPrefix.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 1/25/2018 23:23'!
visitAttributeNodeTestForPrefixAndLocalName: anAttributeNodeTestForPrefixAndLocalName
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' attributeTestForPrefix:''';
		emitAll: anAttributeNodeTestForPrefixAndLocalName prefix;
		emitAll: '''localName:''';
		emitAll: anAttributeNodeTestForPrefixAndLocalName localName;
		emitAll: ''')'.
	^ super visitAttributeNodeTestForPrefixAndLocalName:
		anAttributeNodeTestForPrefixAndLocalName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:17'!
visitAttributeStep: anAttributeStep
	(self canEmitAsPredicateStep: anAttributeStep)
		ifTrue: [self emitAll: ' attributeAxisAnySatisfy:']
		ifFalse: [self emitAll: ' attributeAxis:'].
	^ super visitAttributeStep: anAttributeStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:17'!
visitChildStep: aChildStep
	(self canEmitAsPredicateStep: aChildStep)
		ifTrue: [self emitAll: ' childAxisAnySatisfy:']
		ifFalse: [self emitAll: ' childAxis:'].
	^ super visitChildStep: aChildStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:35'!
visitCommentNodeTest: aCommentNodeTest
	nodeTests addLast: XPathCommentNodeTest new.
	^ super visitCommentNodeTest: aCommentNodeTest.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:17'!
visitDescendantOrSelfStep: aDescendantOrSelfStep
	(self canEmitAsPredicateStep: aDescendantOrSelfStep)
		ifTrue: [self emitAll: ' descendantOrSelfAxisAnySatisfy:']
		ifFalse: [self emitAll: ' descendantOrSelfAxis:'].
	^ super visitDescendantOrSelfStep: aDescendantOrSelfStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:18'!
visitDescendantStep: aDescendantStep
	(self canEmitAsPredicateStep: aDescendantStep)
		ifTrue: [self emitAll: ' descendantAxisAnySatisfy:']
		ifFalse: [self emitAll: ' descendantAxis:'].
	^ super visitDescendantStep: aDescendantStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 3/14/2017 22:41'!
visitDivisionExpression: aDivisionExpression
	^ self
		emitBinaryArithmeticExpression: aDivisionExpression
		withOperator: 'xpathDivision:'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:40'!
visitElementNodeTest: anElementNodeTest
	nodeTests addLast: XPathElementNodeTest new.
	^ super visitElementNodeTest: anElementNodeTest.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:40'!
visitElementNodeTestForLocalName: anElementNodeTestForLocalName
	nodeTests addLast:
		(XPathElementNodeTestForLocalName localName:
			anElementNodeTestForLocalName localName).
	^ super visitElementNodeTestForLocalName: anElementNodeTestForLocalName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:40'!
visitElementNodeTestForName: anElementNodeTestForName
	nodeTests addLast:
		(XPathElementNodeTestForName name:
			anElementNodeTestForName name).
	^ super visitElementNodeTestForName: anElementNodeTestForName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:40'!
visitElementNodeTestForNamespaceURI: anElementNodeTestForNamespaceURI
	nodeTests addLast:
		(XPathElementNodeTestForNamespaceURI namespaceURI:
			anElementNodeTestForNamespaceURI namespaceURI).
	^ super visitElementNodeTestForNamespaceURI:
		anElementNodeTestForNamespaceURI.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:41'!
visitElementNodeTestForNamespaceURIAndLocalName: anElementNodeTestForNamespaceURIAndLocalName
	nodeTests addLast:
		(XPathElementNodeTestForNamespaceURIAndLocalName
			namespaceURI: anElementNodeTestForNamespaceURIAndLocalName namespaceURI
			localName: anElementNodeTestForNamespaceURIAndLocalName localName).
	^ super visitElementNodeTestForNamespaceURIAndLocalName:
		anElementNodeTestForNamespaceURIAndLocalName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:41'!
visitElementNodeTestForPrefix: anElementNodeTestForPrefix
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' elementTestForPrefix:''';
		emitAll: anElementNodeTestForPrefix prefix;
		emitAll: ''')'.
	^ super visitElementNodeTestForPrefix: anElementNodeTestForPrefix.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:41'!
visitElementNodeTestForPrefixAndLocalName: anElementNodeTestForPrefixAndLocalName
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' elementTestForPrefix:''';
		emitAll: anElementNodeTestForPrefixAndLocalName prefix;
		emitAll: '''localName:''';
		emitAll: anElementNodeTestForPrefixAndLocalName localName;
		emitAll: ''')'.
	^ super visitElementNodeTestForPrefixAndLocalName:
		anElementNodeTestForPrefixAndLocalName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/30/2017 18:50'!
visitEqualsExpression: anEqualsExpression
	^ self
		emitBinaryEqualityExpression: anEqualsExpression
		withOperator: '='! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting' stamp: 'monty 2/2/2017 13:33'!
visitExpressionRoot: anExpressionRoot
	self
		generateNewContextBlockVariables;
		emitStartContextBlock.
	super visitExpressionRoot: anExpressionRoot.
	self emitEndBlock.
	^ anExpressionRoot.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 1/19/2017 11:36'!
visitFilterExpression: aFilterExpression
	self emit: $(.
	super visitFilterExpression: aFilterExpression.
	self emit: $).
	^ aFilterExpression.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 4/21/2017 13:12'!
visitFilterExpressionLocationPath: aFilterExpressionLocationPath
	self
		emit: $(;
		emitStartGroupingsForLocationPath: aFilterExpressionLocationPath.
	aFilterExpressionLocationPath expression acceptNodeVisitor: self.
	self
		emitAll: ' asXPathFilterExpressionLocationPathRoot';
		visitLocationPath: aFilterExpressionLocationPath;
		emit: $);
		emitNodeSetSortForLocationPath: aFilterExpressionLocationPath.
	^ aFilterExpressionLocationPath.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 2/20/2017 03:52'!
visitFilterable: aFilterable
	aFilterable hasPredicates
		ifTrue: [
			self emitAll:
				(aFilterable isFilterExpression
					ifTrue: [' asXPathFilterExpressionPredicateRoot filterWithAll:{']
					ifFalse: [' predicates:{']).
			super visitFilterable: aFilterable.
			self emit: $}]
		ifFalse: [super visitFilterable: aFilterable].
	^ aFilterable.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:18'!
visitFollowingSiblingStep: aFollowingSiblingStep
	(self canEmitAsPredicateStep: aFollowingSiblingStep)
		ifTrue: [self emitAll: ' followingSiblingAxisAnySatisfy:']
		ifFalse: [self emitAll: ' followingSiblingAxis:'].
	^ super visitFollowingSiblingStep: aFollowingSiblingStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:18'!
visitFollowingStep: aFollowingStep
	(self canEmitAsPredicateStep: aFollowingStep)
		ifTrue: [self emitAll: ' followingAxisAnySatisfy:']
		ifFalse: [self emitAll: ' followingAxis:'].
	^ super visitFollowingStep: aFollowingStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - functions' stamp: 'monty 2/1/2017 03:19'!
visitFunctionCall: aFunctionCall
	InlinedFunctionNamesAndSelectors
		at: aFunctionCall name
		ifPresent: [:selector |
			self
				perform: selector
				with: aFunctionCall.
			^ aFunctionCall].

	self
		emitAll: '((';
		emitAll: self contextVariable;
		emitAll: ' resolveFunctionReference: ''';
		emitAll: aFunctionCall name;
		emitAll: ''' contextNode: ';
		emitAll: self contextNodeVariable;
		emitAll: ' arguments: {'.
	super visitFunctionCall: aFunctionCall.
	self emitAll: '})invoke)'.
	^ aFunctionCall.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/30/2017 18:50'!
visitGreaterThanExpression: aGreaterThanExpression
	^ self
		emitBinaryRelationalExpression: aGreaterThanExpression
		withOperator: '>'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/30/2017 18:50'!
visitGreaterThanOrEqualToExpression: aGreaterThanOrEqualToExpression
	^ self
		emitBinaryRelationalExpression: aGreaterThanOrEqualToExpression
		withOperator: '>='! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/30/2017 18:50'!
visitLessThanExpression: aLessThanExpression
	^ self
		emitBinaryRelationalExpression: aLessThanExpression
		withOperator: '<'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/30/2017 18:50'!
visitLessThanOrEqualToExpression: aLessThanOrEqualToExpression
	^ self
		emitBinaryRelationalExpression: aLessThanOrEqualToExpression
		withOperator: '<='! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 3/14/2017 22:41'!
visitModulusExpression: aModulusExpression
	^ self
		emitBinaryArithmeticExpression: aModulusExpression
		withOperator: 'xpathModulus:'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/11/2017 13:17'!
visitMultiplicationExpression: aMultiplicationExpression
	^ self
		emitBinaryArithmeticExpression: aMultiplicationExpression
		withOperator: '*'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:34'!
visitNamespaceNodeTest: aNamespaceNodeTest
	nodeTests addLast: XPathNamespaceTest new.
	^ super visitNamespaceNodeTest: aNamespaceNodeTest.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:34'!
visitNamespaceNodeTestForLocalName: aNamespaceNodeTestForLocalName
	nodeTests addLast:
		(XPathNamespaceTestForLocalName localName:
			aNamespaceNodeTestForLocalName localName).
	^ super visitNamespaceNodeTestForLocalName: aNamespaceNodeTestForLocalName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:34'!
visitNamespaceNodeTestForName: aNamespaceNodeTestForName
	nodeTests addLast:
		(XPathNamespaceTestForName name:
			aNamespaceNodeTestForName name).
	^ super visitNamespaceNodeTestForName: aNamespaceNodeTestForName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:39'!
visitNamespaceNodeTestForNamespaceURI: aNamespaceNodeTestForNamespaceURI
	nodeTests addLast:
		(XPathNamespaceTestForNamespaceURI namespaceURI:
			aNamespaceNodeTestForNamespaceURI namespaceURI).
	^ super visitNamespaceNodeTestForNamespaceURI:
		aNamespaceNodeTestForNamespaceURI.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:33'!
visitNamespaceNodeTestForNamespaceURIAndLocalName: aNamespaceNodeTestForNamespaceURIAndLocalName
	nodeTests addLast:
		(XPathNamespaceTestForNamespaceURIAndLocalName
			namespaceURI: aNamespaceNodeTestForNamespaceURIAndLocalName namespaceURI
			localName: aNamespaceNodeTestForNamespaceURIAndLocalName localName).
	^ super visitNamespaceNodeTestForNamespaceURIAndLocalName:
		aNamespaceNodeTestForNamespaceURIAndLocalName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:32'!
visitNamespaceNodeTestForPrefix: aNamespaceNodeTestForPrefix
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' namespaceTestForPrefix:''';
		emitAll: aNamespaceNodeTestForPrefix prefix;
		emitAll: ''')'.
	^ super visitNamespaceNodeTestForPrefix: aNamespaceNodeTestForPrefix.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:26'!
visitNamespaceNodeTestForPrefixAndLocalName: aNamespaceNodeTestForPrefixAndLocalName
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' namespaceTestForPrefix:''';
		emitAll: aNamespaceNodeTestForPrefixAndLocalName prefix;
		emitAll: '''localName:''';
		emitAll: aNamespaceNodeTestForPrefixAndLocalName localName;
		emitAll: ''')'.
	^ super visitNamespaceNodeTestForPrefixAndLocalName:
		aNamespaceNodeTestForPrefixAndLocalName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:18'!
visitNamespaceStep: aNamespaceStep
	(self canEmitAsPredicateStep: aNamespaceStep)
		ifTrue: [self emitAll: ' namespaceAxisAnySatisfy:']
		ifFalse: [self emitAll: ' namespaceAxis:'].
	^ super visitNamespaceStep: aNamespaceStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 2/9/2017 19:55'!
visitNegationExpression: aNegationExpression
	self emit: $(.
	super visitNegationExpression: aNegationExpression.
	aNegationExpression expression type isNumberValueType
		ifFalse: [self emitNumberConversion].
	self emitAll: ' negated)'.
	^ aNegationExpression.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/5/2017 20:30'!
visitNodeTest: aNodeTest
	(aNodeTest isAttributeNodeTestForPrefix
		or: [aNodeTest isElementNodeTestForPrefix
			or: [aNodeTest isNamespaceNodeTestForPrefix]])
		ifFalse: [
			self
				emit: $(;
				emitAll: self nodeTestsVariable;
				emitAll: ' at:';
				emitAll: nodeTests size asString;
				emit: $)]! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/30/2017 18:50'!
visitNotEqualsExpression: aNotEqualsExpression
	^ self
		emitBinaryEqualityExpression: aNotEqualsExpression
		withOperator: '~='! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - literals' stamp: 'monty 3/14/2017 22:31'!
visitNumberLiteral: aNumberLiteral
	| number |

	"can't just use #asXPathString here because we don't want the XPath string
	representation, but a self-evaluating Smalltalk representation, so NaN
	is rendered like 'Float nan' and not 'NaN', and can't just use #asString
	either because older implementations aren't self-evaluating for NaN and
	inifinity"
	(number := aNumberLiteral number) isNaN
		ifTrue: [self emitNumberLiteral: 'Float nan']
		ifFalse: [
			number isInfinite
				ifTrue: [
					number negative
						ifTrue: [self emitNumberLiteral: 'Float xpathNegativeInfinity']
						ifFalse: [self emitNumberLiteral: 'Float infinity']]
				ifFalse: [
					number isZero
						ifTrue: [
							number isXPathNegativeZero
								ifTrue: [
									self emitNumberLiteral: 'Float xpathNegativeZero']
								ifFalse: [self emitNumberLiteral: '0.0']]
						ifFalse: [
							"#asString should be OK for all others"
							self emitNumberLiteral: number asString]]].
	^ aNumberLiteral.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/11/2017 13:20'!
visitOrExpression: anOrExpression
	^ self
		emitBinaryShortCircuitExpression: anOrExpression
		withOperator: 'or:'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:32'!
visitPINodeTest: aPINodeTest
	nodeTests addLast: XPathPINodeTest new.
	^ super visitPINodeTest: aPINodeTest.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:25'!
visitPINodeTestForName: aPINodeTestForName
	nodeTests addLast:
		(XPathPINodeTestForName name: aPINodeTestForName name).
	^ super visitPINodeTestForName: aPINodeTestForName.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:18'!
visitParentStep: aParentStep
	(self canEmitAsPredicateStep: aParentStep)
		ifTrue: [self emitAll: ' parentAxisAnySatisfy:']
		ifFalse: [self emitAll: ' parentAxis:'].
	^ super visitParentStep: aParentStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:19'!
visitPrecedingSiblingStep: aPrecedingSiblingStep
	(self canEmitAsPredicateStep: aPrecedingSiblingStep)
		ifTrue: [self emitAll: ' precedingSiblingAxisAnySatisfy:']
		ifFalse: [self emitAll: ' precedingSiblingAxis:'].
	^ super visitPrecedingSiblingStep: aPrecedingSiblingStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:19'!
visitPrecedingStep: aPrecedingStep
	(self canEmitAsPredicateStep: aPrecedingStep)
		ifTrue: [self emitAll: ' precedingAxisAnySatisfy:']
		ifFalse: [self emitAll: ' precedingAxis:'].
	^ super visitPrecedingStep: aPrecedingStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - predicates' stamp: 'monty 1/29/2017 21:10'!
visitPredicate: aPredicate
	"number predicates like [1] can be inlined without outputting a
	predicate block"
	aPredicate expression isNumberLiteral
		ifTrue: [super visitPredicate: aPredicate]
		ifFalse: [| oldContextBlockVariables |
			oldContextBlockVariables := contextBlockVariables.
			self
				generateNewContextBlockVariables;
				emitStartPredicateBlock.
			super visitPredicate: aPredicate.
			self emitEndBlock.
			contextBlockVariables := oldContextBlockVariables].
	self emitPredicateSeparator.
	^ aPredicate.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - location paths' stamp: 'monty 4/21/2017 13:12'!
visitRelativeLocationPath: aRelativeLocationPath
	self
		emit: $(;
		emitStartGroupingsForLocationPath: aRelativeLocationPath;
		emitAll: self contextNodeVariable.
	super visitRelativeLocationPath: aRelativeLocationPath.
	self
		emit: $);
		emitNodeSetSortForLocationPath: aRelativeLocationPath.
	^ aRelativeLocationPath.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/20/2018 20:19'!
visitSelfStep: aSelfStep
	(self canEmitAsPredicateStep: aSelfStep)
		ifTrue: [self emitAll: ' selfAxisAnySatisfy:']
		ifFalse: [self emitAll: ' selfAxis:'].
	^ super visitSelfStep: aSelfStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - steps' stamp: 'monty 1/15/2017 12:26'!
visitStep: aStep
	super visitStep: aStep.
	self emit: $).
	^ aStep.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - literals' stamp: 'monty 1/11/2017 13:15'!
visitStringLiteral: aStringLiteral
	self emitQuotedString: aStringLiteral string.
	^ aStringLiteral.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/12/2017 06:33'!
visitSubtractionExpression: aSubtractionExpression
	^ self
		emitBinaryArithmeticExpression: aSubtractionExpression
		withOperator: '-'! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - node tests' stamp: 'monty 2/6/2017 23:31'!
visitTextNodeTest: aTextNodeTest
	nodeTests addLast: XPathTextNodeTest new.
	^ super visitTextNodeTest: aTextNodeTest.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - operators' stamp: 'monty 1/20/2018 20:32'!
visitUnionExpression: aUnionExpression
	self emit: $(.
	(aUnionExpression expression
		acceptNodeVisitor: self;
		type) isNodeSetValueType
		ifFalse: [self emitUnionableConversion].

	self emit: $|.

	(aUnionExpression otherExpression
		acceptNodeVisitor: self;
		type) isNodeSetValueType
		ifFalse: [self emitUnionableConversion].
	self emit: $).

	^ aUnionExpression.! !

!XPathASTTranslatingWritingNodeVisitor methodsFor: 'visiting - variables' stamp: 'monty 1/11/2017 13:15'!
visitVariableReference: aVariableReference
	self
		emit: $(;
		emitAll: self contextVariable;
		emitAll: ' resolveVariableReference: ''';
		emitAll: aVariableReference name;
		emitAll: ''')'.
	^ aVariableReference.! !

!XPathASTWritingNodeVisitor class methodsFor: 'class initialization' stamp: 'monty 2/6/2017 21:29'!
initialize
	"self initialize"

	SpaceCharacter := Character space! !

XPathASTWritingNodeVisitor initialize!

!XPathASTWritingNodeVisitor class methodsFor: 'instance creation' stamp: 'monty 2/6/2017 21:28'!
new
	"must use #writeStream instead of 'WriteStream on:' to get a 0-based
	stream on Gemstone"
	^ self on: (String new: 128) writeStream! !

!XPathASTWritingNodeVisitor class methodsFor: 'instance creation' stamp: 'monty 2/6/2017 21:03'!
on: aStream
	^ self basicNew initialize on: aStream! !

!XPathASTWritingNodeVisitor methodsFor: 'accessing' stamp: 'monty 3/9/2017 21:17'!
contents
	"returns a string of the currently written output"
	^ stream contents! !

!XPathASTWritingNodeVisitor methodsFor: 'private' stamp: 'monty 2/6/2017 21:27'!
emit: aCharacter
	stream nextPut: aCharacter! !

!XPathASTWritingNodeVisitor methodsFor: 'private' stamp: 'monty 2/6/2017 21:27'!
emitAll: aString
	stream nextPutAll: aString! !

!XPathASTWritingNodeVisitor methodsFor: 'private' stamp: 'monty 2/6/2017 21:28'!
emitSpace
	self emit: SpaceCharacter! !

!XPathASTWritingNodeVisitor methodsFor: 'initialization' stamp: 'monty 2/6/2017 21:27'!
on: aStream
	stream := aStream! !

!XPathASTWritingNodeVisitor methodsFor: 'printing' stamp: 'monty 3/14/2018 06:44'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		print: stream;
		nextPut: $).! !

!XPathASTWritingNodeVisitor methodsFor: 'private' stamp: 'monty 2/6/2017 21:29'!
stream
	^ stream! !

Object subclass: #XPathASTNodeVisitorIterator
	instanceVariableNames: 'stream previousVisited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation-AST'!

!XPathASTNodeVisitorIterator commentStamp: 'monty 9/29/2017 21:16' prior: 0!
This class can be used to control the iteration of node collections during AST traversal. It wraps a ReadStream and supports #next and #peek (both return nil when #atEnd), and #atEnd, and access to the previous node visited that did not have a nil/null return value.!

!XPathASTNodeVisitorIterator class methodsFor: 'instance creation' stamp: 'monty 1/27/2017 21:00'!
null
	^ self on: #()! !

!XPathASTNodeVisitorIterator class methodsFor: 'instance creation' stamp: 'monty 1/27/2017 22:40'!
on: aCollection
	^ self new on: aCollection! !

!XPathASTNodeVisitorIterator methodsFor: 'accessing' stamp: 'monty 1/27/2017 22:41'!
atEnd
	^ stream atEnd! !

!XPathASTNodeVisitorIterator methodsFor: 'accessing' stamp: 'monty 1/27/2017 22:41'!
next
	^ stream atEnd
		ifTrue: [XPathASTNullNode new]
		ifFalse: [stream next]! !

!XPathASTNodeVisitorIterator methodsFor: 'initialization' stamp: 'monty 1/27/2017 20:29'!
on: aCollection
	stream := aCollection readStream! !

!XPathASTNodeVisitorIterator methodsFor: 'accessing' stamp: 'monty 1/27/2017 22:41'!
peek
	^ stream atEnd
		ifTrue: [XPathASTNullNode new]
		ifFalse: [stream peek]! !

!XPathASTNodeVisitorIterator methodsFor: 'accessing' stamp: 'monty 1/27/2017 20:46'!
previousVisited
	^ previousVisited ifNil: [previousVisited := XPathASTNullNode new]! !

!XPathASTNodeVisitorIterator methodsFor: 'visiting' stamp: 'monty 10/25/2017 07:15'!
visitNextWith: aNodeVisitor
	(self next acceptNodeVisitor: aNodeVisitor)
		ifNil: [^ XPathASTNullNode new]
		ifNotNil: [:node |
			node isNull
				ifFalse: [previousVisited := node].
			^ node]! !

Object subclass: #XPathComparable
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathComparable commentStamp: 'monty 2/23/2016 07:29' prior: 0!
An abstract class for wrapping XPath types to polymorphically implement XPath comparison operators.!

XPathComparable subclass: #XPathBooleanComparable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathBooleanComparable commentStamp: 'monty 2/23/2016 07:29' prior: 0!
A class for wrapping XPath booleans to polymorphically implement XPath comparison operators.!

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
< aComparable
	^ aComparable greaterThanBoolean: value! !

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 14:57'!
<= aComparable
	^ aComparable greaterThanOrEqualToBoolean: value! !

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:26'!
= aComparable
	^ aComparable equalToBoolean: value! !

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
> aComparable
	^ aComparable lessThanBoolean: value! !

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 14:58'!
>= aComparable
	^ aComparable lessThanOrEqualToBoolean: value! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToBoolean: aBoolean
	^ value = aBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToNodeSet: aNodeSet
	^ value = aNodeSet asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToNumber: aNumber
	^ value = aNumber asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:27'!
equalToString: aString
	^ value = aString asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanBoolean: aBoolean
	^ value asXPathNumber > aBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNodeSet: aNodeSet
	^ value asXPathNumber > aNodeSet asXPathBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNumber: aNumber
	^ value asXPathNumber > aNumber asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 14:57'!
greaterThanOrEqualToBoolean: aBoolean
	^ value asXPathNumber >= aBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:04'!
greaterThanOrEqualToNodeSet: aNodeSet
	^ value asXPathNumber >= aNodeSet asXPathBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:19'!
greaterThanOrEqualToNumber: aNumber
	^ value asXPathNumber >= aNumber asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:24'!
greaterThanOrEqualToString: aString
	^ value asXPathNumber >= aString asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
greaterThanString: aString
	^ value asXPathNumber > aString asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanBoolean: aBoolean
	^ value asXPathNumber < aBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNodeSet: aNodeSet
	^ value asXPathNumber < aNodeSet asXPathBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNumber: aNumber
	^ value asXPathNumber < aNumber asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 14:58'!
lessThanOrEqualToBoolean: aBoolean
	^ value asXPathNumber <= aBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:06'!
lessThanOrEqualToNodeSet: aNodeSet
	^ value asXPathNumber <= aNodeSet asXPathBoolean asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:21'!
lessThanOrEqualToNumber: aNumber
	^ value asXPathNumber <= aNumber asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:25'!
lessThanOrEqualToString: aString
	^ value asXPathNumber <= aString asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanString: aString
	^ value asXPathNumber < aString asXPathNumber! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:27'!
notEqualToBoolean: aBoolean
	^ value ~= aBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToNodeSet: aNodeSet
	^ value ~= aNodeSet asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToNumber: aNumber
	^ value ~= aNumber asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToString: aString
	^ value ~= aString asXPathBoolean! !

!XPathBooleanComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:27'!
~= aComparable
	^ aComparable notEqualToBoolean: value! !

!XPathComparable class methodsFor: 'instance creation' stamp: 'monty 2/23/2016 13:07'!
value: aValue
	^ self new setValue: aValue! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
< aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
<= aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
= aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
> aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:01'!
>= aComparable
	self subclassResponsibility! !

!XPathComparable methodsFor: 'converting' stamp: 'monty 2/7/2017 15:30'!
asXPathComparable
	^ self! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToBoolean: aBoolean
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToNodeSet: aNodeSet
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToNumber: aNumber
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:27'!
equalToString: aString
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanBoolean: aBoolean
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNodeSet: aNodeSet
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNumber: aNumber
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 14:57'!
greaterThanOrEqualToBoolean: aBoolean
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:04'!
greaterThanOrEqualToNodeSet: aNodeSet
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:19'!
greaterThanOrEqualToNumber: aNumber
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:24'!
greaterThanOrEqualToString: aString
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
greaterThanString: aString
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanBoolean: aBoolean
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNodeSet: aNodeSet
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNumber: aNumber
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 14:58'!
lessThanOrEqualToBoolean: aBoolean
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:06'!
lessThanOrEqualToNodeSet: aNodeSet
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:21'!
lessThanOrEqualToNumber: aNumber
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:25'!
lessThanOrEqualToString: aString
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanString: aString
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:27'!
notEqualToBoolean: aBoolean
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToNodeSet: aNodeSet
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToNumber: aNumber
	self subclassResponsibility! !

!XPathComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToString: aString
	self subclassResponsibility! !

!XPathComparable methodsFor: 'printing' stamp: 'monty 3/10/2018 22:58'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		print: value;
		nextPut: $).! !

!XPathComparable methodsFor: 'initialization' stamp: 'monty 2/23/2016 13:07'!
setValue: anObject
	value := anObject! !

!XPathComparable methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:58'!
value
	^ value! !

!XPathComparable methodsFor: 'comparing' stamp: 'monty 1/16/2017 14:49'!
~= aComparable
	self subclassResponsibility! !

XPathComparable subclass: #XPathNodeSetComparable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNodeSetComparable commentStamp: 'monty 2/23/2016 07:30' prior: 0!
A class for wrapping XPath node sets to polymorphically implement XPath comparison operators.!

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
< aComparable
	^ aComparable greaterThanNodeSet: value! !

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:04'!
<= aComparable
	^ aComparable greaterThanOrEqualToNodeSet: value! !

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:26'!
= aComparable
	^ aComparable equalToNodeSet: value! !

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
> aComparable
	^ aComparable lessThanNodeSet: value! !

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:06'!
>= aComparable
	^ aComparable lessThanOrEqualToNodeSet: value! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToBoolean: aBoolean
	^ value asXPathBoolean = aBoolean! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/10/2017 22:34'!
equalToNodeSet: aNodeSet
	| smallerNodeSet largerNodeSet |

	"From the spec:
		'If both objects to be compared are node-sets, then the comparison
	will be true if and only if there is a node in the first node-set and
	a node in the second node-set such that the result of performing the
	comparison on the string-values of the two nodes is true.'"
	value size < aNodeSet size
		ifTrue: [
			smallerNodeSet := value.
			largerNodeSet := aNodeSet]
		ifFalse: [
			smallerNodeSet := aNodeSet.
			largerNodeSet := value].
	smallerNodeSet size > 0
		ifTrue: [| smallerNodeSetStringValues |
			smallerNodeSetStringValues := Set new: smallerNodeSet size.
			smallerNodeSet do: [:each |
				smallerNodeSetStringValues add: each stringValue].
			largerNodeSet do: [:each |
				(smallerNodeSetStringValues includes: each stringValue)
					ifTrue: [^ true]]].
	^ false.! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToNumber: aNumber
	^ value anySatisfy: [:each |
		each stringValue asXPathNumber = aNumber]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:27'!
equalToString: aString
	^ value anySatisfy: [:each |
		each stringValue = aString]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanBoolean: aBoolean
	^ value asXPathBoolean asXPathNumber > aBoolean asXPathNumber! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:02'!
greaterThanNodeSet: aNodeSet
	^ aNodeSet minimumStringValueNumber
		ifNil: [false]
		ifNotNil: [:minimum |
			value anySatisfy: [:each |
				each stringValue asXPathNumber > minimum]]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:19'!
greaterThanNumber: aNumber
	^ value anySatisfy: [:each |
		each stringValue asXPathNumber > aNumber]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 14:57'!
greaterThanOrEqualToBoolean: aBoolean
	^ value asXPathBoolean asXPathNumber >= aBoolean asXPathNumber! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:04'!
greaterThanOrEqualToNodeSet: aNodeSet
	^ aNodeSet minimumStringValueNumber
		ifNil: [false]
		ifNotNil: [:minimum |
			value anySatisfy: [:each |
				each stringValue asXPathNumber >= minimum]]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:20'!
greaterThanOrEqualToNumber: aNumber
	^ value anySatisfy: [:each |
		each stringValue asXPathNumber >= aNumber]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:24'!
greaterThanOrEqualToString: aString
	| number |

	number := aString asXPathNumber.
	^ value anySatisfy: [:each |
		each stringValue asXPathNumber >= number]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:23'!
greaterThanString: aString
	| number |

	number := aString asXPathNumber.
	^ value anySatisfy: [:each |
		each stringValue asXPathNumber > number]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanBoolean: aBoolean
	^ value asXPathBoolean asXPathNumber < aBoolean asXPathNumber! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:03'!
lessThanNodeSet: aNodeSet
	^ aNodeSet maximumStringValueNumber
		ifNil: [false]
		ifNotNil: [:maximum |
			value anySatisfy: [:each |
				each stringValue asXPathNumber < maximum]]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:21'!
lessThanNumber: aNumber
	^ value anySatisfy: [:each |
		each stringValue asXPathNumber < aNumber]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 14:58'!
lessThanOrEqualToBoolean: aBoolean
	^ value asXPathBoolean asXPathNumber <= aBoolean asXPathNumber! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:06'!
lessThanOrEqualToNodeSet: aNodeSet
	^ aNodeSet maximumStringValueNumber
		ifNil: [false]
		ifNotNil: [:maximum |
			value anySatisfy: [:each |
				each stringValue asXPathNumber <= maximum]]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:21'!
lessThanOrEqualToNumber: aNumber
	^ value anySatisfy: [:each |
		each stringValue asXPathNumber <= aNumber]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 22:18'!
lessThanOrEqualToString: aString
	| number |

	number := aString asXPathNumber.
	^ value anySatisfy: [:each |
		each stringValue asXPathNumber <= number]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 22:17'!
lessThanString: aString
	| number |

	number := aString asXPathNumber.
	^ value anySatisfy: [:each |
		each stringValue asXPathNumber < number]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:27'!
notEqualToBoolean: aBoolean
	^ value asXPathBoolean ~= aBoolean! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToNodeSet: aNodeSet
	| smallerNodeSet largerNodeSet |

	"From the spec:
		'If both objects to be compared are node-sets, then the comparison
	will be true if and only if there is a node in the first node-set and
	a node in the second node-set such that the result of performing the
	comparison on the string-values of the two nodes is true.'"
	value size < aNodeSet size
		ifTrue: [
			smallerNodeSet := value.
			largerNodeSet := aNodeSet]
		ifFalse: [
			smallerNodeSet := aNodeSet.
			largerNodeSet := value].
	smallerNodeSet size > 0
		ifTrue: [| smallerNodeSetStringValues |
			smallerNodeSetStringValues :=
				smallerNodeSet collect: [:each | each stringValue].
			largerNodeSet do: [:node | | stringValue |
				stringValue := node stringValue.
				smallerNodeSetStringValues do: [:each |
					stringValue ~= each
						ifTrue: [^ true]]]].
	^ false.! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToNumber: aNumber
	^ value anySatisfy: [:each |
		each stringValue asXPathNumber ~= aNumber]! !

!XPathNodeSetComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToString: aString
	^ value anySatisfy: [:each |
		each stringValue ~= aString]! !

!XPathNodeSetComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:28'!
~= aComparable
	^ aComparable notEqualToNodeSet: value! !

XPathComparable subclass: #XPathNumberComparable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNumberComparable commentStamp: 'monty 2/23/2016 07:30' prior: 0!
A class for wrapping XPath numbers to polymorphically implement XPath comparison operators.!

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:03'!
< aComparable
	^ aComparable greaterThanNumber: value! !

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:07'!
<= aComparable
	^ aComparable greaterThanOrEqualToNumber: value! !

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:26'!
= aComparable
	^ aComparable equalToNumber: value! !

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
> aComparable
	^ aComparable lessThanNumber: value! !

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:20'!
>= aComparable
	^ aComparable lessThanOrEqualToNumber: value! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToBoolean: aBoolean
	^ value asXPathBoolean = aBoolean! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each |
		value = each stringValue asXPathNumber]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToNumber: aNumber
	^ value = aNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:27'!
equalToString: aString
	^ value = aString asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanBoolean: aBoolean
	^ value > aBoolean asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:22'!
greaterThanNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each |
		value > each stringValue asXPathNumber]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNumber: aNumber
	^ value > aNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 14:57'!
greaterThanOrEqualToBoolean: aBoolean
	^ value >= aBoolean asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:05'!
greaterThanOrEqualToNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each |
		value >= each stringValue asXPathNumber]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:20'!
greaterThanOrEqualToNumber: aNumber
	^ value >= aNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:24'!
greaterThanOrEqualToString: aString
	^ value >= aString asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
greaterThanString: aString
	^ value > aString asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanBoolean: aBoolean
	^ value < aBoolean asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:03'!
lessThanNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each |
		value < each stringValue asXPathNumber]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNumber: aNumber
	^ value < aNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 14:58'!
lessThanOrEqualToBoolean: aBoolean
	^ value <= aBoolean asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:06'!
lessThanOrEqualToNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each |
		value <= each stringValue asXPathNumber]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:21'!
lessThanOrEqualToNumber: aNumber
	^ value <= aNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
lessThanOrEqualToString: aString
	^ value <= aString asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanString: aString
	^ value < aString asXPathNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:27'!
notEqualToBoolean: aBoolean
	^ value asXPathBoolean ~= aBoolean! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each |
		value ~= each stringValue asXPathNumber]! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToNumber: aNumber
	^ value ~= aNumber! !

!XPathNumberComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToString: aString
	^ value ~= aString asXPathNumber! !

!XPathNumberComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:28'!
~= aComparable
	^ aComparable notEqualToNumber: value! !

XPathComparable subclass: #XPathStringComparable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathStringComparable commentStamp: 'monty 2/23/2016 07:30' prior: 0!
A class for wrapping XPath strings to polymorphically implement XPath comparison operators.!

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
< aComparable
	^ aComparable greaterThanString: value! !

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:24'!
<= aComparable
	^ aComparable greaterThanOrEqualToString: value! !

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:27'!
= aComparable
	^ aComparable equalToString: value! !

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/22/2016 11:04'!
> aComparable
	^ aComparable lessThanString: value! !

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:25'!
>= aComparable
	^ aComparable lessThanOrEqualToString: value! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToBoolean: aBoolean
	^ value asXPathBoolean = aBoolean! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each |
		value = each stringValue]! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
equalToNumber: aNumber
	^ value asXPathNumber = aNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:27'!
equalToString: aString
	^ value = aString! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanBoolean: aBoolean
	^ value asXPathNumber > aBoolean asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:22'!
greaterThanNodeSet: aNodeSet
	| number |
	
	number := value asXPathNumber.
	^ aNodeSet anySatisfy: [:each |
		number > each stringValue asXPathNumber].! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:03'!
greaterThanNumber: aNumber
	^ value asXPathNumber > aNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 14:57'!
greaterThanOrEqualToBoolean: aBoolean
	^ value asXPathNumber >= aBoolean asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:05'!
greaterThanOrEqualToNodeSet: aNodeSet
	| number |
	
	number := value asXPathNumber.
	^ aNodeSet anySatisfy: [:each |
		number >= each stringValue asXPathNumber].! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:20'!
greaterThanOrEqualToNumber: aNumber
	^ value asXPathNumber >= aNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:24'!
greaterThanOrEqualToString: aString
	^ value asXPathNumber >= aString asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
greaterThanString: aString
	^ value asXPathNumber > aString asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanBoolean: aBoolean
	^ value asXPathNumber < aBoolean asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:03'!
lessThanNodeSet: aNodeSet
	| number |
	
	number := value asXPathNumber.
	^ aNodeSet anySatisfy: [:each |
		number < each stringValue asXPathNumber].! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanNumber: aNumber
	^ value asXPathNumber < aNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 14:58'!
lessThanOrEqualToBoolean: aBoolean
	^ value asXPathNumber <= aBoolean asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:07'!
lessThanOrEqualToNodeSet: aNodeSet
	| number |
	
	number := value asXPathNumber.
	^ aNodeSet anySatisfy: [:each |
		number <= each stringValue asXPathNumber].! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:21'!
lessThanOrEqualToNumber: aNumber
	^ value asXPathNumber <= aNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:26'!
lessThanOrEqualToString: aString
	^ value asXPathNumber <= aString asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/22/2016 11:04'!
lessThanString: aString
	^ value asXPathNumber < aString asXPathNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:27'!
notEqualToBoolean: aBoolean
	^ value asXPathBoolean ~= aBoolean! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each |
		value ~= each stringValue]! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToNumber: aNumber
	^ value asXPathNumber ~= aNumber! !

!XPathStringComparable methodsFor: 'private' stamp: 'monty 2/8/2017 15:28'!
notEqualToString: aString
	^ value ~= aString! !

!XPathStringComparable methodsFor: 'comparing' stamp: 'monty 2/8/2017 15:28'!
~= aComparable
	^ aComparable notEqualToString: value! !

Object subclass: #XPathCompiledExpression
	instanceVariableNames: 'block nodeTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathCompiledExpression commentStamp: 'monty 2/10/2017 21:24' prior: 0!
This class stores the compiled XPath expression's three-argument (the context node, the XPathContext object, and node test array) BlockClosure and its array of XPathNodeTest objects.!

!XPathCompiledExpression class methodsFor: 'instance creation' stamp: 'monty 2/7/2017 03:41'!
block: aBlock nodeTests: aNodeTestCollection
	^ self new
		setBlock: aBlock
		nodeTests: aNodeTestCollection! !

!XPathCompiledExpression methodsFor: 'accessing' stamp: 'monty 2/4/2017 21:26'!
block
	^ block! !

!XPathCompiledExpression methodsFor: 'evaluating' stamp: 'monty 2/10/2017 21:42'!
evaluateInNode: aNode withContext: aContext
	^ self block
		value: aNode
		value: aContext
		value: self nodeTests! !

!XPathCompiledExpression methodsFor: 'accessing' stamp: 'monty 2/4/2017 21:26'!
nodeTests
	^ nodeTests! !

!XPathCompiledExpression methodsFor: 'printing' stamp: 'monty 3/10/2018 22:58'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		print: self block;
		nextPut: $).! !

!XPathCompiledExpression methodsFor: 'initialization' stamp: 'monty 2/7/2017 03:41'!
setBlock: aBlock nodeTests: aNodeTestCollection
	block := aBlock.
	nodeTests := aNodeTestCollection asArray.! !

Object subclass: #XPathContext
	instanceVariableNames: 'variables namespaceScope functions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core'!

XPathContext class
	instanceVariableNames: 'defaultFunctions'!

!XPathContext commentStamp: 'monty 11/19/2015 22:09' prior: 0!
An XPathContext controls evaluation of XPath expressions. Contexts have a function library, variable bindings, and namespace mappings.

By default, qualified name tests like 'prefix:name' and wildcard tests like 'prefix:*' will match against the prefix directly. This isn't like the standard, where prefixes in node tests must be declared in the context before evaluation and the namespace they're bound to is matched against the (non-default) namespace of the node, but it's easier to use.

To get standard behavior, just declare at least one prefix in the context before evaluation (then every prefix must be declared in the context and the namespace URIs are matched instead of the literal prefixes).!

XPathContext class
	instanceVariableNames: 'defaultFunctions'!

!XPathContext class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:30'!
defaultFunctions
	^ defaultFunctions
		ifNil: [defaultFunctions := XPathFunctionSet default]! !

!XPathContext class methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:00'!
defaultFunctions: aFunctionSetOrNil
	"can be used to specify a custom default function set"

	defaultFunctions := aFunctionSetOrNil! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:49'!
functions: aFunctionSet
	^ self new functions: aFunctionSet! !

!XPathContext class methodsFor: 'class initialization' stamp: 'monty 1/25/2017 15:26'!
initialize
	"self initialize"

	self defaultFunctions: nil.! !

XPathContext initialize!

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:48'!
namespaces: anAssociationCollection
	^ self new declareNamespaces: anAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:48'!
variables: anAssociationCollection
	^ self new variables: anAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:50'!
variables: aVariableAssociationCollection namespaces: aNamepsaceAssociationCollection
	^ self new
		variables: aVariableAssociationCollection;
		declareNamespaces: aNamepsaceAssociationCollection! !

!XPathContext class methodsFor: 'instance creation' stamp: 'monty 2/13/2015 20:50'!
variables: aVariableAssociationCollection namespaces: aNamepsaceAssociationCollection functions: aFunctionSet
	^ self new
		variables: aVariableAssociationCollection;
		declareNamespaces: aNamepsaceAssociationCollection;
		functions: aFunctionSet! !

!XPathContext methodsFor: 'adding' stamp: 'monty 3/2/2016 14:19'!
addFunction: aFunction
	"use copy-on-write so the default function set isn't modified"
	^ self copiedFunctions add: aFunction! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/5/2017 20:33'!
attributeTestForPrefix: aPrefix
	self hasNamespaces
		ifTrue: [
			^ XPathAttributeNodeTestForNamespaceURI namespaceURI:
				(self resolvePrefixReference: aPrefix)]
		ifFalse: [
			^ XPathAttributeNodeTestForPrefix prefix: aPrefix]! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/5/2017 20:33'!
attributeTestForPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [
			^ XPathAttributeNodeTestForNamespaceURIAndLocalName
				namespaceURI: (self resolvePrefixReference: aPrefix)
				localName: aLocalName]
		ifFalse: [
			^ XPathAttributeNodeTestForName name:
				(aLocalName qualifyWithXMLPrefix: aPrefix)]! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/6/2016 14:26'!
copiedFunctions
	"used to implement copy-on-write for functions"
	^ functions := self functions copy! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 1/19/2015 08:24'!
declareNamespaces: anAssociationCollection
	self namespaceScope mapPrefixesAndURIs: anAssociationCollection! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/21/2015 23:11'!
declarePrefix: aPrefix uri: aURI
	self namespaceScope
		mapPrefix: aPrefix
		to: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/5/2017 20:34'!
elementTestForPrefix: aPrefix
	self hasNamespaces
		ifTrue: [
			^ XPathElementNodeTestForNamespaceURI namespaceURI:
				(self resolvePrefixReference: aPrefix)]
		ifFalse: [
			^ XPathElementNodeTestForPrefix prefix: aPrefix]! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/5/2017 20:34'!
elementTestForPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [
			^ XPathElementNodeTestForNamespaceURIAndLocalName
				namespaceURI: (self resolvePrefixReference: aPrefix)
				localName: aLocalName]
		ifFalse: [
			^ XPathElementNodeTestForName name:
				(aLocalName qualifyWithXMLPrefix: aPrefix)]! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 14:01'!
errorUndeclaredFunction: aFunctionName
	XPathUndeclaredFunctionException
		formatSignal: 'Undeclared function {1}()'
		with: aFunctionName! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/5/2015 07:05'!
errorUndeclaredPrefix: aPrefix
	XPathUndeclaredPrefixException
		formatSignal: 'Prefix "{1}" was not declared in the XPath context'
		with: aPrefix! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/18/2015 14:02'!
errorUndeclaredVariable: aVariableName
	XPathUndeclaredVariableException
		formatSignal: 'Undeclared variable reference ${1}'
		with: aVariableName! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 3/2/2016 14:17'!
functionNamed: aFunctionName
	^ self functions functionNamed: aFunctionName! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 3/2/2016 14:17'!
functionNamed: aFunctionName ifAbsent: aBlock
	^ self functions 
		functionNamed: aFunctionName
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'private' stamp: 'monty 3/2/2016 14:22'!
functions
	"the default function set won't be directly modified because the add/remove
	methods use copy-on-write semantics"
	^ functions ifNil: [functions := self class defaultFunctions]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 3/6/2016 14:42'!
functions: aFunctionSet
	"will only be modified by copy-on-write"
	functions := aFunctionSet asXPathFunctionSet! !

!XPathContext methodsFor: 'testing' stamp: 'monty 3/6/2016 13:19'!
hasFunctions
	^ self functions notEmpty! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 01:02'!
hasNamespaces
	^ namespaceScope notNil
		and: [namespaceScope hasNamespaces]! !

!XPathContext methodsFor: 'testing' stamp: 'monty 3/6/2016 11:28'!
hasVariables
	^ self variables notEmpty! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/10/2015 22:05'!
includesFunction: aFunction
	^ self functions includes: aFunction! !

!XPathContext methodsFor: 'testing' stamp: 'monty 1/17/2015 04:48'!
includesVariable: aVariableName
	^ self variables includesKey: aVariableName! !

!XPathContext methodsFor: 'testing' stamp: 'monty 2/13/2015 20:52'!
isDeclaredPrefix: aPrefix
	^ self namespaceScope includesPrefix: aPrefix! !

!XPathContext methodsFor: 'testing' stamp: 'monty 3/21/2015 23:11'!
isDeclaredPrefix: aPrefix uri: aURI
	^ self namespaceScope
		includesPrefix: aPrefix
		mappedTo: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 12/30/2014 03:46'!
namespaceScope
	^ namespaceScope ifNil: [namespaceScope := XMLNamespaceScope new]! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/5/2017 16:20'!
namespaceTestForPrefix: aPrefix
	self hasNamespaces
		ifTrue: [
			^ XPathNamespaceTestForNamespaceURI namespaceURI:
				(self resolvePrefixReference: aPrefix)]
		ifFalse: [
			^ XPathNamespaceTestForPrefix prefix: aPrefix]! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/5/2017 16:21'!
namespaceTestForPrefix: aPrefix localName: aLocalName
	self hasNamespaces
		ifTrue: [
			^ XPathNamespaceTestForNamespaceURIAndLocalName
				namespaceURI: (self resolvePrefixReference: aPrefix)
				localName: aLocalName]
		ifFalse: [
			^ XPathNamespaceTestForName name:
				(aLocalName qualifyWithXMLPrefix: aPrefix)]! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/2/2016 14:19'!
removeFunction: aFunction
	"use copy-on-write so the default function set isn't modified"
	^ self copiedFunctions remove: aFunction! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/2/2016 14:19'!
removeFunction: aFunction ifAbsent: aBlock
	"use copy-on-write so the default function set isn't modified"
	^ self copiedFunctions
		remove: aFunction
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/6/2016 13:33'!
removeFunctions
	self copiedFunctions removeAll! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/2/2016 14:14'!
removeVariable: aVariable
	^ self variables removeKey: aVariable! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/2/2016 14:14'!
removeVariable: aVariable ifAbsent: aBlock
	^ self variables
		removeKey: aVariable
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'removing' stamp: 'monty 3/6/2016 11:29'!
removeVariables
	self variables removeAll! !

!XPathContext methodsFor: 'private' stamp: 'monty 10/5/2016 17:56'!
resolveFunctionReference: aFunctionName contextNode: aContextNode arguments: anArgumentArray
	^ (self
		functionNamed: aFunctionName
		ifAbsent: [self errorUndeclaredFunction: aFunctionName])
			context: self
			contextNode: aContextNode
			arguments: anArgumentArray! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 2/26/2016 04:51'!
resolvePrefix: aPrefix
	^ self namespaceScope resolvePrefix: aPrefix! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 2/26/2016 04:36'!
resolvePrefix: aPrefix ifUnresolvable: aBlock
	^ self namespaceScope
		resolvePrefix: aPrefix
		ifUnresolvable: aBlock! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/26/2016 04:49'!
resolvePrefixReference: aPrefix
	^ self
		resolvePrefix: aPrefix
		ifUnresolvable: [self errorUndeclaredPrefix: aPrefix]! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 2/24/2016 04:12'!
resolvePrefixesOfNamespaceURI: aURI
	^ self namespaceScope resolvePrefixesOfNamespaceURI: aURI! !

!XPathContext methodsFor: 'private' stamp: 'monty 2/26/2016 04:50'!
resolveVariableReference: aVariableName
	^ self
		variableAt: aVariableName
		ifAbsent: [self errorUndeclaredVariable: aVariableName]! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/2/2016 14:10'!
undeclarePrefix: aPrefix
	self namespaceScope
		unmapPrefix: aPrefix
		ifAbsent: [nil]! !

!XPathContext methodsFor: 'namespacing' stamp: 'monty 3/2/2016 16:27'!
undeclarePrefixes
	self namespaceScope unmapPrefixes! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 3/6/2016 11:23'!
variableAt: aVariableName
	^ self variables
		at: aVariableName
		ifAbsent: [nil]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:49'!
variableAt: aVariableName ifAbsent: aBlock
	^ self variables
		at: aVariableName
		ifAbsent: aBlock! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:49'!
variableAt: aVariableName ifAbsentPut: aBlock
	^ self variables
		at: aVariableName
		ifAbsentPut: aBlock! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 1/17/2015 04:48'!
variableAt: aVariableName put: aValue
	^ self variables
		at: aVariableName
		put: aValue! !

!XPathContext methodsFor: 'private' stamp: 'monty 1/17/2015 04:49'!
variables
	^ variables ifNil: [variables := Dictionary new]! !

!XPathContext methodsFor: 'accessing' stamp: 'monty 2/23/2016 09:50'!
variables: anAssociationCollection
	variables := Dictionary new: anAssociationCollection size.
	anAssociationCollection associationsDo: [:each |
		variables
			at: each key
			put: each value].! !

Object subclass: #XPathExpressionCompiler
	instanceVariableNames: ''
	classVariableNames: 'SystemCompilerClass'
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathExpressionCompiler commentStamp: 'monty 2/10/2017 03:16' prior: 0!
This class compiles XPath expressions. It first parses them to an intermediate representation, optimizes it, translates it to Smalltalk source code, and then compiles the translated source code using the system's compiler and returns the result as an evaluable XPathCompiledExpression object.!

!XPathExpressionCompiler class methodsFor: 'compiling' stamp: 'monty 3/3/2017 09:08'!
compileExpression: anExpressionSourceStringOrStream
	^ self new compileExpression: anExpressionSourceStringOrStream! !

!XPathExpressionCompiler class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:35'!
systemCompilerClass
	^ SystemCompilerClass
		ifNil: [
			"On Pharo/Squeak, Behavior class>>#compilerClass returns the  platform's
			preferred compiler class that can be sent #evaluate: to compile a
			string. On GS, any object can be sent #evaluate: to compile a string."
			SystemCompilerClass :=
				(Behavior respondsTo: #compilerClass)
					ifTrue: [Behavior compilerClass]
					ifFalse: [Behavior]]! !

!XPathExpressionCompiler class methodsFor: 'accessing' stamp: 'monty 10/9/2016 03:35'!
systemCompilerClass: aClass
	SystemCompilerClass := aClass! !

!XPathExpressionCompiler methodsFor: 'compiling' stamp: 'monty 3/2/2017 20:42'!
compileExpression: anExpressionSourceStringOrStream
	^ self compileTranslatedExpression:
		(self translateParsedExpression:
			(self optimizeParsedExpression:
				(self parseExpression: anExpressionSourceStringOrStream)))! !

!XPathExpressionCompiler methodsFor: 'translating' stamp: 'monty 2/4/2017 22:03'!
compileTranslatedExpression: aTranslatedExpression
	^ XPathCompiledExpression
		block:
			(self class systemCompilerClass evaluate:
				aTranslatedExpression sourceCode)
		nodeTests: aTranslatedExpression nodeTests! !

!XPathExpressionCompiler methodsFor: 'optimizing' stamp: 'monty 2/10/2017 22:04'!
optimizeParsedExpression: anExpressionAST
	^ self optimizerClass new
		visitNode: anExpressionAST! !

!XPathExpressionCompiler methodsFor: 'defaults' stamp: 'monty 1/15/2017 15:45'!
optimizerClass
	^ XPathASTOptimizingMutatingNodeVisitor! !

!XPathExpressionCompiler methodsFor: 'parsing' stamp: 'monty 3/2/2017 20:42'!
parseExpression: anExpressionSourceStringOrStream
	^ (self parserClass
		on: anExpressionSourceStringOrStream
		for: self parserHandlerClass new) parse! !

!XPathExpressionCompiler methodsFor: 'defaults' stamp: 'monty 1/8/2015 05:56'!
parserClass
	^ XPathExpressionParser! !

!XPathExpressionCompiler methodsFor: 'defaults' stamp: 'monty 1/1/2017 02:35'!
parserHandlerClass
	^ XPathASTExpressionParserHandler! !

!XPathExpressionCompiler methodsFor: 'translating' stamp: 'monty 2/10/2017 20:15'!
translateParsedExpression: anExpressionAST
	^ self translatorClass new
		visitNode: anExpressionAST;
		translatedExpression! !

!XPathExpressionCompiler methodsFor: 'defaults' stamp: 'monty 2/6/2017 21:03'!
translatorClass
	^ XPathASTTranslatingWritingNodeVisitor! !

Object subclass: #XPathExpressionParserAxis
	instanceVariableNames: 'axisSpecifier handlerSelector defaultNodeTestParserStateClass isImplicit isStartOfRelativeLocationPath isFirstAxis'
	classVariableNames: 'AxisSpecifiers'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParserAxis commentStamp: 'monty 10/8/2017 15:55' prior: 0!
This class holds the current axis while a step is being parsed by an XPathExpressionParser and maps it to the correct handler selector and to a default node test parser state class (to parse any node test that comes after).!

!XPathExpressionParserAxis class methodsFor: 'private' stamp: 'monty 4/10/2015 07:00'!
axisSpecifiers
	^ AxisSpecifiers! !

!XPathExpressionParserAxis class methodsFor: 'private' stamp: 'monty 10/7/2017 14:50'!
axisSpecifiersTemplate
	"Returns an array of arrays where each subarray has an axis name,
	a handler selector to map it to, and the principal node type for
	that axis, which is used to determine the parser state class
	when parsing the node test after."

	^ #(
		#('ancestor'           handleAncestorAxis         element)
		#('ancestor-or-self'   handleAncestorOrSelfAxis   element)
		#('attribute'          handleAttributeAxis        attribute)
		#('child'              handleChildAxis            element)
		#('descendant'         handleDescendantAxis       element)
		#('descendant-or-self' handleDescendantOrSelfAxis element)
		#('following'          handleFollowingAxis        element)
		#('following-sibling'  handleFollowingSiblingAxis element)
		#('namespace'          handleNamespaceAxis        namespace)
		#('parent'             handleParentAxis           element)
		#('preceding'          handlePrecedingAxis        element)
		#('preceding-sibling'  handlePrecedingSiblingAxis element)
		#('self'               handleSelfAxis             element)
	)! !

!XPathExpressionParserAxis class methodsFor: 'class initialization' stamp: 'monty 10/7/2017 14:50'!
initialize
	"self initialize"

	| temp |

	"use a temp to fully initialize it before assignment to avoid possible
	race conditions during class reinitialization"
	temp := Dictionary new.
	self axisSpecifiersTemplate do: [:each |
		| axisSpecifier handlerSelector principalNodeType parserStateClass |
		axisSpecifier := each first.
		handlerSelector := each second.
		principalNodeType := each third.
		parserStateClass :=
			principalNodeType = #attribute
				ifTrue: [XPathNodeTestParserAttributeState]
				ifFalse: [
					principalNodeType = #namespace
						ifTrue: [XPathNodeTestParserNamespaceState]
						ifFalse: [XPathNodeTestParserElementState]].
		temp
			at: axisSpecifier
			put: handlerSelector -> parserStateClass].
	AxisSpecifiers := temp.! !

XPathExpressionParserAxis initialize!

!XPathExpressionParserAxis methodsFor: 'accessing' stamp: 'monty 1/13/2015 11:27'!
axisSpecifier
	^ axisSpecifier! !

!XPathExpressionParserAxis methodsFor: 'accessing' stamp: 'monty 10/9/2017 00:47'!
axisSpecifier: anAxisSpecifier
	anAxisSpecifier = axisSpecifier
		ifFalse: [
			axisSpecifier := anAxisSpecifier.
			handlerSelector := nil.
			defaultNodeTestParserStateClass := nil].
	"now explicit"
	isImplicit := false.! !

!XPathExpressionParserAxis methodsFor: 'changing' stamp: 'monty 10/9/2017 00:47'!
beDefaultImplicitAxis
	axisSpecifier := 'child'.
	handlerSelector := #handleChildAxis.
	defaultNodeTestParserStateClass := XPathNodeTestParserElementState.
	isImplicit := true.
	isFirstAxis := false.
	isStartOfRelativeLocationPath := false.! !

!XPathExpressionParserAxis methodsFor: 'changing' stamp: 'monty 4/16/2015 11:48'!
beFirstAxis
	isFirstAxis := true! !

!XPathExpressionParserAxis methodsFor: 'changing' stamp: 'monty 4/16/2015 12:46'!
beStartOfRelativeLocationPath
	isStartOfRelativeLocationPath := true! !

!XPathExpressionParserAxis methodsFor: 'defaults' stamp: 'monty 10/9/2017 00:47'!
defaultNodeTestParserStateClass
	^ defaultNodeTestParserStateClass
		ifNil: [
			self lookupAxisSpecifier.
			defaultNodeTestParserStateClass]! !

!XPathExpressionParserAxis methodsFor: 'private' stamp: 'monty 4/10/2015 07:36'!
errorUnrecognizedAxisSpecifier
	XPathSyntaxException
		formatSignal: 'Unrecognized axis specifier "{1}"'
		with: self axisSpecifier! !

!XPathExpressionParserAxis methodsFor: 'accessing' stamp: 'monty 1/2/2017 02:33'!
handlerSelector
	^ handlerSelector
		ifNil: [
			self lookupAxisSpecifier.
			handlerSelector]! !

!XPathExpressionParserAxis methodsFor: 'initialization' stamp: 'monty 3/2/2017 20:43'!
initialize
	super initialize.

	self beDefaultImplicitAxis.! !

!XPathExpressionParserAxis methodsFor: 'testing' stamp: 'monty 4/16/2015 11:48'!
isFirstAxis
	^ isFirstAxis! !

!XPathExpressionParserAxis methodsFor: 'testing' stamp: 'monty 4/16/2015 12:45'!
isImplicitAxis
	^ isImplicit! !

!XPathExpressionParserAxis methodsFor: 'testing' stamp: 'monty 1/14/2015 02:34'!
isStartOfRelativeLocationPath
	^ isStartOfRelativeLocationPath! !

!XPathExpressionParserAxis methodsFor: 'private' stamp: 'monty 10/9/2017 00:47'!
lookupAxisSpecifier
	| association |

	association :=
		AxisSpecifiers
			at: self axisSpecifier
			ifAbsent: [self errorUnrecognizedAxisSpecifier].
	handlerSelector := association key.
	defaultNodeTestParserStateClass := association value.! !

!XPathExpressionParserAxis methodsFor: 'printing' stamp: 'monty 3/10/2018 22:59'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self axisSpecifier;
		nextPut: $).! !

Object subclass: #XPathFunction
	instanceVariableNames: 'context contextNode arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

XPathFunction class
	instanceVariableNames: 'prototype'!

!XPathFunction commentStamp: 'monty 1/25/2018 23:38' prior: 0!
An abstract class for XPath functions. Subclasses need to implement the class #prototypeSource method to return a string with an XPath function prototype and then implement the instance-side #function method to implement the function and return its value. When invoked, the arguments and the return value are automatically converted to the types specified by the prototype.

Functions, including user-defined, can be combined into an XPathFunctionSet and injected into an XPathContext object before evaluation, but some functions (last(), position(), true(), and false()) are compiled inline and can never be redefined.!

XPathFunction class
	instanceVariableNames: 'prototype'!

XPathFunction subclass: #XPathBooleanFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathBooleanFunction commentStamp: 'monty 12/22/2014 17:15' prior: 0!
XPath boolean conversion function.!

!XPathBooleanFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'boolean boolean(object)'! !

!XPathBooleanFunction methodsFor: 'implementing' stamp: 'monty 10/5/2016 18:13'!
function
	^ self firstArgument! !

XPathFunction subclass: #XPathCeilingFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathCeilingFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath ceiling function.!

!XPathCeilingFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'number ceiling(number)'! !

!XPathCeilingFunction methodsFor: 'implementing' stamp: 'monty 3/14/2017 22:29'!
function
	^ self firstArgument xpathCeiling! !

XPathFunction subclass: #XPathConcatFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathConcatFunction commentStamp: 'monty 3/13/2015 21:27' prior: 0!
XPath string concatenation function. Concatenates two or more strings.!

!XPathConcatFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'string concat(string, string, string*)'! !

!XPathConcatFunction methodsFor: 'implementing' stamp: 'monty 2/1/2017 23:01'!
function
	| writeStream |

	writeStream := (String new: self totalArguments * 10) writeStream.
	self argumentsDo: [:each |
		writeStream nextPutAll: each].
	^ writeStream contents.! !

XPathFunction subclass: #XPathContainsFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathContainsFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath contains substring function.!

!XPathContainsFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'boolean contains(string, string)'! !

!XPathContainsFunction methodsFor: 'implementing' stamp: 'monty 10/5/2016 18:18'!
function
	"use findString:startingAt: for portability"
	^ (self firstArgument
		findString: self lastArgument
		startingAt: 1) > 0! !

XPathFunction subclass: #XPathCountFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathCountFunction commentStamp: 'monty 6/15/2015 00:40' prior: 0!
XPath node set count (size) function.!

!XPathCountFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'number count(node-set)'! !

!XPathCountFunction methodsFor: 'implementing' stamp: 'monty 10/5/2016 18:18'!
function
	^ self firstArgument size! !

XPathFunction subclass: #XPathEndsWithFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathEndsWithFunction commentStamp: 'monty 6/15/2015 00:40' prior: 0!
Non-standard; added for completeness with starts-with().!

!XPathEndsWithFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'boolean ends-with(string, string)'! !

!XPathEndsWithFunction methodsFor: 'implementing' stamp: 'monty 10/5/2016 18:18'!
function
	^ self firstArgument endsWith: self lastArgument! !

XPathFunction subclass: #XPathFloorFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFloorFunction commentStamp: 'monty 12/22/2014 21:18' prior: 0!
XPath floor function.!

!XPathFloorFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'number floor(number)'! !

!XPathFloorFunction methodsFor: 'implementing' stamp: 'monty 3/14/2017 22:29'!
function
	^ self firstArgument xpathFloor! !

!XPathFunction class methodsFor: 'composition' stamp: 'monty 3/6/2016 14:39'!
+ aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asXPathFunctionSetWithFunction: self! !

!XPathFunction class methodsFor: 'composition' stamp: 'monty 3/6/2016 14:39'!
- aFunctionOrFunctionSet
	^ aFunctionOrFunctionSet asXPathFunctionSetSubtractedFromFunction: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 9/22/2016 17:06'!
asXPathFunctionSet
	^ self functionSetClass with: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetSubtractedFromFunction: aFunction
	^ aFunction asXPathFunctionSet copyWithout: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetSubtractedFromFunctions: aFunctionSet
	^ aFunctionSet copyWithout: self! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 3/6/2016 14:39'!
asXPathFunctionSetWithFunction: aFunction
	^ self asXPathFunctionSet
		add: aFunction;
		yourself! !

!XPathFunction class methodsFor: 'converting' stamp: 'monty 3/6/2016 14:40'!
asXPathFunctionSetWithFunctions: aFunctionSet
	^ self asXPathFunctionSet
		addAll: aFunctionSet;
		yourself! !

!XPathFunction class methodsFor: 'instance creation' stamp: 'monty 10/6/2016 21:40'!
context: aContext contextNode: aContextNode arguments: aSequenceableCollection
	^ self new
		setContext: aContext
		contextNode: aContextNode
		arguments: aSequenceableCollection! !

!XPathFunction class methodsFor: 'private' stamp: 'monty 9/22/2016 17:06'!
functionSetClass
	^ XPathFunctionSet! !

!XPathFunction class methodsFor: 'class initialization' stamp: 'monty 2/10/2017 23:46'!
initialize
	"self initialize"

	self allSubclassesDo: [:each | each prototype: nil]! !

XPathFunction initialize!

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 2/26/2018 23:45'!
prototype
	^ prototype
		ifNil: [
			prototype :=
				XPathFunctionPrototype fromString:
					self prototypeSource]! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:45'!
prototype: aFunctionPrototype
	"
	self allSubclassesDo: [:each |
		each
			prototype: nil;
			prototype]
	"

	prototype := aFunctionPrototype! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:47'!
prototypeName
	^ self prototype name! !

!XPathFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	"Should return a protype string. See subclasses for examples."

	self subclassResponsibility! !

!XPathFunction methodsFor: 'testing' stamp: 'monty 1/9/2017 09:44'!
acceptsArguments
	^ self prototype acceptsArguments! !

!XPathFunction methodsFor: 'testing' stamp: 'monty 1/9/2017 09:44'!
acceptsOptionalArguments
	^ self prototype acceptsOptionalArguments! !

!XPathFunction methodsFor: 'testing' stamp: 'monty 1/9/2017 09:44'!
acceptsVariableArguments
	^ self prototype acceptsVariableArguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:20'!
argumentAt: anIndex
	^ self
		argumentAt: anIndex
		ifAbsent: [nil]! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:07'!
argumentAt: anIndex ifAbsent: aBlock
	^ self arguments
		at: anIndex
		ifAbsent: aBlock! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:44'!
argumentTypeAt: anIndex
	^ self prototype argumentTypeAt: anIndex! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:44'!
argumentTypeAt: anIndex ifAbsent: aBlock
	^ self prototype
		argumentTypeAt: anIndex
		ifAbsent: aBlock! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:44'!
argumentTypes
	^ self prototype argumentTypes! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/5/2016 18:01'!
arguments
	^ arguments! !

!XPathFunction methodsFor: 'enumerating' stamp: 'monty 2/1/2017 23:01'!
argumentsDo: aBlock
	self arguments do: aBlock! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 12/24/2014 23:45'!
context
	^ context! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/14/2015 04:58'!
contextNode
	^ contextNode! !

!XPathFunction methodsFor: 'private' stamp: 'monty 1/9/2017 09:46'!
errorAcceptsAtMost: anArgumentMaximum argumentsButGot: anArgumentTotal
	XPathArgumentNumberException
		formatSignal: '{1}() accepts at most {2} argument(s) but was called with {3}'
		with: self name
		with: anArgumentMaximum
		with: anArgumentTotal! !

!XPathFunction methodsFor: 'private' stamp: 'monty 1/9/2017 09:46'!
errorRequiresAtLeast: anArgumentMinimum argumentsButGot: anArgumentTotal
	XPathArgumentNumberException
		formatSignal:
			'{1}() requires at least {2} argument(s) but was called with {3}'
		with: self name
		with: anArgumentMinimum
		with: anArgumentTotal! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/7/2016 00:12'!
firstArgument
	^ self argumentAt: 1! !

!XPathFunction methodsFor: 'implementing' stamp: 'monty 12/24/2014 23:49'!
function
	self subclassResponsibility! !

!XPathFunction methodsFor: 'testing' stamp: 'monty 10/9/2016 19:21'!
hasArguments
	^ self totalArguments > 0! !

!XPathFunction methodsFor: 'invoking' stamp: 'monty 1/27/2017 14:52'!
invoke
	^ self returnType newFrom: self function! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/7/2016 00:13'!
lastArgument
	^ self argumentAt: self totalArguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:44'!
maxArguments
	^ self prototype maxArguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:44'!
minArguments
	^ self prototype minArguments! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:49'!
name
	^ self prototype name! !

!XPathFunction methodsFor: 'instance creation' stamp: 'monty 2/28/2017 08:21'!
newContextNodeNodeSet
	^ self contextNode
		ifNil: [self newNodeSet]
		ifNotNil: [self nodeSetClass with: self contextNode]! !

!XPathFunction methodsFor: 'instance creation' stamp: 'monty 9/22/2016 17:30'!
newNodeSet
	^ self nodeSetClass new! !

!XPathFunction methodsFor: 'defaults' stamp: 'monty 9/27/2016 13:34'!
nodeSetClass
	^ XPathNodeSet! !

!XPathFunction methodsFor: 'printing' stamp: 'monty 3/10/2018 22:59'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		print: self prototype;
		nextPut: $).! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:44'!
prototype
	^ self class prototype! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:44'!
returnType
	^ self prototype returnType! !

!XPathFunction methodsFor: 'initialization' stamp: 'monty 1/27/2017 14:52'!
setArguments: aSequenceableCollection
	"ensure there aren't too many or too few"
	aSequenceableCollection size < self minArguments
		ifTrue: [
			self
				errorRequiresAtLeast: self minArguments
				argumentsButGot: aSequenceableCollection size].
	(self maxArguments notNil
		and: [aSequenceableCollection size > self maxArguments])
		ifTrue: [
			self
				errorAcceptsAtMost: self maxArguments
				argumentsButGot: aSequenceableCollection size].

	"convert them to the appropriate type (use to:do: for speed)"
	1 to: aSequenceableCollection size do: [:i |
		aSequenceableCollection
			at: i
			put:
				((self argumentTypeAt: i) newFrom:
					(aSequenceableCollection at: i))].

	arguments := aSequenceableCollection asArray.! !

!XPathFunction methodsFor: 'initialization' stamp: 'monty 10/9/2016 18:58'!
setContext: aContext contextNode: aContextNode arguments: aSequenceableCollection
	context := aContext.
	contextNode := aContextNode.
	self setArguments: aSequenceableCollection.! !

!XPathFunction methodsFor: 'accessing' stamp: 'monty 10/7/2016 00:05'!
totalArguments
	^ self arguments size! !

XPathFunction subclass: #XPathIDFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathIDFunction commentStamp: 'monty 3/9/2015 21:50' prior: 0!
XPath id() function to select elements from the document of the context node by ID.!

!XPathIDFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'node-set id(object)'! !

!XPathIDFunction methodsFor: 'invoking' stamp: 'monty 3/20/2017 23:50'!
addElement: anElement withUndeclaredIDs: anIDSet to: aNodeSet
	"just look for an 'xml:id' attribute if there were no declarations"
	anIDSet
		remove:
			(anElement
				attributeAt: 'xml:id'
				ifAbsent: [^ self])
		ifAbsent: [^ self].
	aNodeSet addLast: anElement.! !

!XPathIDFunction methodsFor: 'invoking' stamp: 'monty 3/20/2017 23:18'!
addElement: anElement withUndeclaredOrDeclaredIDs: anIDSet to: aNodeSet declaredWith: anAttributeValidatorDictionary
	anElement attributeNodesDo: [:each |
		((anAttributeValidatorDictionary
			at: each name
			ifAbsent: [nil])
				ifNil: [each name = 'xml:id']
				ifNotNil: [:attributeValidator | attributeValidator isID])
			ifTrue: [
				(anIDSet
					remove: each value
					ifAbsent: [nil])
					ifNotNil: [
						aNodeSet addLast: anElement.
						^ self]]]! !

!XPathIDFunction methodsFor: 'invoking' stamp: 'monty 3/25/2017 01:30'!
addElementsWithUndeclaredIDs: anIDSet in: aRootNode to: aNodeSet
	aRootNode allElementsDo: [:each |
		each hasAttributes
			ifTrue: [
				self
					addElement: each
					withUndeclaredIDs: anIDSet
					to: aNodeSet.
				anIDSet isEmpty
					ifTrue: [^ self]]]! !

!XPathIDFunction methodsFor: 'invoking' stamp: 'monty 3/25/2017 01:30'!
addElementsWithUndeclaredOrDeclaredIDs: anIDSet in: aRootNode to: aNodeSet declaredWith: aDoctypeDefinition
	aRootNode allElementsDo: [:each |
		each hasAttributes
			ifTrue: [
				(aDoctypeDefinition attributeValidatorsAt: each name)
					ifNil: [
						self
							addElement: each
							withUndeclaredIDs: anIDSet
							to: aNodeSet]
					ifNotNil: [:attributeValidators |
						self
							addElement: each
							withUndeclaredOrDeclaredIDs: anIDSet
							to: aNodeSet
							declaredWith: attributeValidators].
				anIDSet isEmpty
					ifTrue: [^ self]]]! !

!XPathIDFunction methodsFor: 'implementing' stamp: 'monty 10/25/2017 07:41'!
function
	| object ids nodeSet |

	object := self firstArgument.
	ids := Set new.
	object isXPathNodeSet
		ifTrue: [
			object do: [:each |
				self
					splitSpaceSeparatedIDs: each stringValue
					into: ids]]
		ifFalse: [
			self
				splitSpaceSeparatedIDs: object asXPathString
				into: ids].

	nodeSet := self newNodeSet.
	(ids notEmpty
		and: [self contextNode notNil])
		ifTrue: [| root doctypeDefinition |
			((root := self contextNode documentRoot) isDocument
				and: [(doctypeDefinition := root doctypeDefinition) notNil
					and: [doctypeDefinition hasAttributeValidators]])
				ifTrue: [
					self
						addElementsWithUndeclaredOrDeclaredIDs: ids
						in: root
						to: nodeSet
						declaredWith: doctypeDefinition]
				ifFalse: [
					self
						addElementsWithUndeclaredIDs: ids
						in: root
						to: nodeSet]].

	"the elements matching the IDs are enumerated in document order, so the
	resulting node set is in document order too"
	^ nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XPathIDFunction methodsFor: 'private' stamp: 'monty 3/12/2016 19:09'!
splitSpaceSeparatedIDs: anIDString into: anIDSet
	| startIndex|

	1 to: anIDString size do: [:i | | nextChar |
		(nextChar := anIDString at: i) isXMLSeparator
			ifTrue: [
				startIndex
					ifNotNil: [
						anIDSet add: (anIDString copyFrom: startIndex to: i - 1).
						startIndex := nil]]
			ifFalse: [
				startIndex
					ifNil: [startIndex := i]]].
	startIndex
		ifNotNil: [
			anIDSet add:
				(anIDString copyFrom: startIndex to: anIDString size)].! !

XPathFunction subclass: #XPathLangFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathLangFunction commentStamp: 'monty 3/25/2015 04:12' prior: 0!
XPath lang() function to test if the context node is in the scope of an xml:lang attribute value matching the argument.!

!XPathLangFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'boolean lang(string)'! !

!XPathLangFunction methodsFor: 'implementing' stamp: 'monty 2/28/2017 08:07'!
function
	^ self contextNode notNil
		and: [self contextNode isInLanguage: self firstArgument]! !

XPathFunction subclass: #XPathLocalNameFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathLocalNameFunction commentStamp: 'monty 12/27/2014 00:36' prior: 0!
XPath local name function.!

!XPathLocalNameFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'string local-name(node-set?)'! !

!XPathLocalNameFunction methodsFor: 'implementing' stamp: 'monty 2/28/2017 08:03'!
function
	| node |

	node :=
		self hasArguments
			ifTrue: [self firstArgument firstInDocumentOrder]
			ifFalse: [self contextNode].

	(node notNil
		and: [node hasExpandedName])
		ifTrue: [^ node localName]
		ifFalse: [^ '']! !

XPathFunction subclass: #XPathNameFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNameFunction commentStamp: 'monty 3/5/2015 15:46' prior: 0!
XPath name function. Returns expanded name or local name of a node or empty string if node has no name. Operates on argument node or the context node if called with no arguments.!

!XPathNameFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'string name(node-set?)'! !

!XPathNameFunction methodsFor: 'implementing' stamp: 'monty 2/28/2017 08:04'!
function
	| node |

	node :=
		self hasArguments
			ifTrue: [self firstArgument firstInDocumentOrder]
			ifFalse: [self contextNode].

	(node notNil
		and: [node hasExpandedName])
		ifTrue: [| namespaceURI |
			(self context hasNamespaces
				and: [(namespaceURI := node namespaceURI) notEmpty
					and: [node hasPrefix]])
				ifTrue: [
					((self context resolvePrefixesOfNamespaceURI: namespaceURI)
						ifEmpty: [^ node localName]
						ifNotEmpty: [:prefixes |
							^ node localName qualifyWithXMLPrefix: prefixes anyOne])]
				ifFalse: [^ node name]]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathNamespaceURIFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNamespaceURIFunction commentStamp: 'monty 12/27/2014 00:27' prior: 0!
XPath namespace URI function.!

!XPathNamespaceURIFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'string namespace-uri(node-set?)'! !

!XPathNamespaceURIFunction methodsFor: 'implementing' stamp: 'monty 2/28/2017 08:02'!
function
	| node |

	node :=
		self hasArguments
			ifTrue: [self firstArgument firstInDocumentOrder]
			ifFalse: [self contextNode].

	(node notNil
		and: [node hasExpandedName])
		ifTrue: [^ node namespaceURI]
		ifFalse: [^ '']! !

XPathFunction subclass: #XPathNormalizeSpaceFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNormalizeSpaceFunction commentStamp: 'monty 6/15/2015 00:41' prior: 0!
XPath whitespace normalization function to remove leading and trailing whitespace and turn whitespace sequences into single spaces.!

!XPathNormalizeSpaceFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'string normalize-space(string?)'! !

!XPathNormalizeSpaceFunction methodsFor: 'implementing' stamp: 'monty 2/28/2017 08:25'!
function
	| string writeStream isInWhitespace normalizedSpace |

	string :=
		self hasArguments
			ifTrue: [self firstArgument]
			ifFalse: [self newContextNodeNodeSet stringValue].

	"must use #writeStream instead of 'WriteStream on:' to get a 0-based
	stream on Gemstone"
	writeStream := (String new: string size) writeStream.
	isInWhitespace := false.
	normalizedSpace := Character space.
	string do: [:each |
		each isXMLSeparator
			ifTrue: [
				isInWhitespace
					ifFalse: [isInWhitespace := true]]
			ifFalse: [
				isInWhitespace
					ifTrue: [
						writeStream position > 0
							ifTrue: [writeStream nextPut: normalizedSpace].
						isInWhitespace := false].
				writeStream nextPut: each]].
	^ writeStream contents.! !

XPathFunction subclass: #XPathNotFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNotFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath negation function.!

!XPathNotFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'boolean not(boolean)'! !

!XPathNotFunction methodsFor: 'implementing' stamp: 'monty 10/5/2016 19:06'!
function
	^ self firstArgument not! !

XPathFunction subclass: #XPathNumberFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathNumberFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath number conversion function.!

!XPathNumberFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'number number(object?)'! !

!XPathNumberFunction methodsFor: 'implementing' stamp: 'monty 2/28/2017 08:22'!
function
	"From the spec: 'If the argument is omitted, it defaults to a
	node-set with the context node as its only member.'"
	^ self hasArguments
		ifTrue: [self firstArgument]
		ifFalse: [self newContextNodeNodeSet]! !

XPathFunction subclass: #XPathRoundFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathRoundFunction commentStamp: 'monty 12/27/2014 00:37' prior: 0!
XPath number rounding function.!

!XPathRoundFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'number round(number)'! !

!XPathRoundFunction methodsFor: 'implementing' stamp: 'monty 3/14/2017 22:29'!
function
	^ self firstArgument xpathRounded! !

XPathFunction subclass: #XPathStartsWithFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStartsWithFunction commentStamp: 'monty 2/10/2015 02:59' prior: 0!
XPath string prefix testing function.!

!XPathStartsWithFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'boolean starts-with(string, string)'! !

!XPathStartsWithFunction methodsFor: 'implementing' stamp: 'monty 10/5/2016 19:05'!
function
	^ self firstArgument beginsWith: self lastArgument! !

XPathFunction subclass: #XPathStringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStringFunction commentStamp: 'monty 12/22/2014 20:01' prior: 0!
XPath string conversion function.!

!XPathStringFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'string string(object?)'! !

!XPathStringFunction methodsFor: 'implementing' stamp: 'monty 2/28/2017 08:21'!
function
	"From the spec: 'If the argument is omitted, it defaults to a
	node-set with the context node as its only member.'"
	^ self hasArguments
		ifTrue: [self firstArgument]
		ifFalse: [self newContextNodeNodeSet]! !

XPathFunction subclass: #XPathStringLengthFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathStringLengthFunction commentStamp: 'monty 12/22/2014 21:24' prior: 0!
XPath string length function.
!

!XPathStringLengthFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'number string-length(string?)'! !

!XPathStringLengthFunction methodsFor: 'implementing' stamp: 'monty 2/28/2017 08:27'!
function
	^ (self hasArguments
		ifTrue: [self firstArgument]
		ifFalse: [self contextNode ifNil: ['']]) size! !

XPathFunction subclass: #XPathSubstringAfterFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringAfterFunction commentStamp: 'monty 6/15/2015 04:48' prior: 0!
XPath function to return the substring after another substring.!

!XPathSubstringAfterFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'string substring-after(string, string)'! !

!XPathSubstringAfterFunction methodsFor: 'implementing' stamp: 'monty 10/5/2016 19:05'!
function
	| string substring indexOfSubstring |

	string := self firstArgument.
	substring := self lastArgument.
	(indexOfSubstring :=
		string
			findString: substring
			startingAt: 1) > 0
		ifTrue: [
			^ string
				copyFrom: indexOfSubstring + substring size
				to: string size]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathSubstringBeforeFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringBeforeFunction commentStamp: 'monty 6/15/2015 04:48' prior: 0!
XPath function to return the substring before another substring.!

!XPathSubstringBeforeFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'string substring-before(string, string)'! !

!XPathSubstringBeforeFunction methodsFor: 'implementing' stamp: 'monty 1/23/2017 13:30'!
function
	| string indexOfSubstring |

	string := self firstArgument.
	(indexOfSubstring :=
		string
			findString: self lastArgument
			startingAt: 1) > 0
		ifTrue: [
			^ string
				copyFrom: 1
				to: indexOfSubstring - 1]
		ifFalse: [^ ''].! !

XPathFunction subclass: #XPathSubstringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSubstringFunction commentStamp: 'monty 6/15/2015 04:48' prior: 0!
XPath substring function. First argument is the source string, second is the one-based position, and third is the substring length.!

!XPathSubstringFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'string substring(string, number, number?)'! !

!XPathSubstringFunction methodsFor: 'implementing' stamp: 'monty 3/14/2017 22:39'!
function
	| string start end |

	string := self argumentAt: 1.
	start := (self argumentAt: 2) xpathRounded.
	end :=
		self totalArguments > 2
			ifTrue: [start + (self argumentAt: 3) xpathRounded - 1]
			ifFalse: [string size].

	"if either start or end are NaN, the test will fail"
	(start <= end
		and: [start <= string size
			and: [end >= 1]])
		ifTrue: [
			"the #xpathRounded calls got rid of any fraciton part, but
			integer flots still must be converted to integers because
			#copyFrom:to: won't take integer floats, and the #min:/#max:
			eliminate +/- infinity"
			^ string
				copyFrom: (start max: 1) asInteger
				to: (end min: string size) asInteger]
		ifFalse: [^ '']	.! !

XPathFunction subclass: #XPathSumFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathSumFunction commentStamp: 'monty 6/15/2015 00:44' prior: 0!
XPath node set sum function.!

!XPathSumFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'number sum(node-set)'! !

!XPathSumFunction methodsFor: 'implementing' stamp: 'monty 10/5/2016 18:25'!
function
	^ self firstArgument
		inject: 0
		into: [:i :each | i + each stringValue asXPathNumber]! !

XPathFunction subclass: #XPathTranslateFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathTranslateFunction commentStamp: 'monty 6/15/2015 00:44' prior: 0!
XPath function to replace/delete all occurances of certain characters in a string.!

!XPathTranslateFunction class methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:43'!
prototypeSource
	^ 'string translate(string, string, string)'! !

!XPathTranslateFunction methodsFor: 'implementing' stamp: 'monty 10/9/2016 19:44'!
function
	| sourceString searchString replacementString replacementMap writeStream |

	sourceString := self argumentAt: 1.
	searchString := self argumentAt: 2.
	replacementString := self argumentAt: 3.
	replacementMap := Dictionary new.
	1 to: searchString size do: [:i |
		replacementMap
			at: (searchString at: i)
			ifAbsentPut: [
				replacementString
					at: i
					ifAbsent: [nil]]].

	writeStream := (String new: sourceString size) writeStream.
	sourceString do: [:each |	
		(replacementMap
			at: each
			ifAbsent: [each])
				ifNotNil: [:nextChar |
					writeStream nextPut: nextChar]].
	^ writeStream contents.! !

Object subclass: #XPathFunctionPrototype
	instanceVariableNames: 'returnType name minArguments maxArguments argumentTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Functions'!

!XPathFunctionPrototype commentStamp: 'monty 9/28/2016 02:23' prior: 0!
An immutable class for storing the function return type, name, and argument number and types parsed from a function prototype source string.!

!XPathFunctionPrototype class methodsFor: 'instance creation' stamp: 'monty 2/26/2018 23:43'!
fromString: aSourceString
	^ (XPathFunctionPrototypeParser
		on: aSourceString
		for: XPathTypedFunctionPrototypeParserHandler new) parse! !

!XPathFunctionPrototype class methodsFor: 'instance creation' stamp: 'monty 1/9/2017 09:53'!
returnType: aReturnType name: aName minArguments: aMinimum maxArguments: aMaximum argumentTypes: anArgumentTypeCollection
	^ self new
		setReturnType: aReturnType
		name: aName
		minArguments: aMinimum
		maxArguments: aMaximum
		argumentTypes: anArgumentTypeCollection! !

!XPathFunctionPrototype methodsFor: 'testing' stamp: 'monty 10/7/2016 00:18'!
acceptsArguments
	^ self minArguments > 0
		or: [self maxArguments isNil
			or: [self maxArguments > 0]]! !

!XPathFunctionPrototype methodsFor: 'testing' stamp: 'monty 10/9/2016 19:25'!
acceptsOptionalArguments
	^ self acceptsArguments
		and: [self minArguments ~= self maxArguments]! !

!XPathFunctionPrototype methodsFor: 'testing' stamp: 'monty 10/9/2016 19:25'!
acceptsVariableArguments
	^ self acceptsArguments
		and: [self maxArguments isNil]! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:09'!
argumentTypeAt: anIndex
	^ self
		argumentTypeAt: anIndex
		ifAbsent: [nil]! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 10/9/2016 19:09'!
argumentTypeAt: anIndex ifAbsent: aBlock
	anIndex > 0
		ifFalse: [^ aBlock value].
	anIndex > self argumentTypes size
		ifTrue: [
			"If it has a variable number of arguments, then
			use the last argument type for the remaining"
			self acceptsVariableArguments
				ifTrue: [^ self argumentTypes last]
				ifFalse: [^ aBlock value]].
	^ self argumentTypes at: anIndex.! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:34'!
argumentTypes
	^ argumentTypes! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:07'!
maxArguments
	^ maxArguments! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:07'!
minArguments
	^ minArguments! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 1/9/2017 09:53'!
name
	^ name! !

!XPathFunctionPrototype methodsFor: 'printing' stamp: 'monty 3/10/2018 22:59'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self returnType name;
		space;
		nextPutAll: self name;
		nextPut: $(.

	self argumentTypes withIndexDo: [:each :i |
		i > 1
			ifTrue: [aStream nextPutAll: ', '].
		aStream nextPutAll: each name.
		i > self minArguments
			ifTrue: [
				self maxArguments
					ifNil: [aStream nextPut: $*]
					ifNotNil: [aStream nextPut: $?]]].

	aStream nextPutAll: '))'.! !

!XPathFunctionPrototype methodsFor: 'accessing' stamp: 'monty 9/23/2016 13:07'!
returnType
	^ returnType! !

!XPathFunctionPrototype methodsFor: 'initialization' stamp: 'monty 1/9/2017 09:53'!
setReturnType: aReturnType name: aName minArguments: aMinimum maxArguments: aMaximum argumentTypes: anArgumentTypeCollection
	returnType := aReturnType.
	name := aName.
	minArguments := aMinimum.
	maxArguments := aMaximum.
	argumentTypes := anArgumentTypeCollection asArray.! !

Object subclass: #XPathNodeSetSorter
	instanceVariableNames: 'nodeSet nodeSetSize nodeSetCollection nodeSetSet mustVisitNamespaces mustVisitAttributes totalSorted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNodeSetSorter commentStamp: 'monty 10/16/2015 01:17' prior: 0!
This class sorts an unsorted node set into document order in linear time by traversing the document or just the nodes of a shared parent. (faster in tests on average than #sort: with a backtracking node order comparison block)!

!XPathNodeSetSorter class methodsFor: 'instance creation' stamp: 'monty 6/9/2015 01:45'!
on: aNodeSet
	^ self new on: aNodeSet! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 6/11/2015 02:05'!
errorNodesLackSharedDocumentRoot
	XPathDOMException signal: 'Cannot sort nodes without shared document root'! !

!XPathNodeSetSorter methodsFor: 'initialization' stamp: 'monty 9/22/2016 10:20'!
on: aNodeSet
	"save the internal state of the node set to inst vars for
	performance and to simplify code"
	nodeSet := aNodeSet.
	nodeSetSize := aNodeSet size.
	nodeSetCollection := aNodeSet collection.
	nodeSetSet := aNodeSet set.

	mustVisitNamespaces := false.
	mustVisitAttributes := false.
	totalSorted := 0.! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 2/18/2017 02:30'!
prescanNodesForSharedParent
	"check if all nodes in the node set have the same parent so sorting
	can be done quicker and if there are no attributes or namespaces
	in the node set so they can be ignored during sorting"

	| sharedParent |

	sharedParent := nodeSetCollection first parent.

	"we could breakout once sharedParent is nil (there isn't one) and
	mustVisitNamespaces and mustVisitAttributes are both true, because
	no more info is needed, but that's so uncommon (attributes and namespace
	nodes in a node set and no shared parent) that it's not worth testing for
	each iteration"
	nodeSetCollection do: [:each |
		each isNamespace
			ifTrue: [mustVisitNamespaces := true]
			ifFalse: [
				each isAttribute
					ifTrue: [mustVisitAttributes := true]].
		sharedParent
			ifNotNil: [
				each parent == sharedParent
					ifFalse: [sharedParent := nil]]].
	^ sharedParent.! !

!XPathNodeSetSorter methodsFor: 'sorting' stamp: 'monty 2/26/2017 10:28'!
sort
	nodeSetSize > 1
		ifTrue: [
			self prescanNodesForSharedParent
				ifNil: [self sortVisitingAllNodes]
				ifNotNil: [:sharedParent |
					self sortVisitingNodesOfSharedParent: sharedParent]].
	nodeSet sortOrder: XPathDocumentSortOrder new.! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 2/18/2017 02:25'!
sortVisitingAllNodes
	nodeSetCollection first documentRoot allNodesDo: [:node |
		self visitNode: node.
		node isElement
			ifTrue: [
				(mustVisitNamespaces
					and: [node hasNamespaceNodes])
					ifTrue: [
						node namespaceNodesDo: [:each |
							self visitNode: each]].
				(mustVisitAttributes
					and: [node hasAttributes])
					ifTrue: [
						node attributeNodesDo: [:each |
							self visitNode: each]]].
		"can abort when every node in the node set has been visited"
		totalSorted = nodeSetSize
			ifTrue: [^ self]].

	"if we got here, then at least one node must not belong to the same
	document as the rest, because otherwise it would have been visited"
	self errorNodesLackSharedDocumentRoot.! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 2/26/2017 10:29'!
sortVisitingNodesOfSharedParent: aSharedParent
	"all nodes in the node set have the same parent, so only its
	namespaces and attributes (if any are in the node set) and
	children need to be visited"
	mustVisitNamespaces
		ifTrue: [
			aSharedParent namespaceNodesDo: [:each |
				self visitNode: each]].
	mustVisitAttributes
		ifTrue: [
			aSharedParent attributeNodesDo: [:each |
				self visitNode: each]].
	aSharedParent hasChildren
		ifTrue: [
			aSharedParent nodesDo: [:each |
				self visitNode: each]].! !

!XPathNodeSetSorter methodsFor: 'private' stamp: 'monty 2/18/2017 02:25'!
visitNode: aNode
	(nodeSetSet includes: aNode)
		ifTrue: [
			nodeSetCollection
				at: (totalSorted := totalSorted + 1)
				put: aNode]! !

Object subclass: #XPathNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNodeTest commentStamp: 'monty 2/4/2017 17:56' prior: 0!
This is a base class for XPath node tests.!

XPathNodeTest subclass: #XPathAnyNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathAnyNodeTest commentStamp: '<historical>' prior: 0!
This is a class for the 'node()' type test for any node.!

!XPathAnyNodeTest methodsFor: 'testing' stamp: 'monty 2/4/2017 18:47'!
isAnyNodeTest
	^ true! !

!XPathAnyNodeTest methodsFor: 'evaluating' stamp: 'monty 2/4/2017 01:58'!
value: aNode
	^ true! !

XPathNodeTest subclass: #XPathAttributeNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathAttributeNodeTest commentStamp: '<historical>' prior: 0!
This is a class for the 'attribute()' type test or for the '*' type test when the principal node type of the axis is 'attribute'.!

!XPathAttributeNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTest
	^ true! !

!XPathAttributeNodeTest methodsFor: 'evaluating' stamp: 'monty 2/4/2017 01:59'!
value: aNode
	^ aNode isAttribute! !

XPathAttributeNodeTest subclass: #XPathAttributeNodeTestForLocalName
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathAttributeNodeTestForLocalName commentStamp: '<historical>' prior: 0!
This is a class for the 'attribute(*:localName)' type test or for the '*:localName' type test when the principal node type of the axis is 'attribute'.!

!XPathAttributeNodeTestForLocalName class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
localName: aLocalName
	^ self new localName: aLocalName! !

!XPathAttributeNodeTestForLocalName methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForLocalName
	^ true! !

!XPathAttributeNodeTestForLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:54'!
localName
	^ localName! !

!XPathAttributeNodeTestForLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
localName: aLocalName
	localName := aLocalName! !

!XPathAttributeNodeTestForLocalName methodsFor: 'printing' stamp: 'monty 3/10/2018 22:57'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self localName;
		nextPut: $).! !

!XPathAttributeNodeTestForLocalName methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:01'!
value: aNode
	^ aNode isAttribute
		and: [aNode localName = self localName]! !

XPathAttributeNodeTest subclass: #XPathAttributeNodeTestForName
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathAttributeNodeTestForName commentStamp: '<historical>' prior: 0!
This is a class for the 'attribute(name)' type test or for the 'name' type test when the principal node type of the axis is 'attribute'.!

!XPathAttributeNodeTestForName class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
name: aName
	^ self new name: aName! !

!XPathAttributeNodeTestForName methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForName
	^ true! !

!XPathAttributeNodeTestForName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:54'!
name
	^ name! !

!XPathAttributeNodeTestForName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
name: aName
	name := aName! !

!XPathAttributeNodeTestForName methodsFor: 'printing' stamp: 'monty 3/10/2018 22:57'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self name;
		nextPut: $).! !

!XPathAttributeNodeTestForName methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:01'!
value: aNode
	^ aNode isAttribute
		and: [aNode name = self name]! !

XPathAttributeNodeTest subclass: #XPathAttributeNodeTestForNamespaceURI
	instanceVariableNames: 'namespaceURI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathAttributeNodeTestForNamespaceURI commentStamp: '<historical>' prior: 0!
This is a class for the 'attribute(Q{namespaceURI}*)' type test or for the 'Q{namespaceURI}*' type test when the principal node type of the axis is 'attribute'.!

!XPathAttributeNodeTestForNamespaceURI class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
namespaceURI: aURI
	^ self new namespaceURI: aURI! !

!XPathAttributeNodeTestForNamespaceURI methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForNamespaceURI
	^ true! !

!XPathAttributeNodeTestForNamespaceURI methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:54'!
namespaceURI
	^ namespaceURI! !

!XPathAttributeNodeTestForNamespaceURI methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
namespaceURI: aURI
	namespaceURI := aURI! !

!XPathAttributeNodeTestForNamespaceURI methodsFor: 'printing' stamp: 'monty 3/10/2018 22:57'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self namespaceURI;
		nextPut: $).! !

!XPathAttributeNodeTestForNamespaceURI methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:01'!
value: aNode
	^ aNode isAttribute
		and: [aNode namespaceURI = self namespaceURI]! !

XPathAttributeNodeTestForNamespaceURI subclass: #XPathAttributeNodeTestForNamespaceURIAndLocalName
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathAttributeNodeTestForNamespaceURIAndLocalName commentStamp: '<historical>' prior: 0!
This is a class for the 'attribute(Q{namespaceURI}localName)' type test or for the 'Q{namespaceURI}localName' type test when the principal node type of the axis is 'attribute'.!

!XPathAttributeNodeTestForNamespaceURIAndLocalName class methodsFor: 'instance creation' stamp: 'monty 2/10/2017 21:56'!
namespaceURI: aURI localName: aLocalName
	^ (self namespaceURI: aURI)
		localName: aLocalName! !

!XPathAttributeNodeTestForNamespaceURIAndLocalName methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isAttributeNodeTestForNamespaceURIAndLocalName
	^ true! !

!XPathAttributeNodeTestForNamespaceURIAndLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:54'!
localName
	^ localName! !

!XPathAttributeNodeTestForNamespaceURIAndLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
localName: aLocalName
	localName := aLocalName! !

!XPathAttributeNodeTestForNamespaceURIAndLocalName methodsFor: 'printing' stamp: 'monty 3/10/2018 22:58'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: (self localName expandWithXMLNamespaceURI: self namespaceURI);
		nextPut: $).! !

!XPathAttributeNodeTestForNamespaceURIAndLocalName methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:01'!
value: aNode
	^ aNode isAttribute
		and: [aNode localName = self localName
			and: [aNode namespaceURI = self namespaceURI]]! !

XPathAttributeNodeTest subclass: #XPathAttributeNodeTestForPrefix
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathAttributeNodeTestForPrefix commentStamp: '<historical>' prior: 0!
This is a class for the 'attribute(prefix:*)' type test or for the 'prefix:*' type test when the principal node type of the axis is 'attribute'.!

!XPathAttributeNodeTestForPrefix class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
prefix: aPrefix
	^ self new prefix: aPrefix! !

!XPathAttributeNodeTestForPrefix methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isAttributeNodeTestForPrefix
	^ true! !

!XPathAttributeNodeTestForPrefix methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:55'!
prefix
	^ prefix! !

!XPathAttributeNodeTestForPrefix methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
prefix: aPrefix
	prefix := aPrefix! !

!XPathAttributeNodeTestForPrefix methodsFor: 'printing' stamp: 'monty 3/10/2018 22:58'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self prefix;
		nextPut: $).! !

!XPathAttributeNodeTestForPrefix methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:01'!
value: aNode
	^ aNode isAttribute
		and: [aNode prefix = self prefix]! !

XPathNodeTest subclass: #XPathBlockNodeTest
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathBlockNodeTest commentStamp: 'monty 2/6/2017 18:38' prior: 0!
This is a node test created from a BlockClosure.!

!XPathBlockNodeTest class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 22:05'!
block: aBlock
	^ self new block: aBlock! !

!XPathBlockNodeTest methodsFor: 'accessing' stamp: 'monty 2/4/2017 22:05'!
block
	^ block! !

!XPathBlockNodeTest methodsFor: 'accessing' stamp: 'monty 2/4/2017 22:05'!
block: aBlock
	block := aBlock! !

!XPathBlockNodeTest methodsFor: 'evaluating' stamp: 'monty 2/4/2017 02:04'!
value: aNode
	^ block value: aNode! !

XPathNodeTest subclass: #XPathCommentNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathCommentNodeTest commentStamp: '<historical>' prior: 0!
This is a class for the 'comment()' type test.!

!XPathCommentNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isCommentNodeTest
	^ true! !

!XPathCommentNodeTest methodsFor: 'evaluating' stamp: 'monty 2/4/2017 18:55'!
value: aNode
	^ aNode isComment! !

XPathNodeTest subclass: #XPathElementNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathElementNodeTest commentStamp: '<historical>' prior: 0!
This is a class for the 'element()' type test or for '*' type tests when the principal node type of the axis is an element.!

!XPathElementNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isElementNodeTest
	^ true! !

!XPathElementNodeTest methodsFor: 'evaluating' stamp: 'monty 2/4/2017 18:56'!
value: aNode
	^ aNode isElement! !

XPathElementNodeTest subclass: #XPathElementNodeTestForLocalName
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathElementNodeTestForLocalName commentStamp: '<historical>' prior: 0!
This is a class for the 'element(*:localName)' type test or for the '*:localName' type test when the principal node type of the axis is 'element'.!

!XPathElementNodeTestForLocalName class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
localName: aLocalName
	^ self new localName: aLocalName! !

!XPathElementNodeTestForLocalName methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForLocalName
	^ true! !

!XPathElementNodeTestForLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:57'!
localName
	^ localName! !

!XPathElementNodeTestForLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
localName: aLocalName
	localName := aLocalName! !

!XPathElementNodeTestForLocalName methodsFor: 'printing' stamp: 'monty 3/10/2018 22:58'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self localName;
		nextPut: $).! !

!XPathElementNodeTestForLocalName methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:00'!
value: aNode
	^ aNode isElement
		and: [aNode localName = self localName]! !

XPathElementNodeTest subclass: #XPathElementNodeTestForName
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathElementNodeTestForName commentStamp: '<historical>' prior: 0!
This is a class for the 'element(name)' type test or for the 'name' type test when the principal node type of the axis is 'element'.!

!XPathElementNodeTestForName class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
name: aName
	^ self new name: aName! !

!XPathElementNodeTestForName methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForName
	^ true! !

!XPathElementNodeTestForName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:58'!
name
	^ name! !

!XPathElementNodeTestForName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
name: aName
	name := aName! !

!XPathElementNodeTestForName methodsFor: 'printing' stamp: 'monty 3/10/2018 22:58'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self name;
		nextPut: $).! !

!XPathElementNodeTestForName methodsFor: 'evaluating' stamp: 'monty 2/4/2017 21:53'!
value: aNode
	^ aNode isElement
		and: [aNode name = self name]! !

XPathElementNodeTest subclass: #XPathElementNodeTestForNamespaceURI
	instanceVariableNames: 'namespaceURI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathElementNodeTestForNamespaceURI commentStamp: '<historical>' prior: 0!
This is a class for the 'element(Q{namespaceURI}*)' type test or for the 'Q{namespaceURI}*' type test when the principal node type of the axis is 'element'.!

!XPathElementNodeTestForNamespaceURI class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
namespaceURI: aURI
	^ self new namespaceURI: aURI! !

!XPathElementNodeTestForNamespaceURI methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForNamespaceURI
	^ true! !

!XPathElementNodeTestForNamespaceURI methodsFor: 'accessing' stamp: 'monty 2/4/2017 19:01'!
namespaceURI
	^ namespaceURI! !

!XPathElementNodeTestForNamespaceURI methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
namespaceURI: aURI
	namespaceURI := aURI! !

!XPathElementNodeTestForNamespaceURI methodsFor: 'printing' stamp: 'monty 3/10/2018 22:58'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self namespaceURI;
		nextPut: $).! !

!XPathElementNodeTestForNamespaceURI methodsFor: 'evaluating' stamp: 'monty 2/4/2017 21:52'!
value: aNode
	^ aNode isElement
		and: [aNode namespaceURI = self namespaceURI]! !

XPathElementNodeTestForNamespaceURI subclass: #XPathElementNodeTestForNamespaceURIAndLocalName
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathElementNodeTestForNamespaceURIAndLocalName commentStamp: '<historical>' prior: 0!
This is a class for the 'element(Q{namespaceURI}localName)' type test or for the 'Q{namespaceURI}localName' type test when the principal node type of the axis is 'element'.!

!XPathElementNodeTestForNamespaceURIAndLocalName class methodsFor: 'instance creation' stamp: 'monty 2/10/2017 21:56'!
namespaceURI: aURI localName: aLocalName
	^ (self namespaceURI: aURI)
		localName: aLocalName! !

!XPathElementNodeTestForNamespaceURIAndLocalName methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForNamespaceURIAndLocalName
	^ true! !

!XPathElementNodeTestForNamespaceURIAndLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 19:02'!
localName
	^ localName! !

!XPathElementNodeTestForNamespaceURIAndLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
localName: aLocalName
	localName := aLocalName! !

!XPathElementNodeTestForNamespaceURIAndLocalName methodsFor: 'printing' stamp: 'monty 3/10/2018 22:58'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: (self localName expandWithXMLNamespaceURI: self namespaceURI);
		nextPut: $).! !

!XPathElementNodeTestForNamespaceURIAndLocalName methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:00'!
value: aNode
	^ aNode isElement
		and: [aNode localName = self localName
			and: [aNode namespaceURI = self namespaceURI]]! !

XPathElementNodeTest subclass: #XPathElementNodeTestForPrefix
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathElementNodeTestForPrefix commentStamp: '<historical>' prior: 0!
This is a class for the 'element(prefix:*)' type test or for the 'prefix:*' type test when the principal node type of the axis is 'element'.!

!XPathElementNodeTestForPrefix class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
prefix: aPrefix
	^ self new prefix: aPrefix! !

!XPathElementNodeTestForPrefix methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForPrefix
	^ true! !

!XPathElementNodeTestForPrefix methodsFor: 'accessing' stamp: 'monty 2/4/2017 19:02'!
prefix
	^ prefix! !

!XPathElementNodeTestForPrefix methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
prefix: aPrefix
	prefix := aPrefix! !

!XPathElementNodeTestForPrefix methodsFor: 'printing' stamp: 'monty 3/10/2018 22:58'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self prefix;
		nextPut: $).! !

!XPathElementNodeTestForPrefix methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:02'!
value: aNode
	^ aNode isElement
		and: [aNode prefix = self prefix]! !

XPathNodeTest subclass: #XPathNamespaceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNamespaceTest commentStamp: '<historical>' prior: 0!
This is a class for the 'namespace()' type test or for '*' type tests when the principal node type of the axis is an namespace.!

!XPathNamespaceTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTest
	^ true! !

!XPathNamespaceTest methodsFor: 'evaluating' stamp: 'monty 2/4/2017 22:07'!
value: aNode
	^ aNode isNamespace! !

XPathNamespaceTest subclass: #XPathNamespaceTestForLocalName
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNamespaceTestForLocalName commentStamp: '<historical>' prior: 0!
This is a class for the 'namespace(*:localName)' type test or for the '*:localName' type test when the principal node type of the axis is 'namespace'.!

!XPathNamespaceTestForLocalName class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
localName: aLocalName
	^ self new localName: aLocalName! !

!XPathNamespaceTestForLocalName methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForLocalName
	^ true! !

!XPathNamespaceTestForLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 19:05'!
localName
	^ localName! !

!XPathNamespaceTestForLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
localName: aLocalName
	localName := aLocalName! !

!XPathNamespaceTestForLocalName methodsFor: 'printing' stamp: 'monty 3/10/2018 22:59'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self localName;
		nextPut: $).! !

!XPathNamespaceTestForLocalName methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:05'!
value: aNode
	^ aNode isNamespace
		and: [aNode localName = self localName]! !

XPathNamespaceTest subclass: #XPathNamespaceTestForName
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNamespaceTestForName commentStamp: '<historical>' prior: 0!
This is a class for the 'namespace(name)' type test or for the 'name' type test when the principal node type of the axis is 'namespace'.!

!XPathNamespaceTestForName class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
name: aName
	^ self new name: aName! !

!XPathNamespaceTestForName methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForName
	^ true! !

!XPathNamespaceTestForName methodsFor: 'accessing' stamp: 'monty 2/4/2017 19:04'!
name
	^ name! !

!XPathNamespaceTestForName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
name: aName
	name := aName! !

!XPathNamespaceTestForName methodsFor: 'printing' stamp: 'monty 3/10/2018 22:59'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self name;
		nextPut: $).! !

!XPathNamespaceTestForName methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:05'!
value: aNode
	^ aNode isNamespace
		and: [aNode name = self name]! !

XPathNamespaceTest subclass: #XPathNamespaceTestForNamespaceURI
	instanceVariableNames: 'namespaceURI'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNamespaceTestForNamespaceURI commentStamp: '<historical>' prior: 0!
This is a class for the 'namespace(Q{namespaceURI}*)' type test or for the 'Q{namespaceURI}*' type test when the principal node type of the axis is 'namespace'.!

!XPathNamespaceTestForNamespaceURI class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
namespaceURI: aURI
	^ self new namespaceURI: aURI! !

!XPathNamespaceTestForNamespaceURI methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isNamespaceNodeTestForNamespaceURI
	^ true! !

!XPathNamespaceTestForNamespaceURI methodsFor: 'accessing' stamp: 'monty 2/4/2017 19:04'!
namespaceURI
	^ namespaceURI! !

!XPathNamespaceTestForNamespaceURI methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
namespaceURI: aURI
	namespaceURI := aURI! !

!XPathNamespaceTestForNamespaceURI methodsFor: 'printing' stamp: 'monty 3/10/2018 22:59'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self namespaceURI;
		nextPut: $).! !

!XPathNamespaceTestForNamespaceURI methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:04'!
value: aNode
	^ aNode isNamespace
		and: [aNode namespaceURI = self namespaceURI]! !

XPathNamespaceTestForNamespaceURI subclass: #XPathNamespaceTestForNamespaceURIAndLocalName
	instanceVariableNames: 'localName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNamespaceTestForNamespaceURIAndLocalName commentStamp: '<historical>' prior: 0!
This is a class for the 'namespace(Q{namespaceURI}localName)' type test or for the 'Q{namespaceURI}localName' type test when the principal node type of the axis is 'namespace'.!

!XPathNamespaceTestForNamespaceURIAndLocalName class methodsFor: 'instance creation' stamp: 'monty 2/10/2017 21:56'!
namespaceURI: aURI localName: aLocalName
	^ (self namespaceURI: aURI)
		localName: aLocalName! !

!XPathNamespaceTestForNamespaceURIAndLocalName methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForNamespaceURIAndLocalName
	^ true! !

!XPathNamespaceTestForNamespaceURIAndLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 19:03'!
localName
	^ localName! !

!XPathNamespaceTestForNamespaceURIAndLocalName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
localName: aLocalName
	localName := aLocalName! !

!XPathNamespaceTestForNamespaceURIAndLocalName methodsFor: 'printing' stamp: 'monty 3/10/2018 22:59'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: (self localName expandWithXMLNamespaceURI: self namespaceURI);
		nextPut: $).! !

!XPathNamespaceTestForNamespaceURIAndLocalName methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:04'!
value: aNode
	^ aNode isNamespace
		and: [aNode localName = self localName
			and: [aNode namespaceURI = self namespaceURI]]! !

XPathNamespaceTest subclass: #XPathNamespaceTestForPrefix
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNamespaceTestForPrefix commentStamp: '<historical>' prior: 0!
This is a class for the 'namespace(prefix:*)' type test or for the 'prefix:*' type test when the principal node type of the axis is 'namespace'.!

!XPathNamespaceTestForPrefix class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
prefix: aPrefix
	^ self new prefix: aPrefix! !

!XPathNamespaceTestForPrefix methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isNamespaceNodeTestForPrefix
	^ true! !

!XPathNamespaceTestForPrefix methodsFor: 'accessing' stamp: 'monty 2/4/2017 19:03'!
prefix
	^ prefix! !

!XPathNamespaceTestForPrefix methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
prefix: aPrefix
	prefix := aPrefix! !

!XPathNamespaceTestForPrefix methodsFor: 'printing' stamp: 'monty 3/10/2018 22:59'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		nextPutAll: self prefix;
		nextPut: $).! !

!XPathNamespaceTestForPrefix methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:03'!
value: aNode
	^ aNode isNamespace
		and: [aNode prefix = self prefix]! !

!XPathNodeTest methodsFor: 'converting' stamp: 'monty 2/5/2017 16:46'!
asXPathAttributeAxisNodeTest
	^ self! !

!XPathNodeTest methodsFor: 'converting' stamp: 'monty 2/5/2017 16:46'!
asXPathNamespaceAxisNodeTest
	^ self! !

!XPathNodeTest methodsFor: 'converting' stamp: 'monty 2/4/2017 17:56'!
asXPathNodeTest
	^ self! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/4/2017 21:23'!
isAnyNodeTest
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTest
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForLocalName
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForName
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:26'!
isAttributeNodeTestForNamespaceURI
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isAttributeNodeTestForNamespaceURIAndLocalName
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isAttributeNodeTestForPrefix
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:27'!
isCommentNodeTest
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isElementNodeTest
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForLocalName
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForName
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForNamespaceURI
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForNamespaceURIAndLocalName
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:30'!
isElementNodeTestForPrefix
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTest
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForLocalName
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForName
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isNamespaceNodeTestForNamespaceURI
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:29'!
isNamespaceNodeTestForNamespaceURIAndLocalName
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isNamespaceNodeTestForPrefix
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isPINodeTest
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isPINodeTestForName
	^ false! !

!XPathNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isTextNodeTest
	^ false! !

!XPathNodeTest methodsFor: 'evaluating' stamp: 'monty 2/4/2017 18:52'!
value: aNode
	self subclassResponsibility! !

XPathNodeTest subclass: #XPathPINodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathPINodeTest commentStamp: '<historical>' prior: 0!
This is a class for the 'processing-instruction()' type test.!

!XPathPINodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isPINodeTest
	^ true! !

!XPathPINodeTest methodsFor: 'evaluating' stamp: 'monty 2/4/2017 01:58'!
value: aNode
	^ aNode isPI! !

XPathPINodeTest subclass: #XPathPINodeTestForName
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathPINodeTestForName commentStamp: '<historical>' prior: 0!
This is a class for the 'processing-instruction(name)' type test.!

!XPathPINodeTestForName class methodsFor: 'instance creation' stamp: 'monty 2/4/2017 18:47'!
name: aName
	^ self new name: aName! !

!XPathPINodeTestForName methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isPINodeTestForName
	^ true! !

!XPathPINodeTestForName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:57'!
name
	^ name! !

!XPathPINodeTestForName methodsFor: 'accessing' stamp: 'monty 2/4/2017 18:47'!
name: aName
	name := aName! !

!XPathPINodeTestForName methodsFor: 'evaluating' stamp: 'monty 2/4/2017 19:03'!
value: aNode
	^ aNode isPI
		and: [aNode target = self name]! !

XPathNodeTest subclass: #XPathTextNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathTextNodeTest commentStamp: '<historical>' prior: 0!
This is a class for the 'text()' type test.!

!XPathTextNodeTest methodsFor: 'testing' stamp: 'monty 2/5/2017 20:28'!
isTextNodeTest
	^ true! !

!XPathTextNodeTest methodsFor: 'evaluating' stamp: 'monty 2/4/2017 01:57'!
value: aNode
	^ aNode isStringNode! !

Object subclass: #XPathNodeTestParserState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

XPathNodeTestParserState class
	instanceVariableNames: 'instance'!

!XPathNodeTestParserState commentStamp: '<historical>' prior: 0!
This is an abstract base class for node test parser states. Instances of subclasses are immutable and shared.!

XPathNodeTestParserState class
	instanceVariableNames: 'instance'!

XPathNodeTestParserState subclass: #XPathNodeTestParserAttributeState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserAttributeState commentStamp: '<historical>' prior: 0!
A state for parsing node tests where attributes are the principal node type.!

!XPathNodeTestParserAttributeState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleNodeTestForLocalName: aLocalName with: aHandler
	aHandler handleAttributeNodeTestForLocalName: aLocalName! !

!XPathNodeTestParserAttributeState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleNodeTestForName: aName with: aHandler
	aHandler handleAttributeNodeTestForName: aName! !

!XPathNodeTestParserAttributeState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleNodeTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleAttributeNodeTestForNamespaceURI: aURI
		localName: aLocalName! !

!XPathNodeTestParserAttributeState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleNodeTestForNamespaceURI: aURI with: aHandler
	aHandler handleAttributeNodeTestForNamespaceURI: aURI! !

!XPathNodeTestParserAttributeState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:08'!
handleNodeTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleAttributeNodeTestForPrefix: aPrefix
		localName: aLocalName! !

!XPathNodeTestParserAttributeState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:08'!
handleNodeTestForPrefix: aPrefix with: aHandler
	aHandler handleAttributeNodeTestForPrefix: aPrefix! !

!XPathNodeTestParserAttributeState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleWildcardNodeTestWith: aHandler
	aHandler handleAttributeNodeTest! !

XPathNodeTestParserAttributeState subclass: #XPathNodeTestParserAttributeTypeTestState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserAttributeTypeTestState commentStamp: '<historical>' prior: 0!
A state for parsing the arguments of an attribute() type test.!

!XPathNodeTestParserAttributeTypeTestState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleEmptyNodeTestWith: aHandler
	aHandler handleAttributeNodeTest! !

XPathNodeTestParserState subclass: #XPathNodeTestParserElementState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserElementState commentStamp: '<historical>' prior: 0!
A state for parsing node tests where elements are the principal node type.!

!XPathNodeTestParserElementState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNodeTestForLocalName: aLocalName with: aHandler
	aHandler handleElementNodeTestForLocalName: aLocalName! !

!XPathNodeTestParserElementState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleNodeTestForName: aName with: aHandler
	aHandler handleElementNodeTestForName: aName! !

!XPathNodeTestParserElementState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleNodeTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleElementNodeTestForNamespaceURI: aURI
		localName: aLocalName! !

!XPathNodeTestParserElementState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleNodeTestForNamespaceURI: aURI with: aHandler
	aHandler handleElementNodeTestForNamespaceURI: aURI! !

!XPathNodeTestParserElementState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleNodeTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleElementNodeTestForPrefix: aPrefix
		localName: aLocalName! !

!XPathNodeTestParserElementState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleNodeTestForPrefix: aPrefix with: aHandler
	aHandler handleElementNodeTestForPrefix: aPrefix! !

!XPathNodeTestParserElementState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleWildcardNodeTestWith: aHandler
	aHandler handleElementNodeTest! !

XPathNodeTestParserElementState subclass: #XPathNodeTestParserElementTypeTestState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserElementTypeTestState commentStamp: '<historical>' prior: 0!
A state for parsing the arguments of an element() type test.!

!XPathNodeTestParserElementTypeTestState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleEmptyNodeTestWith: aHandler
	aHandler handleElementNodeTest! !

XPathNodeTestParserState subclass: #XPathNodeTestParserNamespaceState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserNamespaceState commentStamp: '<historical>' prior: 0!
A state for parsing node tests where namespaces are the principal node type.!

!XPathNodeTestParserNamespaceState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNodeTestForLocalName: aLocalName with: aHandler
	aHandler handleNamespaceNodeTestForLocalName: aLocalName! !

!XPathNodeTestParserNamespaceState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNodeTestForName: aName with: aHandler
	aHandler handleNamespaceNodeTestForName: aName! !

!XPathNodeTestParserNamespaceState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNodeTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	aHandler
		handleNamespaceNodeTestForNamespaceURI: aURI
		localName: aLocalName! !

!XPathNodeTestParserNamespaceState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNodeTestForNamespaceURI: aURI with: aHandler
	aHandler handleNamespaceNodeTestForNamespaceURI: aURI! !

!XPathNodeTestParserNamespaceState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleNodeTestForPrefix: aPrefix localName: aLocalName with: aHandler
	aHandler
		handleNamespaceNodeTestForPrefix: aPrefix
		localName: aLocalName! !

!XPathNodeTestParserNamespaceState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNodeTestForPrefix: aPrefix with: aHandler
	aHandler handleNamespaceNodeTestForPrefix: aPrefix! !

!XPathNodeTestParserNamespaceState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleWildcardNodeTestWith: aHandler
	aHandler handleNamespaceNodeTest! !

XPathNodeTestParserNamespaceState subclass: #XPathNodeTestParserNamespaceTypeTestState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserNamespaceTypeTestState commentStamp: '<historical>' prior: 0!
A state for parsing the arguments of a namespace() type test.!

!XPathNodeTestParserNamespaceTypeTestState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleEmptyNodeTestWith: aHandler
	aHandler handleNamespaceNodeTest! !

!XPathNodeTestParserState class methodsFor: 'accessing' stamp: 'monty 10/9/2016 04:57'!
instance
	^ instance
		ifNil: [instance := self basicNew initialize]! !

!XPathNodeTestParserState class methodsFor: 'instance creation' stamp: 'monty 10/9/2016 04:59'!
new
	"these classes are immutable and shared, so they are only initialized once"
	^ self instance! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 1/4/2017 07:46'!
handleAnyNodeTestWith: aHandler
	aHandler handleAnyNodeTest! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:08'!
handleCommentNodeTestWith: aHandler
	aHandler handleCommentNodeTest! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleEmptyNodeTestWith: aHandler
	aHandler handleEmptyNodeTest! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:05'!
handleNodeTestForLocalName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:05'!
handleNodeTestForName: aName with: aHandler
	self subclassResponsibility
! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:05'!
handleNodeTestForNamespaceURI: aURI localName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:05'!
handleNodeTestForNamespaceURI: aURI with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:05'!
handleNodeTestForPrefix: aPrefix localName: aLocalName with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:06'!
handleNodeTestForPrefix: aPrefix with: aHandler
	self subclassResponsibility! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handlePINodeTestForName: aName with: aHandler
	aHandler handlePINodeTestForName: aName! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handlePINodeTestWith: aHandler
	aHandler handlePINodeTest! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleTextNodeTestWith: aHandler
	aHandler handleTextNodeTest! !

!XPathNodeTestParserState methodsFor: 'handling' stamp: 'monty 2/5/2017 17:06'!
handleWildcardNodeTestWith: aHandler
	self subclassResponsibility! !

Object subclass: #XPathNodeTestWithPredicates
	instanceVariableNames: 'nodeTest predicates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathNodeTestWithPredicates commentStamp: 'monty 2/11/2017 18:45' prior: 0!
This class stores an object to be converted to a node test and one or more predicates to apply with it.!

!XPathNodeTestWithPredicates class methodsFor: 'instance creation' stamp: 'monty 2/11/2017 18:01'!
nodeTest: aNodeTest predicates: aPredicateOrPredicateCollection
	^ self new
		setNodeTest: aNodeTest
		predicates: aPredicateOrPredicateCollection! !

!XPathNodeTestWithPredicates methodsFor: 'copying' stamp: 'monty 2/14/2017 00:30'!
?? aPredicateOrPredicateCollection
	^ self copy setPredicates:
		(aPredicateOrPredicateCollection isCollection
			ifTrue: [predicates, aPredicateOrPredicateCollection]
			ifFalse: [predicates copyWith: aPredicateOrPredicateCollection])! !

!XPathNodeTestWithPredicates methodsFor: 'testing' stamp: 'monty 2/11/2017 18:09'!
isXPathNodeTestWithPredicates
	^ true! !

!XPathNodeTestWithPredicates methodsFor: 'accessing' stamp: 'monty 2/11/2017 18:01'!
nodeTest
	^ nodeTest! !

!XPathNodeTestWithPredicates methodsFor: 'accessing' stamp: 'monty 2/11/2017 18:08'!
predicates
	^ predicates! !

!XPathNodeTestWithPredicates methodsFor: 'printing' stamp: 'monty 3/10/2018 22:59'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		print: self nodeTest;
		nextPutAll: '; ';
		print: self predicates;
		nextPut: $).! !

!XPathNodeTestWithPredicates methodsFor: 'initialization' stamp: 'monty 2/13/2017 23:36'!
setNodeTest: aNodeTest predicates: aPredicateOrPredicateCollection
	nodeTest := aNodeTest.
	self setPredicates: aPredicateOrPredicateCollection.! !

!XPathNodeTestWithPredicates methodsFor: 'initialization' stamp: 'monty 3/14/2018 06:52'!
setPredicates: aPredicateOrPredicateCollection
	predicates :=
		aPredicateOrPredicateCollection isArray
			ifTrue: [aPredicateOrPredicateCollection]
			ifFalse: [
				aPredicateOrPredicateCollection isCollection
					ifTrue: [
						"avoid #newFrom: for portability"
						Array withAll: aPredicateOrPredicateCollection]
					ifFalse: [Array with: aPredicateOrPredicateCollection]]! !

Object subclass: #XPathParser
	instanceVariableNames: 'handler readStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathParser commentStamp: 'monty 3/1/2017 06:49' prior: 0!
This is an abstract class for XPath parsers that parse input using injectable parser handlers. It contains support for parsing common constructs like quoted string literals, qualified and non-qualified names, and comma-separted argument lists in parentheses.!

XPathParser subclass: #XPathExpressionParser
	instanceVariableNames: 'currentAxis nodeTestParser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParser commentStamp: 'monty 1/25/2017 12:07' prior: 0!
This class parses XPath expressions. It understands all of XPath 1.0 syntax and supports some extensions like the attribute(), element(), and namespace() type tests that can optionally have name test arguments, and name tests like 'Q{NamespaceURI}localName', '*:localName', and 'Q{NamespaceURI}*'.!

!XPathExpressionParser methodsFor: 'testing' stamp: 'monty 2/7/2017 03:32'!
atDigit
	readStream peek
		ifNil: [^ false]
		ifNotNil: [:nextChar | ^ nextChar isDigit]! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 4/2/2015 08:19'!
errorExpectedEndPredicate
	self errorExpected: '"]" end of predicate'! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/21/2015 18:29'!
errorExpectedNodeTest
	self errorExpected: 'node test after axis'! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/14/2015 04:35'!
errorExpectedStep
	self errorExpected: 'location path step'! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/26/2015 20:32'!
nextAdditionalSteps
	self peekForAdditionalSteps
		ifFalse: [self errorExpectedStep]! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 10:48'!
nextAdditiveExpression
	handler handleStartAdditiveExpression.
	self nextMultiplicativeExpression.
	[self peekForAdditiveOperator]
		whileTrue: [self nextMultiplicativeExpression].
	handler handleEndAdditiveExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/1/2017 06:06'!
nextAndExpression
	handler handleStartAndExpression.
	self nextEqualityExpression.
	[self peekForAndOperator]
		whileTrue: [
			handler handleAndOperator.
			self nextEqualityExpression].
	handler handleEndAndExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:19'!
nextArgument
	handler handleStartFunctionArgument.
	self nextOrExpression.
	handler handleEndFunctionArgument.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextDigitsOnWriteStream
	"first digit"
	writeStream nextPut: readStream next.
	[self atDigit]
		whileTrue: [writeStream nextPut: readStream next].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 11:10'!
nextEqualityExpression
	handler handleStartEqualityExpression.
	self nextRelationalExpression.
	[self peekForEqualityOperator]
		whileTrue: [self nextRelationalExpression].
	handler handleEndEqualityExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 10/28/2015 15:54'!
nextFilterExpression
	handler handleStartFilterExpression.
	self
		nextPrimaryExpression;
		peekForPredicates.
	handler handleEndFilterExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/1/2017 22:16'!
nextFunctionCall
	handler handleStartFunctionCall: self nextName.
	self nextArgumentList.
	handler handleEndFunctionCall.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 2/10/2015 07:43'!
nextMultiplicativeExpression
	handler handleStartMultiplicativeExpression.
	self nextUnaryExpression.
	[self peekForMultiplicativeOperator]
		whileTrue: [self nextUnaryExpression].
	handler handleEndMultiplicativeExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/1/2017 06:08'!
nextOrExpression
	handler handleStartOrExpression.
	self nextAndExpression.
	[self peekForOrOperator]
		whileTrue: [
			handler handleOrOperator.
			self nextAndExpression].
	handler handleEndOrExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/1/2017 09:21'!
nextPathExpression
	handler handleStartPathExpression.
	self peekForLocationPathExpression
		ifFalse: [
			self
				nextFilterExpression;
				peekForFilterExpressionLocationPath].
	handler handleEndPathExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/1/2017 22:18'!
nextPredicateBody
	handler handleStartPredicate.
	self nextOrExpression.
	self peekForEndPredicate
		ifFalse: [self errorExpectedEndPredicate].
	handler handleEndPredicate.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 3/1/2017 08:11'!
nextPrimaryExpression
	readStream skipSeparators.
	(self peekForVariableReference
		or: [self peekForParenthesizedExpression
			or: [self peekForStringLiteral
				or: [self peekForNumberLiteral]]])
		ifFalse: [self nextFunctionCall].! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/13/2015 11:46'!
nextRelationalExpression
	handler handleStartRelationalExpression.
	self nextAdditiveExpression.
	[self peekForRelationalOperator]
		whileTrue: [self nextAdditiveExpression].
	handler handleEndRelationalExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/24/2017 20:59'!
nextUnaryExpression
	handler handleStartUnaryExpression.
	[self peekForNegationOperator]
		whileTrue: [handler handleNegationOperator].
	self nextUnionExpression.
	handler handleEndUnaryExpression.! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 1/25/2017 11:46'!
nextUnionExpression
	handler handleStartUnionExpression.
	self nextPathExpression.
	[self peekForUnionOperator]
		whileTrue: [self nextPathExpression].
	handler handleEndUnionExpression.! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 4/3/2017 17:27'!
nodeTestParserClass
	^ XPathNodeTestParser! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 4/3/2017 17:32'!
nodeTestParserHandlerClass
	^ XPathExpressionNodeTestParserHandler! !

!XPathExpressionParser methodsFor: 'parsing' stamp: 'monty 4/4/2017 20:39'!
parseInput
	currentAxis := XPathExpressionParserAxis new.
	nodeTestParser :=
		self nodeTestParserClass
			on: readStream
			for:
				(self nodeTestParserHandlerClass
					currentAxis: currentAxis
					expressionParserHandler: handler).

	self nextOrExpression.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForAbbreviatedAxis
	(readStream peekFor: $@)
		ifTrue: [
			currentAxis axisSpecifier: 'attribute'.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForAbbreviatedDescendantStep
	(readStream peekFor: $/)
		ifFalse: [^ false].

	currentAxis axisSpecifier: 'descendant-or-self'.
	self startNodeTestForAnyNodeType.
	self peekForStep
		ifFalse: [self errorExpectedStep].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForAbbreviatedStep
	(readStream peekFor: $.)
		ifFalse: [^ false].
	self atDigit
		ifTrue: [
			"a float literal, not a . or .. step"
			readStream skipBack.
			^ false].

	(readStream peekFor: $.)
		ifTrue: [currentAxis axisSpecifier: 'parent']
		ifFalse: [currentAxis axisSpecifier: 'self'].
	"abbreviated steps cannot have filters"
	self startNodeTestForAnyNodeType.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/11/2017 07:41'!
peekForAbsoluteLocationPath
	self peekForLocationPathSeparator
		ifFalse: [^ false].

	handler handleStartAbsoluteLocationPath.
	currentAxis
		beDefaultImplicitAxis;
		beFirstAxis.
	self peekForAdditionalSteps
		ifFalse: [
			currentAxis axisSpecifier: 'self'.
			self startNodeTestForAnyNodeType].
	handler handleEndLocationPath.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 4/16/2015 05:34'!
peekForAdditionalSteps
	(self peekForAbbreviatedDescendantStep
		or: [self peekForStep])
		ifFalse: [^ false].
	[self peekForLocationPathSeparator]
		whileTrue: [
			(self peekForAbbreviatedDescendantStep
				or: [self peekForStep])
				ifFalse: [self errorExpectedStep]].
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForAdditiveOperator
	readStream skipSeparators.
	(readStream peekFor: $+)
		ifTrue: [
			handler handleAdditionOperator.
			^ true].
	(readStream peekFor: $-)
		ifTrue: [
			handler handleSubtractionOperator.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/23/2018 07:37'!
peekForAndOperator
	^ readStream
		skipSeparators;
		peekForNCName: 'and'! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForAxis
	| startPosition ncName |

	self peekForAbbreviatedAxis
		ifTrue: [^ true].
	startPosition := readStream position.
	(ncName := self nextNCNameOptional: true)
		ifNil: [^ false].
	readStream skipSeparators.
	((readStream peekFor: $:)
		and: [readStream peekFor: $:])
		ifFalse: [
			readStream
				pushBackNCName: ncName
				position: startPosition.
			^ false].
	currentAxis axisSpecifier: ncName.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForEndPredicate
	^ readStream
		skipSeparators;
		peekFor: $]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/23/2018 07:38'!
peekForEqualityOperator
	readStream skipSeparators.
	(readStream peekFor: $!!)
		ifTrue: [
			self expectNext: $=.
			handler handleNotEqualsOperator.
			^ true].
	(readStream peekFor: $=)
		ifTrue: [
			handler handleEqualsOperator.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 09:22'!
peekForFilterExpressionLocationPath
	self peekForLocationPathSeparator
		ifTrue: [
			handler handleStartFilterExpressionLocationPath.
			self nextAdditionalSteps.
			handler handleEndLocationPath.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/22/2015 22:21'!
peekForLocationPathExpression
	^ self peekForAbsoluteLocationPath
		or: [self peekForRelativeLocationPath]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForLocationPathSeparator
	^ readStream
		skipSeparators;
		peekFor: $/! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/23/2018 07:38'!
peekForMultiplicativeOperator
	readStream skipSeparators.
	readStream atEnd
		ifTrue: [^ false].
	(readStream peekFor: $*)
		ifTrue: [
			handler handleMultiplicationOperator.
			^ true].
	(readStream peekForNCName: 'div')
		ifTrue: [
			handler handleDivisionOperator.
			^ true].
	(readStream peekForNCName: 'mod')
		ifTrue: [
			handler handleModulusOperator.
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForNegationOperator
	^ readStream
		skipSeparators;
		peekFor: $-! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:42'!
peekForNodeTest
	^ nodeTestParser parse! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:11'!
peekForNumberLiteral
	| startPosition |

	startPosition := readStream position.
	writeStream reset.
	self atDigit
		ifTrue: [
			self nextDigitsOnWriteStream.
			(readStream peekFor: $.)
				ifTrue: [
					writeStream nextPut: $..
					self atDigit
						ifTrue: [self nextDigitsOnWriteStream]].
			handler handleNumberLiteral: writeStream contents.
			^ true].
	((readStream peekFor: $.)
		and: [self atDigit])
		ifTrue: [
			writeStream nextPut: $..
			self nextDigitsOnWriteStream.
			handler handleNumberLiteral: writeStream contents.
			^ true].
	readStream position: startPosition.
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/23/2018 07:38'!
peekForOrOperator
	^ readStream
		skipSeparators;
		peekForNCName: 'or'! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForParenthesizedExpression
	(readStream peekFor: $()
		ifFalse: [^ false].

	self nextOrExpression.
	readStream skipSeparators.
	self expectNext: $).
	^ true.
! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/23/2016 07:04'!
peekForPredicate
	self peekForStartPredicate
		ifTrue: [
			self nextPredicateBody.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/12/2017 12:47'!
peekForPredicates
	self peekForStartPredicate
		ifFalse: [^ false].
	handler handleStartPredicates.
	self nextPredicateBody.
	[self peekForPredicate] whileTrue.
	handler handleEndPredicates.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForRelationalOperator
	readStream skipSeparators.
	(readStream peekFor: $<)
		ifTrue: [
			(readStream peekFor: $=)
				ifTrue: [handler handleLessThanOrEqualToOperator]
				ifFalse: [handler handleLessThanOperator].
			^ true].
	(readStream peekFor: $>)
		ifTrue: [
			(readStream peekFor: $=)
				ifTrue: [handler handleGreaterThanOrEqualToOperator]
				ifFalse: [handler handleGreaterThanOperator].
			^ true].
	^ false.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/11/2017 07:41'!
peekForRelativeLocationPath
	currentAxis
		beDefaultImplicitAxis;
		beFirstAxis;
		beStartOfRelativeLocationPath.
	self peekForStep
		ifFalse: [^ false].
	self peekForLocationPathSeparator
		ifTrue: [self nextAdditionalSteps].
	handler handleEndLocationPath.
	^ true.! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForStartPredicate
	^ readStream
		skipSeparators;
		peekFor: $[! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:42'!
peekForStep
	readStream skipSeparators.
	readStream atEnd
		ifTrue: [^ false].

	self peekForAbbreviatedStep
		ifTrue: [^ true].

	self peekForAxis.
	self peekForNodeTest
		ifTrue: [
			self peekForPredicates.
			handler handleEndStep.
			^ true]
		ifFalse: [
			currentAxis isImplicitAxis
				ifFalse: [self errorExpectedNodeTest].
			currentAxis beDefaultImplicitAxis.
			^ false].! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 1/21/2015 07:12'!
peekForStringLiteral
	(self nextStringLiteralOptional: true)
		ifNil: [^ false]
		ifNotNil: [:string |
			handler handleStringLiteral: string.
			^ true]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForUnionOperator
	readStream skipSeparators.
	(readStream peekFor: $|)
		ifTrue: [
			handler handleUnionOperator.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForVariableReference
	(readStream peekFor: $$)
		ifTrue: [
			handler handleVariableReference: self nextName.
			^ true]
		ifFalse: [^ false]! !

!XPathExpressionParser methodsFor: 'private' stamp: 'monty 1/4/2017 07:37'!
startNodeTestForAnyNodeType
	currentAxis isStartOfRelativeLocationPath
		ifTrue: [handler handleStartRelativeLocationPath].
	handler
		handleStartStep;
		perform: currentAxis handlerSelector;
		handleAnyNodeTest;
		handleEndStep.
	currentAxis beDefaultImplicitAxis.! !

XPathParser subclass: #XPathFunctionPrototypeParser
	instanceVariableNames: 'hasOptionalArgument hasUnboundedArgument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathFunctionPrototypeParser commentStamp: 'monty 6/5/2015 01:09' prior: 0!
This class parses XPath function prototypes to extract the name, return type, and the number and type of arguments.!

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:26'!
errorArgumentAfterUnboundedArgument
	XPathSyntaxException signal: 'Argument after unbounded "*" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:26'!
errorNonOptionalArgumentAfterOptional
	XPathSyntaxException signal: 'Non-optional argument afer optional "?" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:23'!
errorUnboundedArgumentAfterOptional
	XPathSyntaxException signal: 'Unbounded "*" argument after optional "?" argument'! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextArgument
	hasUnboundedArgument
		ifTrue: [self errorArgumentAfterUnboundedArgument].

	readStream skipSeparators.
	self nextModifierForArgument: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextFunctionName
	readStream skipSeparators.
	handler handleFunctionName: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextModifierForArgument: anArgument
	readStream skipSeparators.
	(readStream peekFor: $*)
		ifTrue: [
			hasOptionalArgument
				ifTrue: [self errorUnboundedArgumentAfterOptional].
			hasUnboundedArgument := true.
			handler handleUnboundedArgument: anArgument]
		ifFalse: [
			(readStream peekFor: $?)
				ifTrue: [
					hasOptionalArgument := true.
					handler handleOptionalArgument: anArgument]
				ifFalse: [
					hasOptionalArgument
						ifTrue: [self errorNonOptionalArgumentAfterOptional].
					handler handleArgument: anArgument]].! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextReturnType
	readStream skipSeparators.
	handler handleReturnType: self nextName.! !

!XPathFunctionPrototypeParser methodsFor: 'parsing' stamp: 'monty 4/4/2017 20:40'!
parseInput
	hasOptionalArgument := false.
	hasUnboundedArgument := false.

	self
		nextReturnType;
		nextFunctionName;
		nextArgumentList.! !

XPathParser subclass: #XPathNodeTestParser
	instanceVariableNames: 'state isParsingNodeTypeTest'
	classVariableNames: 'NodeTypeTestParserSelectors'
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParser commentStamp: 'monty 4/2/2016 02:44' prior: 0!
This class parses node tests that are either node name tests like 'name' and '*' or node type tests like 'node()' and 'comment()'.!

!XPathNodeTestParser class methodsFor: 'class initialization' stamp: 'monty 1/4/2017 07:51'!
initialize 
	"self initialize"

	"assign after with #yourself to avoid possible race
	conditions when reinitializing the class"
	NodeTypeTestParserSelectors :=
		Dictionary new
			at: 'comment' put: #nextCommentTest;
			at: 'text' put: #nextTextTest;
			at: 'processing-instruction' put: #nextPITest;
			at: 'node' put: #nextAnyNodeTest;
			at: 'element' put: #nextElementTest;
			at: 'attribute' put: #nextAttributeTest;
			at: 'namespace' put: #nextNamespaceTest;
			yourself! !

XPathNodeTestParser initialize!

!XPathNodeTestParser methodsFor: 'private' stamp: 'monty 2/27/2018 00:18'!
errorExpectedExpandedNameTest
	self errorExpected:
		'terminating "}" for expanded name literal test, as in "Q{uri}ncName"'! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 10/7/2017 14:49'!
nextAnyNodeTest
	self nextEndArgumentList.
	state handleAnyNodeTestWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 10/7/2017 14:49'!
nextAttributeTest
	state := XPathNodeTestParserAttributeTypeTestState new.
	self
		peekForNodeTestArgument;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 10/7/2017 14:49'!
nextCommentTest
	self nextEndArgumentList.
	state handleCommentNodeTestWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 10/7/2017 14:49'!
nextElementTest
	state := XPathNodeTestParserElementTypeTestState new.
	self
		peekForNodeTestArgument;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 10/7/2017 14:49'!
nextEmptyTest
	state handleEmptyNodeTestWith: handler! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 10/7/2017 14:49'!
nextNamespaceTest
	state := XPathNodeTestParserNamespaceTypeTestState new.
	self
		peekForNodeTestArgument;
		nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 10/7/2017 14:49'!
nextPITest
	self peekForPITestTarget
		ifFalse: [
			state handlePINodeTestWith: handler].
	self nextEndArgumentList.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 10/7/2017 14:49'!
nextTextTest
	self nextEndArgumentList.
	state handleTextNodeTestWith: handler.! !

!XPathNodeTestParser methodsFor: 'parsing' stamp: 'monty 10/7/2017 14:50'!
parseInput
	state := handler defaultNodeTestParserStateClass new.
	isParsingNodeTypeTest := false.

	self peekForNodeTest.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 2/27/2018 00:17'!
peekForExpandedNameTestStartingWithNCName: anNCName
	| nextChar uri |

	(anNCName = 'Q'
		and: [readStream peekFor: ${])
		ifFalse: [^ false].

	writeStream reset.
	[(nextChar := readStream next) == $}
		or: [nextChar == nil]]
		whileFalse: [writeStream nextPut: nextChar].
	nextChar
		ifNil: [self errorExpectedExpandedNameTest].
	uri := writeStream contents.

	"either a 'Q{uri}*' wildcard test or a 'Q{uri}localName' test"
	(readStream peekFor: $*)
		ifTrue: [
			state
				handleNodeTestForNamespaceURI: uri
				with: handler]
		ifFalse: [
			state
				handleNodeTestForNamespaceURI: uri
				localName: self nextNCName
				with: handler].

	^ true.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 2/27/2018 00:16'!
peekForNameTestStartingWithNCName: anNCName
	| startPosition |

	startPosition := readStream position.
	(readStream peekFor: $:)
		ifTrue: [
			readStream peek == $:
				ifFalse: [
					"'::' means anNCName is an axis specifier and not the start
					of a node test, otherwise the ':' should be followed by a '*'
					or another NCName"
					(readStream peekFor: $*)
						ifTrue: [
							"a 'prefix:*' wildcard QName test"
							state
								handleNodeTestForPrefix: anNCName
								with: handler.
							^ true]
						ifFalse: [| localName |
							localName := self nextNCName.
							self peekForStartArgumentList
								ifFalse: [
									"not a function call, so it's a 'prefix:localName'
									QName test"
									state
										handleNodeTestForPrefix: anNCName
										localName: localName
										with: handler.
									^ true]]]]
		ifFalse: [
			(self peekForExpandedNameTestStartingWithNCName: anNCName)
				ifTrue: [ ^ true].

			"whitespace can be between the axis specifier and '::' separator,
			but not between the prefix and ':' QName separator, so any ':'
			not matched above but matched after #skipSeparators is an '::'
			axis separator, and anNCName is an axis specifier, not a node test"
			(readStream
				skipSeparators;
				peekFor: $:)
				ifFalse: [
					(isParsingNodeTypeTest not
						and: [self peekForStartArgumentList])
						ifTrue: [
							(self peekForNodeTypeTest: anNCName)
								ifTrue: [^ true]]
						ifFalse: [
							state
								handleNodeTestForName: anNCName
								with: handler.
							^ true]]].

	"anNCName is either an axis specifier or the start of a
	function call and not a node test"
	readStream position: startPosition.
	^ false.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/3/2017 18:20'!
peekForNodeTest
	^ self peekForNodeTestStartingWithWildCardOrNCName! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/4/2017 01:54'!
peekForNodeTestArgument
	^ self peekForNodeTestStartingWithWildCardOrNCName! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/4/2017 02:40'!
peekForNodeTestStartingWithNCName
	| startPosition ncName |

	startPosition := readStream position.
	(ncName := self nextNCNameOptional: true)
		ifNil: [^ false].
	(self peekForNameTestStartingWithNCName: ncName)
		ifFalse: [
			readStream
				pushBackNCName: ncName
				position: startPosition.
			^ false].
	^ true.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 10/7/2017 14:49'!
peekForNodeTestStartingWithWildCard
	(readStream peekFor: $*)
		ifFalse: [^ false].

	(readStream peekFor: $:)
		ifTrue: [
			(readStream peekFor: $*)
				ifTrue: [state handleWildcardNodeTestWith: handler]
				ifFalse: [
					state
						handleNodeTestForLocalName: self nextNCName
						with: handler]]
		ifFalse: [state handleWildcardNodeTestWith: handler].
	^ true.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/3/2017 18:19'!
peekForNodeTestStartingWithWildCardOrNCName
	readStream skipSeparators.
	(readStream atEnd not
		and: [self peekForNodeTestStartingWithWildCard
			or: [self peekForNodeTestStartingWithNCName]])
		ifTrue: [^ true]
		ifFalse: [
			self nextEmptyTest.
			^ false]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/4/2017 06:56'!
peekForNodeTypeTest: aNodeTypeOrFunctionName
	| nodeTypeTestParserSelector |

	nodeTypeTestParserSelector :=
		NodeTypeTestParserSelectors
			at: aNodeTypeOrFunctionName
			ifAbsent: [^ false].
	isParsingNodeTypeTest := true.
	self perform: nodeTypeTestParserSelector.
	^ true.! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 10/7/2017 14:49'!
peekForPITestTarget
	| target |

	readStream skipSeparators.
	(target :=
		(self nextStringLiteralOptional: true)
			ifNil: [self nextNCNameOptional: true])
		ifNil: [^ false]
		ifNotNil: [
			state
				handlePINodeTestForName: target
				with: handler.
			^ true]! !

!XPathNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForStartArgumentList
	readStream skipSeparators.
	^ readStream peekFor: $(.! !

XPathParser subclass: #XPathNumberParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNumberParser commentStamp: 'monty 1/25/2017 12:11' prior: 0!
This class parses XPath number literals like '1.0', '.0', '1.', and '-1.0'. If the sign is absent, it is assumed to be 1, and if the integer part is absesnt (as in '.1' or '-.1') or the fraction part is absent (as  in '1' or '1.'), they are assumed to be zero.!

!XPathNumberParser methodsFor: 'private' stamp: 'monty 1/24/2017 21:18'!
errorExpectedFractionPart
	self errorExpected: 'fraction part'! !

!XPathNumberParser methodsFor: 'private' stamp: 'monty 1/24/2017 21:18'!
errorExpectedIntegerPart
	self errorExpected: 'integer part'! !

!XPathNumberParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextFractionPartOptional: aBoolean
	(readStream atEnd not
		and: [readStream peek isDigit])
		ifTrue: [| base fractionPart |
			base := 10.
			fractionPart :=
				(readStream next asciiValue - $0 asciiValue) / base.
			[readStream atEnd not
				and: [readStream peek isDigit]]
				whileTrue: [
					base := base * 10.
					fractionPart :=
						fractionPart +
							((readStream next asciiValue - $0 asciiValue) / base)].
			handler handleFractionPart: fractionPart]
		ifFalse: [
			aBoolean
				ifTrue: [handler handleFractionPart: 0]
				ifFalse: [self errorExpectedFractionPart]]! !

!XPathNumberParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextIntegerPart
	| integerPart |

	(readStream atEnd not
		and: [readStream peek isDigit])
		ifFalse: [self errorExpectedIntegerPart].
	integerPart := readStream next asciiValue - $0 asciiValue.
	[readStream atEnd not
		and: [readStream peek isDigit]]
		whileTrue: [
			integerPart :=
				(integerPart * 10) +
					(readStream next asciiValue - $0 asciiValue)].
	handler handleIntegerPart: integerPart.! !

!XPathNumberParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
parseInput
	readStream skipSeparators.
	self peekForSign.
	(readStream peekFor: $.)
		ifTrue: [
			handler handleIntegerPart: 0.
			self nextFractionPartOptional: false]
		ifFalse: [
			self nextIntegerPart.
			(readStream peekFor: $.)
				ifTrue: [self nextFractionPartOptional: true]
				ifFalse: [handler handleFractionPart: 0]].! !

!XPathNumberParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
peekForSign
	(readStream peekFor: $-)
		ifTrue: [handler handleNegativeSign]
		ifFalse: [
			readStream peekFor: $+.
			handler handlePositiveSign]! !

!XPathParser class methodsFor: 'instance creation' stamp: 'monty 1/8/2015 06:01'!
on: aStringOrStream for: aHandler
	^ self new
		on: aStringOrStream
		for: aHandler! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
endParsing
	handler handleEndParsing.
	handler mustBeAtEndAfterParsing
		ifTrue: [	
			readStream skipSeparators.
			readStream atEnd
				ifFalse: [self errorExpectedAtEnd]].! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/15/2015 13:54'!
errorExpected: aString
	XPathSyntaxException
		formatSignal: 'Expected {1}'
		with: aString! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/9/2015 07:53'!
errorExpectedAtEnd
	self errorExpected: 'end of input'! !

!XPathParser methodsFor: 'private' stamp: 'monty 1/15/2015 13:54'!
errorExpectedLiteral: anExpectedCharacterOrString butGot: aReceivedCharacterOrString
	XPathSyntaxException
		formatSignal: 'Expected "{1}" but got "{2}"'
		with: anExpectedCharacterOrString
		with: (aReceivedCharacterOrString ifNil: [''])! !

!XPathParser methodsFor: 'private' stamp: 'monty 3/25/2016 22:00'!
errorExpectedName
	self errorExpected: 'an XPath qualified or non-qualified name'! !

!XPathParser methodsFor: 'private' stamp: 'monty 3/10/2015 19:48'!
errorExpectedStringLiteral
	self errorExpected: 'single or double quoted string literal'! !

!XPathParser methodsFor: 'private' stamp: 'monty 3/5/2018 01:39'!
errorExpectedTerminatingQuote: aQuote
	self errorExpected:
		'string terminating ',
		(aQuote == $'
			ifTrue: ['single']
			ifFalse: ['double']),
		' quote character'! !

!XPathParser methodsFor: 'private' stamp: 'monty 9/19/2017 11:22'!
expectNext: aCharacter
	| nextChar |

	"use #= for pre-SpurVM compatibility where wide chars aren't #=="
	(nextChar := readStream next) = aCharacter
		ifFalse: [
			self
				errorExpectedLiteral: aCharacter
				butGot: nextChar].
	^ aCharacter.! !

!XPathParser methodsFor: 'accessing' stamp: 'monty 1/8/2015 06:02'!
handler
	^ handler! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/15/2015 22:25'!
nextArgument
	"override to parse arguments in function argument lists"! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/10/2015 19:26'!
nextArgumentList
	"a template method; nextArgument must be overriden to handle arguments"
	self nextStartArgumentList.
	self peekForEndArgumentList
		ifFalse: [
			self nextArgument.
			[self peekForArgumentSeparator]
				whileTrue: [self nextArgument].
			self nextEndArgumentList].! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 10:20'!
nextEmptyArgumentList
	self
		nextStartArgumentList;
		nextEndArgumentList
! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextEndArgumentList
	readStream skipSeparators.
	self expectNext: $).! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/14/2015 03:46'!
nextNCName
	^ self nextNCNameOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextNCNameOptional: aBoolean
	| ncName |

	(ncName := readStream nextNCName)
		ifNil: [
			aBoolean
				ifFalse: [self errorExpectedName]].
	^ ncName.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 3/2/2015 04:40'!
nextName
	^ self nextNameOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextNameOptional: aBoolean
	| name |

	(name := readStream nextName)
		ifNil: [
			aBoolean
				ifFalse: [self errorExpectedName]].
	^ name.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
nextStartArgumentList
	readStream skipSeparators.
	self expectNext: $(.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/10/2015 03:42'!
nextStringLiteral
	^ self nextStringLiteralOptional: false! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/26/2018 23:54'!
nextStringLiteralOptional: aBoolean
	| quote |

	((quote := readStream peek) == $"
		or: [quote == $'])
		ifTrue: [| nextChar |
			writeStream reset.
			readStream next.
			[(nextChar := readStream next) == quote
				or: [nextChar == nil]]
				whileFalse: [writeStream nextPut: nextChar].
			nextChar
				ifNil: [self errorExpectedTerminatingQuote: quote].
			^ writeStream contents]
		ifFalse: [
			aBoolean
				ifFalse: [self errorExpectedStringLiteral].
			^ nil]! !

!XPathParser methodsFor: 'initialization' stamp: 'monty 2/7/2017 03:32'!
on: aStringOrStream for: aHandler
	readStream :=
		(aStringOrStream isStream
			ifTrue: [aStringOrStream asXPathReadStreamAdapter]
			ifFalse: [aStringOrStream readStream asXPathReadStreamAdapter]).
	handler := aHandler.
	"must use #writeStream instead of 'WriteStream on:' to get a 0-based
	stream on Gemstone"
	writeStream := (String new: 32) writeStream.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 2/7/2017 03:32'!
parse
	[self
		startParsing;
		parseInput;
		endParsing]
		on: XPathException
		do: [:error |
			error hasPosition
				ifFalse: [error position: readStream position].
			error pass].
	^ handler parsingResult.! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/8/2015 06:06'!
parseInput
	self subclassResponsibility! !

!XPathParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForArgumentSeparator
	readStream skipSeparators.
	^ readStream peekFor: $,.! !

!XPathParser methodsFor: 'parsing - peeking' stamp: 'monty 2/7/2017 03:32'!
peekForEndArgumentList
	readStream skipSeparators.
	^ readStream peekFor: $).! !

!XPathParser methodsFor: 'printing' stamp: 'monty 3/14/2018 07:07'!
printOn: aStream
	super printOn: aStream.

	aStream nextPut: $(.
	handler
		ifNotNil: [
			aStream
				print: handler;
				nextPutAll: ', '].
	aStream
		print: readStream;
		nextPut: $).! !

!XPathParser methodsFor: 'accessing' stamp: 'monty 2/7/2017 03:32'!
readStream
	^ readStream! !

!XPathParser methodsFor: 'parsing' stamp: 'monty 1/9/2015 07:59'!
startParsing
	handler handleStartParsing! !

Object subclass: #XPathParserHandler
	instanceVariableNames: 'parsingResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathParserHandler commentStamp: 'monty 5/11/2015 00:46' prior: 0!
An abstract class for XPath parser handlers. Subclasses implement "handling" messages sent by parsers.!

XPathParserHandler subclass: #XPathExpressionParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionParserHandler commentStamp: 'monty 2/22/2016 04:29' prior: 0!
An abstract class for XPath expression parser handlers.!

XPathExpressionParserHandler subclass: #XPathASTExpressionParserHandler
	instanceVariableNames: 'expressionNodeStack operatorNodeStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathASTExpressionParserHandler commentStamp: 'monty 1/17/2017 19:06' prior: 0!
This is a handler class for XPath expression parsers that generates an AST that can be searched and manipulated using AST node visitors.!

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 07:58'!
handleAdditionOperator
	self
		popAnyAdditiveExpressionNodes;
		pushBinaryOperatorNode: XPathASTAdditionExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:47'!
handleAncestorAxis
	self pushOperatorNode: XPathASTAncestorStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:47'!
handleAncestorOrSelfAxis
	self pushOperatorNode: XPathASTAncestorOrSelfStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:02'!
handleAndOperator
	self
		popAnyAndExpressionNodes;
		pushBinaryOperatorNode: XPathASTAndExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/10/2017 18:53'!
handleAnyNodeTest
	self topOperatorNode nodeTest: XPathASTAnyNodeTestNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:48'!
handleAttributeAxis
	self pushOperatorNode: XPathASTAttributeStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:22'!
handleAttributeNodeTest
	self topOperatorNode nodeTest: XPathASTAttributeNodeTestNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:22'!
handleAttributeNodeTestForLocalName: aLocalName
	self topOperatorNode nodeTest:
		(XPathASTAttributeNodeTestForLocalNameNode localName: aLocalName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:23'!
handleAttributeNodeTestForName: aName
	self topOperatorNode nodeTest:
		(XPathASTAttributeNodeTestForNameNode name: aName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:23'!
handleAttributeNodeTestForNamespaceURI: aURI
	self topOperatorNode nodeTest:
		(XPathASTAttributeNodeTestForNamespaceURINode namespaceURI: aURI)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:23'!
handleAttributeNodeTestForNamespaceURI: aURI localName: aLocalName
	self topOperatorNode nodeTest:
		(XPathASTAttributeNodeTestForNamespaceURIAndLocalNameNode
			namespaceURI: aURI
			localName: aLocalName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:23'!
handleAttributeNodeTestForPrefix: aPrefix
	self topOperatorNode nodeTest:
		(XPathASTAttributeNodeTestForPrefixNode prefix: aPrefix)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:23'!
handleAttributeNodeTestForPrefix: aPrefix localName: aLocalName
	self topOperatorNode nodeTest:
		(XPathASTAttributeNodeTestForPrefixAndLocalNameNode
			prefix: aPrefix
			localName: aLocalName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:50'!
handleChildAxis
	self pushOperatorNode: XPathASTChildStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:23'!
handleCommentNodeTest
	self topOperatorNode nodeTest: XPathASTCommentNodeTestNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:48'!
handleDescendantAxis
	self pushOperatorNode: XPathASTDescendantStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:48'!
handleDescendantOrSelfAxis
	self pushOperatorNode: XPathASTDescendantOrSelfStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:02'!
handleDivisionOperator
	self
		popAnyMultiplicativeExpressionNodes;
		pushBinaryOperatorNode: XPathASTDivisionExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:24'!
handleElementNodeTest
	self topOperatorNode nodeTest: XPathASTElementNodeTestNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:24'!
handleElementNodeTestForLocalName: aLocalName
	self topOperatorNode nodeTest:
		(XPathASTElementNodeTestForLocalNameNode localName: aLocalName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:24'!
handleElementNodeTestForName: aName
	self topOperatorNode nodeTest:
		(XPathASTElementNodeTestForNameNode name: aName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:24'!
handleElementNodeTestForNamespaceURI: aURI
	self topOperatorNode nodeTest:
		(XPathASTElementNodeTestForNamespaceURINode namespaceURI: aURI)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:24'!
handleElementNodeTestForNamespaceURI: aURI localName: aLocalName
	self topOperatorNode nodeTest:
		(XPathASTElementNodeTestForNamespaceURIAndLocalNameNode
			namespaceURI: aURI
			localName: aLocalName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:24'!
handleElementNodeTestForPrefix: aPrefix
	self topOperatorNode nodeTest:
		(XPathASTElementNodeTestForPrefixNode prefix: aPrefix)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:24'!
handleElementNodeTestForPrefix: aPrefix localName: aLocalName
	self topOperatorNode nodeTest:
		(XPathASTElementNodeTestForPrefixAndLocalNameNode
			prefix: aPrefix
			localName: aLocalName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 07:59'!
handleEndAdditiveExpression
	self popAnyAdditiveExpressionNodes! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 07:59'!
handleEndAndExpression
	self popAnyAndExpressionNodes! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:00'!
handleEndEqualityExpression
	self popAnyEqualityExpressionNodes! !

!XPathASTExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/21/2017 12:14'!
handleEndFilterExpression
	self topOperatorNode isFilterExpression
		ifTrue: [self pushExpressionNode: self popOperatorNode]! !

!XPathASTExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/17/2017 14:50'!
handleEndFunctionArgument
	self topOperatorNode addArgument:
		(XPathASTArgumentNode expression: self popExpressionNode)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/10/2017 10:55'!
handleEndFunctionCall
	self pushExpressionNode: self popOperatorNode! !

!XPathASTExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/11/2017 09:56'!
handleEndLocationPath
	self pushExpressionNode: self popOperatorNode! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:01'!
handleEndMultiplicativeExpression
	self popAnyMultiplicativeExpressionNodes! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/25/2018 23:54'!
handleEndOrExpression
	self
		popAnyOrExpressionNodes;
		popOperatorNode "pop the null node used for grouping"! !

!XPathASTExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/11/2017 11:14'!
handleEndParsing
	self parsingResult:
		(XPathASTExpressionRootNode expression: self popExpressionNode)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/17/2017 12:52'!
handleEndPredicate
	self topOperatorNode addPredicate:
		(XPathASTPredicateNode expression: self popExpressionNode)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:02'!
handleEndRelationalExpression
	self popAnyRelationalExpressionNodes! !

!XPathASTExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/11/2017 09:44'!
handleEndStep
	| step |

	step := self popOperatorNode.
	self topOperatorNode addStep: step.! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:07'!
handleEndUnaryExpression
	self popAnyUnaryExpressionNodes! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:02'!
handleEndUnionExpression
	self popAnyUnionExpressionNodes! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:03'!
handleEqualsOperator
	self
		popAnyEqualityExpressionNodes;
		pushBinaryOperatorNode: XPathASTEqualsExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:49'!
handleFollowingAxis
	self pushOperatorNode: XPathASTFollowingStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:49'!
handleFollowingSiblingAxis
	self pushOperatorNode: XPathASTFollowingSiblingStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:03'!
handleGreaterThanOperator
	self
		popAnyRelationalExpressionNodes;
		pushBinaryOperatorNode: XPathASTGreaterThanExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:03'!
handleGreaterThanOrEqualToOperator
	self
		popAnyRelationalExpressionNodes;
		pushBinaryOperatorNode: XPathASTGreaterThanOrEqualToExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:03'!
handleLessThanOperator
	self
		popAnyRelationalExpressionNodes;
		pushBinaryOperatorNode: XPathASTLessThanExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:03'!
handleLessThanOrEqualToOperator
	self
		popAnyRelationalExpressionNodes;
		pushBinaryOperatorNode: XPathASTLessThanOrEqualToExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:04'!
handleModulusOperator
	self
		popAnyMultiplicativeExpressionNodes;
		pushBinaryOperatorNode: XPathASTModulusExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:04'!
handleMultiplicationOperator
	self
		popAnyMultiplicativeExpressionNodes;
		pushBinaryOperatorNode: XPathASTMultiplicationExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:49'!
handleNamespaceAxis
	self pushOperatorNode: XPathASTNamespaceStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:09'!
handleNamespaceNodeTest
	self topOperatorNode nodeTest: XPathASTNamespaceTestNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForLocalName: aLocalName
	self topOperatorNode nodeTest:
		(XPathASTNamespaceTestForLocalNameNode localName: aLocalName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForName: aName
	self topOperatorNode nodeTest:
		(XPathASTNamespaceTestForNameNode name: aName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForNamespaceURI: aURI
	self topOperatorNode nodeTest:
		(XPathASTNamespaceTestForNamespaceURINode namespaceURI: aURI)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForNamespaceURI: aURI localName: aLocalName
	self topOperatorNode nodeTest:
		(XPathASTNamespaceTestForNamespaceURIAndLocalNameNode
			namespaceURI: aURI
			localName: aLocalName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForPrefix: aPrefix
	self topOperatorNode nodeTest:
		(XPathASTNamespaceTestForPrefixNode prefix: aPrefix)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:09'!
handleNamespaceNodeTestForPrefix: aPrefix localName: aLocalName
	self topOperatorNode nodeTest:
		(XPathASTNamespaceTestForPrefixAndLocalNameNode
			prefix: aPrefix
			localName: aLocalName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/24/2017 20:56'!
handleNegationOperator
	self pushUnaryOperatorNode: XPathASTNegationExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 08:05'!
handleNotEqualsOperator
	self
		popAnyEqualityExpressionNodes;
		pushBinaryOperatorNode: XPathASTNotEqualsExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - literals' stamp: 'monty 1/18/2017 08:37'!
handleNumberLiteral: anIntegerOrFloatString
	self pushExpressionNode:
		(XPathASTNumberLiteralNode number: anIntegerOrFloatString asXPathNumber)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 11:38'!
handleOrOperator
	self
		popAnyOrExpressionNodes;
		pushBinaryOperatorNode: XPathASTOrExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:25'!
handlePINodeTest
	self topOperatorNode nodeTest: XPathASTPINodeTestNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:25'!
handlePINodeTestForName: aName
	self topOperatorNode nodeTest:
		(XPathASTPINodeTestForNameNode name: aName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:49'!
handleParentAxis
	self pushOperatorNode: XPathASTParentStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:50'!
handlePrecedingAxis
	self pushOperatorNode: XPathASTPrecedingStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:50'!
handlePrecedingSiblingAxis
	self pushOperatorNode: XPathASTPrecedingSiblingStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/11/2017 03:49'!
handleSelfAxis
	self pushOperatorNode: XPathASTSelfStepNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/11/2017 09:57'!
handleStartAbsoluteLocationPath
	self pushOperatorNode: XPathASTAbsoluteLocationPathNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/13/2017 04:15'!
handleStartFilterExpressionLocationPath
	self pushOperatorNode:
		(XPathASTFilterExpressionLocationPathNode expression:
			self popExpressionNode)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 1/10/2017 18:59'!
handleStartFunctionCall: aFunctionName
	self pushOperatorNode:
		(XPathASTFunctionCallNode name: aFunctionName)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/25/2018 23:53'!
handleStartOrExpression
	"this null node is used for grouping"
	self pushOperatorNode: XPathASTNullNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling' stamp: 'monty 1/7/2017 03:30'!
handleStartParsing
	expressionNodeStack := OrderedCollection new.
	operatorNodeStack := OrderedCollection new.! !

!XPathASTExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 1/21/2017 12:14'!
handleStartPredicates
	self topOperatorNode isStep
		ifFalse: [
			self pushOperatorNode:
				(XPathASTFilterExpressionNode expression:
					self popExpressionNode)]! !

!XPathASTExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/11/2017 09:57'!
handleStartRelativeLocationPath
	self pushOperatorNode: XPathASTRelativeLocationPathNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - literals' stamp: 'monty 1/7/2017 04:08'!
handleStringLiteral: aString
	self pushExpressionNode:
		(XPathASTStringLiteralNode string: aString)! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 07:58'!
handleSubtractionOperator
	self
		popAnyAdditiveExpressionNodes;
		pushBinaryOperatorNode: XPathASTSubtractionExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 20:25'!
handleTextNodeTest
	self topOperatorNode nodeTest: XPathASTTextNodeTestNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/11/2017 11:40'!
handleUnionOperator
	self
		popAnyUnionExpressionNodes;
		pushBinaryOperatorNode: XPathASTUnionExpressionNode new! !

!XPathASTExpressionParserHandler methodsFor: 'handling - variables' stamp: 'monty 1/10/2017 18:59'!
handleVariableReference: aName
	self pushExpressionNode:
		(XPathASTVariableReferenceNode name: aName)! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/21/2017 12:15'!
popAnyAdditiveExpressionNodes
	[self topOperatorNode isAdditiveExpression]
		whileTrue: [self popBinaryOperatorNode]! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/21/2017 12:15'!
popAnyAndExpressionNodes
	[self topOperatorNode isAndExpression]
		whileTrue: [self popBinaryOperatorNode]! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/21/2017 12:15'!
popAnyEqualityExpressionNodes
	[self topOperatorNode isEqualityExpression]
		whileTrue: [self popBinaryOperatorNode]! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/21/2017 12:15'!
popAnyMultiplicativeExpressionNodes
	[self topOperatorNode isMultiplicativeExpression]
		whileTrue: [self popBinaryOperatorNode]! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/21/2017 12:16'!
popAnyOrExpressionNodes
	[self topOperatorNode isOrExpression]
		whileTrue: [self popBinaryOperatorNode]! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/21/2017 12:16'!
popAnyRelationalExpressionNodes
	[self topOperatorNode isRelationalExpression]
		whileTrue: [self popBinaryOperatorNode]! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/21/2017 12:15'!
popAnyUnaryExpressionNodes
	[self topOperatorNode isUnaryOperatorExpression]
		whileTrue: [self popUnaryOperatorNode]! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/21/2017 12:15'!
popAnyUnionExpressionNodes
	[self topOperatorNode isUnionExpression]
		whileTrue: [self popBinaryOperatorNode]! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/19/2017 10:49'!
popBinaryOperatorNode
	^ self pushExpressionNode:
		(self popOperatorNode otherExpression: self popExpressionNode)! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/7/2017 03:47'!
popExpressionNode
	^ expressionNodeStack removeLast! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/7/2017 03:41'!
popOperatorNode
	^ operatorNodeStack removeLast! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/19/2017 12:11'!
popUnaryOperatorNode
	^ self pushExpressionNode:
		(self popOperatorNode expression: self popExpressionNode)! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/19/2017 10:48'!
pushBinaryOperatorNode: aBinaryOperatorNode
	^ self pushOperatorNode:
		(aBinaryOperatorNode expression: self popExpressionNode)! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/7/2017 03:47'!
pushExpressionNode: anExpressionNode
	^ expressionNodeStack addLast: anExpressionNode! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/7/2017 03:41'!
pushOperatorNode: anOperatorNode
	^ operatorNodeStack addLast: anOperatorNode! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/11/2017 08:07'!
pushUnaryOperatorNode: aUnaryOperatorNode
	^ self pushOperatorNode: aUnaryOperatorNode! !

!XPathASTExpressionParserHandler methodsFor: 'private' stamp: 'monty 1/21/2017 12:16'!
topOperatorNode
	^ operatorNodeStack last! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:06'!
handleAdditionOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleAncestorAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleAncestorOrSelfAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:06'!
handleAndOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 1/4/2017 07:37'!
handleAnyNodeTest! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleAttributeAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTest! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForLocalName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForName: aName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForNamespaceURI: aURI! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForNamespaceURI: aURI localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:08'!
handleAttributeNodeTestForPrefix: aPrefix! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:08'!
handleAttributeNodeTestForPrefix: aPrefix localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleChildAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:08'!
handleCommentNodeTest! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleDescendantAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleDescendantOrSelfAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:07'!
handleDivisionOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleElementNodeTest! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleElementNodeTestForLocalName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForName: aName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForNamespaceURI: aURI! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForNamespaceURI: aURI localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForPrefix: aPrefix! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForPrefix: aPrefix localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndAdditiveExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndAndExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndEqualityExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleEndFilterExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/22/2016 04:27'!
handleEndFunctionArgument! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/22/2016 04:27'!
handleEndFunctionCall! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 1/11/2017 07:40'!
handleEndLocationPath! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndMultiplicativeExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndOrExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleEndPathExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/22/2016 04:27'!
handleEndPredicate! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/23/2016 07:05'!
handleEndPredicates! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndRelationalExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleEndStep! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndUnaryExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleEndUnionExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:07'!
handleEqualsOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleFollowingAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleFollowingSiblingAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:07'!
handleGreaterThanOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:07'!
handleGreaterThanOrEqualToOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:07'!
handleLessThanOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:07'!
handleLessThanOrEqualToOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:07'!
handleModulusOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:08'!
handleMultiplicationOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleNamespaceAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:09'!
handleNamespaceNodeTest! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForLocalName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForName: aName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForNamespaceURI: aURI! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForNamespaceURI: aURI localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForPrefix: aPrefix! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:09'!
handleNamespaceNodeTestForPrefix: aPrefix localName: aLocalName! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:08'!
handleNegationOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:08'!
handleNotEqualsOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - literals' stamp: 'monty 2/22/2016 04:27'!
handleNumberLiteral: anIntegerOrFloatString! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:08'!
handleOrOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:09'!
handlePINodeTest! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:09'!
handlePINodeTestForName: aName! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleParentAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handlePrecedingAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handlePrecedingSiblingAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - axis' stamp: 'monty 1/2/2017 02:37'!
handleSelfAxis! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartAbsoluteLocationPath! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartAdditiveExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartAndExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartEqualityExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartFilterExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartFilterExpressionLocationPath! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/22/2016 04:27'!
handleStartFunctionArgument! !

!XPathExpressionParserHandler methodsFor: 'handling - functions' stamp: 'monty 2/22/2016 04:27'!
handleStartFunctionCall: aFunctionName! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartMultiplicativeExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartOrExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartPathExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/22/2016 04:27'!
handleStartPredicate! !

!XPathExpressionParserHandler methodsFor: 'handling - predicates' stamp: 'monty 2/23/2016 07:05'!
handleStartPredicates! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartRelationalExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartRelativeLocationPath! !

!XPathExpressionParserHandler methodsFor: 'handling - location paths' stamp: 'monty 2/22/2016 04:27'!
handleStartStep! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartUnaryExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 2/22/2016 04:27'!
handleStartUnionExpression! !

!XPathExpressionParserHandler methodsFor: 'handling - literals' stamp: 'monty 2/22/2016 04:27'!
handleStringLiteral: aString! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:13'!
handleSubtractionOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - node tests' stamp: 'monty 2/5/2017 17:09'!
handleTextNodeTest! !

!XPathExpressionParserHandler methodsFor: 'handling - operators' stamp: 'monty 1/1/2017 06:13'!
handleUnionOperator! !

!XPathExpressionParserHandler methodsFor: 'handling - variables' stamp: 'monty 2/22/2016 04:27'!
handleVariableReference: aName! !

XPathParserHandler subclass: #XPathFunctionPrototypeParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathFunctionPrototypeParserHandler commentStamp: 'monty 2/22/2016 04:52' prior: 0!
An abstract class for function prototype parser handlers.!

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:50'!
handleArgument: anArgument! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:51'!
handleFunctionName: aName! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:51'!
handleOptionalArgument: anArgument! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:51'!
handleReturnType: aReturnType! !

!XPathFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 2/22/2016 04:52'!
handleUnboundedArgument: anArgument! !

XPathFunctionPrototypeParserHandler subclass: #XPathTypedFunctionPrototypeParserHandler
	instanceVariableNames: 'returnType functionName minArguments maxArguments argumentTypes typesByName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathTypedFunctionPrototypeParserHandler commentStamp: 'monty 9/28/2016 23:26' prior: 0!
A handler class for function prototype parsers that returns XPathFunctionPrototypes with the function name, return type, and number and types of arguments from the prototype source.!

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 1/27/2017 17:24'!
addArgumentTypeFor: aTypeName
	argumentTypes addLast: (self typeNamed: aTypeName)! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 9/23/2016 13:27'!
errorUnrecognizedTypeName: aTypeName
	XPathTypeException
		formatSignal: 'Unrecognized type name "{1}"'
		with: aTypeName! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:33'!
handleArgument: anArgument
	minArguments := minArguments + 1.
	maxArguments := maxArguments + 1.
	self addArgumentTypeFor: anArgument.! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2017 09:52'!
handleEndParsing
	self parsingResult:
		(XPathFunctionPrototype
			returnType: returnType
			name: functionName
			minArguments: minArguments
			maxArguments: maxArguments
			argumentTypes: argumentTypes)! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:17'!
handleFunctionName: aName
	functionName := aName! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:33'!
handleOptionalArgument: anArgument
	maxArguments := maxArguments + 1.
	self addArgumentTypeFor: anArgument.! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/27/2017 17:24'!
handleReturnType: aReturnType
	returnType := self typeNamed: aReturnType! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 5/15/2017 21:06'!
handleStartParsing
	minArguments := 0.
	maxArguments := 0.
	argumentTypes := OrderedCollection new.

	typesByName := Dictionary new.
	XPathValueType withAllSubclassesDo: [:each | | type |
		type := each new.
		typesByName
			at: type name
			put: type].! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:32'!
handleUnboundedArgument: anArgument
	maxArguments := nil.
	self addArgumentTypeFor: anArgument.! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 2/28/2017 07:54'!
typeNamed: aTypeName
	^ self
		typeNamed: aTypeName
		ifNone: [self errorUnrecognizedTypeName: aTypeName]! !

!XPathTypedFunctionPrototypeParserHandler methodsFor: 'private' stamp: 'monty 2/28/2017 07:54'!
typeNamed: aTypeName ifNone: aBlock
	^ typesByName
		at: aTypeName
		ifAbsent: aBlock! !

XPathParserHandler subclass: #XPathNodeTestParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNodeTestParserHandler commentStamp: 'monty 10/9/2017 00:52' prior: 0!
An abstract class for node test parser handlers. Parsing is controlled by XPathNodeTestParserState classes.!

XPathNodeTestParserHandler subclass: #XPathExpressionNodeTestParserHandler
	instanceVariableNames: 'currentAxis expressionParserHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathExpressionNodeTestParserHandler commentStamp: 'monty 4/4/2017 18:01' prior: 0!
This is a handler class used by the expression parser for parsing node tests that are part of location path steps. It forwards its handler messages to the expression parser handler and returns a boolean as its parsing result indicating if a node test was successfully parsed.!

!XPathExpressionNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 1/13/2015 11:43'!
currentAxis: anAxis expressionParserHandler: anExpressionParserHandler
	^ self new
		setCurrentAxis: anAxis
		expressionParserHandler: anExpressionParserHandler! !

!XPathExpressionNodeTestParserHandler methodsFor: 'defaults' stamp: 'monty 10/7/2017 14:50'!
defaultNodeTestParserStateClass
	^ currentAxis defaultNodeTestParserStateClass! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/4/2017 07:37'!
handleAnyNodeTest
	self startNodeTest.
	expressionParserHandler handleAnyNodeTest.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTest
	self startNodeTest.
	expressionParserHandler handleAttributeNodeTest.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleAttributeNodeTestForLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForName: aName
	self startNodeTest.
	expressionParserHandler handleAttributeNodeTestForName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForNamespaceURI: aURI
	self startNodeTest.
	expressionParserHandler handleAttributeNodeTestForNamespaceURI: aURI.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleAttributeNodeTestForNamespaceURI: aURI
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:08'!
handleAttributeNodeTestForPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleAttributeNodeTestForPrefix: aPrefix.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:08'!
handleAttributeNodeTestForPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleAttributeNodeTestForPrefix: aPrefix
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:08'!
handleCommentNodeTest
	self startNodeTest.
	expressionParserHandler handleCommentNodeTest.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleElementNodeTest
	self startNodeTest.
	expressionParserHandler handleElementNodeTest.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleElementNodeTestForLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleElementNodeTestForLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForName: aName
	self startNodeTest.
	expressionParserHandler handleElementNodeTestForName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForNamespaceURI: aURI
	self startNodeTest.
	expressionParserHandler handleElementNodeTestForNamespaceURI: aURI.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleElementNodeTestForNamespaceURI: aURI
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleElementNodeTestForPrefix: aPrefix.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleElementNodeTestForPrefix: aPrefix
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleNamespaceNodeTest
	self startNodeTest.
	expressionParserHandler handleNamespaceNodeTest.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForLocalName: aLocalName
	self startNodeTest.
	expressionParserHandler handleNamespaceNodeTestForLocalName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForName: aName
	self startNodeTest.
	expressionParserHandler handleNamespaceNodeTestForName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForNamespaceURI: aURI
	self startNodeTest.
	expressionParserHandler handleNamespaceNodeTestForNamespaceURI: aURI.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForNamespaceURI: aURI localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleNamespaceNodeTestForNamespaceURI: aURI
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForPrefix: aPrefix
	self startNodeTest.
	expressionParserHandler handleNamespaceNodeTestForPrefix: aPrefix.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleNamespaceNodeTestForPrefix: aPrefix localName: aLocalName
	self startNodeTest.
	expressionParserHandler
		handleNamespaceNodeTestForPrefix: aPrefix
		localName: aLocalName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handlePINodeTest
	self startNodeTest.
	expressionParserHandler handlePINodeTest.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handlePINodeTestForName: aName
	self startNodeTest.
	expressionParserHandler handlePINodeTestForName: aName.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/13/2015 12:42'!
handleStartParsing
	self parsingResult: false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleTextNodeTest
	self startNodeTest.
	expressionParserHandler handleTextNodeTest.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'testing' stamp: 'monty 2/10/2015 02:26'!
mustBeAtEndAfterParsing
	^ false! !

!XPathExpressionNodeTestParserHandler methodsFor: 'initialization' stamp: 'monty 1/13/2015 11:43'!
setCurrentAxis: anAxis expressionParserHandler: anExpressionParserHandler
	currentAxis := anAxis.
	expressionParserHandler := anExpressionParserHandler.! !

!XPathExpressionNodeTestParserHandler methodsFor: 'private' stamp: 'monty 1/2/2017 02:34'!
startNodeTest
	self parsingResult: true.
	currentAxis isStartOfRelativeLocationPath
		ifTrue: [expressionParserHandler handleStartRelativeLocationPath].
	expressionParserHandler
		handleStartStep;
		perform: currentAxis handlerSelector.
	currentAxis beDefaultImplicitAxis.! !

!XPathNodeTestParserHandler methodsFor: 'defaults' stamp: 'monty 10/7/2017 14:50'!
defaultNodeTestParserStateClass
	self subclassResponsibility! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 1/4/2017 07:37'!
handleAnyNodeTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForNamespaceURI: aURI! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:07'!
handleAttributeNodeTestForNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:08'!
handleAttributeNodeTestForPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:08'!
handleAttributeNodeTestForPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:08'!
handleCommentNodeTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleElementNodeTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleElementNodeTestForLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForNamespaceURI: aURI! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:11'!
handleElementNodeTestForPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleEmptyNodeTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleNamespaceNodeTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForLocalName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForNamespaceURI: aURI! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForNamespaceURI: aURI localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForPrefix: aPrefix! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleNamespaceNodeTestForPrefix: aPrefix localName: aLocalName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handlePINodeTest! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handlePINodeTestForName: aName! !

!XPathNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleTextNodeTest! !

XPathNodeTestParserHandler subclass: #XPathStringNodeTestParserHandler
	instanceVariableNames: 'defaultNodeTestParserStateClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathStringNodeTestParserHandler commentStamp: 'monty 11/20/2015 20:32' prior: 0!
A handler for node tests that occur in string arguments to the axis selectors defined in the "enumerating - axis" category of XMLNode and subclasses. It converts them to node test blocks.!

!XPathStringNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 10/7/2017 14:51'!
withAttributePrincipalNodeType
	^ self new defaultNodeTestParserStateClass: XPathNodeTestParserAttributeState! !

!XPathStringNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 10/7/2017 14:51'!
withElementPrincipalNodeType
	^ self new defaultNodeTestParserStateClass: XPathNodeTestParserElementState! !

!XPathStringNodeTestParserHandler class methodsFor: 'instance creation' stamp: 'monty 10/7/2017 14:51'!
withNamespacePrincipalNodeType
	^ self new defaultNodeTestParserStateClass: XPathNodeTestParserNamespaceState! !

!XPathStringNodeTestParserHandler methodsFor: 'defaults' stamp: 'monty 10/7/2017 14:51'!
defaultNodeTestParserStateClass
	^ defaultNodeTestParserStateClass! !

!XPathStringNodeTestParserHandler methodsFor: 'defaults' stamp: 'monty 10/7/2017 14:51'!
defaultNodeTestParserStateClass: aClass
	defaultNodeTestParserStateClass := aClass! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/4/2017 20:26'!
handleAnyNodeTest
	self parsingResult: XPathAnyNodeTest new! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:32'!
handleAttributeNodeTest
	self parsingResult: XPathAttributeNodeTest new! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:32'!
handleAttributeNodeTestForLocalName: aLocalName
	self parsingResult:
		(XPathAttributeNodeTestForLocalName localName: aLocalName)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:32'!
handleAttributeNodeTestForName: aName
	self parsingResult:
		(XPathAttributeNodeTestForName name: aName)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:33'!
handleAttributeNodeTestForNamespaceURI: aURI
	self parsingResult:
		(XPathAttributeNodeTestForNamespaceURI namespaceURI: aURI)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:33'!
handleAttributeNodeTestForNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		(XPathAttributeNodeTestForNamespaceURIAndLocalName
			namespaceURI: aURI
			localName: aLocalName)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:33'!
handleAttributeNodeTestForPrefix: aPrefix
	self parsingResult:
		(XPathAttributeNodeTestForPrefix prefix: aPrefix)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:32'!
handleAttributeNodeTestForPrefix: aPrefix localName: aLocalName
	self parsingResult:
		(XPathAttributeNodeTestForName name:
			(aLocalName qualifyWithXMLPrefix: aPrefix))! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:33'!
handleCommentNodeTest
	self parsingResult: XPathCommentNodeTest new! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:33'!
handleElementNodeTest
	self parsingResult: XPathElementNodeTest new! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:33'!
handleElementNodeTestForLocalName: aLocalName
	self parsingResult:
		(XPathElementNodeTestForLocalName localName: aLocalName)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:34'!
handleElementNodeTestForName: aName
	self parsingResult:
		(XPathElementNodeTestForName name: aName)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:34'!
handleElementNodeTestForNamespaceURI: aURI
	self parsingResult:
		(XPathElementNodeTestForNamespaceURI namespaceURI: aURI)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:34'!
handleElementNodeTestForNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		(XPathElementNodeTestForNamespaceURIAndLocalName
			namespaceURI: aURI
			localName: aLocalName)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:34'!
handleElementNodeTestForPrefix: aPrefix
	self parsingResult:
		(XPathElementNodeTestForPrefix prefix: aPrefix)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:34'!
handleElementNodeTestForPrefix: aPrefix localName: aLocalName
	self parsingResult:
		(XPathElementNodeTestForName name:
			(aLocalName qualifyWithXMLPrefix: aPrefix))! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/10/2017 22:43'!
handleEmptyNodeTest
	XPathSyntaxException signal:
		'String arguments to axis selectors must contain node tests'! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleNamespaceNodeTest
	self parsingResult: XPathNamespaceTest new! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForLocalName: aLocalName
	self parsingResult:
		(XPathNamespaceTestForLocalName localName: aLocalName)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForName: aName
	self parsingResult:
		(XPathNamespaceTestForName name: aName)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForNamespaceURI: aURI
	self parsingResult:
		(XPathNamespaceTestForNamespaceURI namespaceURI: aURI)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForNamespaceURI: aURI localName: aLocalName
	self parsingResult:
		(XPathNamespaceTestForNamespaceURIAndLocalName
			namespaceURI: aURI
			localName: aLocalName)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:10'!
handleNamespaceNodeTestForPrefix: aPrefix
	self parsingResult:
		(XPathNamespaceTestForPrefix prefix: aPrefix)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 17:09'!
handleNamespaceNodeTestForPrefix: aPrefix localName: aLocalName
	self parsingResult:
		(XPathNamespaceTestForName name:
			(aLocalName qualifyWithXMLPrefix: aPrefix))! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:32'!
handlePINodeTest
	self parsingResult: XPathPINodeTest new! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:32'!
handlePINodeTestForName: aName
	self parsingResult:
		(XPathPINodeTestForName name: aName)! !

!XPathStringNodeTestParserHandler methodsFor: 'handling' stamp: 'monty 2/5/2017 20:32'!
handleTextNodeTest
	self parsingResult: XPathTextNodeTest new! !

XPathParserHandler subclass: #XPathNumberParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathNumberParserHandler commentStamp: 'monty 1/18/2017 18:25' prior: 0!
An abstract class for number parser handlers.!

XPathNumberParserHandler subclass: #XPathFloatNumberParserHandler
	instanceVariableNames: 'sign integer fraction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Parsers'!

!XPathFloatNumberParserHandler commentStamp: 'monty 1/24/2017 21:34' prior: 0!
A handler for number parsers  that returns signed floating point numbers, including possibly nan and +/- infinity.!

!XPathFloatNumberParserHandler methodsFor: 'handling' stamp: 'monty 1/23/2017 13:04'!
handleEndParsing
	self parsingResult: ((integer + fraction) asFloat sign: sign)! !

!XPathFloatNumberParserHandler methodsFor: 'handling' stamp: 'monty 1/19/2017 07:11'!
handleFractionPart: aFraction
	fraction := aFraction! !

!XPathFloatNumberParserHandler methodsFor: 'handling' stamp: 'monty 1/19/2017 07:11'!
handleIntegerPart: anInteger
	integer := anInteger! !

!XPathFloatNumberParserHandler methodsFor: 'handling' stamp: 'monty 1/23/2017 12:59'!
handleNegativeSign
	sign := -1! !

!XPathFloatNumberParserHandler methodsFor: 'handling' stamp: 'monty 1/18/2017 09:26'!
handlePositiveSign
	sign := 1! !

!XPathNumberParserHandler methodsFor: 'handling' stamp: 'monty 1/19/2017 07:11'!
handleFractionPart: aFraction! !

!XPathNumberParserHandler methodsFor: 'handling' stamp: 'monty 1/19/2017 07:11'!
handleIntegerPart: anInteger! !

!XPathNumberParserHandler methodsFor: 'handling' stamp: 'monty 1/18/2017 09:24'!
handleNegativeSign! !

!XPathNumberParserHandler methodsFor: 'handling' stamp: 'monty 1/18/2017 09:24'!
handlePositiveSign! !

!XPathParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:18'!
handleEndParsing! !

!XPathParserHandler methodsFor: 'handling' stamp: 'monty 1/9/2015 07:18'!
handleStartParsing! !

!XPathParserHandler methodsFor: 'testing' stamp: 'monty 2/10/2015 02:26'!
mustBeAtEndAfterParsing
	^ true! !

!XPathParserHandler methodsFor: 'accessing' stamp: 'monty 1/10/2015 06:10'!
parsingResult
	^ parsingResult! !

!XPathParserHandler methodsFor: 'accessing' stamp: 'monty 3/14/2015 14:00'!
parsingResult: aParsingResult
	"set value to be returned by #parse"

	parsingResult := aParsingResult! !

Object subclass: #XPathPushedBackToken
	instanceVariableNames: 'value position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackToken commentStamp: 'monty 1/15/2015 11:06' prior: 0!
This is a class for storing pushed-back tokens so they can be quickly read again.!

XPathPushedBackToken subclass: #XPathPushedBackNCNameToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathPushedBackNCNameToken commentStamp: 'monty 1/10/2015 01:22' prior: 0!
A pushed-back non-qualified name token, to be read by nextNCName.!

!XPathPushedBackNCNameToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:21'!
isNCNameToken
	^ true! !

!XPathPushedBackToken class methodsFor: 'instance creation' stamp: 'monty 3/25/2016 21:03'!
value: aValue position: aPosition
	^ self new
		setValue: aValue
		position: aPosition! !

!XPathPushedBackToken methodsFor: 'testing' stamp: 'monty 1/8/2015 07:19'!
isNCNameToken
	^ false! !

!XPathPushedBackToken methodsFor: 'accessing' stamp: 'monty 1/9/2015 08:18'!
position
	^ position! !

!XPathPushedBackToken methodsFor: 'initialization' stamp: 'monty 3/25/2016 21:03'!
setValue: aValue position: aPosition
	value := aValue.
	position := aPosition.! !

!XPathPushedBackToken methodsFor: 'accessing' stamp: 'monty 3/25/2016 21:04'!
value
	^ value! !

Object subclass: #XPathSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

XPathSortOrder class
	instanceVariableNames: 'instance'!

!XPathSortOrder commentStamp: 'monty 1/25/2018 23:41' prior: 0!
Abstract class for node sort orders to keep track of the order of nodes in a node set, and to implement node set-based axis selections on them.

Instances of subclasses are immutable and shared.!

XPathSortOrder class
	instanceVariableNames: 'instance'!

XPathSortOrder subclass: #XPathDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathDocumentSortOrder commentStamp: 'monty 2/10/2015 03:47' prior: 0!
A sort order for nodes in document order.!

!XPathDocumentSortOrder methodsFor: 'converting' stamp: 'monty 10/18/2015 04:18'!
asReversedSortOrder
	^ XPathReverseDocumentSortOrder new! !

!XPathDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 1/30/2015 17:12'!
documentOrderSort: aNodeSet
	"already in document order"! !

!XPathDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 3/22/2017 23:53'!
documentOrderSorted: aNodeSet
	^ aNodeSet! !

!XPathDocumentSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet first! !

!XPathDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/22/2017 16:04'!
on: aNodeSet attributeAxis: aNodeTestStringOrBlock
	^ (super
		on: aNodeSet
		attributeAxis: aNodeTestStringOrBlock) sortOrder: self! !

!XPathDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/22/2017 16:04'!
on: aNodeSet attributeAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ (super
		on: aNodeSet
		attributeAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection) sortOrder: self! !

!XPathDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/22/2017 16:04'!
on: aNodeSet namespaceAxis: aNodeTestStringOrBlock
	^ (super
		on: aNodeSet
		namespaceAxis: aNodeTestStringOrBlock) sortOrder: self! !

!XPathDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/22/2017 16:04'!
on: aNodeSet namespaceAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ (super
		on: aNodeSet
		namespaceAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection) sortOrder: self! !

!XPathDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/22/2017 16:05'!
on: aNodeSet parentAxis: aNodeTestStringOrBlock
	"this is a document order axis according to the spec"
	^ (super
		on: aNodeSet
		parentAxis: aNodeTestStringOrBlock) sortOrder: self! !

!XPathDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/22/2017 16:05'!
on: aNodeSet selfAxis: aNodeTestStringOrBlock
	^ (super
		on: aNodeSet
		selfAxis: aNodeTestStringOrBlock) sortOrder: self! !

XPathDocumentSortOrder subclass: #XPathLevelDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathLevelDocumentSortOrder commentStamp: 'monty 3/27/2017 02:04' prior: 0!
This is a document sort order for node sets where all nodes are at the same level, meaning they have the same number of ancestors and share one or more ancestors.!

!XPathLevelDocumentSortOrder methodsFor: 'converting' stamp: 'monty 3/15/2017 17:25'!
asReversedSortOrder
	^ XPathLevelReverseDocumentSortOrder new! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/22/2017 16:05'!
on: aNodeSet childAxis: aNodeTestStringOrBlock
	^ (super
		on: aNodeSet
		childAxis: aNodeTestStringOrBlock) sortOrder: self! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/22/2017 16:05'!
on: aNodeSet childAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ (super
		on: aNodeSet
		childAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection) sortOrder: self! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:37'!
on: aNodeSet descendantAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first descendantAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			descendantAxisSelect: nodeTest
			into: copy].
	"will be in document order after, but not necessarily level document order"
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:38'!
on: aNodeSet descendantAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			descendantAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			descendantAxis: nodeTest
			predicates: aPredicateCollection)
				addAllTo: copy].
	"will be in document order after, but not necessarily level document order"
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:38'!
on: aNodeSet descendantOrSelfAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first descendantOrSelfAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			descendantOrSelfAxisSelect: nodeTest
			into: copy].
	"will be in document order after, but not necessarily level document order"
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathLevelDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:39'!
on: aNodeSet descendantOrSelfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			descendantOrSelfAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			descendantOrSelfAxis: nodeTest
			predicates: aPredicateCollection)
				addAllTo: copy].
	"will be in document order after, but not necessarily level document order"
	^ copy sortOrder: XPathDocumentSortOrder new.! !

XPathSortOrder subclass: #XPathReverseDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathReverseDocumentSortOrder commentStamp: 'monty 3/31/2015 02:16' prior: 0!
A sort order for nodes in reverse document order.!

XPathReverseDocumentSortOrder subclass: #XPathLevelReverseDocumentSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathLevelReverseDocumentSortOrder commentStamp: 'monty 3/27/2017 02:04' prior: 0!
This is a reverse document sort order for node sets where all nodes are at the same level, meaning they have the same number of ancestors and share one or more ancestors.!

!XPathLevelReverseDocumentSortOrder methodsFor: 'converting' stamp: 'monty 3/15/2017 17:26'!
asReversedSortOrder
	^ XPathLevelDocumentSortOrder new! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:44'!
on: aNodeSet childAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet last childAxis: nodeTest.
	aNodeSet allButLastReverseDo: [:each |
		each
			childAxisSelect: nodeTest
			into: copy].
	^ copy sortOrder: self asReversedSortOrder.! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:44'!
on: aNodeSet childAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet last
			childAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButLastReverseDo: [:each |
		(each
			childAxis: nodeTest
			predicates: aPredicateCollection)
				addAllTo: copy].
	^ copy sortOrder: self asReversedSortOrder.! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:45'!
on: aNodeSet descendantAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet last descendantAxis: nodeTest.
	aNodeSet allButLastReverseDo: [:each |
		each
			descendantAxisSelect: nodeTest
			into: copy].
	"will be in document order after, but not necessarily level document order"
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:45'!
on: aNodeSet descendantAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet last
			descendantAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButLastReverseDo: [:each |
		(each
			descendantAxis: nodeTest
			predicates: aPredicateCollection)
				addAllTo: copy].
	"will be in document order after, but not necessarily level document order"
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:46'!
on: aNodeSet descendantOrSelfAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet last descendantOrSelfAxis: nodeTest.
	aNodeSet allButLastReverseDo: [:each |
		each
			descendantOrSelfAxisSelect: nodeTest
			into: copy].
	"will be in document order after, but not necessarily level document order"
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathLevelReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:46'!
on: aNodeSet descendantOrSelfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet last
			descendantOrSelfAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButLastReverseDo: [:each |
		(each
			descendantOrSelfAxis: nodeTest
			predicates: aPredicateCollection)
				addAllTo: copy].
	"will be in document order after, but not necessarily level document order"
	^ copy sortOrder: XPathDocumentSortOrder new.! !

!XPathReverseDocumentSortOrder methodsFor: 'converting' stamp: 'monty 10/18/2015 04:19'!
asReversedSortOrder
	^ XPathDocumentSortOrder new! !

!XPathReverseDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 10/18/2015 04:17'!
documentOrderSort: aNodeSet
	aNodeSet reverseInPlace! !

!XPathReverseDocumentSortOrder methodsFor: 'sorting' stamp: 'monty 3/22/2017 23:53'!
documentOrderSorted: aNodeSet
	^ aNodeSet reversed! !

!XPathReverseDocumentSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet last! !

!XPathReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:40'!
on: aNodeSet attributeAxis: aNodeTestStringOrBlock
	| copy attributeAxisNodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	attributeAxisNodeTest := aNodeTestStringOrBlock asXPathAttributeAxisNodeTest.
	copy := aNodeSet last attributeAxis: attributeAxisNodeTest.
	aNodeSet allButLastReverseDo: [:each |
		each
			attributeAxisSelect: attributeAxisNodeTest
			into: copy].
	^ copy sortOrder: self asReversedSortOrder.! !

!XPathReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:40'!
on: aNodeSet attributeAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy attributeAxisNodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	attributeAxisNodeTest := aNodeTestStringOrBlock asXPathAttributeAxisNodeTest.
	copy :=
		aNodeSet last
			attributeAxis: attributeAxisNodeTest
			predicates: aPredicateCollection.
	aNodeSet allButLastReverseDo: [:each |
		(each
			attributeAxis: attributeAxisNodeTest
			predicates: aPredicateCollection)
				addAllTo: copy].
	^ copy sortOrder: self asReversedSortOrder.! !

!XPathReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:42'!
on: aNodeSet namespaceAxis: aNodeTestStringOrBlock
	| copy namespaceAxisNodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	namespaceAxisNodeTest := aNodeTestStringOrBlock asXPathNamespaceAxisNodeTest.
	copy := aNodeSet last namespaceAxis: namespaceAxisNodeTest.
	aNodeSet allButLastReverseDo: [:each |
		each
			namespaceAxisSelect: namespaceAxisNodeTest
			into: copy].
	^ copy sortOrder: self asReversedSortOrder.! !

!XPathReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:43'!
on: aNodeSet namespaceAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy namespaceAxisNodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	namespaceAxisNodeTest := aNodeTestStringOrBlock asXPathNamespaceAxisNodeTest.
	copy :=
		aNodeSet last
			namespaceAxis: namespaceAxisNodeTest
			predicates: aPredicateCollection.
	aNodeSet allButLastReverseDo: [:each |
		(each
			namespaceAxis: namespaceAxisNodeTest
			predicates: aPredicateCollection)
				addAllTo: copy].
	^ copy sortOrder: self asReversedSortOrder.! !

!XPathReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:41'!
on: aNodeSet parentAxis: aNodeTestStringOrBlock
	| copy |

	copy := aNodeSet copyEmpty.
	aNodeSet isEmpty
		ifFalse: [| nodeTest |
			nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
			aNodeSet reverseDo: [:each |
				each
					parentAxisSelect: nodeTest
					ifNotPresentInto: copy]].
	"parent is a document order axis according to the spec"
	^ copy sortOrder: self asReversedSortOrder.! !

!XPathReverseDocumentSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:42'!
on: aNodeSet selfAxis: aNodeTestStringOrBlock
	| copy |

	copy := aNodeSet copyEmpty.
	aNodeSet isEmpty
		ifFalse: [| nodeTest |
			nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
			aNodeSet reverseDo: [:each |
				each
					selfAxisSelect: nodeTest
					into: copy]].
	^ copy sortOrder: self asReversedSortOrder.! !

!XPathSortOrder class methodsFor: 'accessing' stamp: 'monty 10/9/2016 04:59'!
instance
	^ instance
		ifNil: [instance := self basicNew initialize]! !

!XPathSortOrder class methodsFor: 'instance creation' stamp: 'monty 10/9/2016 04:59'!
new
	"these classes are immutable and shared, so they are only initialized once"
	^ self instance! !

!XPathSortOrder methodsFor: 'converting' stamp: 'monty 10/18/2015 04:18'!
asReversedSortOrder
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'sorting' stamp: 'monty 1/26/2015 18:43'!
documentOrderSort: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'sorting' stamp: 'monty 3/22/2017 23:53'!
documentOrderSorted: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:24'!
firstInDocumentOrderFrom: aNodeSet
	self subclassResponsibility! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:11'!
on: aNodeSet ancestorAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first ancestorAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			ancestorAxisSelect: nodeTest
			ifNotPresentInto: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:12'!
on: aNodeSet ancestorAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			ancestorAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			ancestorAxis: nodeTest
			predicates: aPredicateCollection)
				addAllIfNotPresentTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:13'!
on: aNodeSet ancestorOrSelfAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first ancestorOrSelfAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			ancestorOrSelfAxisSelect: nodeTest
			ifNotPresentInto: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:13'!
on: aNodeSet ancestorOrSelfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			ancestorOrSelfAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			ancestorOrSelfAxis: nodeTest
			predicates: aPredicateCollection)
				addAllIfNotPresentTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:16'!
on: aNodeSet attributeAxis: aNodeTestStringOrBlock
	| copy attributeAxisNodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	attributeAxisNodeTest := aNodeTestStringOrBlock asXPathAttributeAxisNodeTest.
	copy := aNodeSet first attributeAxis: attributeAxisNodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			attributeAxisSelect: attributeAxisNodeTest
			into: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:18'!
on: aNodeSet attributeAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy attributeAxisNodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	attributeAxisNodeTest := aNodeTestStringOrBlock asXPathAttributeAxisNodeTest.
	copy :=
		aNodeSet first
			attributeAxis: attributeAxisNodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			attributeAxis: attributeAxisNodeTest
			predicates: aPredicateCollection)
				addAllTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:19'!
on: aNodeSet childAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first childAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			childAxisSelect: nodeTest
			into: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:22'!
on: aNodeSet childAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			childAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			childAxis: nodeTest
			predicates: aPredicateCollection)
				addAllTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:23'!
on: aNodeSet descendantAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first descendantAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			descendantAxisSelect: nodeTest
			ifNotPresentInto: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:23'!
on: aNodeSet descendantAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			descendantAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			descendantAxis: nodeTest
			predicates: aPredicateCollection)
				addAllIfNotPresentTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:25'!
on: aNodeSet descendantOrSelfAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first descendantOrSelfAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			descendantOrSelfAxisSelect: nodeTest
			ifNotPresentInto: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:26'!
on: aNodeSet descendantOrSelfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			descendantOrSelfAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			descendantOrSelfAxis: nodeTest
			predicates: aPredicateCollection)
				addAllIfNotPresentTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:27'!
on: aNodeSet followingAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first followingAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			followingAxisSelect: nodeTest
			ifNotPresentInto: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:27'!
on: aNodeSet followingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			followingAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			followingAxis: nodeTest
			predicates: aPredicateCollection)
				addAllIfNotPresentTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:28'!
on: aNodeSet followingSiblingAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first followingSiblingAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			followingSiblingAxisSelect: nodeTest
			ifNotPresentInto: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:28'!
on: aNodeSet followingSiblingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			followingSiblingAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			followingSiblingAxis: nodeTest
			predicates: aPredicateCollection)
				addAllIfNotPresentTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:29'!
on: aNodeSet namespaceAxis: aNodeTestStringOrBlock
	| copy namespaceAxisNodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	namespaceAxisNodeTest := aNodeTestStringOrBlock asXPathNamespaceAxisNodeTest.
	copy := aNodeSet first namespaceAxis: namespaceAxisNodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			namespaceAxisSelect: namespaceAxisNodeTest
			into: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:29'!
on: aNodeSet namespaceAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy namespaceAxisNodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	namespaceAxisNodeTest := aNodeTestStringOrBlock asXPathNamespaceAxisNodeTest.
	copy :=
		aNodeSet first
			namespaceAxis: namespaceAxisNodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			namespaceAxis: namespaceAxisNodeTest
			predicates: aPredicateCollection)
				addAllTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:30'!
on: aNodeSet parentAxis: aNodeTestStringOrBlock
	| copy |

	copy := aNodeSet copyEmpty.
	aNodeSet isEmpty
		ifFalse: [| nodeTest |
			nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
			aNodeSet do: [:each |
				each
					parentAxisSelect: nodeTest
					ifNotPresentInto: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 1/15/2017 14:12'!
on: aNodeSet parentAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ (self
		on: aNodeSet
		parentAxis: aNodeTestStringOrBlock)
			filterEachInSeparateContextWithAll: aPredicateCollection! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:33'!
on: aNodeSet precedingAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first precedingAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			precedingAxisSelect: nodeTest
			ifNotPresentInto: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:32'!
on: aNodeSet precedingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			precedingAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			precedingAxis: nodeTest
			predicates: aPredicateCollection)
				addAllIfNotPresentTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:34'!
on: aNodeSet precedingSiblingAxis: aNodeTestStringOrBlock
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy := aNodeSet first precedingSiblingAxis: nodeTest.
	aNodeSet allButFirstDo: [:each |
		each
			precedingSiblingAxisSelect: nodeTest
			ifNotPresentInto: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:33'!
on: aNodeSet precedingSiblingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	| copy nodeTest |

	aNodeSet isEmpty
		ifTrue: [^ aNodeSet copyEmpty].
	nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
	copy :=
		aNodeSet first
			precedingSiblingAxis: nodeTest
			predicates: aPredicateCollection.
	aNodeSet allButFirstDo: [:each |
		(each
			precedingSiblingAxis: nodeTest
			predicates: aPredicateCollection)
				addAllIfNotPresentTo: copy].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:36'!
on: aNodeSet selfAxis: aNodeTestStringOrBlock
	| copy |

	copy := aNodeSet copyEmpty.
	aNodeSet isEmpty
		ifFalse: [| nodeTest |
			nodeTest := aNodeTestStringOrBlock asXPathNodeTest.
			aNodeSet do: [:each |
				each
					selfAxisSelect: nodeTest
					into: copy]].
	^ copy.! !

!XPathSortOrder methodsFor: 'enumerating' stamp: 'monty 3/24/2017 00:31'!
on: aNodeSet selfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ (self
		on: aNodeSet
		selfAxis: aNodeTestStringOrBlock)
			filterEachInSeparateContextWithAll: aPredicateCollection! !

XPathSortOrder subclass: #XPathUnknownSortOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathUnknownSortOrder commentStamp: 'monty 2/10/2015 03:49' prior: 0!
A sort order for unsorted nodes or nodes in an unknown sort order.!

!XPathUnknownSortOrder methodsFor: 'converting' stamp: 'monty 10/18/2015 04:19'!
asReversedSortOrder
	^ self! !

!XPathUnknownSortOrder methodsFor: 'sorting' stamp: 'monty 6/9/2015 01:58'!
documentOrderSort: aNodeSet
	(XPathNodeSetSorter on: aNodeSet) sort! !

!XPathUnknownSortOrder methodsFor: 'sorting' stamp: 'monty 3/22/2017 23:53'!
documentOrderSorted: aNodeSet
	^ aNodeSet sorted! !

!XPathUnknownSortOrder methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:25'!
firstInDocumentOrderFrom: aNodeSet
	^ aNodeSet sorted first! !

Object subclass: #XPathTranslatedExpression
	instanceVariableNames: 'sourceCode nodeTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Compilation'!

!XPathTranslatedExpression commentStamp: 'monty 2/6/2017 18:39' prior: 0!
This class stores the XPath expression's translation to Smalltalk source code and its array of XPathNodeTest objects.!

!XPathTranslatedExpression class methodsFor: 'instance creation' stamp: 'monty 2/7/2017 03:41'!
sourceCode: aSourceString nodeTests: aNodeTestCollection
	^ self new
		setSourceCode: aSourceString
		nodeTests: aNodeTestCollection! !

!XPathTranslatedExpression methodsFor: 'accessing' stamp: 'monty 2/4/2017 21:59'!
nodeTests
	^ nodeTests! !

!XPathTranslatedExpression methodsFor: 'printing' stamp: 'monty 3/10/2018 22:59'!
printOn: aStream
	super printOn: aStream.

	aStream
		nextPut: $(;
		print: self sourceCode;
		nextPut: $).! !

!XPathTranslatedExpression methodsFor: 'initialization' stamp: 'monty 2/7/2017 03:41'!
setSourceCode: aSourceString nodeTests: aNodeTestCollection
	sourceCode := aSourceString.
	nodeTests := aNodeTestCollection asArray.! !

!XPathTranslatedExpression methodsFor: 'accessing' stamp: 'monty 2/4/2017 21:59'!
sourceCode
	^ sourceCode! !

Object subclass: #XPathType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

XPathType class
	instanceVariableNames: 'instance'!

!XPathType commentStamp: 'monty 2/9/2017 23:18' prior: 0!
This is an abstract base class for XPath types. Subclasses must implement the #name method to return a printable type name.

Instances of subclasses are immutable and shared.!

XPathType class
	instanceVariableNames: 'instance'!

XPathType subclass: #XPathNodeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathNodeType commentStamp: 'monty 2/7/2017 03:30' prior: 0!
This is a base class for node types.!

XPathNodeType subclass: #XPathAttributeNodeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathAttributeNodeType commentStamp: 'monty 2/7/2017 03:30' prior: 0!
This is a class for the attribute node type.!

!XPathAttributeNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isAttributeNodeType
	^ true! !

!XPathAttributeNodeType methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:27'!
name
	^ 'attribute'! !

XPathNodeType subclass: #XPathCommentNodeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathCommentNodeType commentStamp: 'monty 2/7/2017 03:30' prior: 0!
This is a class for the comment node type.!

!XPathCommentNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isCommentNodeType
	^ true! !

!XPathCommentNodeType methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:28'!
name
	^ 'comment'! !

XPathNodeType subclass: #XPathElementNodeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathElementNodeType commentStamp: 'monty 2/7/2017 03:31' prior: 0!
This is a class for the element node type.!

!XPathElementNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isElementNodeType
	^ true! !

!XPathElementNodeType methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:28'!
name
	^ 'element'! !

XPathNodeType subclass: #XPathNamespaceNodeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathNamespaceNodeType commentStamp: 'monty 2/7/2017 03:31' prior: 0!
This is a class for the namespace node type.!

!XPathNamespaceNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isNamespaceNodeType
	^ true! !

!XPathNamespaceNodeType methodsFor: 'accessing' stamp: 'monty 2/7/2017 03:28'!
name
	^ 'namespace'! !

!XPathNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isAttributeNodeType
	^ false! !

!XPathNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isCommentNodeType
	^ false! !

!XPathNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isElementNodeType
	^ false! !

!XPathNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isNamespaceNodeType
	^ false! !

!XPathNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isPINodeType
	^ false! !

!XPathNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isTextNodeType
	^ false! !

!XPathNodeType methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:30'!
name
	^ 'node'! !

XPathNodeType subclass: #XPathPINodeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathPINodeType commentStamp: 'monty 2/7/2017 03:31' prior: 0!
This is a class for the PI node type.!

!XPathPINodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isPINodeType
	^ true! !

!XPathPINodeType methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:28'!
name
	^ 'processing-instruction'! !

XPathNodeType subclass: #XPathTextNodeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathTextNodeType commentStamp: 'monty 2/9/2017 20:03' prior: 0!
This is a class for the text (string) node type.!

!XPathTextNodeType methodsFor: 'testing' stamp: 'monty 2/7/2017 03:52'!
isTextNodeType
	^ true! !

!XPathTextNodeType methodsFor: 'accessing' stamp: 'monty 2/6/2017 22:28'!
name
	^ 'text'! !

!XPathType class methodsFor: 'accessing' stamp: 'monty 1/27/2017 18:36'!
instance
	^ instance ifNil: [instance := self basicNew initialize]! !

!XPathType class methodsFor: 'instance creation' stamp: 'monty 1/27/2017 18:36'!
new
	^ self instance! !

!XPathType methodsFor: 'comparing' stamp: 'monty 2/6/2017 22:25'!
= anObject
	^ self == anObject
		or: [self species == anObject species]! !

!XPathType methodsFor: 'comparing' stamp: 'monty 2/12/2017 21:04'!
hash
	^ self species hash! !

!XPathType methodsFor: 'accessing' stamp: 'monty 1/27/2017 17:22'!
name
	self subclassResponsibility! !

!XPathType methodsFor: 'printing' stamp: 'monty 1/27/2017 17:21'!
printOn: aStream
	aStream nextPutAll: self name! !

XPathType subclass: #XPathValueType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathValueType commentStamp: 'monty 2/10/2017 22:26' prior: 0!
This is an XPath type class for any XPath value. Subclasses must implement #newFrom: to return the argument converted to the receiver type.!

XPathValueType subclass: #XPathBooleanValueType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathBooleanValueType commentStamp: 'monty 2/9/2017 19:56' prior: 0!
This is an XPath type class for 'true' and 'false' values.!

!XPathBooleanValueType methodsFor: 'testing' stamp: 'monty 2/9/2017 19:55'!
isBooleanValueType
	^ true! !

!XPathBooleanValueType methodsFor: 'accessing' stamp: 'monty 1/27/2017 14:51'!
name
	^ 'boolean'! !

!XPathBooleanValueType methodsFor: 'instance creation' stamp: 'monty 1/27/2017 14:48'!
newFrom: anObject
	^ anObject asXPathBoolean! !

XPathValueType subclass: #XPathNodeSetValueType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathNodeSetValueType commentStamp: 'monty 2/9/2017 19:56' prior: 0!
This is an XPath type class for XPathNodeSet values.!

!XPathNodeSetValueType methodsFor: 'testing' stamp: 'monty 2/9/2017 19:55'!
isNodeSetValueType
	^ true! !

!XPathNodeSetValueType methodsFor: 'accessing' stamp: 'monty 1/27/2017 14:51'!
name
	^ 'node-set'! !

!XPathNodeSetValueType methodsFor: 'instance creation' stamp: 'monty 1/27/2017 14:48'!
newFrom: anObject
	^ anObject asXPathNodeSet! !

XPathValueType subclass: #XPathNumberValueType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathNumberValueType commentStamp: 'monty 1/27/2017 17:28' prior: 0!
This is an XPath type class for Floats and instances of other Number subclasses.!

!XPathNumberValueType methodsFor: 'testing' stamp: 'monty 2/9/2017 19:55'!
isNumberValueType
	^ true! !

!XPathNumberValueType methodsFor: 'accessing' stamp: 'monty 1/27/2017 14:51'!
name
	^ 'number'! !

!XPathNumberValueType methodsFor: 'instance creation' stamp: 'monty 1/27/2017 14:49'!
newFrom: anObject
	^ anObject asXPathNumber! !

XPathValueType subclass: #XPathStringValueType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Types'!

!XPathStringValueType commentStamp: 'monty 2/9/2017 19:56' prior: 0!
This is an XPath type class for string values.!

!XPathStringValueType methodsFor: 'testing' stamp: 'monty 2/9/2017 19:56'!
isStringValueType
	^ true! !

!XPathStringValueType methodsFor: 'accessing' stamp: 'monty 1/27/2017 14:51'!
name
	^ 'string'! !

!XPathStringValueType methodsFor: 'instance creation' stamp: 'monty 1/27/2017 14:49'!
newFrom: anObject
	^ anObject asXPathString! !

!XPathValueType methodsFor: 'testing' stamp: 'monty 2/9/2017 19:55'!
isBooleanValueType
	^ false! !

!XPathValueType methodsFor: 'testing' stamp: 'monty 2/9/2017 19:55'!
isNodeSetValueType
	^ false! !

!XPathValueType methodsFor: 'testing' stamp: 'monty 2/9/2017 19:55'!
isNumberValueType
	^ false! !

!XPathValueType methodsFor: 'testing' stamp: 'monty 2/9/2017 19:56'!
isStringValueType
	^ false! !

!XPathValueType methodsFor: 'accessing' stamp: 'monty 1/27/2017 14:51'!
name
	^ 'object'! !

!XPathValueType methodsFor: 'instance creation' stamp: 'monty 2/6/2017 22:30'!
newFrom: anObject
	^ anObject! !

!XMLString methodsFor: '*XPath-Core-accessing' stamp: 'monty 3/25/2015 19:32'!
stringValue
	^ self string! !

!Stream methodsFor: '*XPath-Core-converting' stamp: 'monty 2/22/2016 05:49'!
asXPathReadStreamAdapter
	^ XPathReadStreamAdapter on: self! !

XMLReadStreamAdapter subclass: #XPathReadStreamAdapter
	instanceVariableNames: 'pushedBackToken nameStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-Streams'!

!XPathReadStreamAdapter commentStamp: 'monty 3/27/2015 21:44' prior: 0!
This class is an adapter for positionable read streams that wraps them to be safe to send messages like next and peek when atEnd and supports efficient push back of token objects to minimize backtracking by parsers.!

!XPathReadStreamAdapter methodsFor: 'converting' stamp: 'monty 1/14/2015 03:19'!
asXPathReadStreamAdapter
	^ self! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/23/2018 07:33'!
nextNCName
	"returns the next non-qualified name or nil"

	(self peekPushedBackToken notNil
		and: [self peekPushedBackToken isNCNameToken])
		ifTrue: [^ self nextPushedBackToken value].

	self peek isXMLNCNameStartChar
		ifFalse: [^ nil].
	nameStream
		reset;
		nextPut: self next.
	[self peek isXMLNCNameChar]
		whileTrue: [nameStream nextPut: self next].
	^ nameStream contents.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 4/1/2016 00:57'!
nextName
	"returns the next qualified or non-qualified name or nil"

	| oldPosition ncNameOrPrefix |

	oldPosition := self position.
	(ncNameOrPrefix := self nextNCName)
		ifNil: [^ nil].
	(self peekFor: $:)
		ifFalse: [
			"just a local name"
			^ ncNameOrPrefix].
	self nextNCName
		ifNil: [
			"an NCName followed by : must have a local name after"
			self position: oldPosition.
			^ nil]
		ifNotNil: [:localName |
			"a full qualified name"
			^ localName qualifyWithXMLPrefix: ncNameOrPrefix].! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 11/13/2017 11:34'!
nextPushedBackToken
	^ self peekPushedBackToken
		ifNotNil: [:token |
			self position: self position + token value size.
			token]! !

!XPathReadStreamAdapter methodsFor: 'initialization' stamp: 'monty 1/23/2018 07:21'!
on: aStream
	super on: aStream.

	"must use #writeStream instead of 'WriteStream on:' to get a 0-based
	stream on Gemstone"
	nameStream := (String new: 32) writeStream.! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 1/23/2018 07:37'!
peekForNCName: anNCName
	| position ncName |

	position := self position.
	ncName := self nextNCName
		ifNil: [^ false].
	ncName = anNCName
		ifTrue: [^ true]
		ifFalse: [
			self
				pushBackNCName: ncName
				position: position.
			^ false].! !

!XPathReadStreamAdapter methodsFor: 'accessing' stamp: 'monty 11/13/2017 11:34'!
peekPushedBackToken
	(pushedBackToken notNil
		and: [pushedBackToken position = self position])
		ifTrue: [^ pushedBackToken]
		ifFalse: [^ nil]! !

!XPathReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 3/25/2016 21:42'!
pushBackNCName: anNCName position: aPosition
	self pushBackToken:
		(XPathPushedBackNCNameToken
			value: anNCName
			position: aPosition)! !

!XPathReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 1/9/2015 11:33'!
pushBackToken: aPushedBackToken
	pushedBackToken := aPushedBackToken.
	self position: aPushedBackToken position.! !

!XPathReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 1/23/2018 07:25'!
skipBack
	"does not peek like #back"
	self position: self position - 1! !

!XPathReadStreamAdapter methodsFor: 'positioning' stamp: 'monty 1/23/2018 07:25'!
skipSeparators
	"provides consistent cross-platform separator skipping with the XML set of
	separators, which the XPath spec uses for whitespace too:
		ExprWhitespace	   ::=   	S
		S	   ::=   	(#x20 | #x9 | #xD | #xA)+"
	[self atEnd not
		and: [self peek isXMLSeparator]]
		whileTrue: [self next]! !

XMLNodeList subclass: #XPathNodeSet
	instanceVariableNames: 'set sortOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Core-DOM'!

!XPathNodeSet commentStamp: 'monty 3/20/2017 17:15' prior: 0!
This class implements XPath node sets to store the results of XPath location path expressions. Location path expresssion produce node seets in document order, regardless of the direction (forward or reverse) of the final step axis.!

!XPathNodeSet class methodsFor: 'instance creation' stamp: 'monty 4/15/2015 11:47'!
new
	^ self new: 10! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/16/2017 17:50'!
% aStringOrBlockOrNodeTestWithPredicates
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				parentAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self parentAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/16/2017 17:50'!
%% aStringOrBlockOrNodeTestWithPredicates
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				ancestorAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self ancestorAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/16/2017 17:51'!
%%~ aStringOrBlockOrNodeTestWithPredicates
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self ancestorOrSelfAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/29/2015 19:01'!
& aNodeSet
	"redefined here for portability"
	^ self intersection: aNodeSet! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/16/2017 17:51'!
/ aStringOrBlockOrNodeTestWithPredicates
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				childAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self childAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/11/2017 18:21'!
// aStringOrBlockOrNodeTestWithPredicates
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				descendantAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self descendantAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 2/11/2017 18:21'!
//~ aStringOrBlockOrNodeTestWithPredicates
	^ aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				descendantOrSelfAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self descendantOrSelfAxis: aStringOrBlockOrNodeTestWithPredicates]! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/16/2017 17:52'!
<< aStringOrBlockOrNodeTestWithPredicates
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				precedingAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self precedingAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/16/2017 17:52'!
<<< aStringOrBlockOrNodeTestWithPredicates
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				precedingSiblingAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self precedingSiblingAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/16/2017 17:52'!
>> aStringOrBlockOrNodeTestWithPredicates
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				followingAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self followingAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/16/2017 17:53'!
>>> aStringOrBlockOrNodeTestWithPredicates
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				followingSiblingAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self followingSiblingAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/16/2017 17:21'!
?? aPredicateOrPredicateCollection
	"?? filters an entire resulting node set like a filter expression, so
	all predicate positions are relative to the document order of the nodes"

	^ aPredicateOrPredicateCollection isCollection
		ifTrue: [
			self asXPathFilterExpressionPredicateRoot
				filterWithAll: aPredicateOrPredicateCollection]
		ifFalse: [
			self asXPathFilterExpressionPredicateRoot
				filterWith: aPredicateOrPredicateCollection]! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/16/2017 17:53'!
@ aStringOrBlockOrNodeTestWithPredicates
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				attributeAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self attributeAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/18/2017 23:11'!
@@ aStringOrBlockOrNodeTestWithPredicates
	"Returns an ordered list of all attribute value strings of all matching
	attributes from all elements of the receiver or an empty list if there
	aren't any."

	^ (self @ aStringOrBlockOrNodeTestWithPredicates) stringValues! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/29/2015 19:01'!
\ aNodeSet
	"redefined here for portability"
	^ self difference: aNodeSet! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/21/2017 10:20'!
addAllIfNotPresentTo: aCollection
	"this inverts #addAll: because #addAll: uses #do: instead of #to:do:
	because it accepts non-SequenceableCollection arguments, and also
	does an #includes: test to avoid adding an already present node to
	the end of a node set, which whould left shift everything after
	its old position by one"
	1 to: collection size do: [:i | | node |
		node := collection at: i.
		(aCollection includes: node)
			ifFalse: [aCollection addLast: node]]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/21/2017 10:20'!
addAllTo: aCollection
	"this inverts #addAll: because #addAll: uses #do: instead of #to:do:
	because it accepts non-SequenceableCollection arguments"
	1 to: collection size do: [:i |
		aCollection addLast: (collection at: i)]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAdding: aNode at: anIndex
	| oldSize |

	sortOrder := nil.
	oldSize := self set size.
	(self set
		add: aNode;
		size) = oldSize
		ifTrue: [
			self
				removeDuplicateOf: aNode
				notAt: anIndex]
		ifFalse: [
			observer
				ifNotNil: [observer addedNode: aNode]].! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 9/5/2016 23:43'!
afterAddingLast: aNode
	| oldSize |

	sortOrder := nil.
	oldSize := self set size.
	(self set
		add: aNode;
		size) = oldSize
		ifTrue: [
			self
				removeDuplicateOf: aNode
				notAt: oldSize]
		ifFalse: [
			observer
				ifNotNil: [observer addedNode: aNode]]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/21/2017 00:35'!
afterAddingToCopyLast: aNode
	self set add: aNode.
	observer
		ifNotNil: [observer addedNode: aNode].! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 8/30/2016 18:26'!
afterRemoving: aNode
	"removing does not change order, so sortOrder is not reset here"
	self set remove: aNode.
	observer
		ifNotNil: [observer removedNode: aNode].! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/24/2017 00:49'!
allButLastReverseDo: aBlock
	collection size - 1 to: 1 by: -1 do: [:i |
		aBlock value: (collection at: i)]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 08:27'!
ancestorAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		ancestorAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:10'!
ancestorAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		ancestorAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:42'!
ancestorAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each ancestorAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 08:27'!
ancestorOrSelfAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		ancestorOrSelfAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:10'!
ancestorOrSelfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		ancestorOrSelfAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:42'!
ancestorOrSelfAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each ancestorOrSelfAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 3/22/2017 23:53'!
asSorted
	"unlike #sorted, this only returns a copy if sorting was needed"

	^ self sortOrder documentOrderSorted: self! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/20/2014 20:40'!
asXPathBoolean
	^ self notEmpty! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 2/22/2016 11:05'!
asXPathComparable
	^ XPathNodeSetComparable value: self! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 3/14/2017 23:03'!
asXPathFilterExpressionLocationPathRoot
	"any node set can be used as the root of a filter expression
	location path, like (/one)/two or '$one/two' (when $one is bound
	to a node set)"

	^ self! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 3/22/2017 23:52'!
asXPathFilterExpressionPredicateRoot
	"any node set can be filterd as a whole with predicates in a filter
	expression, like '(/one)[two]' or '$one[two]' (when $one is bound to
	a node set), but it must be sorted so predicate positions are relative to
	document order"

	^ self asSorted! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 10/27/2015 17:37'!
asXPathNodeSet
	^ self! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 12/20/2014 20:40'!
asXPathNumber
	^ self asXPathString asXPathNumber! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 3/25/2015 20:44'!
asXPathString
	^ self firstInDocumentOrder
		ifNil: ['']
		ifNotNil: [:node | node stringValue]! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 2/22/2016 10:19'!
asXPathUnionable
	^ self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 08:28'!
attributeAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		attributeAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:11'!
attributeAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		attributeAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:42'!
attributeAxisAnySatisfy: anAttributeNodeTest
	^ self anySatisfy: [:each |
		each attributeAxisAnySatisfy: anAttributeNodeTest]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 08:48'!
childAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		childAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:11'!
childAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		childAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:41'!
childAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each childAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2017 03:02'!
copy
	"copies that don't add or replace keep sort order"
	^ super copy sortOrder: self sortOrder! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2017 03:02'!
copyAfter: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyAfter: anObject) sortOrder: self sortOrder! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2017 03:02'!
copyAfterLast: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyAfterLast: anObject) sortOrder: self sortOrder! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2017 03:02'!
copyFrom: aStartIndex to: anEndIndex
	"copies that don't add or replace keep sort order"
	^ (super
		copyFrom: aStartIndex
		to: anEndIndex) sortOrder: self sortOrder! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2017 03:02'!
copyUpTo: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyUpTo: anObject) sortOrder: self sortOrder! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2017 03:02'!
copyUpToLast: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyUpToLast: anObject) sortOrder: self sortOrder! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2017 03:02'!
copyWithout: anObject
	"copies that don't add or replace keep sort order"
	^ (super copyWithout: anObject) sortOrder: self sortOrder! !

!XPathNodeSet methodsFor: 'copying' stamp: 'monty 3/25/2017 03:02'!
copyWithoutAll: aCollection
	"copies that don't add or replace keep sort order"
	^ (super copyWithoutAll: aCollection) sortOrder: self sortOrder! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 11:11'!
descendantAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		descendantAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:11'!
descendantAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		descendantAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:41'!
descendantAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each descendantAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 11:11'!
descendantOrSelfAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		descendantOrSelfAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:11'!
descendantOrSelfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		descendantOrSelfAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:41'!
descendantOrSelfAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each descendantOrSelfAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 21:35'!
difference: aNodeSet
	^ (self copyWithoutAll: aNodeSet) sort! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2017 03:03'!
filterEachInSeparateContextWith: aThreeArgumentBlockOrNumber
	| copy |

	aThreeArgumentBlockOrNumber isNumber
		ifTrue: [
			copy :=
				aThreeArgumentBlockOrNumber asXPathNodeSetPosition = 1
					ifTrue: [self copy]
					ifFalse: [self copyEmpty]]
		ifFalse: [
			copy := self copyEmpty.
			1 to: self size do: [:i | | node result |
				node := self at: i.
				(result :=
					aThreeArgumentBlockOrNumber
						cull: node "context node"
						cull: 1 "context position"
						cull: 1) isNumber "context size"
						ifTrue: [
							result asXPathNodeSetPosition = 1
								ifTrue: [copy addToCopyLast: node]]
						ifFalse: [
							result asXPathBoolean
								ifTrue: [copy addToCopyLast: node]]]].
	"filtering cannot change the sort order"
	^ copy sortOrder: self sortOrder.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/6/2017 03:20'!
filterEachInSeparateContextWithAll: aFilterCollection
	^ self
		filterEachInSeparateContextWithAll: aFilterCollection
		startingAt: 1! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/6/2017 18:29'!
filterEachInSeparateContextWithAll: aFilterCollection startingAt: anIndex
	| filteredNodeSet |

	filteredNodeSet := self.
	anIndex to: aFilterCollection size do: [:i |
		filteredNodeSet isEmpty
			ifTrue: [^ filteredNodeSet].
		filteredNodeSet :=
			filteredNodeSet filterEachInSeparateContextWith:
				(aFilterCollection at: i)].
	^ filteredNodeSet.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2017 03:03'!
filterWith: aThreeArgumentBlockOrNumber
	| copy |

	copy := self copyEmpty.
	aThreeArgumentBlockOrNumber isNumber
		ifTrue: [
			(self at: aThreeArgumentBlockOrNumber asXPathNodeSetPosition)
				ifNotNil: [:node |
					copy addToCopyLast: node]]
		ifFalse: [| contextSize |
			contextSize := self size.
			1 to: contextSize do: [:i | | node result |
				node := self at: i.
				(result :=
					aThreeArgumentBlockOrNumber
						cull: node "context node"
						cull: i "context position"
						cull: contextSize) isNumber
					ifTrue: [
						result asXPathNodeSetPosition = i
							ifTrue: [copy addToCopyLast: node]]
					ifFalse: [
						result asXPathBoolean
							ifTrue: [copy addToCopyLast: node]]]].
	"filtering cannot change the sort order"
	^ copy sortOrder: self sortOrder.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/6/2017 03:19'!
filterWithAll: aFilterCollection
	^ self
		filterWithAll: aFilterCollection
		startingAt: 1! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/6/2017 18:29'!
filterWithAll: aFilterCollection startingAt: anIndex
	| filteredNodeSet |

	filteredNodeSet := self.
	anIndex to: aFilterCollection size do: [:i |
		filteredNodeSet isEmpty
			ifTrue: [^ filteredNodeSet].
		filteredNodeSet :=
			filteredNodeSet filterWith: (aFilterCollection at: i)].
	^ filteredNodeSet.! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 2/3/2015 01:24'!
firstInDocumentOrder
	^ self sortOrder firstInDocumentOrderFrom: self! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 11:12'!
followingAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		followingAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:11'!
followingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		followingAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:40'!
followingAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each followingAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 11:12'!
followingSiblingAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		followingSiblingAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:11'!
followingSiblingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		followingSiblingAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:40'!
followingSiblingAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each followingSiblingAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'testing' stamp: 'monty 1/16/2015 05:26'!
includes: aNode
	^ self set includes: aNode! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 21:35'!
intersection: aNodeSet
	^ (self select: [:each | aNodeSet includes: each]) sort! !

!XPathNodeSet methodsFor: 'testing' stamp: 'monty 3/20/2017 22:56'!
isXPathNodeSet
	^ true! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/8/2017 15:00'!
maximumStringValueNumber
	| maximum |

	self do: [:each | | number |
		number := each stringValue asXPathNumber.
		maximum
			ifNil: [maximum := number]
			ifNotNil: [
				number > maximum
					ifTrue: [maximum := number]]].
	^ maximum.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 2/8/2017 15:00'!
minimumStringValueNumber
	| minimum |

	self do: [:each | | number |
		number := each stringValue asXPathNumber.
		minimum
			ifNil: [minimum := number]
			ifNotNil: [
				number < minimum
					ifTrue: [minimum := number]]].
	^ minimum.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 11:12'!
namespaceAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		namespaceAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:11'!
namespaceAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		namespaceAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:40'!
namespaceAxisAnySatisfy: aNamespaceNodeTest
	^ self anySatisfy: [:each |
		each namespaceAxisAnySatisfy: aNamespaceNodeTest]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 11:12'!
parentAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		parentAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:12'!
parentAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		parentAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:40'!
parentAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each parentAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 11:13'!
precedingAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		precedingAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:12'!
precedingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		precedingAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:40'!
precedingAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each precedingAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 11:13'!
precedingSiblingAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		precedingSiblingAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:12'!
precedingSiblingAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		precedingSiblingAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:39'!
precedingSiblingAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each precedingSiblingAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/25/2017 03:02'!
reject: aBlock
	"rejecting doesn't change sort order"
	^ (super reject: aBlock) sortOrder: self sortOrder! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/25/2017 02:41'!
reverseInPlace
	"unlike #reverse/#reversed, this sorts the receiver directly and
	does not return a copy"

	| previousSortOrder start end |

	"saved because swap:with: clears the sort order"
	previousSortOrder := self sortOrder.
	start := 1.
	end := self size.
	[start < end]
		whileTrue: [
			self
				swap: start
				with: end.
			start := start + 1.
			end := end - 1].
	self sortOrder: previousSortOrder asReversedSortOrder.! !

!XPathNodeSet methodsFor: 'converting' stamp: 'monty 10/18/2015 04:17'!
reversed
	^ super reversed sortOrder: self sortOrder asReversedSortOrder! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/25/2017 03:03'!
select: aBlock
	"selecting doesn't change sort order"
	^ (super select: aBlock) sortOrder: self sortOrder! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 11:13'!
selfAxis: aNodeTestStringOrBlock
	^ self sortOrder
		on: self
		selfAxis: aNodeTestStringOrBlock! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/15/2017 14:12'!
selfAxis: aNodeTestStringOrBlock predicates: aPredicateCollection
	^ self sortOrder
		on: self
		selfAxis: aNodeTestStringOrBlock
		predicates: aPredicateCollection! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/23/2017 05:39'!
selfAxisAnySatisfy: aNodeTest
	^ self anySatisfy: [:each |
		each selfAxisAnySatisfy: aNodeTest]! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 4/15/2015 11:45'!
set
	"IdentitySet is not used because namespace nodes implement ="
	^ set ifNil: [set := Set new: self capacity]! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 3/20/2017 17:54'!
sort
	"Sorts the receiver's nodes in document order.
	If it's already been sorted, no sorting is done."

	self sortOrder documentOrderSort: self! !

!XPathNodeSet methodsFor: 'sorting' stamp: 'monty 6/7/2015 00:44'!
sort: aSortBlock
	super sort: aSortBlock.
	self sortOrder: nil.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 3/15/2017 17:41'!
sortOrder
	sortOrder
		ifNil: [
			sortOrder :=
				self size > 1
					ifTrue: [XPathUnknownSortOrder new]
					ifFalse: [
						"safe for node sets with <= 1 node"
						XPathLevelDocumentSortOrder new]].
	^ sortOrder.! !

!XPathNodeSet methodsFor: 'private' stamp: 'monty 1/26/2015 17:48'!
sortOrder: aSortOrder
	sortOrder := aSortOrder! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 8/16/2015 21:33'!
stringValue
	"returns XPath string-value for the first node in document order"
	^ self asXPathString! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 3/27/2015 01:16'!
stringValues
	"returns XPath string-values of nodes"
	^ self collect: [:each | each stringValue]! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/25/2017 01:18'!
stringValuesDo: aBlock
	"enumerates XPath string-values of nodes in document order"
	self asSorted do: [:each |
		aBlock value: each stringValue]! !

!XPathNodeSet methodsFor: 'accessing' stamp: 'monty 6/7/2015 06:10'!
swap: aFirstIndex with: aSecondIndex
	super
		swap: aFirstIndex
		with: aSecondIndex.
	self sortOrder: nil.! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/27/2015 21:11'!
union: aNodeSet
	"XPath node set union operator"
	^ self copy
		addAll: aNodeSet;
		sort! !

!XPathNodeSet methodsFor: 'enumerating' stamp: 'monty 3/29/2015 19:01'!
| aNodeSet
	"redefined here for portability"
	^ self union: aNodeSet! !

!XPathNodeSet methodsFor: 'enumerating - axis' stamp: 'monty 3/16/2017 17:54'!
~ aStringOrBlockOrNodeTestWithPredicates
	^ (aStringOrBlockOrNodeTestWithPredicates isXPathNodeTestWithPredicates
		ifTrue: [
			self
				selfAxis: aStringOrBlockOrNodeTestWithPredicates nodeTest
				predicates: aStringOrBlockOrNodeTestWithPredicates predicates]
		ifFalse: [
			self selfAxis: aStringOrBlockOrNodeTestWithPredicates]) sort! !

XPath initialize!

XPathFunction initialize!

XPathASTWritingNodeVisitor initialize!

XPathASTTranslatingWritingNodeVisitor initialize!

XPathNodeTestParser initialize!

XPathContext initialize!

XPathExpressionParserAxis initialize!
